//MATERIALS
//      
	RECT wr,wr1;

HDC ambDC,diffDC,specDC;

BOOL CALLBACK _export Material_UIProc(HWND, UINT, WPARAM, LPARAM);

void draw_mc()
{
int rgb;int rr,gg,bb;

HBRUSH  hbrFace;

wr.left=0;wr.top=0;
wr.right=20;wr.bottom=12;
//diff
rr=4*64.0*Materialbank[currentMaterial].Diffuse.b;if (rr>255) rr=255;
gg=4*64.0*Materialbank[currentMaterial].Diffuse.g;if (gg>255) gg=255;
bb=4*64.0*Materialbank[currentMaterial].Diffuse.r;if (bb>255) bb=255;
hbrFace = CreateSolidBrush(RGB(bb,gg,rr));   
FillRect (diffDC, &wr, hbrFace); 
DeleteObject(hbrFace);
//amb	
rr=4*64.0*Materialbank[currentMaterial].Ambient.b;if (rr>255) rr=255;
gg=4*64.0*Materialbank[currentMaterial].Ambient.g;if (gg>255) gg=255;
bb=4*64.0*Materialbank[currentMaterial].Ambient.r;if (bb>255) bb=255;
hbrFace = CreateSolidBrush(RGB(bb,gg,rr));   
FillRect (ambDC, &wr, hbrFace); 
DeleteObject(hbrFace);
//spec
rr=4*64.0*Materialbank[currentMaterial].Specular.b;if (rr>255) rr=255;
gg=4*64.0*Materialbank[currentMaterial].Specular.g;if (gg>255) gg=255;
bb=4*64.0*Materialbank[currentMaterial].Specular.r;if (bb>255) bb=255;
hbrFace = CreateSolidBrush(RGB(bb,gg,rr));   
FillRect (specDC, &wr, hbrFace); 
DeleteObject(hbrFace);

}

// 
void MaterialUI_init()
{
//   
static DLGPROC lpfnDlgProc;
lpfnDlgProc = (DLGPROC)MakeProcInstance((FARPROC)Material_UIProc, hInst);
Material_UIDlg = CreateDialog(hInst, MAKEINTRESOURCE(IDD_MTE),Parent_hWnd, lpfnDlgProc);
}

void write_materialdata(FILE* fp,char* aa)
{
	fprintf(fp,_itoa(64.0*Materialbank[currentMaterial].Diffuse.r,aa,10));fprintf(fp,","); 
	fprintf(fp,_itoa(64.0*Materialbank[currentMaterial].Diffuse.g,aa,10));fprintf(fp,","); 
	fprintf(fp,_itoa(64.0*Materialbank[currentMaterial].Diffuse.b,aa,10));fprintf(fp,","); 
	fprintf(fp,_itoa(64.0*Materialbank[currentMaterial].Specular.r,aa,10));fprintf(fp,","); 
	fprintf(fp,_itoa(64.0*Materialbank[currentMaterial].Specular.g,aa,10));fprintf(fp,","); 
	fprintf(fp,_itoa(64.0*Materialbank[currentMaterial].Specular.b,aa,10));fprintf(fp,","); 
	fprintf(fp,_itoa(64.0*Materialbank[currentMaterial].Ambient.r,aa,10));fprintf(fp,",");		
	fprintf(fp,_itoa(64.0*Materialbank[currentMaterial].Ambient.g,aa,10));fprintf(fp,",");		
	fprintf(fp,_itoa(64.0*Materialbank[currentMaterial].Ambient.b,aa,10));fprintf(fp,",");		
	fprintf(fp,_itoa(Materialbank[currentMaterial].Power,aa,10));fprintf(fp,",");		
	fprintf(fp,_itoa(Materialbank_vertexbumplink[currentMaterial],aa,10));fprintf(fp,",");		
	fprintf(fp,_itoa(Materialbank_vertexbumpdepth[currentMaterial],aa,10));fprintf(fp,",");		
	fprintf(fp,_itoa(Materialbank_st1[currentMaterial].type,aa,10));fprintf(fp,",");		
	fprintf(fp,_itoa(Materialbank_st1[currentMaterial].texture,aa,10));fprintf(fp,",");		
	fprintf(fp,_itoa(Materialbank_st2[currentMaterial].type,aa,10));fprintf(fp,",");		
	fprintf(fp,_itoa(Materialbank_st2[currentMaterial].texture,aa,10));fprintf(fp,",");		

		memcpy(r_string,&material_name[currentMaterial][0],100);
		fprintf(fp,"mname=");fprintf(fp,r_string);fprintf(fp,";\n");
}

void write_materialdata2(FILE* fp,char* aa)
{
	fprintf(fp,_itoa(64.0*Materialbank[currentMaterial].Diffuse.r,aa,10));fprintf(fp,","); 
	fprintf(fp,_itoa(64.0*Materialbank[currentMaterial].Diffuse.g,aa,10));fprintf(fp,","); 
	fprintf(fp,_itoa(64.0*Materialbank[currentMaterial].Diffuse.b,aa,10));fprintf(fp,","); 
	fprintf(fp,_itoa(64.0*Materialbank[currentMaterial].Specular.r,aa,10));fprintf(fp,","); 
	fprintf(fp,_itoa(64.0*Materialbank[currentMaterial].Specular.g,aa,10));fprintf(fp,","); 
	fprintf(fp,_itoa(64.0*Materialbank[currentMaterial].Specular.b,aa,10));fprintf(fp,","); 
	fprintf(fp,_itoa(64.0*Materialbank[currentMaterial].Ambient.r,aa,10));fprintf(fp,",");		
	fprintf(fp,_itoa(64.0*Materialbank[currentMaterial].Ambient.g,aa,10));fprintf(fp,",");		
	fprintf(fp,_itoa(64.0*Materialbank[currentMaterial].Ambient.b,aa,10));fprintf(fp,",");		
	fprintf(fp,_itoa(Materialbank[currentMaterial].Power,aa,10));fprintf(fp,",");		
	fprintf(fp,_itoa(Materialbank_vertexbumplink[currentMaterial],aa,10));fprintf(fp,",");		
	fprintf(fp,_itoa(Materialbank_vertexbumpdepth[currentMaterial],aa,10));fprintf(fp,",");		
	fprintf(fp,_itoa(Materialbank_st1[currentMaterial].type,aa,10));fprintf(fp,",");		
	fprintf(fp,_itoa(Materialbank_st1[currentMaterial].texture,aa,10));fprintf(fp,",");		
	fprintf(fp,_itoa(Materialbank_st2[currentMaterial].type,aa,10));fprintf(fp,",");		
	fprintf(fp,_itoa(Materialbank_st2[currentMaterial].texture,aa,10));fprintf(fp,",");		

		memcpy(r_string,&material_name[currentMaterial][0],100);
		fprintf(fp,"//mname=");fprintf(fp,r_string);fprintf(fp,";\n");
}

void read_materialdata(char* i)
{int mj; char* ie;
	mj=atoi(i);Materialbank[currentMaterial].Diffuse.r=mj/64.0;i=strstr(i,",");i+=1;
	mj=atoi(i);Materialbank[currentMaterial].Diffuse.g=mj/64.0;i=strstr(i,",");i+=1;
	mj=atoi(i);Materialbank[currentMaterial].Diffuse.b=mj/64.0;i=strstr(i,",");i+=1;
	mj=atoi(i);Materialbank[currentMaterial].Specular.r=mj/64.0;i=strstr(i,",");i+=1;
	mj=atoi(i);Materialbank[currentMaterial].Specular.g=mj/64.0;i=strstr(i,",");i+=1;
	mj=atoi(i);Materialbank[currentMaterial].Specular.b=mj/64.0;i=strstr(i,",");i+=1;
	mj=atoi(i);Materialbank[currentMaterial].Ambient.r=mj/64.0;i=strstr(i,",");i+=1;
	mj=atoi(i);Materialbank[currentMaterial].Ambient.g=mj/64.0;i=strstr(i,",");i+=1;
	mj=atoi(i);Materialbank[currentMaterial].Ambient.b=mj/64.0;i=strstr(i,",");i+=1;
	mj=atoi(i);Materialbank[currentMaterial].Power=mj;i=strstr(i,",");i+=1;
	mj=atoi(i);Materialbank_vertexbumplink[currentMaterial]=mj;i=strstr(i,",");i+=1;
	mj=atoi(i);Materialbank_vertexbumpdepth[currentMaterial]=mj;i=strstr(i,",");i+=1;
	mj=atoi(i);Materialbank_st1[currentMaterial].type=mj;i=strstr(i,",");i+=1;
	mj=atoi(i);Materialbank_st1[currentMaterial].texture=mj;i=strstr(i,",");i+=1;
	mj=atoi(i);Materialbank_st2[currentMaterial].type=mj;i=strstr(i,",");i+=1;
	mj=atoi(i);Materialbank_st2[currentMaterial].texture=mj;i=strstr(i,",");i+=1;

	i=strstr(i,"mname=");
	ie=strstr(i,";");*(ie)=0;
	strcpy((char*)&material_name[currentMaterial][0],i+6);
	*(ie)=';';
}				

void LoadMaterialdataToControls(HWND hWnd)
{
		SendDlgItemMessage(Material_UIDlg,IDC_VBCOMBO,CB_RESETCONTENT,0,0);
		for (int f=0;f<255;f++)
		{
		sprintf(r_string,"%d:    ",f); // 
		memcpy(r_string+4,&texture_name[f][0],96);
		SendDlgItemMessage(Material_UIDlg,IDC_VBCOMBO,CB_ADDSTRING,0,(LPARAM) (LPCTSTR)r_string);
		}
		SendDlgItemMessage(hWnd,IDC_VBCOMBO,CB_SETCURSEL,(WPARAM)Materialbank_vertexbumplink[currentMaterial],0);					

		SendDlgItemMessage(Material_UIDlg,IDC_MTEX1,CB_RESETCONTENT,0,0);
		for (f=0;f<255;f++)
		{
		sprintf(r_string,"%d:    ",f); // 
		memcpy(r_string+4,&texture_name[f][0],96);
		SendDlgItemMessage(Material_UIDlg,IDC_MTEX1,CB_ADDSTRING,0,(LPARAM) (LPCTSTR)r_string);
		}
		SendDlgItemMessage(Material_UIDlg,IDC_MTEX1,CB_SETCURSEL,(WPARAM)Materialbank_st1[currentMaterial].texture,0);					

		SendDlgItemMessage(Material_UIDlg,IDC_MTEX2,CB_RESETCONTENT,0,0);
		for (f=0;f<255;f++)
		{
		sprintf(r_string,"%d:    ",f); // 
		memcpy(r_string+4,&texture_name[f][0],96);
		SendDlgItemMessage(Material_UIDlg,IDC_MTEX2,CB_ADDSTRING,0,(LPARAM) (LPCTSTR)r_string);
		}
		SendDlgItemMessage(Material_UIDlg,IDC_MTEX2,CB_SETCURSEL,(WPARAM)Materialbank_st2[currentMaterial].texture,0);					


	SendDlgItemMessage(hWnd,SPEC_R,TBM_SETPOS,TRUE,(LPARAM) (Materialbank[currentMaterial].Specular.r*64.0));
	SendDlgItemMessage(hWnd,SPEC_G,TBM_SETPOS,TRUE,(LPARAM) (Materialbank[currentMaterial].Specular.g*64.0));
	SendDlgItemMessage(hWnd,SPEC_B,TBM_SETPOS,TRUE,(LPARAM) (Materialbank[currentMaterial].Specular.b*64.0));
	SendDlgItemMessage(hWnd,DIFF_R,TBM_SETPOS,TRUE,(LPARAM) (Materialbank[currentMaterial].Diffuse.r*64.0));
	SendDlgItemMessage(hWnd,DIFF_G,TBM_SETPOS,TRUE,(LPARAM) (Materialbank[currentMaterial].Diffuse.g*64.0));
	SendDlgItemMessage(hWnd,DIFF_B,TBM_SETPOS,TRUE,(LPARAM) (Materialbank[currentMaterial].Diffuse.b*64.0));
	SendDlgItemMessage(hWnd,AMB_R,TBM_SETPOS,TRUE,(LPARAM) (Materialbank[currentMaterial].Ambient.r*64.0));
	SendDlgItemMessage(hWnd,AMB_G,TBM_SETPOS,TRUE,(LPARAM) (Materialbank[currentMaterial].Ambient.g*64.0));
	SendDlgItemMessage(hWnd,AMB_B,TBM_SETPOS,TRUE,(LPARAM) (Materialbank[currentMaterial].Ambient.b*64.0));
	SendDlgItemMessage(hWnd,POW,TBM_SETPOS,TRUE,(LPARAM) 255-Materialbank[currentMaterial].Power);
	SendDlgItemMessage(hWnd,VBDEPTH,TBM_SETPOS,TRUE,(LPARAM) Materialbank_vertexbumpdepth[currentMaterial]);
//	SetDlgItemInt(hWnd,IDC_VBN,Materialbank_vertexbumplink[currentMaterial],FALSE);
	SetDlgItemInt(hWnd,NMATERIAL,currentMaterial,FALSE);
	SetDlgItemInt(hWnd,IDC_MTN,Materialbank_st1[currentMaterial].texture,FALSE);
	SendDlgItemMessage(hWnd,IDC_MTTYPE,CB_SETCURSEL,Materialbank_st1[currentMaterial].type,0);
	SetDlgItemInt(hWnd,IDC_MTN2,Materialbank_st2[currentMaterial].texture,FALSE);
	SendDlgItemMessage(hWnd,IDC_MTTYPE2,CB_SETCURSEL,Materialbank_st2[currentMaterial].type,0);

	memcpy(r_string,&material_name[currentMaterial][0],100);
	SetDlgItemText(Material_UIDlg,IDC_MATNAME,r_string);
						
}


BOOL CALLBACK Material_UIProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	int aa;

   static HWND  hTip_material = NULL;
    static char* buf_material[]={
        "click to select color",
		"multitexturing type",
		"landscape depth for landcape-objects"
		};


	switch (message) 
	{
	case WM_ACTIVATE:
		if (LOWORD(wParam)==WA_INACTIVE) active_app=0; else active_app=1;
		break;

    case WM_LBUTTONDOWN:
             PostMessage(hWnd, WM_NCLBUTTONDOWN, HTCAPTION,0);
			 break;

	case WM_MOVING:
		{
		DrawScene();draw_tw();
		break;
		}
	case WM_SIZE:
		{
		if (wParam==SIZE_MINIMIZED)
			{
			if (AutoFocus!=0)
				{
				ShowWindow(Material_UIDlg,SW_RESTORE);
				if (window_fixer[6]==1) SetWindowPos(Material_UIDlg,HWND_TOP,wp[24],wp[25],wp[26]-wp[24],50,SWP_SHOWWINDOW|SWP_NOMOVE);
				if (window_fixer[6]==0) SetWindowPos(Material_UIDlg,HWND_TOP,wp[24],wp[25],wp[26]-wp[24],wp[27]-wp[25],SWP_SHOWWINDOW|SWP_NOMOVE);
				if (fix_mode!=0) SetWindowPos(Material_UIDlg,HWND_TOP,wp[24],wp[25],wp[26]-wp[24],wp[27]-wp[25],SWP_SHOWWINDOW|SWP_NOMOVE);
				window_fixer[6]=1-window_fixer[6];
				SetFocus(Material_UIDlg);
				break;
				}

			window_fixer[6]=1-window_fixer[6];
			ShowWindow(Material_UIDlg,SW_RESTORE);
			SetFocus(Material_UIDlg);
			}
		break;
		}

	case WM_CLOSE:
		{
		SendMessage(Parent_hWnd,WM_COMMAND,W_MT,0);
		break;
		}

	case WM_MOUSEMOVE:
		{
		draw_mc();
		if (window!=6&&AutoFocus==0) 
			{
			SetFocus(hWnd);window=6;
			winpos();
			}
		break;
		}

	case WM_INITDIALOG:
	{
        hTip_material = CreateToolTip(hWnd);
        BOOL res = AddTool(hTip_material,GetDlgItem(hWnd,IDC_GETDIFFRGB),NULL,0,buf_material[0]);
		res = AddTool(hTip_material,GetDlgItem(hWnd,IDC_GETSPECRGB),NULL,0,buf_material[0]);
		res = AddTool(hTip_material,GetDlgItem(hWnd,IDC_GETAMBRGB),NULL,0,buf_material[0]);
		res = AddTool(hTip_material,GetDlgItem(hWnd,IDC_MTTYPE),NULL,0,buf_material[1]);
		res = AddTool(hTip_material,GetDlgItem(hWnd,IDC_RS),NULL,0,buf_material[2]);
		res = AddTool(hTip_material,GetDlgItem(hWnd,VBDEPTH),NULL,0,buf_material[2]);
        EnableToolTip(hTip_material,TRUE);
		//  - 
		SendDlgItemMessage(hWnd,IDC_MATCOMBOSELECTOR,CB_RESETCONTENT,0,0);
		for (int ii=0; ii<256; ii++)
			{
			sprintf(tempstr,"%d",ii);
			SendDlgItemMessage(hWnd,IDC_MATCOMBOSELECTOR,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)tempstr);
			}
		SendDlgItemMessage(hWnd,IDC_MATCOMBOSELECTOR,CB_SETCURSEL,0,0);
		//---
		SetDlgItemInt(hWnd,IDC_MTTEX,0,FALSE);
		SendDlgItemMessage(hWnd,IDC_MTTYPE,CB_RESETCONTENT,0,0);
		SendDlgItemMessage(hWnd,IDC_MTTYPE,CB_ADDSTRING,0,(LPARAM) (LPCTSTR) "none");
		SendDlgItemMessage(hWnd,IDC_MTTYPE,CB_ADDSTRING,0,(LPARAM) (LPCTSTR) "n-add");
		SendDlgItemMessage(hWnd,IDC_MTTYPE,CB_ADDSTRING,0,(LPARAM) (LPCTSTR) "n-sub");
		SendDlgItemMessage(hWnd,IDC_MTTYPE,CB_ADDSTRING,0,(LPARAM) (LPCTSTR) "n-mod");
		SendDlgItemMessage(hWnd,IDC_MTTYPE,CB_ADDSTRING,0,(LPARAM) (LPCTSTR) "sfere-add");
		SendDlgItemMessage(hWnd,IDC_MTTYPE,CB_ADDSTRING,0,(LPARAM) (LPCTSTR) "sfere-sub");
		SendDlgItemMessage(hWnd,IDC_MTTYPE,CB_ADDSTRING,0,(LPARAM) (LPCTSTR) "sfere-mod");
		SendDlgItemMessage(hWnd,IDC_MTTYPE,CB_ADDSTRING,0,(LPARAM) (LPCTSTR) "add");
		SendDlgItemMessage(hWnd,IDC_MTTYPE,CB_ADDSTRING,0,(LPARAM) (LPCTSTR) "sub");
		SendDlgItemMessage(hWnd,IDC_MTTYPE,CB_ADDSTRING,0,(LPARAM) (LPCTSTR) "mod");
		SendDlgItemMessage(hWnd,IDC_MTTYPE,CB_ADDSTRING,0,(LPARAM) (LPCTSTR) "displace");
		SendDlgItemMessage(hWnd,IDC_MTTYPE,CB_ADDSTRING,0,(LPARAM) (LPCTSTR) "displace2");
	
		SendDlgItemMessage(hWnd,IDC_MTTYPE2,CB_RESETCONTENT,0,0);
		SendDlgItemMessage(hWnd,IDC_MTTYPE2,CB_ADDSTRING,0,(LPARAM) (LPCTSTR) "none");
		SendDlgItemMessage(hWnd,IDC_MTTYPE2,CB_ADDSTRING,0,(LPARAM) (LPCTSTR) "n-add");
		SendDlgItemMessage(hWnd,IDC_MTTYPE2,CB_ADDSTRING,0,(LPARAM) (LPCTSTR) "n-sub");
		SendDlgItemMessage(hWnd,IDC_MTTYPE2,CB_ADDSTRING,0,(LPARAM) (LPCTSTR) "n-mod");
		SendDlgItemMessage(hWnd,IDC_MTTYPE2,CB_ADDSTRING,0,(LPARAM) (LPCTSTR) "sfere-add");
		SendDlgItemMessage(hWnd,IDC_MTTYPE2,CB_ADDSTRING,0,(LPARAM) (LPCTSTR) "sfere-sub");
		SendDlgItemMessage(hWnd,IDC_MTTYPE2,CB_ADDSTRING,0,(LPARAM) (LPCTSTR) "sfere-mod");
		SendDlgItemMessage(hWnd,IDC_MTTYPE2,CB_ADDSTRING,0,(LPARAM) (LPCTSTR) "add");
		SendDlgItemMessage(hWnd,IDC_MTTYPE2,CB_ADDSTRING,0,(LPARAM) (LPCTSTR) "sub");
		SendDlgItemMessage(hWnd,IDC_MTTYPE2,CB_ADDSTRING,0,(LPARAM) (LPCTSTR) "mod");


		SendDlgItemMessage(hWnd,IDC_MTTYPE,CB_SETCURSEL,0,0);
		SendDlgItemMessage(hWnd,IDC_MTTYPE2,CB_SETCURSEL,0,0);
		SetDlgItemInt(hWnd,IDC_MTN,0,FALSE);
		SetDlgItemInt(hWnd,IDC_MTN2,0,FALSE);
			
		for (int i=0;i<255;i++) Materialbank_vertexbumplink[i]=1;
		SendDlgItemMessage(hWnd,SPEC_R,TBM_SETRANGE,TRUE,(LPARAM) MAKELONG(0,255));
		SendDlgItemMessage(hWnd,SPEC_G,TBM_SETRANGE,TRUE,(LPARAM) MAKELONG(0,255));
		SendDlgItemMessage(hWnd,SPEC_B,TBM_SETRANGE,TRUE,(LPARAM) MAKELONG(0,255));
		SendDlgItemMessage(hWnd,DIFF_R,TBM_SETRANGE,TRUE,(LPARAM) MAKELONG(0,255));
		SendDlgItemMessage(hWnd,DIFF_G,TBM_SETRANGE,TRUE,(LPARAM) MAKELONG(0,255));
		SendDlgItemMessage(hWnd,DIFF_B,TBM_SETRANGE,TRUE,(LPARAM) MAKELONG(0,255));
		SendDlgItemMessage(hWnd,AMB_R,TBM_SETRANGE,TRUE,(LPARAM) MAKELONG(0,255));
		SendDlgItemMessage(hWnd,AMB_G,TBM_SETRANGE,TRUE,(LPARAM) MAKELONG(0,255));
		SendDlgItemMessage(hWnd,AMB_B,TBM_SETRANGE,TRUE,(LPARAM) MAKELONG(0,255));
	
		SendDlgItemMessage(hWnd,POW,TBM_SETRANGE,TRUE,(LPARAM) MAKELONG(0,255));
		SendDlgItemMessage(hWnd,VBDEPTH,TBM_SETRANGE,TRUE,(LPARAM) MAKELONG(0,255));
		SetDlgItemInt(hWnd,IDC_VBN,Materialbank_vertexbumplink[currentMaterial],FALSE);
		SetDlgItemInt(hWnd,NMATERIAL,0,FALSE);
		break;
	}

	case WM_HSCROLL:
		{
		int tt,aa;
		double sq,nx,ny,nz,f;

		Materialbank[currentMaterial].Specular.r=SendDlgItemMessage(hWnd,SPEC_R,TBM_GETPOS,0,0)/64.0;
		Materialbank[currentMaterial].Specular.g=SendDlgItemMessage(hWnd,SPEC_G,TBM_GETPOS,0,0)/64.0;
		Materialbank[currentMaterial].Specular.b=SendDlgItemMessage(hWnd,SPEC_B,TBM_GETPOS,0,0)/64.0;
		Materialbank[currentMaterial].Diffuse.r=SendDlgItemMessage(hWnd,DIFF_R,TBM_GETPOS,0,0)/64.0;
		Materialbank[currentMaterial].Diffuse.g=SendDlgItemMessage(hWnd,DIFF_G,TBM_GETPOS,0,0)/64.0;
		Materialbank[currentMaterial].Diffuse.b=SendDlgItemMessage(hWnd,DIFF_B,TBM_GETPOS,0,0)/64.0;
		Materialbank[currentMaterial].Ambient.r=SendDlgItemMessage(hWnd,AMB_R,TBM_GETPOS,0,0)/64.0;
		Materialbank[currentMaterial].Ambient.g=SendDlgItemMessage(hWnd,AMB_G,TBM_GETPOS,0,0)/64.0;
		Materialbank[currentMaterial].Ambient.b=SendDlgItemMessage(hWnd,AMB_B,TBM_GETPOS,0,0)/64.0;
		Materialbank[currentMaterial].Power=255-SendDlgItemMessage(hWnd,POW,TBM_GETPOS,0,0);
		Materialbank_vertexbumpdepth[currentMaterial]=SendDlgItemMessage(hWnd,VBDEPTH,TBM_GETPOS,0,0);
		draw_mc();
		break;
		}

		
	case WM_COMMAND:
		{

		switch (LOWORD(wParam))
			{
			case IDC_VBCOMBO:
				{
				int t;int ti=0;
				t=SendDlgItemMessage(Material_UIDlg,IDC_VBCOMBO,CB_GETCURSEL,0,0);
				
				if (HIWORD (wParam) == CBN_DROPDOWN)
					{
					SendDlgItemMessage(Material_UIDlg,IDC_VBCOMBO,CB_RESETCONTENT,0,0);
					for (int f=0;f<255;f++)
						{
						sprintf(r_string,"%d:    ",f); // 
						memcpy(r_string+4,&texture_name[f][0],96);
						SendDlgItemMessage(Material_UIDlg,IDC_VBCOMBO,CB_ADDSTRING,0,(LPARAM) (LPCTSTR)r_string);
						}
					SendDlgItemMessage(Material_UIDlg,IDC_VBCOMBO,CB_SETCURSEL,(WPARAM)t,0);					
					goto qq;
					}

				if (t!=CB_ERR)
						Materialbank_vertexbumplink[currentMaterial]=t;
				qq:;
				break;
				}

			case IDC_MATNAME:
				{
				if (HIWORD (wParam) == EN_CHANGE)  
					{
					if (GetFocus()==GetDlgItem(Material_UIDlg,IDC_MATNAME))
						{
						GetDlgItemText(Material_UIDlg,IDC_MATNAME,r_string,99);
						memcpy(&material_name[currentMaterial][0],r_string,100);
						}
					int t;
					t=SendDlgItemMessage(Geo_UIDlg,IDC_MSELCOMBO,CB_GETCURSEL,0,0);
				
					SendDlgItemMessage(Geo_UIDlg,IDC_MSELCOMBO,CB_RESETCONTENT,0,0);
					for (int f=0;f<255;f++)
						{
						sprintf(r_string,"%d:    ",f); // 
						memcpy(r_string+4,&material_name[f][0],96);
						SendDlgItemMessage(Geo_UIDlg,IDC_MSELCOMBO,CB_ADDSTRING,0,(LPARAM) (LPCTSTR)r_string);
						}
					SendDlgItemMessage(Geo_UIDlg,IDC_MSELCOMBO,CB_SETCURSEL,(WPARAM)t,0);					
					}
				break;
				}

			//case IDC_MTNEXT: {if (Materialbank_st1[currentMaterial].texture<254) Materialbank_st1[currentMaterial].texture++;LoadMaterialdataToControls(hWnd);break;}
			//case IDC_MTPREV: {if (Materialbank_st1[currentMaterial].texture>0)   Materialbank_st1[currentMaterial].texture--;LoadMaterialdataToControls(hWnd);break;}
			//case IDC_MTNEXT2: {if (Materialbank_st2[currentMaterial].texture<254) Materialbank_st2[currentMaterial].texture++;LoadMaterialdataToControls(hWnd);break;}
			//case IDC_MTPREV2: {if (Materialbank_st2[currentMaterial].texture>0)   Materialbank_st2[currentMaterial].texture--;LoadMaterialdataToControls(hWnd);break;}
			case IDC_MTEX1:
				{
				int t;int ti=0;
				t=SendDlgItemMessage(Material_UIDlg,IDC_MTEX1,CB_GETCURSEL,0,0);
				
				if (HIWORD (wParam) == CBN_DROPDOWN)
					{
					SendDlgItemMessage(Material_UIDlg,IDC_MTEX1,CB_RESETCONTENT,0,0);
					for (int f=0;f<255;f++)
						{
						sprintf(r_string,"%d:    ",f); // 
						memcpy(r_string+4,&texture_name[f][0],96);
						SendDlgItemMessage(Material_UIDlg,IDC_MTEX1,CB_ADDSTRING,0,(LPARAM) (LPCTSTR)r_string);
						}
					SendDlgItemMessage(Material_UIDlg,IDC_MTEX1,CB_SETCURSEL,(WPARAM)t,0);					
					goto qqq;
					}

				if (t!=CB_ERR)
						Materialbank_st1[currentMaterial].texture=t;
				qqq:;
				break;
				}
			case IDC_MTEX2:
				{
				int t;int ti=0;
				t=SendDlgItemMessage(Material_UIDlg,IDC_MTEX2,CB_GETCURSEL,0,0);
				
				if (HIWORD (wParam) == CBN_DROPDOWN)
					{
					SendDlgItemMessage(Material_UIDlg,IDC_MTEX2,CB_RESETCONTENT,0,0);
					for (int f=0;f<255;f++)
						{
						sprintf(r_string,"%d:    ",f); // 
						memcpy(r_string+4,&texture_name[f][0],96);
						SendDlgItemMessage(Material_UIDlg,IDC_MTEX2,CB_ADDSTRING,0,(LPARAM) (LPCTSTR)r_string);
						}
					SendDlgItemMessage(Material_UIDlg,IDC_MTEX2,CB_SETCURSEL,(WPARAM)t,0);					
					goto qqq2;
					}

				if (t!=CB_ERR)
						Materialbank_st2[currentMaterial].texture=t;
				qqq2:;
				break;
				}
			case IDC_MTTYPE:
				{
				Materialbank_st1[currentMaterial].type=SendDlgItemMessage(hWnd,IDC_MTTYPE,CB_GETCURSEL,0,0);
				LoadMaterialdataToControls(hWnd);
				break;
				}
			case IDC_MTTYPE2:
				{
				Materialbank_st2[currentMaterial].type=SendDlgItemMessage(hWnd,IDC_MTTYPE2,CB_GETCURSEL,0,0);
				LoadMaterialdataToControls(hWnd);
				break;
				}

			case IDC_GETDIFFRGB:
				{
				CHOOSECOLOR sc;
				ZeroMemory(&sc,sizeof(CHOOSECOLOR));
				sc.hwndOwner=hWnd;
				sc.Flags=CC_FULLOPEN|CC_RGBINIT;
				sc.lStructSize = sizeof(CHOOSECOLOR);
				
				int rr,gg,bb;
				rr=4*64.0*Materialbank[currentMaterial].Diffuse.b;if (rr>255) rr=255;
				gg=4*64.0*Materialbank[currentMaterial].Diffuse.g;if (gg>255) gg=255;
				bb=4*64.0*Materialbank[currentMaterial].Diffuse.r;if (bb>255) bb=255;

				sc.rgbResult = RGB(rr, gg, bb);
				sc.lpCustColors = aclrCust;

				if (ChooseColor(&sc)==TRUE)
				{
				Materialbank[currentMaterial].Diffuse.r=GetRValue(sc.rgbResult)/64.0/4.0;
				Materialbank[currentMaterial].Diffuse.g=GetGValue(sc.rgbResult)/64.0/4.0;
				Materialbank[currentMaterial].Diffuse.b=GetBValue(sc.rgbResult)/64.0/4.0;
				
				draw_mc();
				LoadMaterialdataToControls(hWnd);
				}
				break;
				}
			case IDC_GETAMBRGB:
				{
				CHOOSECOLOR sc;
				ZeroMemory(&sc,sizeof(CHOOSECOLOR));
				sc.hwndOwner=hWnd;
				sc.Flags=CC_FULLOPEN|CC_RGBINIT;
				sc.lStructSize = sizeof(CHOOSECOLOR);
				int rr,gg,bb;
				rr=4*64.0*Materialbank[currentMaterial].Diffuse.b;if (rr>255) rr=255;
				gg=4*64.0*Materialbank[currentMaterial].Diffuse.g;if (gg>255) gg=255;
				bb=4*64.0*Materialbank[currentMaterial].Diffuse.r;if (bb>255) bb=255;

				sc.rgbResult = RGB(rr, gg, bb);
				sc.lpCustColors = aclrCust;

				if (ChooseColor(&sc)==TRUE)
				{
				Materialbank[currentMaterial].Ambient.r=GetRValue(sc.rgbResult)/64.0/4.0;
				Materialbank[currentMaterial].Ambient.g=GetGValue(sc.rgbResult)/64.0/4.0;
				Materialbank[currentMaterial].Ambient.b=GetBValue(sc.rgbResult)/64.0/4.0;
				draw_mc();
				LoadMaterialdataToControls(hWnd);
				}
				break;
				}

			case IDC_GETSPECRGB:
				{
				CHOOSECOLOR sc;
				ZeroMemory(&sc,sizeof(CHOOSECOLOR));
				sc.hwndOwner=hWnd;
				sc.Flags=CC_FULLOPEN|CC_RGBINIT;
				sc.lStructSize = sizeof(CHOOSECOLOR);
				int rr,gg,bb;
				rr=4*64.0*Materialbank[currentMaterial].Diffuse.b;if (rr>255) rr=255;
				gg=4*64.0*Materialbank[currentMaterial].Diffuse.g;if (gg>255) gg=255;
				bb=4*64.0*Materialbank[currentMaterial].Diffuse.r;if (bb>255) bb=255;

				sc.rgbResult = RGB(rr, gg, bb);
				sc.lpCustColors = aclrCust;

				if (ChooseColor(&sc)==TRUE)
				{
				Materialbank[currentMaterial].Specular.r=GetRValue(sc.rgbResult)/64.0/4.0;
				Materialbank[currentMaterial].Specular.g=GetGValue(sc.rgbResult)/64.0/4.0;
				Materialbank[currentMaterial].Specular.b=GetBValue(sc.rgbResult)/64.0/4.0;
				draw_mc();
				LoadMaterialdataToControls(hWnd);
				}
				break;
				}


				
				case IDC_CLEARMATERIAL:
				{
					int mj=0;
					Materialbank[currentMaterial].Diffuse.r=mj;
					Materialbank[currentMaterial].Diffuse.g=mj;
					Materialbank[currentMaterial].Diffuse.b=mj;
					Materialbank[currentMaterial].Specular.r=mj;
					Materialbank[currentMaterial].Specular.g=mj;
					Materialbank[currentMaterial].Specular.b=mj;
					Materialbank[currentMaterial].Ambient.r=mj;
					Materialbank[currentMaterial].Ambient.g=mj;
					Materialbank[currentMaterial].Ambient.b=mj;
					Materialbank[currentMaterial].Power=mj;
					Materialbank_vertexbumplink[currentMaterial]=0;
					Materialbank_vertexbumpdepth[currentMaterial]=0;
					draw_mc();
					LoadMaterialdataToControls(hWnd);
					break;
				}
				case IDC_MATCOMBOSELECTOR:
					{
					currentMaterial=SendDlgItemMessage(hWnd,IDC_MATCOMBOSELECTOR,CB_GETCURSEL,0,0);
					if (Materialbank_vertexbumplink[currentMaterial]<1) Materialbank_vertexbumplink[currentMaterial]=1;
					draw_mc();
					LoadMaterialdataToControls(hWnd);
					break;
					}
				case PREV_MATERIAL:
					{
					if (currentMaterial>0) currentMaterial--;
					SendDlgItemMessage(hWnd,IDC_MATCOMBOSELECTOR,CB_SETCURSEL,currentMaterial,0);
					if (Materialbank_vertexbumplink[currentMaterial]<1) Materialbank_vertexbumplink[currentMaterial]=1;
					draw_mc();
					LoadMaterialdataToControls(hWnd);
					break;
					}
				case NEXT_MATERIAL:
					{
					if (currentMaterial<255) currentMaterial++;
					SendDlgItemMessage(hWnd,IDC_MATCOMBOSELECTOR,CB_SETCURSEL,currentMaterial,0);
					if (Materialbank_vertexbumplink[currentMaterial]<1) Materialbank_vertexbumplink[currentMaterial]=1;
					draw_mc();
					LoadMaterialdataToControls(hWnd);
					break;
					}
				/*case IDC_VBPREV:
					{
					if (Materialbank_vertexbumplink[currentMaterial]>0) Materialbank_vertexbumplink[currentMaterial]--;
					draw_mc();
					LoadMaterialdataToControls(hWnd);
					break;
					}
				case IDC_VBNEXT:
					{
					if (Materialbank_vertexbumplink[currentMaterial]<254) Materialbank_vertexbumplink[currentMaterial]++;
					draw_mc();
					LoadMaterialdataToControls(hWnd);
					break;
					}*/

			}
		}
		
	}
 return 0L;
}