void Invert(BYTE* dst)
{
	memcpy(dst,dst-tsize*tsize*4,tsize*tsize*4);
	int ts;
	ts=tsize*tsize;
	_asm{
		mov ecx,ts
		mov edi,dst
		mov ebx,0xffffffff
lp:
		mov eax,[edi]
		xor eax,ebx
		mov [edi],ax
		shr eax,16
		mov [edi+2],al
		add edi,4
		loop lp
		}
}


void InvertAlfa(BYTE* dst)
{
	int ts;
	memcpy(dst,dst-tsize*tsize*4,tsize*tsize*4);
	ts=tsize*tsize;
	_asm{
		mov ecx,ts
		mov edi,dst
		mov ebx,0xffffffff
lp:
		mov al,[edi+3]
		xor al,bl
		mov [edi+3],al
		add edi,4
		loop lp
		}
}


void SinColor(BYTE* dst,int bc,int gc, int rc,int gain)
{
int j;
memcpy(dst,dst-tsize*tsize*4,tsize*tsize*4);
for (j=0;j<tsize*tsize;j++)
	{
	get_r_g_b(dst,j,0);
	_r=128+127*sin(gain*_r*rc/128.0/32.0/128.0);
	_g=128+127*sin(gain*_g*gc/128.0/32.0/128.0);
	_b=128+127*sin(gain*_b*bc/128.0/32.0/128.0);
	place_r_g_b(dst,j,0);
	}
}

void ScaleColor(BYTE* dst,int bc,int gc, int rc)
{
int j;
memcpy(dst,dst-tsize*tsize*4,tsize*tsize*4);
for (j=0;j<tsize*tsize;j++)
	{
	get_r_g_b(dst,j,0);
	_r=_r*rc/128.0;
	_g=_g*gc/128.0;
	_b=_b*bc/128.0;
	if (_r>255) _r=255;if (_g>255) _g=255;if (_b>255) _b=255;
	place_r_g_b(dst,j,0);
	}
}


void AdjustColor(BYTE* dst,int alfa,int light,int contrast)
{
memcpy(dst,dst-tsize*tsize*4,tsize*tsize*4);
int p,j;double r,g,b,r1,g1,b1,c1,c2,c3;
double m[255];
alfa=255-alfa;light=light*2-256;contrast=contrast*4;
for (j=0;j<42;j++) m[j+42*0]=0;
for (j=0;j<42;j++) m[j+42*1]=j*6;
for (j=0;j<42;j++) m[j+42*2]=252;
for (j=0;j<42;j++) m[j+42*3]=252;
for (j=0;j<42;j++) m[j+42*4]=252-j*6;
for (j=0;j<42;j++) m[j+42*5]=0;

p=alfa;c1=m[p];
p=alfa+256/3.0; if (p>255) p-=255;c2=m[p];
p=alfa+2*256/3.0; if (p>255) p-=255;c3=m[p];

for (j=0;j<tsize*tsize;j++)
	{
	b=peekb(dst+j*4+0);
	g=peekb(dst+j*4+1);
	r=peekb(dst+j*4+2);
	r1=(r*c1/252.0+g*c2/252.0+b*c3/252.0)/2.0;
	g1=(r*c3/252.0+g*c1/252.0+b*c2/252.0)/2.0;
	b1=(r*c2/252.0+g*c3/252.0+b*c1/252.0)/2.0;

	r1+=light;g1+=light;b1+=light;
	r1=r1*contrast/256;g1=g1*contrast/256;b1=b1*contrast/256;

	if (r1>255) r1=255;if (g1>255) g1=255;if (b1>255) b1=255;
	if (r1<0) r1=0;if (g1<0) g1=0;if (b1<0) b1=0;

	pokeb (dst+j*4+0,b1);
	pokeb (dst+j*4+1,g1);
	pokeb (dst+j*4+2,r1);

	}

}




 
