void ClearRGB(BYTE* dst);

void LoadTGA(BYTE* dst,char* txn)
{
FILE *fp;
char a[300];

SetCurrentDirectory(cdir);
strcpy(a,txn);
fp=fopen(a,"rb");
if (fp)
	{
	fseek(fp,18,0);
	fread(dst,1,tsize*tsize*4,fp);
	fclose(fp);
	}
}

//paporotnik by by bitl/7dump (from BECHA 64k intro)
void List(BYTE*  dst,int rt, int n,int p1,int p2,int p3,int p4,int p5)
{
int ox,oy,sx,sy;
ox=113; oy=24; sx=27; sy=18;
ox=ox*tsize/256;
oy=oy*tsize/256;
sx=sx*tsize/256;
sy=sy*tsize/256;

int nn;int px,py;
double newx,x,y,newy,a,b,r,c,d,e,f;
ClearRGB(dst);
srand(0);

for (nn=1;nn<n*1000;nn++)
{
	r=rand()/32768.0;
	if (r<=0.1) 
	{
			if (rt==2)
				{
				a=(p1-128)/128.0;
				b=(p2-128)/128.0;
				c=(p3-128)/128.0;
				d=(p4-128)/128.0;
				f=(p5-128)/128.0;
				}
			else
			{a=0;b=0;c=0;d=0.16;f=0;}
	}
	else 
	{
		if ((r>0.1)&&(r<=0.86))
		{
		if (rt==0)
			{
			a=(p1-128)/128.0;
			b=(p2-128)/128.0;
			c=(p3-128)/128.0;
			d=(p4-128)/128.0;
			f=(p5-128)/64.0;
			}
			else
			{
			a=0.85 ;b=0.04;c=-0.04;d=0.85;f=1.6;
			}
		}
		else 
		{
			if ((r>0.86)&&(r<=0.93))
			{
			if (rt==1)
				{
				a=(p1-128)/128.0;
				b=(p2-128)/128.0;
				c=(p3-128)/128.0;
				d=(p4-128)/128.0;
				f=(p5-128)/128.0;
				}
				else
				{a=0.2;b=-0.26;c=0.23;d=0.22;f=1.6;}
			}
			else 
			{
			if (rt==1)
				{
				a=-(p1-128)/128.0;
				b=-(p2-128)/128.0;
				c=(p3-128)/128.0;
				d=(p4-128)/128.0;
				f=(128-p5)/128.0;
				}
				else
				{
				a=-0.15;b=0.28;c=0.26;d=0.24;f=0.44;
				}

			}
		}
	}
	newx=(a*x)+(b*y);
	newy=(c*x)+(d*y)+f;
	x=newx;
	y=newy;

    _rgb=0xffffffff;
	px=(int)(x*sx+ox);
	py=(int)(y*sy+oy);

  if (px>0&&px<tsize&&py>0&&py<tsize) place_rgb(dst,px, py);

}

}

//Clouds by San
void Clouds( BYTE* dst, int a,int b,double cnt)
{
  ClearRGB(dst);

  a+=8;a*=2;
  if (b==1) b=255;
  int x, y;int addr = 0;

  srand(b);
  for ( x=0;x<(tsize+256) * (tsize+256); x++ )
	{
     int r = rand() +47;
     pokeb(texture_swp+addr,r - (r/256)*256);
     addr++;
	}

  BYTE* dsti = dst;

  float fpx, fpy, fkx, fky;
  int ipx, ipy, n, cl, htsize;
  float rcol;
  byte c0, c1, c2, c3;

  cl = 0x80;
  htsize = tsize / 2;
  addr = 0;
  for ( y=0; y<tsize; y++ )
	{
       for ( x=0; x<tsize; x++ )
			{

            rcol=0;
            n = 1;
            while( n<cnt )
				{
                 float dd = n*a/cnt;
				 if ( dd<1 ) dd=1;
                 fpx = (x-htsize) / dd + htsize+n;
                 fpy = (y-htsize) / dd + htsize+n;

                 ipx = int( fpx );
                 ipy = int( fpy );

                 fkx = fpx - ipx;
                 fky = fpy - ipy;

                 c0 = *(texture_swp+ipy*tsize + ipx );
                 c1 = *(texture_swp+ipy*tsize + ipx + 1 );
                 c2 = *(texture_swp+(ipy+1)*tsize + ipx );
                 c3 = *(texture_swp+(ipy+1)*tsize + ipx + 1 );

                 byte colx0 = int( c0 * ( 1-fkx ) + c1*fkx );
                 byte colx1 = int( c2 * ( 1-fkx ) + c3*fkx );

                 cl = int( colx0 * ( 1-fky ) + colx1 * fky );
                 rcol += cl * ((n+2)/cnt);
                 n = n * 2;
				}
            cl = int( rcol );
            if ( cl > 255 ) cl = 255;

			_rgb=cl<<16 | cl<<8 | cl;
			_asm{
				mov edi,dsti
				mov edx,addr
				add edi,edx
					mov eax,_rgb
					mov [edi],ax
					shr eax,16
					mov [edi+2],al
				}
            addr+=4;
			}
	}
}


void LGradient(BYTE* dst,int r1,int g1,int b1,int r2,int g2,int b2)
{
int res_rgb;double c,rc;BYTE* adr;

adr=dst;
for (int y=0;y<tsize;y++)
	{
	c=y/((double)tsize);rc=1-c;
	res_rgb=(int)(r1*c+r2*rc)*256*256+
			(int)(g1*c+g2*rc)*256+
			(int)(b1*c+b2*rc);

		_asm{
			mov eax,res_rgb
			mov ebx,eax
			shr ebx,16

			mov ecx,tsize
			mov edi,adr
		lp:
			mov [edi],ax
			mov [edi+2],bl
			add edi,4
			loop lp
			}
		adr=adr+tsize*4;
	}
}

void DrwLetter(BYTE* dst,int p1,int x,int y)
{
	BYTE* srca,*dst2;
	//if (y<8) y=8;
	if (y>tsize-16) y=tsize-16;
	if (x>tsize-16) return;
	dst2=dst+x*4+y*tsize*4+16*tsize*4+16*4;
	srca=font+p1*32+5;
	_asm{
		mov esi,srca
		mov edi,dst2
		
		mov edx,tsize
		add edx,edx
		add edx,edx

		mov ecx,16
	lp2:
		mov bl,[esi+1]
			mov bh,[esi]
		push ecx
		push edi

		//mov bh,0xff
			mov ecx,16
		lp:
			mov ax,bx
			and al,1
			cmp al,1
			jnz ndrw
				mov al,255
				mov [edi],al
				mov [edi+1],al
				mov [edi+2],al
			ndrw:
				sub edi,4
			shr bx,1

			loop lp

			inc esi
			inc esi
		pop edi
		sub edi,edx
		pop ecx
		loop lp2
		}

}

/*void DrwTxt(BYTE* dst,int x,int y,int p1,char* txt)
{
	char a;
	x=x*tsize/256;y=y*tsize/256;
	memcpy(dst,dst-tsize*tsize*4,tsize*tsize*4);
	for (int t=0;t<255;t++)
		{
		a=*(txt+t);
		if (a==0) return;
		if (a==',') a=3;
		if (a=='.') a=2;
		if (a=='?') a=1;
		if (a=='!') a=0;
		if (a==' ') goto t;
		if (a>='0'&&a<='9') a=a-'0'+4;
		if (a>='A'&&a<='Z') a=a-'A'+4+10;
		DrwLetter(dst,a,x+t*p1,y);
		t:;
		}
}


*/
void DrwTxt(BYTE* dst,int x,int y,int p1,char* txt)
{
	char a;
	x=x*tsize/256;y=y*tsize/256;
	memcpy(dst,dst-tsize*tsize*4,tsize*tsize*4);
	for (int t=0;t<255;t++)
		{
		a=*(txt+t);
		if (a==0) return;
		if (a==',') a=3;
		if (a=='.') a=2;
		if (a=='?') a=1;
		if (a=='!') a=0;
		if (a==' ') goto t;
		if (a>='0'&&a<='9') a=a-'0'+4;
		if (a>='A'&&a<='Z') a=a-'A'+4+10;
		DrwLetter(dst,a,x+t*p1,y);
		t:;
		}
}



//
void Box(BYTE* dst,int x,int y,int xsz,int ysz,unsigned char r,unsigned char g,unsigned char b)
{
int tx,ty,a,color;
x=x-xsz/2;y=y-ysz/2;
x=x*tsize/255;y=y*tsize/255;
xsz=xsz*tsize/255;ysz=ysz*tsize/255;
color=b+(g<<8)+(r<<16);
memcpy(dst,dst-tsize*tsize*4,tsize*tsize*4);
for (ty=y;ty<(y+ysz);ty++)
for (tx=x;tx<(x+xsz);tx++)
	{
	a=ty*tsize*4+tx*4;
	if (tx>=0&&tx<tsize&&ty>=0&&ty<tsize)
		{
		_asm
			{
			mov edi,a
			mov edx,dst
			mov eax,[color]
			mov [edi+edx],ax
			shr eax,16
			add edi,2
			mov [edi+edx],al
			}
		}
	}
}


//953->609 by San
void Circle(BYTE* dst,int x,int y,int xsz,unsigned char r,unsigned char g,unsigned char b){
	memcpy(dst,dst-tsize*tsize*4,tsize*tsize*4);
	x=x*tsize/255;y=y*tsize/255;xsz=xsz*tsize/255;
	int x0, y0, x1, y1, xs, ys, shift, radsq;
	x0 = x-xsz; x1 = x+xsz;
	y0 = y-xsz; y1 = y+xsz;
	if ( x0<0 ) x0=0;
	if ( y0<0 ) y0=0;
	if ( x1>tsize ) x1 = tsize;
	if ( y1>tsize ) y1 = tsize;
	__asm{
		xor		eax, eax;
		mov		ah, r;
		mov		al, g;
		shl		eax, 8;
		mov		al, b;
		mov		esi, eax;// color
		mov		eax, xsz;
		mul		eax;
		mov		radsq, eax;
		mov		eax, x1;
		sub		eax, x0;
		mov		dword ptr[ xs ], eax;
		mov		eax, y1;
		sub		eax, y0;
		mov		dword ptr[ ys ], eax;
		mov		eax, tsize;
		mul		y0;
		add		eax, x0;
		shl		eax, 2;
		add		eax, dst;
		mov		edi, eax;// dst
		mov		eax, x;
		sub		dword ptr[ x0 ], eax;
		sub		dword ptr[ x1 ], eax;
		mov		eax, y;
		sub		dword ptr[ y0 ], eax;
		sub		dword ptr[ y1 ], eax;
		mov		eax, tsize;
		sub		eax, xs;
		shl		eax, 2;
		mov		shift, eax;
		mov		ebx, y0;
m0:		push	ebx;
		imul	ebx, ebx;
		mov		ecx, x0;
m1:		mov		eax, ecx;
		mul		eax;
		add		eax, ebx;
		cmp		eax, radsq;
		jnl		m2;
		//mov		dword ptr[ edi ], esi;
				mov edx,esi
				mov		[ edi ], dx;
				shr edx,8
				mov		[ edi+2 ], dh;
				//
m2:		add		edi, 4;
		inc		ecx;
		cmp		ecx, x1;
		jnge	m1;
		add		edi, shift;
		pop		ebx;
		inc		ebx;
		cmp		ebx, y1;
		jnge	m0;
	}
}

//1390->570 by San
void ChessField(BYTE *dst,int i,int j){
i=(i+1)*tsize/256;j=(j+1)*tsize/256;
	if ( i <= 0 ) i = 1;
	if ( j <= 0 ) j = 1;
	if ( i > tsize ) i = tsize;
	if ( j > tsize ) j = tsize;
	int rcol = 0;
	__asm{
		mov		esi, dst;
		mov		eax, dword ptr[ tsize ];
		mul		eax;
		mov		edi, eax;
		mov		ebx, i;
		mov		ecx, dword ptr[ tsize ];
		mov		edx, j;
		xor		eax, eax;
m0:		//mov		dword ptr[ esi ], eax;
		mov		[ esi ], ax;
		mov		[ esi+2], al;
		dec		ebx;
		jnz		m1;
		mov		ebx, i;
		not		eax;
m1:		dec		ecx;
		jnz		m3;
		mov		ebx, i;
		mov		ecx, dword ptr[ tsize ];
		dec		edx;
		jnz		m2;
		mov		edx, j;
		not		dword ptr[ rcol ];
m2:		mov		eax, dword ptr[ rcol ];
m3:		add		esi, 4;
		dec		edi;
		jnz		m0;
	}
}

//4800->2100 by San
void Plasm(BYTE *dst,int p1,int p2,int p3,int p4)
{
	float f1 = p1 / 64.0f;
	float f3 = p3 / 64.0f;
	float f2 = (float)p2;
	float f4 = (float)p4;
	float f635 = 63.5f;
	float f127 = 127.0f;
	float trash;
	int	col, x, y;
	int tt;
	tt=tsize;col=0x00ff00ff;
	__asm{
		finit;
		fild	tt;
		fldpi;
		fadd	st(0), st(0);
		fdiv	st(0), st(1);
		mov		edi, dst;
		mov		ecx, tt;
m1:		mov		dword ptr[ y ], ecx;
		fld		f3;
		fimul	y;
		fadd	f4;
		fmul	st(0), st(1);
		fsin;
		fmul	f635;
		mov		ebx, tt;
m0:		mov		dword ptr[ x ], ebx;
		fld		f1;
		fimul	x;
		fadd	f2;
		fmul	st(0), st(2);
		fsin;
		fmul	f635;
		fadd	st(0), st(1);
		fadd	f127;
		fistp	col;
		mov		eax, col;
		mov		ah, al;
			//shl		eax, 8;
			//mov		al, ah;
			mov		[edi], ax;
			mov		[edi+2], al;
		add		edi, 4;
		dec		ebx;
		jnz		m0;
		fstp	trash;
		loop	m1;
		fstp	trash;
	}
}



//--------------------------------------
//cells - 1st pass optimized by Shimara (x12.5)
//2 st pass by f0x - x2

int modul(int x){

if (x<0) return 0;
if (x>tsize) return tsize;
return x;
}

void Cells(BYTE *dst,long p1,long p2,long p3,long p4)
{
int x,y,u,y1,y2,ys1,ys2,ye1,ye2;int addr=0;
double xa[1024],tx,ty,x_ofs,y_ofs,prx;

double r;int jb;

p2=p2*tsize/256;p3=p3*256/tsize;
p4/=8;//max 32 particles
x_ofs=0;y_ofs=0;

for (x=0;x<p4*2;x++) xa[x]=p2*sin(((p1+1222)*x/50)*grt);

//  
x=tsize*tsize;
		_asm{
			mov ecx,x
			mov edi,dst
			mov eax,0xffffffff
		 lp:mov [edi],ax
			mov [edi+2],al
			add edi,4
			loop lp
			}

//  
if (p3<=10) r=tsize; else r=32*255/p3;

//     
for (u=0;u<p4;u++){
	x_ofs=xa[u];y_ofs=xa[u+4];
	tx=tsize/2-x_ofs;
	ty=tsize/2-y_ofs;
	if (tx>(tsize-1)) tx=tx-(tsize-1);if (tx<0) tx=tx+(tsize-1);
	if (ty>(tsize-1)) ty=ty-(tsize-1);if (ty<0) ty=ty+(tsize-1);

//  (tx,ty) - ,  
	for (x=modul(tx-r);x<modul(tx+r);x++)
		{prx=(x-tx+1)*(x-tx+1);

		ys1=sqrt(r*r-prx);
		y1=ys1+ty;
		y2=-ys1+ty;
		
		ys1=modul(y2+1);
		ys2=modul(ty+1);
		ye1=modul(ty);
		ye2=modul(y1);

		addr=x*tsize*4+ys1*4;
		for (y=ys1;y<=ye1;y++)
			{
			jb=sqrt(prx+(y-ty)*(y-ty))*p3;
				_asm{
					mov ebx,jb
					shr bx,5
					mov edi,dst
					mov edx,addr
					add edi,edx
				
					mov al,[edi]
					cmp al,bl
					jb zz2
					mov al,bl
				zz2:
					mov ah,al
					mov [edi+0],ax
					mov [edi+2],al
					}
				addr+=4;
			}


		for (y=ys2;y<=ye2;y++)
			{
			jb=sqrt(prx+(y-ty)*(y-ty))*p3;
				
				_asm{
					mov ebx,jb
					shr bx,5
					mov edi,dst
					mov edx,addr
					add edi,edx
				
					mov al,[edi]
					cmp al,bl
					jb zz1
					mov al,bl
				zz1:
					mov ah,al
					mov [edi+0],ax
					mov [edi+2],al
					}
				addr+=4;
			}
		}
}

}
//--

//----------------------------------------------
int iJulia(float x0,float y0,float a,float b)
{
  float x,y,x2,y2,xy;
  float r;
  float k;
  r=1;
  
  x=x0; y=y0;
  k=120;
  while ((k>0) && (r<4))
  {
    x2=x*x;
    y2=y*y;
    xy=x*y;
    x=x2-y2+a;
    y=2*xy+b;
    r=x2+y2;
    k--;
  }
  k=(k/120)*255;
  return (int)k;
}

void Julia(BYTE *dst,long p1,long p2)
{
int x,y,addr1;
int a;
int mx,my; mx=my=tsize;

p1=p1*20;p2=p2*20;

  for (y=0;y<tsize;y++)
  {
    for (x=0;x<tsize;x++)
	{
	a=255-iJulia((float)x/mx,(float)y/my,(float)(-p1*0.000125), (float)(-p2*0.000125));
    if (a>255) a=255;if (a<0) a=0;

    addr1=x*4+y*4*tsize;
	_asm{
			mov eax,a
			mov ah,al
			mov edi,addr1
			mov edx,dst
			mov [edi+edx],ax
			add edi,2
			mov [edi+edx],al
		}

	}
  }
}

//---------------------------------------------
void AddStars(BYTE* dst,int howmuch,int lightness)
{
int x,y;
memcpy(dst,dst-tsize*tsize*4,tsize*tsize*4);
for (int i=0;i<howmuch;i++)
	{
	//x=rand()%255;y=rand()%255;
	x=32768*sin(i);y=32768*cos(i);
	x=x&0xff;y=y&0xff;
	x=x*tsize/256;y=y*tsize/256;
	_rgb=(lightness<<16)+(lightness<<8)+lightness;
	place_rgb(dst,x,y);
	}
}


float Iter_MB(float xx,float yy,float sqr_betrag)
{
 float zx,zy,szx,szy;
 float res=255.0;
   zx=xx;
   zy=yy;
   
  for (int i=0;i<256;i++)
  {
    szx=zx*zx;
    szy=zy*zy;
    if ((szx+szy)>sqr_betrag) {return (float)i;}
    zy=(float)(2.0*zx*zy + yy);
    zx=szx-szy + xx;
  }
   
  return res;
}

void Mandelbrot(BYTE *dst,long p1,long p2,long p3,long p4)
{
  p1*=10;p2*=10;p3*=10;p4*=10;

  float x,r,tx,ty,base_off;
  float ux,uy;
  int addr1,rr;
  double dx,xs,y,dy,sqr_betrag;
  xs=p1*0.000125-0.777;
  dx=p2*0.000125;
  y=p3*0.000125-0.777;
  dy=p4*0.000125;
  sqr_betrag=16;
  
  ux=(float)dx/(float)tsize;
  uy=(float)dy/(float)tsize;
  base_off=0;
  for (ty=0;ty<tsize;ty++)
  {
    x=(float)xs;
    for (tx=base_off;tx<(base_off+(float)tsize);tx++)
    {
    r=Iter_MB(x,(float)y,(float)sqr_betrag);
    
	rr=(int)r;
	    addr1=tx*4+ty*4*tsize;
	
	_asm{
			mov eax,rr
			mov ah,al
			mov edi,addr1
			mov edx,dst
			mov [edi+edx],ax
			add edi,2
			mov [edi+edx],al
		}

    x+=ux;
    }
    y+=uy;
  }

}


void AddNoise(BYTE *dst,int amp)
{
int x,y,u;
memcpy(dst,dst-tsize*tsize*4,tsize*tsize*4);
for (y=0;y<tsize*tsize;y++)
	{
		u=32768*sin(y*97)*sin(y*47)*sin(y*22);u=u&0xff;
		u=u*amp/255;
		_rgb=(u<<16)+(u<<8)+u;
		add_rgb(dst,y,0);
	}
}


/*
//--------bezier code

void bz2(BYTE* dst,double x,double y,
		           double x0,double y0,
				   double x1,double y1,
				   double x2,double y2,
				   int p1,int p2,int p3,int p4,int p5,int p6,int index)
{
double i;
double Step,t,q1,q2,q3,q4,qx,qy,tx,ty;
int hmp,ba;
double dens;
dens=(256-p3)/256.0;
if (dens<0.0001) dens=0.0001;
if (dens>1) dens=1;

ba=crt_tex*256*100*4+ccl[crt_tex]*100*4;
hmp=peekb(bezier_bank+ba)/3;
if (hmp<1) hmp=1;

double cr_fat;
	//cr_fat=p2*index/(double)(hmp);
for (i=0;i<1;i+=dens)
	{
	t=i;
	//    q1,q2,q3,q4  
	q1 = t*t*t*-1 + t*t*3 + t*(-3) + 1;
	q2 = t*t*t*3 + t*t*(-6) + t*3;
	q3 = t*t*t*(-3) + t*t*3;
	q4 = t*t*t;
	//     
	qx = q1*x + q2*x0 + q3*x1 + q4*x2;  
	qy = q1*y + q2*y0 + q3*y1 + q4*y2;  
	//addpoint2(dst,qx,qy,p2,255,255,255);
	if (p1==0) addpoint2(dst,qx,qy,p2,p4,p5,p6);
	if (p1==1) addpoint2(dst,qx,qy,p2*(index+i)/(double)hmp,p4,p5,p6);
	if (p1==2) addpoint2(dst,qx,qy,p2*(hmp-index+(1-i)-1)/(double)hmp,p4,p5,p6);
	if (p1==3) 
		{
		cr_fat=p2*(cos(((index+i)/(hmp))*3.14-3.14/2));
		addpoint2(dst,qx,qy,cr_fat,p4,p5,p6);
		}

		q:;
	
	}
}


void bezier(BYTE* dst,int ba,int p1,int p2,int p3,int p4,int p5,int p6)
{
int c,i;
c=peekb (bezier_bank+ba);
for (i=0;i<(c-3);i+=3)
	{
	bz2(dst,
		peekb (bezier_bank+ba+i*2+1),
	    peekb (bezier_bank+ba+i*2+2),
	    peekb (bezier_bank+ba+i*2+3),
	    peekb (bezier_bank+ba+i*2+4),
	    peekb (bezier_bank+ba+i*2+5),
	    peekb (bezier_bank+ba+i*2+6),
	    peekb (bezier_bank+ba+i*2+7),
	    peekb (bezier_bank+ba+i*2+8),
	    p1,p2,p3,p4,p5,p6,i/3);
	}

}

//-linepath code
void linepath(BYTE* dst,int ba,int p1,int p2,int p3,int p4,int p5,int p6)
{
int hmp,apb,i,kx,ky,kx1,ky1,kx2,ky2,k;double cr_fat;
hmp=peekb(point_bank+ba);

for (i=0;i<hmp-1;i++)
	{
	kx1=peekb(i*2+point_bank+ba+1);ky1=peekb(i*2+2+point_bank+ba);
	kx2=peekb(i*2+point_bank+ba+1+2);ky2=peekb(i*2+2+point_bank+ba+2);
	  for (k=0;k<255;k+=(256-p3))
		{
		kx=kx1*k/256+kx2*(256-k)/256;
		ky=ky1*k/256+ky2*(256-k)/256;
		if (p1==0) addpoint2(dst,kx,ky,p2,p4,p5,p6);
		if (p1==1) addpoint2(dst,kx,ky,p2*(i+(1-k/255.0))/hmp,p4,p5,p6);
		if (p1==2) addpoint2(dst,kx,ky,p2*(hmp-i+k/255.0-2)/hmp,p4,p5,p6);
		if (p1==3) 
			{
			cr_fat=p2*(cos((((double)(i+(255-k)/255.0+0.5))/(double)(hmp))*3.14-3.14/2)-.25);
			if (cr_fat<0) cr_fat=0;
			addpoint2(dst,kx,ky,cr_fat,p4,p5,p6);
			}
		}

	}
}
*/