#define WM_MOUSEWHEEL                   0x020A

#include <stdio.h>

// 
BYTE *texture_bank,*texture_tmp,*texture_swp;//    TextureWProc

int tfunc_count=0;
int tst=0;//  ?

typedef struct {int fnum,p[10];char txt[32];} _log;

_log tx_log[255][255];
_log tmp_tx_log[255][255];
int tsize_store[255];
int tmp_tsize_store[255];
int store_texture_stagenum=0;
int change_flag=0;

int twf=0;

int current_texture=0;
int texture_stagenum=1;//history - current log position



#include "t_service.h"
#include "t_generators.h"
#include "t_filters.h"
#include "t_color.h"


int texture_addrinfo[256];
int texture_size[256];
int tmp_texture_size[256];
int texture_type[256];
int tmp_texture_type[256];
char texture_name[256][100];
char tmp_texture_name[256][100];
int texture_stagenums[256];
int tmp_texture_stagenums[256];
int t_viewzoom=64;
int t_viewroll=0;

int tsize_table[7]={32,64,128,256,512,1024,2048};

int LastGen;

//      
HWND Texture_UIDlg;
BOOL CALLBACK _export TextureUIProc(HWND, UINT, WPARAM, LPARAM);

HWND Texture_WDlg;
LRESULT CALLBACK TextureWProc (HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);

HDC mainDC;//  dc     

void draw_tw();

// 
void TextureUI_init()
{
//    
static DLGPROC lpfnDlgProc;
lpfnDlgProc = (DLGPROC)MakeProcInstance((FARPROC)TextureUIProc, hInst);
Texture_UIDlg = CreateDialog(hInst, MAKEINTRESOURCE(IDD_TEXTUREGEN),Parent_hWnd, lpfnDlgProc);

}

//  (, , )
//   7
typedef struct {LPCTSTR fname;
				int numparams;
				LPCTSTR pdesc[9];
				int defvalue[9];} fdesc;

fdesc tx_gens[100],tx_gens_backup[100];


#include "t_anim.h"

typedef struct {int pdesc,pslider,pplus,pminus,pnumview;} param_ctrls;
param_ctrls TUI_param_ctrls[9];

void exec_func(HWND hDlg,int i)
{
int j;int p[9];BYTE* Mptr;
if (i<0||i>=tfunc_count) goto exit;
if (*(tx_gens[i].fname)==':') goto exit;//   :  

//get params to p[j]
for (j=1;j<=tx_gens[i].numparams;j++)
	{
	p[j]=SendDlgItemMessage (hDlg,TUI_param_ctrls[j].pslider,TBM_GETPOS,0,0);
	SetDlgItemInt(hDlg,TUI_param_ctrls[j].pnumview,p[j],FALSE);
	}

Mptr=texture_tmp+texture_stagenum*tsize*tsize*4;

//process functions
if (tx_gens[i].fname=="Cells")		Cells			(Mptr,p[1],p[2],p[3],p[4]);
if (tx_gens[i].fname=="Plasm")		Plasm			(Mptr,p[1],p[2],p[3],p[4]);
if (tx_gens[i].fname=="ChessField")	ChessField		(Mptr,p[1],p[2]);
if (tx_gens[i].fname=="Mandelbrot")	Mandelbrot		(Mptr,p[1],p[2],p[3],p[4]);
if (tx_gens[i].fname=="Julia")		Julia			(Mptr,p[1],p[2]);
if (tx_gens[i].fname=="List")		List			(Mptr,p[1],p[2],p[3],p[4],p[5],p[6],p[7]);
if (tx_gens[i].fname=="Clouds")		Clouds			(Mptr,p[1],p[2],p[3]);
if (tx_gens[i].fname=="LGradient") LGradient		(Mptr,p[1],p[2],p[3],p[4],p[5],p[6]);
if (tx_gens[i].fname=="RenderScene") RenderScene	(Mptr,p[1],p[2]);
//if (tx_gens[i].fname=="Beizer") Beizer(Mptr,p[1],p[2]);
if (tx_gens[i].fname=="Box")		Box				(Mptr,p[1],p[2],p[3],p[4],p[5],p[6],p[7]);
if (tx_gens[i].fname=="Circle")		Circle			(Mptr,p[1],p[2],p[3],p[4],p[5],p[6]);
if (tx_gens[i].fname=="AddParticle")AddParticle		(Mptr,p[1],p[2],p[3],p[4],p[5],p[6],p[7]);
if (tx_gens[i].fname=="AddSprite")	AddSprite		(Mptr,p[1],p[2],p[3],p[4],p[5]);
if (tx_gens[i].fname=="DrwTxt")		DrwTxt			(Mptr,p[1],p[2],p[3],tx_log[current_texture][texture_stagenum].txt);
if (tx_gens[i].fname=="SolidFill") 	SolidFill		(Mptr,p[1],p[2],p[3],p[4],p[5],p[6]);
if (tx_gens[i].fname=="AddNoise")	AddNoise		(Mptr,p[1]);
if (tx_gens[i].fname=="AddStars")	AddStars		(Mptr,p[1],p[2]);
if (tx_gens[i].fname=="SinDistort")	SinDistort		(Mptr,p[1],p[2],p[3],p[4]);
if (tx_gens[i].fname=="Twirl")		Twirl			(Mptr,p[1],p[2],p[3],p[4],p[5]);
if (tx_gens[i].fname=="Lenz")		Lenz			(Mptr,p[1],p[2],p[3],p[4]);
if (tx_gens[i].fname=="Blur")		Blur			(Mptr,p[1],p[2]);
if (tx_gens[i].fname=="MotionBlur")	MotionBlur		(Mptr,p[1],p[2]);
if (tx_gens[i].fname=="RadialBlur")	RadialBlur		(Mptr,p[1],p[2]);
if (tx_gens[i].fname=="Sharpen")	Sharpen			(Mptr);
if (tx_gens[i].fname=="PShift")		PShift			(Mptr,p[1],p[2],p[3],p[4]);
if (tx_gens[i].fname=="RadialPShift")RadialPShift	(Mptr,p[1],p[2],p[3],p[4]);
if (tx_gens[i].fname=="Map2dPShift") 
	{
	if (p[1]<1) p[1]=1;
	if (p[1]>(texture_stagenum-1)) p[1]=texture_stagenum-1;
	SendDlgItemMessage(hDlg,TUI_param_ctrls[1].pslider,TBM_SETPOS,TRUE,(LPARAM) p[1]);	
	SetDlgItemInt(hDlg,TUI_param_ctrls[1].pnumview,p[1],FALSE);	
	Map2dPShift(Mptr,p[1],p[2],p[3]);
	}
if (tx_gens[i].fname=="Map2dPShift2") 
	{
	if (p[1]<1) p[1]=1;
	if (p[1]>(texture_stagenum-1)) p[1]=texture_stagenum-1;
	SendDlgItemMessage(hDlg,TUI_param_ctrls[1].pslider,TBM_SETPOS,TRUE,(LPARAM) p[1]);	
	SetDlgItemInt(hDlg,TUI_param_ctrls[1].pnumview,p[1],FALSE);	
	Map2dPShift2(Mptr,p[1],p[2],p[3],p[4],p[5]);
	}

if (tx_gens[i].fname=="Median")		Median			(Mptr);
if (tx_gens[i].fname=="Dilate")		Dilate			(Mptr);
if (tx_gens[i].fname=="Erode")		Erode			(Mptr);
if (tx_gens[i].fname=="Edge")		Edge			(Mptr);
if (tx_gens[i].fname=="Emboss")		Emboss			(Mptr);
if (tx_gens[i].fname=="RotorZoom")	RotorZoom		(Mptr,p[1],p[2],p[3],p[4],p[5],p[6]);
if (tx_gens[i].fname=="Roll")		Roll			(Mptr,p[1],p[2],p[3]);
if (tx_gens[i].fname=="Tiling")		Tiling			(Mptr,p[1],p[2],p[3],p[4]);
if (tx_gens[i].fname=="Mozaic")		Mozaic			(Mptr,p[1]);
if (tx_gens[i].fname=="Mixer")	
	{	
	if (p[1]<1) p[1]=1;
	if (p[2]<1) p[2]=1;
	if (p[1]>(texture_stagenum-1)) p[1]=texture_stagenum-1;
	if (p[2]>(texture_stagenum-1)) p[2]=texture_stagenum-1;
	SendDlgItemMessage(hDlg,TUI_param_ctrls[1].pslider,TBM_SETPOS,TRUE,(LPARAM) p[1]);	
	SendDlgItemMessage(hDlg,TUI_param_ctrls[2].pslider,TBM_SETPOS,TRUE,(LPARAM) p[2]);	
	SetDlgItemInt(hDlg,TUI_param_ctrls[1].pnumview,p[1],FALSE);	
	SetDlgItemInt(hDlg,TUI_param_ctrls[2].pnumview,p[2],FALSE);	
	Mixer(Mptr,p[1],p[2],p[3],p[4],p[5]);
	}
if (tx_gens[i].fname=="CrossFade")	CrossFade		(Mptr,p[1],p[2]);
if (tx_gens[i].fname=="Clear")		Clear			(Mptr);
if (tx_gens[i].fname=="ClearRGB") 	ClearRGB		(Mptr);
if (tx_gens[i].fname=="CopyBlueToAlfa") CopyBlueToAlfa(Mptr);
if (tx_gens[i].fname=="ClearAlfa")	ClearAlfa		(Mptr);
if (tx_gens[i].fname=="InvertAlfa")	InvertAlfa		(Mptr);
if (tx_gens[i].fname=="Invert")		Invert			(Mptr);
if (tx_gens[i].fname=="ScaleColor")	ScaleColor		(Mptr,p[1],p[2],p[3]);
if (tx_gens[i].fname=="AdjustColor")AdjustColor		(Mptr,p[1],p[2],p[3]);
if (tx_gens[i].fname=="SinColor")	SinColor		(Mptr,p[1],p[2],p[3],p[4]);
if (tx_gens[i].fname=="SetTxBase")	SetTxBase		(p[1],p[2],p[3],p[4],p[5],p[7],p[7]);
if (tx_gens[i].fname=="SetTxAmp")	SetTxAmp		(p[1],p[2],p[3],p[4],p[5],p[7],p[7]);
if (tx_gens[i].fname=="SetTxSpd")	SetTxSpd		(p[1],p[2],p[3],p[4],p[5],p[7],p[7]);
if (tx_gens[i].fname=="SetTxFz")	SetTxFz			(p[1],p[2],p[3],p[4],p[5],p[7],p[7]);
if (tx_gens[i].fname=="SinAnimP")	SinAnimP		(p[1]);
if (tx_gens[i].fname=="AbsSinAnimP")AbsSinAnimP		(p[1]);
if (tx_gens[i].fname=="CycleAnimP")	CycleSinAnimP	(p[1]);
if (tx_gens[i].fname=="LoadTGA")	LoadTGA(Mptr,texture_name[current_texture]);
if (tx_gens[i].fname=="Empty")		memcpy			(Mptr,Mptr-tsize*tsize*4,tsize*tsize*4);

exit:;
}

void pload(HWND hDlg,int i)
{
if (tx_gens[i].fname!="::Generators"&&
	tx_gens[i].fname!="::Geometry"&&
	tx_gens[i].fname!="::Filters"&&
	tx_gens[i].fname!="::Color")
	{
	SetDlgItemText(hDlg,fn,tx_gens[i].fname);
	for (int j=1;j<=tx_gens[i].numparams;j++)
		{
		SendDlgItemMessage(hDlg,TUI_param_ctrls[j].pslider,TBM_SETPOS,TRUE,(LPARAM) tx_gens[i].defvalue[j-1]);
		SetDlgItemInt(hDlg,TUI_param_ctrls[j].pnumview,tx_gens[i].defvalue[j-1],FALSE);
		SetDlgItemText(hDlg,TUI_param_ctrls[j].pdesc,tx_gens[i].pdesc[j-1]);
		ShowWindow(GetDlgItem(hDlg,TUI_param_ctrls[j].pslider),TRUE);
		ShowWindow(GetDlgItem(hDlg,TUI_param_ctrls[j].pdesc),TRUE);
		ShowWindow(GetDlgItem(hDlg,TUI_param_ctrls[j].pnumview),TRUE);
		ShowWindow(GetDlgItem(hDlg,TUI_param_ctrls[j].pminus),TRUE);
		ShowWindow(GetDlgItem(hDlg,TUI_param_ctrls[j].pplus),TRUE);
		}
	}
}

void pload_from_tx_log(HWND hDlg,int i)
{
if (tx_gens[i].fname!="::Generators"&&
	tx_gens[i].fname!="::Geometry"&&
	tx_gens[i].fname!="::Filters"&&
	tx_gens[i].fname!="::Color")
	{
	SetDlgItemText(hDlg,fn,tx_gens[i].fname);
	for (int j=1;j<=tx_gens[i].numparams;j++)
		{
		SendDlgItemMessage(hDlg,TUI_param_ctrls[j].pslider,TBM_SETPOS,TRUE,(LPARAM) tx_log[current_texture][texture_stagenum].p[j]);
		SetDlgItemInt(hDlg,TUI_param_ctrls[j].pnumview,tx_log[current_texture][texture_stagenum].p[j],FALSE);
		SetDlgItemText(hDlg,TUI_param_ctrls[j].pdesc,tx_gens[i].pdesc[j-1]);
		ShowWindow(GetDlgItem(hDlg,TUI_param_ctrls[j].pslider),TRUE);
		ShowWindow(GetDlgItem(hDlg,TUI_param_ctrls[j].pdesc),TRUE);
		ShowWindow(GetDlgItem(hDlg,TUI_param_ctrls[j].pnumview),TRUE);
		ShowWindow(GetDlgItem(hDlg,TUI_param_ctrls[j].pminus),TRUE);
		ShowWindow(GetDlgItem(hDlg,TUI_param_ctrls[j].pplus),TRUE);
		}
	}	
}


void TUI_hide_param_ctrls(HWND hDlg)
{
	// 
	for (int i=1;i<=7;i++)
	{
	ShowWindow(GetDlgItem(hDlg,TUI_param_ctrls[i].pdesc),FALSE);
	ShowWindow(GetDlgItem(hDlg,TUI_param_ctrls[i].pminus),FALSE);
	ShowWindow(GetDlgItem(hDlg,TUI_param_ctrls[i].pplus),FALSE);
	ShowWindow(GetDlgItem(hDlg,TUI_param_ctrls[i].pnumview),FALSE);
	ShowWindow(GetDlgItem(hDlg,TUI_param_ctrls[i].pslider),FALSE);
	}
	SetDlgItemText(hDlg,fn,"");
}

//   , 
void TUI_statics(HWND hDlg)
{
SendDlgItemMessage(hDlg,IDC_COMBO1,CB_RESETCONTENT,0,0);
for (int p=0;p<6;p++) {_itoa(tsize_table[p],r_string,10);SendDlgItemMessage(hDlg,IDC_COMBO1,CB_ADDSTRING,0,(LPARAM) (LPCTSTR)r_string);}
SendDlgItemMessage(hDlg,IDC_COMBO1,CB_SETCURSEL,0,0);

TCITEM tie; 
tie.mask = TCIF_TEXT | TCIF_IMAGE; 
tie.iImage = -1; 
tie.pszText = "Color";TabCtrl_InsertItem(GetDlgItem(hDlg,IDC_TAB1), 0, &tie);
tie.pszText = "Filters";TabCtrl_InsertItem(GetDlgItem(hDlg,IDC_TAB1), 0, &tie);
tie.pszText = "Geometry";TabCtrl_InsertItem(GetDlgItem(hDlg,IDC_TAB1), 0, &tie);
tie.pszText = "Generators";TabCtrl_InsertItem(GetDlgItem(hDlg,IDC_TAB1), 0, &tie);

SendDlgItemMessage(hDlg,IDC_LIST2,LB_SETCURSEL,32,0);
TabCtrl_SetCurSel(GetDlgItem(hDlg,IDC_TAB1),0);
int tgi;
tgi=0;
tx_gens[tgi].fname="::Generators";tx_gens[tgi].numparams=0;
tgi++;
tx_gens[tgi].fname="Cells";tx_gens[tgi].numparams=4;
tx_gens[tgi].pdesc[0]="alfa";tx_gens[tgi].defvalue[0]=166;
tx_gens[tgi].pdesc[1]="density";tx_gens[tgi].defvalue[1]=233;
tx_gens[tgi].pdesc[2]="brightness";tx_gens[tgi].defvalue[2]=166;
tx_gens[tgi].pdesc[3]="complexity";tx_gens[tgi].defvalue[3]=233;
tgi++;
tx_gens[tgi].fname="Plasm";tx_gens[tgi].numparams=4;
tx_gens[tgi].pdesc[0]="freq x";tx_gens[tgi].defvalue[0]=255;
tx_gens[tgi].pdesc[1]="disp x";tx_gens[tgi].defvalue[1]=0;
tx_gens[tgi].pdesc[2]="freq y";tx_gens[tgi].defvalue[2]=255;
tx_gens[tgi].pdesc[3]="disp y";tx_gens[tgi].defvalue[3]=0;
tgi++;
tx_gens[tgi].fname="ChessField";tx_gens[tgi].numparams=2;
tx_gens[tgi].pdesc[0]="cells by x";tx_gens[tgi].defvalue[0]=128;
tx_gens[tgi].pdesc[1]="cells by y";tx_gens[tgi].defvalue[1]=128;
tgi++;
tx_gens[tgi].fname="Mandelbrot";tx_gens[tgi].numparams=4;
tx_gens[tgi].pdesc[0]="x";tx_gens[tgi].defvalue[0]=164;
tx_gens[tgi].pdesc[1]="zoom by x";tx_gens[tgi].defvalue[1]=22;
tx_gens[tgi].pdesc[2]="y";tx_gens[tgi].defvalue[2]=164;
tx_gens[tgi].pdesc[3]="zoom by y";tx_gens[tgi].defvalue[3]=13;
tgi++;
tx_gens[tgi].fname="Julia";tx_gens[tgi].numparams=2;
tx_gens[tgi].pdesc[0]="p 1";tx_gens[tgi].defvalue[0]=183;
tx_gens[tgi].pdesc[1]="p 2";tx_gens[tgi].defvalue[1]=231;
tgi++;

tx_gens[tgi].fname="List";tx_gens[tgi].numparams=7;
tx_gens[tgi].pdesc[0]="type (0-2)";tx_gens[tgi].defvalue[0]=0;
tx_gens[tgi].pdesc[1]="iterations";tx_gens[tgi].defvalue[1]=64;
tx_gens[tgi].pdesc[2]="p1";tx_gens[tgi].defvalue[2]=64;
tx_gens[tgi].pdesc[3]="p2";tx_gens[tgi].defvalue[3]=64;
tx_gens[tgi].pdesc[4]="p3";tx_gens[tgi].defvalue[4]=64;
tx_gens[tgi].pdesc[5]="p4";tx_gens[tgi].defvalue[5]=64;
tx_gens[tgi].pdesc[6]="p5";tx_gens[tgi].defvalue[6]=64;
tgi++;

tx_gens[tgi].fname="Clouds";tx_gens[tgi].numparams=3;
tx_gens[tgi].pdesc[0]="scale";tx_gens[tgi].defvalue[0]=32;
tx_gens[tgi].pdesc[1]="rnd-ofs";tx_gens[tgi].defvalue[1]=32;
tx_gens[tgi].pdesc[2]="layers";tx_gens[tgi].defvalue[2]=32;
tgi++;

tx_gens[tgi].fname="LGradient";
tx_gens[tgi].numparams=6;
tx_gens[tgi].defvalue[0]=0;tx_gens[tgi].pdesc[0]="r1";
tx_gens[tgi].defvalue[1]=0;tx_gens[tgi].pdesc[1]="g1";
tx_gens[tgi].defvalue[2]=0;tx_gens[tgi].pdesc[2]="b1";
tx_gens[tgi].defvalue[3]=255;tx_gens[tgi].pdesc[3]="r2";
tx_gens[tgi].defvalue[4]=255;tx_gens[tgi].pdesc[4]="g2";
tx_gens[tgi].defvalue[5]=255;tx_gens[tgi].pdesc[5]="b2";
tgi++;

tx_gens[tgi].fname="RenderScene";
tx_gens[tgi].numparams=2;
tx_gens[tgi].defvalue[0]=0;tx_gens[tgi].pdesc[0]="scene-id";
tx_gens[tgi].defvalue[1]=0;tx_gens[tgi].pdesc[1]="cam-id";
tgi++;

LastGen=tgi-1;

tx_gens[tgi].fname="::Geometry";tx_gens[tgi].numparams=0;
tgi++;

//tx_gens[tgi].fname="Beizer";
//tx_gens[tgi].numparams=0;
//tgi++;

tx_gens[tgi].fname="Box";
tx_gens[tgi].numparams=7;
tx_gens[tgi].defvalue[0]=0;tx_gens[tgi].pdesc[0]="x";
tx_gens[tgi].defvalue[1]=0;tx_gens[tgi].pdesc[1]="y";
tx_gens[tgi].defvalue[2]=32;tx_gens[tgi].pdesc[2]="width";
tx_gens[tgi].defvalue[3]=32;tx_gens[tgi].pdesc[3]="heith";
tx_gens[tgi].defvalue[4]=128;tx_gens[tgi].pdesc[4]="r";
tx_gens[tgi].defvalue[5]=128;tx_gens[tgi].pdesc[5]="g";
tx_gens[tgi].defvalue[6]=128;tx_gens[tgi].pdesc[6]="b";
tgi++;
tx_gens[tgi].fname="Circle";
tx_gens[tgi].numparams=6;
tx_gens[tgi].defvalue[0]=0;tx_gens[tgi].pdesc[0]="x";
tx_gens[tgi].defvalue[1]=0;tx_gens[tgi].pdesc[1]="y";
tx_gens[tgi].defvalue[2]=32;tx_gens[tgi].pdesc[2]="rad";
tx_gens[tgi].defvalue[3]=128;tx_gens[tgi].pdesc[3]="r";
tx_gens[tgi].defvalue[4]=128;tx_gens[tgi].pdesc[4]="g";
tx_gens[tgi].defvalue[5]=128;tx_gens[tgi].pdesc[5]="b";
tgi++;
tx_gens[tgi].fname="AddParticle";
tx_gens[tgi].numparams=7;
tx_gens[tgi].defvalue[0]=128;tx_gens[tgi].pdesc[0]="x";
tx_gens[tgi].defvalue[1]=128;tx_gens[tgi].pdesc[1]="y";
tx_gens[tgi].defvalue[2]=255;tx_gens[tgi].pdesc[2]="r";
tx_gens[tgi].defvalue[3]=255;tx_gens[tgi].pdesc[3]="g";
tx_gens[tgi].defvalue[4]=255;tx_gens[tgi].pdesc[4]="b";
tx_gens[tgi].defvalue[5]=128;tx_gens[tgi].pdesc[5]="rad";
tx_gens[tgi].defvalue[6]=255;tx_gens[tgi].pdesc[6]="fade-out";
tgi++;

tx_gens[tgi].fname="AddSprite";
tx_gens[tgi].numparams=5;
tx_gens[tgi].defvalue[0]=128;tx_gens[tgi].pdesc[0]="x";
tx_gens[tgi].defvalue[1]=128;tx_gens[tgi].pdesc[1]="y";
tx_gens[tgi].defvalue[2]=1;tx_gens[tgi].pdesc[2]="stage-num";
tx_gens[tgi].defvalue[3]=128;tx_gens[tgi].pdesc[3]="rad";
tx_gens[tgi].defvalue[4]=128;tx_gens[tgi].pdesc[4]="rotation";
tgi++;

tx_gens[tgi].fname="DrwTxt";
tx_gens[tgi].numparams=3;
tx_gens[tgi].defvalue[0]=0;tx_gens[tgi].pdesc[0]="x";
tx_gens[tgi].defvalue[1]=0;tx_gens[tgi].pdesc[1]="y";
tx_gens[tgi].defvalue[2]=14;tx_gens[tgi].pdesc[2]="kerning";
tgi++;

tx_gens[tgi].fname="::Filters";tx_gens[tgi].numparams=0;
tgi++;
tx_gens[tgi].fname="SolidFill";
tx_gens[tgi].numparams=6;
tx_gens[tgi].defvalue[0]=126;tx_gens[tgi].pdesc[0]="x";
tx_gens[tgi].defvalue[1]=126;tx_gens[tgi].pdesc[1]="y";
tx_gens[tgi].defvalue[2]=255;tx_gens[tgi].pdesc[2]="r";
tx_gens[tgi].defvalue[3]=255;tx_gens[tgi].pdesc[3]="g";
tx_gens[tgi].defvalue[4]=255;tx_gens[tgi].pdesc[4]="b";
tx_gens[tgi].defvalue[5]=1;tx_gens[tgi].pdesc[5]="color range";
tgi++;
tx_gens[tgi].fname="AddNoise";tx_gens[tgi].numparams=1;
tx_gens[tgi].pdesc[0]="amp";tx_gens[tgi].defvalue[0]=255;
tgi++;
tx_gens[tgi].fname="AddStars";tx_gens[tgi].numparams=2;
tx_gens[tgi].pdesc[0]="count";tx_gens[tgi].defvalue[0]=255;
tx_gens[tgi].pdesc[1]="brightness";tx_gens[tgi].defvalue[1]=255;
tgi++;

tx_gens[tgi].fname="SinDistort";tx_gens[tgi].numparams=2;
tx_gens[tgi].numparams=4;tx_gens[tgi].defvalue[0]=0;
tx_gens[tgi].pdesc[0]="amp x";	tx_gens[tgi].defvalue[1]=0;
tx_gens[tgi].pdesc[1]="freq x";tx_gens[tgi].defvalue[2]=0;
tx_gens[tgi].pdesc[2]="amp y";tx_gens[tgi].defvalue[3]=0;
tx_gens[tgi].pdesc[3]="freq y";
tgi++;
tx_gens[tgi].fname="Twirl";
tx_gens[tgi].numparams=5;
tx_gens[tgi].defvalue[0]=128;tx_gens[tgi].pdesc[0]="x";
tx_gens[tgi].defvalue[1]=128;tx_gens[tgi].pdesc[1]="y";
tx_gens[tgi].defvalue[2]=128;tx_gens[tgi].pdesc[2]="rotation";
tx_gens[tgi].defvalue[3]=192;tx_gens[tgi].pdesc[3]="force";
tx_gens[tgi].defvalue[4]=64;tx_gens[tgi].pdesc[4]="rad";
tgi++;
tx_gens[tgi].fname="Lenz";
tx_gens[tgi].numparams=4;
tx_gens[tgi].defvalue[0]=128;tx_gens[tgi].pdesc[0]="x";
tx_gens[tgi].defvalue[1]=128;tx_gens[tgi].pdesc[1]="y";
tx_gens[tgi].defvalue[2]=192;tx_gens[tgi].pdesc[2]="force";
tx_gens[tgi].defvalue[3]=64;tx_gens[tgi].pdesc[3]="rad";
tgi++;

tx_gens[tgi].fname="Blur";
tx_gens[tgi].numparams=2;
tx_gens[tgi].defvalue[0]=1;tx_gens[tgi].pdesc[0]="blur";
tx_gens[tgi].defvalue[1]=0;tx_gens[tgi].pdesc[1]="add.brightness";
tgi++;
tx_gens[tgi].fname="MotionBlur";
tx_gens[tgi].numparams=2;
tx_gens[tgi].defvalue[0]=1;tx_gens[tgi].pdesc[0]="blur";
tx_gens[tgi].defvalue[1]=0;tx_gens[tgi].pdesc[1]="add.brightness";
tgi++;
tx_gens[tgi].fname="RadialBlur";
tx_gens[tgi].numparams=2;
tx_gens[tgi].defvalue[0]=1;tx_gens[tgi].pdesc[0]="iterations";
tx_gens[tgi].defvalue[1]=1;tx_gens[tgi].pdesc[1]="zoom";
tgi++;
tx_gens[tgi].fname="Sharpen";
tx_gens[tgi].numparams=0;
tgi++;

tx_gens[tgi].fname="PShift";
tx_gens[tgi].numparams=4;
tx_gens[tgi].defvalue[0]=0;tx_gens[tgi].pdesc[0]="r-shift";
tx_gens[tgi].defvalue[1]=0;tx_gens[tgi].pdesc[1]="g-shift";
tx_gens[tgi].defvalue[2]=0;tx_gens[tgi].pdesc[2]="b-shift";
tx_gens[tgi].defvalue[3]=0;tx_gens[tgi].pdesc[3]="saturnation";
tgi++;
tx_gens[tgi].fname="RadialPShift";
tx_gens[tgi].numparams=4;
tx_gens[tgi].defvalue[0]=0;tx_gens[tgi].pdesc[0]="r-shift";
tx_gens[tgi].defvalue[1]=0;tx_gens[tgi].pdesc[1]="g-shift";
tx_gens[tgi].defvalue[2]=0;tx_gens[tgi].pdesc[2]="b-shift";
tx_gens[tgi].defvalue[3]=0;tx_gens[tgi].pdesc[3]="saturnation";
tgi++;
tx_gens[tgi].fname="Map2dPShift";
tx_gens[tgi].numparams=3;
tx_gens[tgi].defvalue[0]=99;tx_gens[tgi].pdesc[0]="stage-num";
tx_gens[tgi].defvalue[1]=128;tx_gens[tgi].pdesc[1]="x-scale";
tx_gens[tgi].defvalue[2]=128;tx_gens[tgi].pdesc[2]="y-scale";
tgi++;
tx_gens[tgi].fname="Map2dPShift2";
tx_gens[tgi].numparams=5;
tx_gens[tgi].defvalue[0]=99;tx_gens[tgi].pdesc[0]="stage-num";
tx_gens[tgi].defvalue[1]=128;tx_gens[tgi].pdesc[1]="amp1";
tx_gens[tgi].defvalue[2]=128;tx_gens[tgi].pdesc[2]="offset1";
tx_gens[tgi].defvalue[3]=128;tx_gens[tgi].pdesc[3]="amp2";
tx_gens[tgi].defvalue[4]=128;tx_gens[tgi].pdesc[4]="offset2";

tgi++;

tx_gens[tgi].fname="Median";
tx_gens[tgi].numparams=0;
tgi++;
tx_gens[tgi].fname="Dilate";
tx_gens[tgi].numparams=0;
tgi++;
tx_gens[tgi].fname="Erode";
tx_gens[tgi].numparams=0;
tgi++;
tx_gens[tgi].fname="Edge";
tx_gens[tgi].numparams=0;
tgi++;
tx_gens[tgi].fname="Emboss";
tx_gens[tgi].numparams=0;
tgi++;

tx_gens[tgi].fname="RotorZoom";
tx_gens[tgi].numparams=6;
tx_gens[tgi].defvalue[0]=128;tx_gens[tgi].pdesc[0]="x";
tx_gens[tgi].defvalue[1]=128;tx_gens[tgi].pdesc[1]="y";
tx_gens[tgi].defvalue[2]=128;tx_gens[tgi].pdesc[2]="rotation";
tx_gens[tgi].defvalue[3]=64;tx_gens[tgi].pdesc[3]="zoom";
tx_gens[tgi].defvalue[4]=64;tx_gens[tgi].pdesc[4]="x-deform";
tx_gens[tgi].defvalue[5]=64;tx_gens[tgi].pdesc[5]="y-deform";
tgi++;
tx_gens[tgi].fname="Roll";
tx_gens[tgi].numparams=3;
tx_gens[tgi].defvalue[0]=0;tx_gens[tgi].pdesc[0]="x";
tx_gens[tgi].defvalue[1]=0;tx_gens[tgi].pdesc[1]="y";
tx_gens[tgi].defvalue[2]=0;tx_gens[tgi].pdesc[2]="flip";
tgi++;
tx_gens[tgi].fname="Tiling";
tx_gens[tgi].numparams=4;
tx_gens[tgi].defvalue[0]=0;tx_gens[tgi].pdesc[0]="x";
tx_gens[tgi].defvalue[1]=0;tx_gens[tgi].pdesc[1]="y";
tx_gens[tgi].defvalue[2]=128;tx_gens[tgi].pdesc[2]="anglestep";
tx_gens[tgi].defvalue[3]=1;tx_gens[tgi].pdesc[3]="mixtype";
tgi++;
tx_gens[tgi].fname="Mozaic";
tx_gens[tgi].numparams=1;
tx_gens[tgi].defvalue[0]=128;tx_gens[tgi].pdesc[0]="order";
tgi++;

tx_gens[tgi].fname="Mixer";
tx_gens[tgi].numparams=5;
tx_gens[tgi].defvalue[0]=99;tx_gens[tgi].pdesc[0]="source 1";
tx_gens[tgi].defvalue[1]=99;tx_gens[tgi].pdesc[1]="source 2";
tx_gens[tgi].defvalue[2]=128;tx_gens[tgi].pdesc[2]="brightness 1";
tx_gens[tgi].defvalue[3]=128;tx_gens[tgi].pdesc[3]="brightness 2";
tx_gens[tgi].defvalue[4]=0;tx_gens[tgi].pdesc[4]="type (0-5)";
tgi++;
tx_gens[tgi].fname="CrossFade";
tx_gens[tgi].numparams=2;
tx_gens[tgi].defvalue[0]=32;tx_gens[tgi].pdesc[0]="crossfade zone";
tx_gens[tgi].defvalue[1]=0;tx_gens[tgi].pdesc[1]="direction (0-1)";
tgi++;

tx_gens[tgi].fname="Clear";
tx_gens[tgi].numparams=0;
tgi++;
tx_gens[tgi].fname="ClearRGB";
tx_gens[tgi].numparams=0;
tgi++;

tx_gens[tgi].fname="CopyBlueToAlfa";
tx_gens[tgi].numparams=0;
tgi++;

tx_gens[tgi].fname="InvertAlfa";
tx_gens[tgi].numparams=0;
tgi++;

tx_gens[tgi].fname="ClearAlfa";
tx_gens[tgi].numparams=0;
tgi++;

tx_gens[tgi].fname="::Color";
tx_gens[tgi].numparams=0;
tgi++;
tx_gens[tgi].fname="Invert";
tx_gens[tgi].numparams=0;
tgi++;
tx_gens[tgi].fname="ScaleColor";
tx_gens[tgi].numparams=3;
tx_gens[tgi].defvalue[0]=128;tx_gens[tgi].pdesc[0]="r";
tx_gens[tgi].defvalue[1]=128;tx_gens[tgi].pdesc[1]="g";
tx_gens[tgi].defvalue[2]=128;tx_gens[tgi].pdesc[2]="b";
tgi++;
tx_gens[tgi].fname="AdjustColor";
tx_gens[tgi].numparams=3;
tx_gens[tgi].defvalue[0]=128;tx_gens[tgi].pdesc[0]="hue";
tx_gens[tgi].defvalue[1]=128;tx_gens[tgi].pdesc[1]="brightness";
tx_gens[tgi].defvalue[2]=128;tx_gens[tgi].pdesc[2]="contrast";
tgi++;
tx_gens[tgi].fname="SinColor";
tx_gens[tgi].numparams=4;
tx_gens[tgi].defvalue[0]=128;tx_gens[tgi].pdesc[0]="r";
tx_gens[tgi].defvalue[1]=128;tx_gens[tgi].pdesc[1]="g";
tx_gens[tgi].defvalue[2]=128;tx_gens[tgi].pdesc[2]="b";
tx_gens[tgi].defvalue[3]=128;tx_gens[tgi].pdesc[3]="all";
tgi++;
tx_gens[tgi].fname="SetTxBase";
tx_gens[tgi].numparams=7;
tx_gens[tgi].defvalue[0]=128;tx_gens[tgi].pdesc[0]="1";
tx_gens[tgi].defvalue[1]=128;tx_gens[tgi].pdesc[1]="2";
tx_gens[tgi].defvalue[2]=128;tx_gens[tgi].pdesc[2]="3";
tx_gens[tgi].defvalue[3]=128;tx_gens[tgi].pdesc[3]="4";
tx_gens[tgi].defvalue[4]=128;tx_gens[tgi].pdesc[4]="5";
tx_gens[tgi].defvalue[5]=128;tx_gens[tgi].pdesc[5]="6";
tx_gens[tgi].defvalue[6]=128;tx_gens[tgi].pdesc[6]="7";
tgi++;
tx_gens[tgi].fname="SetTxAmp";
tx_gens[tgi].numparams=7;
tx_gens[tgi].defvalue[0]=128;tx_gens[tgi].pdesc[0]="1";
tx_gens[tgi].defvalue[1]=128;tx_gens[tgi].pdesc[1]="2";
tx_gens[tgi].defvalue[2]=128;tx_gens[tgi].pdesc[2]="3";
tx_gens[tgi].defvalue[3]=128;tx_gens[tgi].pdesc[3]="4";
tx_gens[tgi].defvalue[4]=128;tx_gens[tgi].pdesc[4]="5";
tx_gens[tgi].defvalue[5]=128;tx_gens[tgi].pdesc[5]="6";
tx_gens[tgi].defvalue[6]=128;tx_gens[tgi].pdesc[6]="7";
tgi++;
tx_gens[tgi].fname="SetTxSpd";
tx_gens[tgi].numparams=7;
tx_gens[tgi].defvalue[0]=128;tx_gens[tgi].pdesc[0]="1";
tx_gens[tgi].defvalue[1]=128;tx_gens[tgi].pdesc[1]="2";
tx_gens[tgi].defvalue[2]=128;tx_gens[tgi].pdesc[2]="3";
tx_gens[tgi].defvalue[3]=128;tx_gens[tgi].pdesc[3]="4";
tx_gens[tgi].defvalue[4]=128;tx_gens[tgi].pdesc[4]="5";
tx_gens[tgi].defvalue[5]=128;tx_gens[tgi].pdesc[5]="6";
tx_gens[tgi].defvalue[6]=128;tx_gens[tgi].pdesc[6]="7";
tgi++;
tx_gens[tgi].fname="SetTxFz";
tx_gens[tgi].numparams=7;
tx_gens[tgi].defvalue[0]=128;tx_gens[tgi].pdesc[0]="1";
tx_gens[tgi].defvalue[1]=128;tx_gens[tgi].pdesc[1]="2";
tx_gens[tgi].defvalue[2]=128;tx_gens[tgi].pdesc[2]="3";
tx_gens[tgi].defvalue[3]=128;tx_gens[tgi].pdesc[3]="4";
tx_gens[tgi].defvalue[4]=128;tx_gens[tgi].pdesc[4]="5";
tx_gens[tgi].defvalue[5]=128;tx_gens[tgi].pdesc[5]="6";
tx_gens[tgi].defvalue[6]=128;tx_gens[tgi].pdesc[6]="7";
tgi++;
tx_gens[tgi].fname="SinAnimP";
tx_gens[tgi].numparams=1;
tx_gens[tgi].defvalue[0]=0;tx_gens[tgi].pdesc[0]="stage";
tgi++;
tx_gens[tgi].fname="AbsSinAnimP";
tx_gens[tgi].numparams=1;
tx_gens[tgi].defvalue[0]=0;tx_gens[tgi].pdesc[0]="stage";
tgi++;
tx_gens[tgi].fname="CycleAnimP";
tx_gens[tgi].numparams=1;
tx_gens[tgi].defvalue[0]=0;tx_gens[tgi].pdesc[0]="stage";
tgi++;

tx_gens[tgi].fname="LoadTGA";
tx_gens[tgi].numparams=0;
tgi++;

tx_gens[tgi].fname="Empty";
tx_gens[tgi].numparams=0;
tgi++;

tx_gens[tgi].fname="end"; //marker!!    

tfunc_count=tgi;

for (int q=0;q<tfunc_count;q++) tx_gens_backup[q]=tx_gens[q];//for "restore default" button


SendDlgItemMessage(hDlg,IDC_LIST2,LB_RESETCONTENT,0,0);
for (int n=0;n<tfunc_count;n++) 
{
char st[100];

		strcpy(st,"  ");
		strcat(st,tx_gens[n].fname);

	if (tx_gens[n].fname=="::Generators"||
		tx_gens[n].fname=="::Filters"||
		tx_gens[n].fname=="::Geometry"||
		tx_gens[n].fname=="::Color")
		{
		strcpy(st,tx_gens[n].fname);
		}

	if (tx_gens[n].fname=="Blur"||
		tx_gens[n].fname=="PShift"||
		tx_gens[n].fname=="Median"||
		tx_gens[n].fname=="Mixer"||
		tx_gens[n].fname=="CopyBlueToAlfa"||
		tx_gens[n].fname=="RotorZoom"||
		tx_gens[n].fname=="Clear"||
		tx_gens[n].fname=="Twirl")
		{
		strcpy(st," ");
		strcat(st,tx_gens[n].fname);
		}

	SendDlgItemMessage(hDlg,IDC_LIST2,LB_ADDSTRING,0,(LPARAM) st);
}

//  ,     (      )
TUI_param_ctrls[1].pdesc=descp1;
TUI_param_ctrls[1].pslider=IDC_P1;
TUI_param_ctrls[1].pplus=IDC_P1PLUS;
TUI_param_ctrls[1].pminus=IDC_P1MINUS;
TUI_param_ctrls[1].pnumview=IDC_EP1;
TUI_param_ctrls[2].pdesc=descp2;
TUI_param_ctrls[2].pslider=IDC_P2;
TUI_param_ctrls[2].pplus=IDC_P2PLUS;
TUI_param_ctrls[2].pminus=IDC_P2MINUS;
TUI_param_ctrls[2].pnumview=IDC_EP2;
TUI_param_ctrls[3].pdesc=descp3;
TUI_param_ctrls[3].pslider=IDC_P3;
TUI_param_ctrls[3].pplus=IDC_P3PLUS;
TUI_param_ctrls[3].pminus=IDC_P3MINUS;
TUI_param_ctrls[3].pnumview=IDC_EP3;
TUI_param_ctrls[4].pdesc=descp4;
TUI_param_ctrls[4].pslider=IDC_P4;
TUI_param_ctrls[4].pplus=IDC_P4PLUS;
TUI_param_ctrls[4].pminus=IDC_P4MINUS;
TUI_param_ctrls[4].pnumview=IDC_EP4;
TUI_param_ctrls[5].pdesc=descp5;
TUI_param_ctrls[5].pslider=IDC_P5;
TUI_param_ctrls[5].pplus=IDC_P5PLUS;
TUI_param_ctrls[5].pminus=IDC_P5MINUS;
TUI_param_ctrls[5].pnumview=IDC_EP5;
TUI_param_ctrls[6].pdesc=descp6;
TUI_param_ctrls[6].pslider=IDC_P6;
TUI_param_ctrls[6].pplus=IDC_P6PLUS;
TUI_param_ctrls[6].pminus=IDC_P6MINUS;
TUI_param_ctrls[6].pnumview=IDC_EP6;
TUI_param_ctrls[7].pdesc=descp7;
TUI_param_ctrls[7].pslider=IDC_P7;
TUI_param_ctrls[7].pplus=IDC_P7PLUS;
TUI_param_ctrls[7].pminus=IDC_P7MINUS;
TUI_param_ctrls[7].pnumview=IDC_EP7;

				TUI_hide_param_ctrls(hDlg);

				//set ctrls range
				for (int i=1;i<=7;i++)
				{
				SendDlgItemMessage(hDlg,TUI_param_ctrls[i].pslider,TBM_SETRANGE,TRUE,(LPARAM) MAKELONG(0,255));
				SendDlgItemMessage(hDlg,TUI_param_ctrls[i].pslider,TBM_SETPOS,TRUE,(LPARAM) 0);
				SetDlgItemInt(hDlg,TUI_param_ctrls[i].pnumview,0,FALSE);
				}

}

int iPage=0;

void write_texturedata(FILE* fp)
{int i,j;

		fprintf(fp,"texture generation log");
		fprintf(fp,"\n");

		if (texture_stagenum>0)
		{
		_itoa(tsize,r_string,10);
		fprintf(fp,"tsize=");fprintf(fp,r_string);fprintf(fp,";\n");

		_itoa(texture_type[current_texture],r_string,10);
		fprintf(fp,"ttype=");fprintf(fp,r_string);fprintf(fp,";\n");

		memcpy(r_string,&texture_name[current_texture][0],100);
		fprintf(fp,"tname=");fprintf(fp,r_string);fprintf(fp,";\n");
		
		for (i=1;i<texture_stagenum;i++)
			{
			fprintf(fp,tx_gens[tx_log[current_texture][i].fnum].fname);
				fprintf(fp,"(");
				for (j=1;j<=tx_gens[tx_log[current_texture][i].fnum].numparams;j++)
					{		
					_itoa(tx_log[current_texture][i].p[j],r_string,10);
					fprintf(fp,r_string);
					if (j<tx_gens[tx_log[current_texture][i].fnum].numparams) fprintf(fp,","); 
					}
				//
				if (tx_gens[tx_log[current_texture][i].fnum].fname=="DrwTxt")
				{
					fprintf(fp,",");
					fprintf(fp,tx_log[current_texture][i].txt);
				}
				//
				fprintf(fp,");");
			fprintf(fp,"\n");
			}
		}

		fprintf(fp,"end");fprintf(fp,"\n");
}

void read_texturedata(char* i)
{int mj,r,t,r2;char* ie;


				i=strstr(i,"tsize=");
				tsize=atoi(i+6);

				i=strstr(i,"ttype=");
				texture_type[current_texture]=atoi(i+6);

				i=strstr(i,"tname=");
				ie=strstr(i,";");*(ie)=0;
				texture_name[current_texture][0]=0;
				if (ie>(i+6)) strcpy((char*)&texture_name[current_texture][0],i+6);
				*(ie)=';';

				for (r=0;r<6;r++) 
					{
					if (tsize==tsize_table[r]) SendDlgItemMessage(Texture_UIDlg,IDC_COMBO1,CB_SETCURSEL,r,0);
					}

				if (texture_type[current_texture]==0)
					{
					pTexture[current_texture]->Release();
					pDevice->CreateTexture(tsize,tsize,0,0,D3DFMT_A8R8G8B8,D3DPOOL_MANAGED,&pTexture[current_texture],NULL);
					}
				if (texture_type[current_texture]==1)
					{
					pTexture[current_texture]->Release();
					pDevice->CreateTexture(tsize,tsize,0,D3DUSAGE_RENDERTARGET,D3DFMT_A8R8G8B8,D3DPOOL_DEFAULT,&pTexture[current_texture],NULL);
					}
				if (texture_type[current_texture]==2)
					{
					pTexture[current_texture]->Release();
					pDevice->CreateTexture(tsize,tsize,0,D3DUSAGE_DMAP,D3DFMT_A8R8G8B8,D3DPOOL_DEFAULT,&pTexture[current_texture],NULL);
					}
				SendDlgItemMessage(Texture_UIDlg,IDC_TTYPE,CB_SETCURSEL,texture_type[current_texture],0);
				tsize_store[current_texture]=tsize;
				texture_size[current_texture]=tsize;

				i=strstr(i+6,";");i+=2;

				read_token:;
				//recognizing function name
				for (t=1;t<=tfunc_count;t++)
					{
					r=0;
					for (r2=0;r2<strlen(tx_gens[t].fname);r2++)
						{
						if (*(i+r2)!=*(tx_gens[t].fname+r2)) goto q;
						}
					if (t!=tfunc_count&&*(i+r2)!=0x28) goto q;
					r=1;
					goto k;
					q:;
					}
				k:;
				if (r==0) MessageBox(Texture_UIDlg,"unknown command","error",MB_OK);
				if (t==tfunc_count) goto ok;
				tx_log[current_texture][texture_stagenum].fnum=t;
				//recoginzing function parameters
				//r2++;
				i=i+r2;
				if (tx_gens[t].numparams==0) goto np;
				i=strstr(i,"(");i++;
				for (r=1;r<=tx_gens[t].numparams;r++)
					{
					tx_log[current_texture][texture_stagenum].p[r]=atoi(i);
					//MessageBox(hDlg,_itoa(tx_log[current_texture][texture_stagenum].p[r],aa,10),"123",MB_OK);
					if (r<(tx_gens[t].numparams)) {i=strstr(i,",");i++;}
					}
				if (tx_gens[t].fname=="DrwTxt")
					{char sl=0;
					i=strstr(i,",");i++;
					while (*(i+sl)!=')') {sl++;}
					memcpy(tx_log[current_texture][texture_stagenum].txt,i,sl);

					}
				np:;
				texture_stagenum++;
				i=strstr(i,";");i+=2;
				goto read_token;
				
				ok:;
}

void calc_texture_silent()
{
	int sl,r,r2,t;
	char* aaa,*bbb;aaa="           ";bbb=new char[100];
//	SendDlgItemMessage(Texture_UIDlg,IDC_LIST1,LB_RESETCONTENT,0,0);

//	memcpy(r_string,&texture_name[current_texture][0],100);
//	SetDlgItemText(Texture_UIDlg,IDC_TEXNAME,r_string);

				r2=texture_stagenum;
				texture_stagenum=1;

				Clear(texture_tmp+(texture_stagenum)*tsize*tsize*4);
				Clear(texture_tmp+(texture_stagenum-1)*tsize*tsize*4);

				for (r=1;r<r2;r++)
				{
					//ZeroMemory(bbb,100);

					//SendDlgItemMessage(Texture_UIDlg,IDC_LIST2,LB_SETCURSEL,tx_log[current_texture][r].fnum,0);
					pload_from_tx_log(Texture_UIDlg,tx_log[current_texture][r].fnum);
					exec_func(Texture_UIDlg,tx_log[current_texture][r].fnum);
					tst=texture_stagenum;
					
					memcpy (texture_tmp+(texture_stagenum+1)*tsize*tsize*4,texture_tmp+texture_stagenum*tsize*tsize*4,tsize*tsize*4);

					//_itoa(texture_stagenum,bbb,10);
					//strcat(bbb,tx_gens[tx_log[current_texture][r].fnum].fname);
					//pokeb((BYTE*)bbb+strlen(bbb),0);
					
					//SendDlgItemMessage(Texture_UIDlg,IDC_LIST1,LB_INSERTSTRING,0,(LPARAM) (LPCTSTR)bbb);

					texture_stagenum++;
					//MessageBox(hWndMain,_itoa(tsize,aaa,10),"123",MB_OK);
				}
				texture_stagenum=r2;
				
				//SendDlgItemMessage(Texture_UIDlg,IDC_LIST2,LB_SETCURSEL,0,0);
				//pload(Texture_UIDlg,0);

				delete (bbb);
									draw_tw();
									

}

void calc_texture()
{
	if (dtx_view==1) {
	int sl,r,r2,t;
	char* aaa,*bbb;aaa="           ";bbb=new char[100];
	SendDlgItemMessage(Texture_UIDlg,IDC_LIST1,LB_RESETCONTENT,0,0);

	memcpy(r_string,&texture_name[current_texture][0],100);
	SetDlgItemText(Texture_UIDlg,IDC_TEXNAME,r_string);

				r2=texture_stagenum;
				texture_stagenum=1;

				Clear(texture_tmp+(texture_stagenum)*tsize*tsize*4);
				Clear(texture_tmp+(texture_stagenum-1)*tsize*tsize*4);

				for (r=1;r<r2;r++)
				{
					ZeroMemory(bbb,100);

					SendDlgItemMessage(Texture_UIDlg,IDC_LIST2,LB_SETCURSEL,tx_log[current_texture][r].fnum,0);
					pload_from_tx_log(Texture_UIDlg,tx_log[current_texture][r].fnum);
					exec_func(Texture_UIDlg,tx_log[current_texture][r].fnum);
					tst=texture_stagenum;
					draw_tw();
					memcpy (texture_tmp+(texture_stagenum+1)*tsize*tsize*4,texture_tmp+texture_stagenum*tsize*tsize*4,tsize*tsize*4);
					
					_itoa(texture_stagenum,bbb,10);
					strcat(bbb,tx_gens[tx_log[current_texture][r].fnum].fname);
					pokeb((BYTE*)bbb+strlen(bbb),0);
					
					SendDlgItemMessage(Texture_UIDlg,IDC_LIST1,LB_INSERTSTRING,0,(LPARAM) (LPCTSTR)bbb);

					texture_stagenum++;
					//MessageBox(hWndMain,_itoa(tsize,aaa,10),"123",MB_OK);
				}
				texture_stagenum=r2;
				
				SendDlgItemMessage(Texture_UIDlg,IDC_LIST2,LB_SETCURSEL,0,0);
				pload(Texture_UIDlg,0);

				delete (bbb);

	}
}


void SetTextureN(int n)
{
	//if (n!=0)
	{
			int r1,r2,r;
				texture_stagenums[current_texture]=texture_stagenum;
				texture_size[current_texture]=tsize;

				current_texture=n;

				memcpy(r_string,&texture_name[current_texture][0],100);
				SetDlgItemText(Texture_UIDlg,IDC_TEXNAME,r_string);


				SendDlgItemMessage(Texture_UIDlg,IDC_LIST1,LB_RESETCONTENT,0,0);
				texture_stagenum=texture_stagenums[current_texture];
				tsize=texture_size[current_texture];

			for (r=0;r<6;r++) 
					{
					if (tsize==tsize_table[r]) SendDlgItemMessage(Texture_UIDlg,IDC_COMBO1,CB_SETCURSEL,r,0);
					}
				/*if (texture_type[current_texture]==0)
					{
					pTexture[current_texture]->Release();
					pDevice->CreateTexture(tsize,tsize,0,0,D3DFMT_A8R8G8B8,D3DPOOL_DEFAULT,&pTexture[current_texture],NULL);
					}
				if (texture_type[current_texture]==1)
					{
					pTexture[current_texture]->Release();
					pDevice->CreateTexture(tsize,tsize,0,D3DUSAGE_RENDERTARGET,D3DFMT_A8R8G8B8,D3DPOOL_DEFAULT,&pTexture[current_texture],NULL);
					}
				if (texture_type[current_texture]==2)
					{
					pTexture[current_texture]->Release();
					pDevice->CreateTexture(tsize,tsize,0,D3DUSAGE_DMAP,D3DFMT_A8R8G8B8,D3DPOOL_DEFAULT,&pTexture[current_texture],NULL);
					}*/
				SendDlgItemMessage(Texture_UIDlg,IDC_TTYPE,CB_SETCURSEL,texture_type[current_texture],0);
				tsize_store[current_texture]=tsize;

				r2=texture_stagenum;
				texture_stagenum=1;

				Clear(texture_tmp+(texture_stagenum)*tsize*tsize*4);
				Clear(texture_tmp+(texture_stagenum-1)*tsize*tsize*4);

				for (r=1;r<r2;r++)
				{
					SendDlgItemMessage(Texture_UIDlg,IDC_LIST2,LB_SETCURSEL,tx_log[current_texture][r].fnum,0);
					pload_from_tx_log(Texture_UIDlg,tx_log[current_texture][r].fnum);
					exec_func(Texture_UIDlg,tx_log[current_texture][r].fnum);
					tst=texture_stagenum;
					draw_tw();
					memcpy (texture_tmp+(texture_stagenum+1)*tsize*tsize*4,texture_tmp+texture_stagenum*tsize*tsize*4,tsize*tsize*4);
					_itoa(texture_stagenum,r_string,10);
					SendDlgItemMessage(Texture_UIDlg,IDC_LIST1,LB_INSERTSTRING,0,(LPARAM) (LPCTSTR)strcat(r_string,tx_gens[tx_log[current_texture][r].fnum].fname));
													
					texture_stagenum++;
				}
				texture_stagenum=r2;
				
				SendDlgItemMessage(Texture_UIDlg,IDC_LIST2,LB_SETCURSEL,0,0);
				pload(Texture_UIDlg,0);
				SetDlgItemInt(Texture_UIDlg,IDC_EDIT1,current_texture,FALSE);
	}
	tst=texture_stagenum;
}

void PreRenderTexture()
{
	int tt;
int t=SendDlgItemMessage(Texture_UIDlg,IDC_LIST1,LB_GETCURSEL,0,0);
SendMessage(Texture_UIDlg,WM_COMMAND,IDC_BUTTON10,0);

tt=tst;//texture_stagenum;
SendDlgItemMessage(Texture_UIDlg,IDC_LIST1,LB_SETCURSEL,t,0);
SendMessage(Texture_UIDlg,WM_COMMAND,IDC_TCHANGE,0);
		tst=tt;
		DrawScene();
		draw_tw();



}

//   
BOOL CALLBACK _export 
TextureUIProc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
int wmId, wmEvent;


	 switch( msg )
  {
	case WM_ACTIVATE:
		if (LOWORD(wParam)==WA_INACTIVE) active_app=0; else active_app=1;
		break;
		
    case WM_LBUTTONDOWN:
             PostMessage(hDlg, WM_NCLBUTTONDOWN, HTCAPTION,0);
			 break;

		case WM_MOVING:
		{
		DrawScene();draw_tw();
		break;
		}
	case WM_SIZE:
		{
		if (wParam==SIZE_MINIMIZED)
			{
			if (AutoFocus!=0)
				{
				ShowWindow(Texture_UIDlg,SW_RESTORE);
				if (window_fixer[1]==1) SetWindowPos(Texture_UIDlg,HWND_TOP,wp[4],wp[5],wp[6]-wp[4],75,SWP_SHOWWINDOW|SWP_NOMOVE);
				if (window_fixer[1]==0) SetWindowPos(Texture_UIDlg,HWND_TOP,wp[4],wp[5],wp[6]-wp[4],wp[7]-wp[5],SWP_SHOWWINDOW|SWP_NOMOVE);
				if (fix_mode!=0) SetWindowPos(Texture_UIDlg,HWND_TOP,wp[4],wp[5],wp[6]-wp[4],wp[7]-wp[5],SWP_SHOWWINDOW|SWP_NOMOVE);
				window_fixer[1]=1-window_fixer[1];
				SetFocus(Texture_UIDlg);
				break;
				}

			window_fixer[1]=1-window_fixer[1];
			ShowWindow(Texture_UIDlg,SW_RESTORE);
			SetFocus(Texture_UIDlg);
			}
		break;
		}
		
  case WM_HSCROLL:
		{
			int f,j;
			tst=texture_stagenum;
			f=SendDlgItemMessage(hDlg,IDC_LIST2,LB_GETCURSEL,0,0);
			for (j=0;j<tx_gens[f].numparams;j++)
				{
				tx_gens[f].defvalue[j]=SendDlgItemMessage (hDlg,TUI_param_ctrls[j+1].pslider,TBM_GETPOS,0,0);
				}
			exec_func(hDlg,SendDlgItemMessage(hDlg,IDC_LIST2,LB_GETCURSEL,0,0));
			draw_tw();
			DrawScene();
			break;
		}

	case WM_NOTIFY: 
		{int t,n;
		t=TabCtrl_GetCurSel(GetDlgItem(hDlg,IDC_TAB1));
		if (iPage != t) 
			{
			iPage=t;
			SendDlgItemMessage(hDlg,IDC_LIST2,LB_SETCURSEL,tfunc_count-1,0);
			if (t==0) {
						for (n=0;n<tfunc_count;n++) 
						{if (tx_gens[n].fname=="::Generators") {SendDlgItemMessage(hDlg,IDC_LIST2,LB_SETCURSEL,n,0);goto tabq;}}
					}
			if (t==1) {
						for (n=0;n<tfunc_count;n++) 
						{if (tx_gens[n].fname=="::Geometry") {SendDlgItemMessage(hDlg,IDC_LIST2,LB_SETCURSEL,n,0);goto tabq;}}
					}
			if (t==2) {
						for (n=0;n<tfunc_count;n++) 
						{if (tx_gens[n].fname=="::Filters") {SendDlgItemMessage(hDlg,IDC_LIST2,LB_SETCURSEL,n,0);goto tabq;}}
					}
			if (t==3) {
						for (n=0;n<tfunc_count;n++) 
						{if (tx_gens[n].fname=="::Color") {SendDlgItemMessage(hDlg,IDC_LIST2,LB_SETCURSEL,n,0);goto tabq;}}
					}

			tabq:;
			}
		break;
		
		}
	case WM_MOUSEMOVE: 
		{
			if (window!=2&&AutoFocus==0) {window=2;winpos();SetFocus(Texture_UIDlg);}
			break;
		}
	case WM_CLOSE:
			{
			SendMessage(Parent_hWnd,WM_COMMAND,W_T,0);
			break;
			}

	case WM_INITDIALOG:
		{
		SendDlgItemMessage(hDlg,IDC_TTYPE,CB_RESETCONTENT,0,0);
		SendDlgItemMessage(hDlg,IDC_TTYPE,CB_ADDSTRING,0,(LPARAM) (LPCTSTR)"normal");
		SendDlgItemMessage(hDlg,IDC_TTYPE,CB_ADDSTRING,0,(LPARAM) (LPCTSTR)"render-target");
		SendDlgItemMessage(hDlg,IDC_TTYPE,CB_ADDSTRING,0,(LPARAM) (LPCTSTR)"dmap");
		SendDlgItemMessage(hDlg,IDC_TTYPE,CB_SETCURSEL,0,0);
		//  - 
		SendDlgItemMessage(hDlg,IDC_TEXCOMBOSELECTOR,CB_RESETCONTENT,0,0);
		for (int ii=0; ii<256; ii++)
			{
			sprintf(tempstr,"%d",ii);
			SendDlgItemMessage(hDlg,IDC_TEXCOMBOSELECTOR,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)tempstr);
			}
		SendDlgItemMessage(hDlg,IDC_TEXCOMBOSELECTOR,CB_SETCURSEL,0,0);
		//---
		TUI_statics(hDlg);
		SetDlgItemInt(hDlg,IDC_EDIT1,current_texture,FALSE);
		tst=texture_stagenum;
		break;
		}

	case WM_COMMAND:
		{
		int i;
		//  +  - 
			int p;
			for (i=1;i<8;i++)
				{
				  if (LOWORD(wParam)==TUI_param_ctrls[i].pplus)
					{p=SendDlgItemMessage (hDlg,TUI_param_ctrls[i].pslider,TBM_GETPOS,0,0);if (p<255) p++;goto q1;}
					
				  if (LOWORD(wParam)==TUI_param_ctrls[i].pminus)
					{p=SendDlgItemMessage (hDlg,TUI_param_ctrls[i].pslider,TBM_GETPOS,0,0);if (p>0) p--;goto q1;}
				goto q2;
				q1:;
					SendDlgItemMessage(hDlg,TUI_param_ctrls[i].pslider,TBM_SETPOS,TRUE,(LPARAM) p);
					SetDlgItemInt(hDlg,TUI_param_ctrls[i].pnumview,p,FALSE);
					exec_func(hDlg,SendDlgItemMessage(hDlg,IDC_LIST2,LB_GETCURSEL,0,0));
					draw_tw();
				q2:;
				}
		//-----------------------------
		switch (LOWORD(wParam))
			{
			case IDC_TEXNAME:
				{int t;
				if (HIWORD (wParam) == EN_CHANGE)  
				{
					if (GetFocus()==GetDlgItem(Texture_UIDlg,IDC_TEXNAME))
						{
						GetDlgItemText(Texture_UIDlg,IDC_TEXNAME,r_string,99);
						memcpy(&texture_name[current_texture][0],r_string,100);
						}
					//-------
					t=SendDlgItemMessage(Geo_UIDlg,IDC_TSELCOMBO,CB_GETCURSEL,0,0);
					SendDlgItemMessage(Geo_UIDlg,IDC_TSELCOMBO,CB_RESETCONTENT,0,0);
					for (int f=0;f<255;f++)
					{
					sprintf(r_string,"%d:    ",f); // 
					memcpy(r_string+4,&texture_name[f][0],96);
					SendDlgItemMessage(Geo_UIDlg,IDC_TSELCOMBO,CB_ADDSTRING,0,(LPARAM) (LPCTSTR)r_string);
					}
					SendDlgItemMessage(Geo_UIDlg,IDC_TSELCOMBO,CB_SETCURSEL,(WPARAM)t,0);					
					//-------
					t=SendDlgItemMessage(Material_UIDlg,IDC_VBCOMBO,CB_GETCURSEL,0,0);
					SendDlgItemMessage(Material_UIDlg,IDC_VBCOMBO,CB_RESETCONTENT,0,0);
					for (f=0;f<255;f++)
					{
					sprintf(r_string,"%d:    ",f); // 
					memcpy(r_string+4,&texture_name[f][0],96);
					SendDlgItemMessage(Material_UIDlg,IDC_VBCOMBO,CB_ADDSTRING,0,(LPARAM) (LPCTSTR)r_string);
					}
					SendDlgItemMessage(Material_UIDlg,IDC_VBCOMBO,CB_SETCURSEL,(WPARAM)t,0);					
					//-------
					t=SendDlgItemMessage(Material_UIDlg,IDC_MTEX2,CB_GETCURSEL,0,0);
					SendDlgItemMessage(Material_UIDlg,IDC_MTEX2,CB_RESETCONTENT,0,0);
					for (f=0;f<255;f++)
					{
					sprintf(r_string,"%d:    ",f); // 
					memcpy(r_string+4,&texture_name[f][0],96);
					SendDlgItemMessage(Material_UIDlg,IDC_MTEX2,CB_ADDSTRING,0,(LPARAM) (LPCTSTR)r_string);
					}
					SendDlgItemMessage(Material_UIDlg,IDC_MTEX2,CB_SETCURSEL,(WPARAM)t,0);					
					//--------
					t=SendDlgItemMessage(Material_UIDlg,IDC_MTEX1,CB_GETCURSEL,0,0);
					SendDlgItemMessage(Material_UIDlg,IDC_MTEX1,CB_RESETCONTENT,0,0);
					for (f=0;f<255;f++)
					{
					sprintf(r_string,"%d:    ",f); // 
					memcpy(r_string+4,&texture_name[f][0],96);
					SendDlgItemMessage(Material_UIDlg,IDC_MTEX1,CB_ADDSTRING,0,(LPARAM) (LPCTSTR)r_string);
					}
					SendDlgItemMessage(Material_UIDlg,IDC_MTEX1,CB_SETCURSEL,(WPARAM)t,0);					
					//--------
				}
				break;
				}
			case IDC_TTYPE:
				{
					int tt;
					tt=SendDlgItemMessage(hDlg,IDC_TTYPE,CB_GETCURSEL,0,0);
					texture_type[current_texture]=tt;
					
					switch (tt)
					{
					case 0:
						{
						pTexture[current_texture]->Release();
						pDevice->CreateTexture(tsize,tsize,0,0,D3DFMT_A8R8G8B8,D3DPOOL_MANAGED,&pTexture[current_texture],NULL);
						break;
						}
					case 1:
						{
						pTexture[current_texture]->Release();
						pDevice->CreateTexture(tsize,tsize,0,D3DUSAGE_RENDERTARGET,D3DFMT_A8R8G8B8,D3DPOOL_DEFAULT,&pTexture[current_texture],NULL);
						break;
						}
					case 2:
						{
						pTexture[current_texture]->Release();
						pDevice->CreateTexture(tsize,tsize,0,D3DUSAGE_DMAP,D3DFMT_A8R8G8B8,D3DPOOL_DEFAULT,&pTexture[current_texture],NULL);
						break;
						}
					}
				break;
				}
			case IDC_LIST1:
				{
				int t,tt;
				if (change_flag==0)
					{
					t=tst;
					tst=texture_stagenum-SendDlgItemMessage(Texture_UIDlg,IDC_LIST1,LB_GETCURSEL,0,0)-1;
					draw_tw();
					tst=t;
					}

				if (HIWORD (wParam) == LBN_DBLCLK) if (change_flag==0) SendMessage(Texture_UIDlg,WM_COMMAND,IDC_TCHANGE,0);

				break;
				}
			case IDC_FVIEW:
				{
				PreRenderTexture();
				break;
				}
			case IDC_TESTER:
				{double a,b,t;char *aa,*bb;
				aa=new char [20];bb=new char [20];
				a=float(GetTickCount()%0xffff);
				for (int i=0;i<50;i++)
					{
					memcpy(texture_tmp+(texture_stagenum)*tsize*tsize*4,texture_tmp+(texture_stagenum-1)*tsize*tsize*4,tsize*tsize*4);
					//radial_blur(texture_tmp+(texture_stagenum)*tsize*tsize*4,16);
					//addparticle(texture_tmp+(texture_stagenum)*tsize*tsize*4,128,128,255,255,255,128,255);
					}
				b=float(GetTickCount()%0xffff);
				t=b-a;
				MessageBox(hDlg,_gcvt(t,10,aa),"timetest",MB_OK);
				break;
				}
			case IDC_TEXCOMBOSELECTOR:
				{
				int r1,r2,r;char* aaa;aaa="           ";
				texture_stagenums[current_texture]=texture_stagenum;
				texture_size[current_texture]=tsize;

				int tempint=SendDlgItemMessage(hDlg,IDC_TEXCOMBOSELECTOR,CB_GETCURSEL,0,0);
				if (tempint != current_texture)
				{
				current_texture=tempint;

				memcpy(r_string,&texture_name[current_texture][0],100);
				SetDlgItemText(hDlg,IDC_TEXNAME,r_string);
				
				SendDlgItemMessage(hDlg,IDC_LIST1,LB_RESETCONTENT,0,0);
				texture_stagenum=texture_stagenums[current_texture];
				tsize=texture_size[current_texture];

				for (r=0;r<7;r++) 
					{
					if (tsize==tsize_table[r]) SendDlgItemMessage(hDlg,IDC_COMBO1,CB_SETCURSEL,r,0);
					}

				SendDlgItemMessage(hDlg,IDC_TTYPE,CB_SETCURSEL,texture_type[current_texture],0);

				tsize_store[current_texture]=tsize;
				
				r2=texture_stagenum;
				texture_stagenum=1;

				Clear(texture_tmp+(texture_stagenum)*tsize*tsize*4);
				Clear(texture_tmp+(texture_stagenum-1)*tsize*tsize*4);

				for (r=1;r<r2;r++)
				{
					SendDlgItemMessage(hDlg,IDC_LIST2,LB_SETCURSEL,tx_log[current_texture][r].fnum,0);
					pload_from_tx_log(hDlg,tx_log[current_texture][r].fnum);
					exec_func(hDlg,tx_log[current_texture][r].fnum);
					tst=texture_stagenum;
					draw_tw();
					memcpy (texture_tmp+(texture_stagenum+1)*tsize*tsize*4,texture_tmp+texture_stagenum*tsize*tsize*4,tsize*tsize*4);
					_itoa(texture_stagenum,r_string,10);
					SendDlgItemMessage(hDlg,IDC_LIST1,LB_INSERTSTRING,0,(LPARAM) (LPCTSTR)strcat(r_string,tx_gens[tx_log[current_texture][r].fnum].fname));
					texture_stagenum++;
				}
				texture_stagenum=r2;
				
				SendDlgItemMessage(hDlg,IDC_LIST2,LB_SETCURSEL,0,0);
				pload(hDlg,0);
				SetDlgItemInt(hDlg,IDC_EDIT1,current_texture,FALSE);
				tst=texture_stagenum;
				draw_tw();
				DrawScene();
				}
				break;
				}
			case IDC_BUTTON19:
				{
				int r1,r2,r;char* aaa;aaa="           ";
				texture_stagenums[current_texture]=texture_stagenum;
				texture_size[current_texture]=tsize;

				if (current_texture<255) current_texture++;
				SendDlgItemMessage(hDlg,IDC_TEXCOMBOSELECTOR,CB_SETCURSEL,current_texture,0);
				memcpy(r_string,&texture_name[current_texture][0],100);
				SetDlgItemText(hDlg,IDC_TEXNAME,r_string);
				
				SendDlgItemMessage(hDlg,IDC_LIST1,LB_RESETCONTENT,0,0);
				texture_stagenum=texture_stagenums[current_texture];
				tsize=texture_size[current_texture];

				for (r=0;r<7;r++) 
					{
					if (tsize==tsize_table[r]) SendDlgItemMessage(hDlg,IDC_COMBO1,CB_SETCURSEL,r,0);
					}

				SendDlgItemMessage(hDlg,IDC_TTYPE,CB_SETCURSEL,texture_type[current_texture],0);

				tsize_store[current_texture]=tsize;
				
				r2=texture_stagenum;
				texture_stagenum=1;

				Clear(texture_tmp+(texture_stagenum)*tsize*tsize*4);
				Clear(texture_tmp+(texture_stagenum-1)*tsize*tsize*4);

				for (r=1;r<r2;r++)
				{
					SendDlgItemMessage(hDlg,IDC_LIST2,LB_SETCURSEL,tx_log[current_texture][r].fnum,0);
					pload_from_tx_log(hDlg,tx_log[current_texture][r].fnum);
					exec_func(hDlg,tx_log[current_texture][r].fnum);
					tst=texture_stagenum;
					draw_tw();
					memcpy (texture_tmp+(texture_stagenum+1)*tsize*tsize*4,texture_tmp+texture_stagenum*tsize*tsize*4,tsize*tsize*4);
					_itoa(texture_stagenum,r_string,10);
					SendDlgItemMessage(hDlg,IDC_LIST1,LB_INSERTSTRING,0,(LPARAM) (LPCTSTR)strcat(r_string,tx_gens[tx_log[current_texture][r].fnum].fname));
					texture_stagenum++;
				}
				texture_stagenum=r2;
				
				SendDlgItemMessage(hDlg,IDC_LIST2,LB_SETCURSEL,0,0);
				pload(hDlg,0);
				SetDlgItemInt(hDlg,IDC_EDIT1,current_texture,FALSE);
				tst=texture_stagenum;
				draw_tw();
				DrawScene();
				break;
				}

			case IDC_BUTTON18:
				{
				int r1,r2,r;char* aaa;aaa="           ";
				texture_stagenums[current_texture]=texture_stagenum;
				texture_size[current_texture]=tsize;

				if (current_texture>0) current_texture--;
				SendDlgItemMessage(hDlg,IDC_TEXCOMBOSELECTOR,CB_SETCURSEL,current_texture,0);
				memcpy(r_string,&texture_name[current_texture][0],100);
				SetDlgItemText(hDlg,IDC_TEXNAME,r_string);

				SendDlgItemMessage(hDlg,IDC_LIST1,LB_RESETCONTENT,0,0);
				texture_stagenum=texture_stagenums[current_texture];
				tsize=texture_size[current_texture];

			for (r=0;r<6;r++) 
					{
					if (tsize==tsize_table[r]) SendDlgItemMessage(hDlg,IDC_COMBO1,CB_SETCURSEL,r,0);
					}

				/*if (texture_type[current_texture]==0)
					{
					pTexture[current_texture]->Release();
					pDevice->CreateTexture(tsize,tsize,0,0,D3DFMT_A8R8G8B8,D3DPOOL_DEFAULT,&pTexture[current_texture],NULL);
					}
				if (texture_type[current_texture]==1)
					{
					pTexture[current_texture]->Release();
					pDevice->CreateTexture(tsize,tsize,0,D3DUSAGE_RENDERTARGET,D3DFMT_A8R8G8B8,D3DPOOL_DEFAULT,&pTexture[current_texture],NULL);
					}
				if (texture_type[current_texture]==2)
					{
					pTexture[current_texture]->Release();
					pDevice->CreateTexture(tsize,tsize,0,D3DUSAGE_DMAP,D3DFMT_A8R8G8B8,D3DPOOL_DEFAULT,&pTexture[current_texture],NULL);
					}*/

				SendDlgItemMessage(hDlg,IDC_TTYPE,CB_SETCURSEL,texture_type[current_texture],0);
				tsize_store[current_texture]=tsize;


				r2=texture_stagenum;
				texture_stagenum=1;

				Clear(texture_tmp+(texture_stagenum)*tsize*tsize*4);
				Clear(texture_tmp+(texture_stagenum-1)*tsize*tsize*4);

				for (r=1;r<r2;r++)
				{
					SendDlgItemMessage(hDlg,IDC_LIST2,LB_SETCURSEL,tx_log[current_texture][r].fnum,0);
					pload_from_tx_log(hDlg,tx_log[current_texture][r].fnum);
					exec_func(hDlg,tx_log[current_texture][r].fnum);
					tst=texture_stagenum;
					draw_tw();
					memcpy (texture_tmp+(texture_stagenum+1)*tsize*tsize*4,texture_tmp+texture_stagenum*tsize*tsize*4,tsize*tsize*4);
					_itoa(texture_stagenum,r_string,10);
					SendDlgItemMessage(hDlg,IDC_LIST1,LB_INSERTSTRING,0,(LPARAM) (LPCTSTR)strcat(r_string,tx_gens[tx_log[current_texture][r].fnum].fname));
													
					texture_stagenum++;
				}
				texture_stagenum=r2;
				
				SendDlgItemMessage(hDlg,IDC_LIST2,LB_SETCURSEL,0,0);
				pload(hDlg,0);
				SetDlgItemInt(hDlg,IDC_EDIT1,current_texture,FALSE);
				tst=texture_stagenum;
				draw_tw();
				DrawScene();
				break;
				}

			case IDC_RESETPARAM:
				{
				int f;
				f=SendDlgItemMessage(hDlg,IDC_LIST2,LB_GETCURSEL,0,0);
				tx_gens[f]=tx_gens_backup[f];
				pload(hDlg,f);
				exec_func(hDlg,f);
				draw_tw();
				break;
				}

			case IDC_COMBO1:
				{
				int r,r2;
				//change texture size
				int a,b;
				a=dtx_view;b=anim_view;
				dtx_view=1;anim_view=1;
				if (tsize!=tsize_table[SendDlgItemMessage(hDlg,IDC_COMBO1,CB_GETCURSEL,0,0)])
				{
					SendDlgItemMessage(hDlg,IDC_LIST1,LB_RESETCONTENT,0,0);
			
					tsize=tsize_table[SendDlgItemMessage(hDlg,IDC_COMBO1,CB_GETCURSEL,0,0)];
					if (texture_type[current_texture]==0)
						{
						pTexture[current_texture]->Release();
						pDevice->CreateTexture(tsize,tsize,0,0,D3DFMT_A8R8G8B8,D3DPOOL_MANAGED,&pTexture[current_texture],NULL);
						}
					if (texture_type[current_texture]==1)
						{
						pTexture[current_texture]->Release();
						pDevice->CreateTexture(tsize,tsize,0,D3DUSAGE_RENDERTARGET,D3DFMT_A8R8G8B8,D3DPOOL_DEFAULT,&pTexture[current_texture],NULL);
						}
					if (texture_type[current_texture]==2)
						{
						pTexture[current_texture]->Release();
						pDevice->CreateTexture(tsize,tsize,0,D3DUSAGE_DMAP,D3DFMT_A8R8G8B8,D3DPOOL_DEFAULT,&pTexture[current_texture],NULL);
						}
					tsize_store[current_texture]=tsize;
					texture_size[current_texture]=tsize;

					r2=texture_stagenum;
					texture_stagenum=1;

					Clear(texture_tmp+(texture_stagenum)*tsize*tsize*4);
					Clear(texture_tmp+(texture_stagenum-1)*tsize*tsize*4);

					for (r=1;r<r2;r++)
					{
					SendDlgItemMessage(hDlg,IDC_LIST2,LB_SETCURSEL,tx_log[current_texture][r].fnum,0);
						
					pload_from_tx_log(hDlg,tx_log[current_texture][r].fnum);
						
					exec_func(hDlg,tx_log[current_texture][r].fnum);
						
					tst=texture_stagenum;
					draw_tw();
						
					memcpy (texture_tmp+(texture_stagenum+1)*tsize*tsize*4,texture_tmp+texture_stagenum*tsize*tsize*4,tsize*tsize*4);
						
					_itoa(texture_stagenum,r_string,10);
						
					SendDlgItemMessage(hDlg,IDC_LIST1,LB_INSERTSTRING,0,(LPARAM) (LPCTSTR)strcat(r_string,tx_gens[tx_log[current_texture][r].fnum].fname));
						

					texture_stagenum++;
					}
					
					texture_stagenum=r2;
				}
				
				pload(hDlg,SendDlgItemMessage(hDlg,IDC_LIST2,LB_GETCURSEL,0,0));
				
				exec_func(hDlg,SendDlgItemMessage(hDlg,IDC_LIST2,LB_GETCURSEL,0,0));
				
				tst=texture_stagenum;
				draw_tw();
				dtx_view=a;anim_view=b;

				break;
				}

			case IDC_BUTTON21:
				{
					char* aaa;aaa="           ";
				//insert step of creating texture
				int cf,f,r,r2;
				if (LB_ERR==SendDlgItemMessage(hDlg,IDC_LIST1,LB_GETCURSEL,0,0))
					SendDlgItemMessage(hDlg,IDC_LIST1,LB_SETCURSEL,0,0);
				cf=texture_stagenum-SendDlgItemMessage(hDlg,IDC_LIST1,LB_GETCURSEL,0,0)-1;
				if (cf>texture_stagenum||cf<1) break;
				//insert in log
				for (f=texture_stagenum;f>cf;f--)
					{
					tx_log[current_texture][f]=tx_log[current_texture][f-1];
					}
				//correcting mixer&2dpshift step-links
				for (f=cf;f<texture_stagenum-1;f++)
					{
					if (tx_gens[tx_log[current_texture][f].fnum].fname=="Mixer") 
						{
						if (tx_log[current_texture][f].p[1]<cf) tx_log[current_texture][f].p[1]++;
						if (tx_log[current_texture][f].p[2]<cf) tx_log[current_texture][f].p[2]++;
						}
					if (tx_gens[tx_log[current_texture][f].fnum].fname=="Map2dPShift") 
						{
						if (tx_log[current_texture][f].p[1]<cf) tx_log[current_texture][f].p[1]++;
						}
					if (tx_gens[tx_log[current_texture][f].fnum].fname=="Map2dPShift2") 
						{
						if (tx_log[current_texture][f].p[1]<cf) tx_log[current_texture][f].p[1]++;
						}

					if (tx_gens[tx_log[current_texture][f].fnum].fname=="AddSprite") 
						{
						if (tx_log[current_texture][f].p[3]<cf) tx_log[current_texture][f].p[3]++;
						}
					}
				//
				for (f=0;f<tfunc_count;f++)
					{
					if (tx_gens[f].fname=="Empty") tx_log[current_texture][cf].fnum=f;
					}
				//reset viewlog
				SendDlgItemMessage(hDlg,IDC_LIST1,LB_RESETCONTENT,0,0);
				
				texture_stagenum++;
				//recreate
				r2=texture_stagenum;
				texture_stagenum=1;

				for (r=1;r<r2;r++)
				{
					SendDlgItemMessage(hDlg,IDC_LIST2,LB_SETCURSEL,tx_log[current_texture][r].fnum,0);
					pload_from_tx_log(hDlg,tx_log[current_texture][r].fnum);
					exec_func(hDlg,tx_log[current_texture][r].fnum);
					draw_tw();
					memcpy (texture_tmp+(texture_stagenum+1)*tsize*tsize*4,texture_tmp+texture_stagenum*tsize*tsize*4,tsize*tsize*4);
					_itoa(texture_stagenum,r_string,10);
					SendDlgItemMessage(hDlg,IDC_LIST1,LB_INSERTSTRING,0,(LPARAM) (LPCTSTR)strcat(r_string,tx_gens[tx_log[current_texture][r].fnum].fname));
					texture_stagenum++;
				}
				texture_stagenum=r2;
				tst=texture_stagenum;
				draw_tw();
				SendDlgItemMessage(hDlg,IDC_LIST2,LB_SETCURSEL,0,0);
				//}
				break;
				}



			case IDC_BUTTON16:
				{
				//	char* aaa;aaa="           ";
				//delete step of creating texture
				int cf,f,r,r2;
				if (LB_ERR==SendDlgItemMessage(hDlg,IDC_LIST1,LB_GETCURSEL,0,0))
					SendDlgItemMessage(hDlg,IDC_LIST1,LB_SETCURSEL,0,0);
				cf=texture_stagenum-SendDlgItemMessage(hDlg,IDC_LIST1,LB_GETCURSEL,0,0)-1;
				if (cf>texture_stagenum||cf<1) break;
				//del string
				*(tx_log[current_texture][cf].txt)=0;
				
				//del in log
				for (f=cf;f<texture_stagenum-1;f++)
					{
					tx_log[current_texture][f]=tx_log[current_texture][f+1];
					}
				
				//correcting mixer step-links
				for (f=cf;f<texture_stagenum-1;f++)
					{
					if (tx_gens[tx_log[current_texture][f].fnum].fname=="Mixer") 
						{
						if (tx_log[current_texture][f].p[1]>cf) tx_log[current_texture][f].p[1]--;
						if (tx_log[current_texture][f].p[2]>cf) tx_log[current_texture][f].p[2]--;
						}
					if (tx_gens[tx_log[current_texture][f].fnum].fname=="Map2dPShift") 
						{
						if (tx_log[current_texture][f].p[1]>cf) tx_log[current_texture][f].p[1]--;
						}
					if (tx_gens[tx_log[current_texture][f].fnum].fname=="Map2dPShift2") 
						{
						if (tx_log[current_texture][f].p[1]>cf) tx_log[current_texture][f].p[1]--;
						}

					if (tx_gens[tx_log[current_texture][f].fnum].fname=="AddSprite") 
						{
						if (tx_log[current_texture][f].p[3]>cf) tx_log[current_texture][f].p[3]--;
						}


					}
				//
				//reset viewlog
				SendDlgItemMessage(hDlg,IDC_LIST1,LB_RESETCONTENT,0,0);
				
				texture_stagenum--;
				//recreate
				r2=texture_stagenum;
				texture_stagenum=1;
				

				Clear(texture_tmp+(texture_stagenum)*tsize*tsize*4);
				Clear(texture_tmp+(texture_stagenum-1)*tsize*tsize*4);
				
				for (r=1;r<r2;r++)
				{
					SendDlgItemMessage(hDlg,IDC_LIST2,LB_SETCURSEL,tx_log[current_texture][r].fnum,0);
					
					pload_from_tx_log(hDlg,tx_log[current_texture][r].fnum);
					
					exec_func(hDlg,tx_log[current_texture][r].fnum);
					
					draw_tw();
					
					memcpy (texture_tmp+(texture_stagenum+1)*tsize*tsize*4,texture_tmp+texture_stagenum*tsize*tsize*4,tsize*tsize*4);
					
					_itoa(texture_stagenum,r_string,10);
					
					SendDlgItemMessage(hDlg,IDC_LIST1,LB_INSERTSTRING,0,(LPARAM) (LPCTSTR)strcat(r_string,tx_gens[tx_log[current_texture][r].fnum].fname));
					
					texture_stagenum++;
				}
				texture_stagenum=r2;
				tst=texture_stagenum;
				draw_tw();
				
				SendDlgItemMessage(hDlg,IDC_LIST2,LB_SETCURSEL,0,0);
				//}
				if (texture_stagenum<1) texture_stagenum=1;
				break;
				}

			case IDC_BUTTON17:
				{
				//clear texture log
				if (IDOK==MessageBox(Texture_UIDlg,"Clear texture?","Attention!!!",MB_OKCANCEL))
				{
				int a;
				for (int cf=1;cf<texture_stagenum;cf++)
					{
					*(tx_log[current_texture][cf].txt)=0;
					}

				texture_stagenum=1;
				Clear(texture_tmp+(texture_stagenum)*tsize*tsize*4);
				Clear(texture_tmp+(texture_stagenum-1)*tsize*tsize*4);
				SendDlgItemMessage(hDlg,IDC_LIST1,LB_RESETCONTENT,0,0);
				tst=texture_stagenum;
				draw_tw();
				SendDlgItemMessage(hDlg,IDC_LIST2,LB_SETCURSEL,0,0);
				}
				break;
				}

			case IDC_TCHANGE:
				{
				//change step
				int cf,f;
					if (LB_ERR==SendDlgItemMessage(hDlg,IDC_LIST1,LB_GETCURSEL,0,0))
					SendDlgItemMessage(hDlg,IDC_LIST1,LB_SETCURSEL,0,0);

				change_flag=1;
				store_texture_stagenum=texture_stagenum;
				cf=texture_stagenum-SendDlgItemMessage(hDlg,IDC_LIST1,LB_GETCURSEL,0,0)-1;
				if (cf>texture_stagenum||cf<1) break;
				texture_stagenum=cf;
				memcpy (texture_tmp+(texture_stagenum+1)*tsize*tsize*4,texture_tmp+texture_stagenum*tsize*tsize*4,tsize*tsize*4);
				SendDlgItemMessage(hDlg,IDC_LIST2,LB_SETCURSEL,tx_log[current_texture][texture_stagenum].fnum,0);
				TUI_hide_param_ctrls(hDlg);
				pload_from_tx_log(hDlg,tx_log[current_texture][texture_stagenum].fnum);
					
				exec_func(hDlg,tx_log[current_texture][texture_stagenum].fnum);
				tst=texture_stagenum;
				draw_tw();
				ShowWindow(GetDlgItem(hDlg,IDC_FVIEW),SW_SHOW);
				EnableWindow(GetDlgItem(hDlg,IDC_TCHANGE),FALSE);
				EnableWindow(GetDlgItem(hDlg,IDC_BUTTON21),FALSE);
				EnableWindow(GetDlgItem(hDlg,IDC_BUTTON17),FALSE);
				EnableWindow(GetDlgItem(hDlg,IDC_BUTTON16),FALSE);
				break;
				}

			case IDC_BUTTON10:
				{
				//write to log & prepare to next step of creating texture
				int f,t,r;
				char* aa;aa="           ";
				char* aaa;aaa="           ";
				
				if (change_flag==1) 
				{for (r=texture_stagenum;r<store_texture_stagenum;r++) {SendDlgItemMessage(hDlg,IDC_LIST1,LB_DELETESTRING,0,0);}}

				f=SendDlgItemMessage(hDlg,IDC_LIST2,LB_GETCURSEL,0,0);
				if (*(tx_gens[f].fname)!=':')
					{
					memcpy (texture_tmp+(texture_stagenum+1)*tsize*tsize*4,texture_tmp+texture_stagenum*tsize*tsize*4,tsize*tsize*4);
					for (int j=1;j<=(tx_gens[f].numparams+1);j++)
						{
						tx_log[current_texture][texture_stagenum].p[j]=SendDlgItemMessage (hDlg,TUI_param_ctrls[j].pslider,TBM_GETPOS,0,0);
						}	
					tx_log[current_texture][texture_stagenum].fnum=f;
					_itoa(texture_stagenum,r_string,10);
					SendDlgItemMessage(hDlg,IDC_LIST1,LB_INSERTSTRING,0,(LPARAM) (LPCTSTR)strcat(r_string,tx_gens[f].fname));
					texture_stagenum++;
				}
				

				if (change_flag==1)
				{
					t=texture_stagenum;

					for (r=t;r<store_texture_stagenum;r++)
					{
					SendDlgItemMessage(hDlg,IDC_LIST2,LB_SETCURSEL,tx_log[current_texture][r].fnum,0);
					pload_from_tx_log(hDlg,tx_log[current_texture][r].fnum);
					exec_func(hDlg,tx_log[current_texture][r].fnum);
					draw_tw();
					memcpy (texture_tmp+(texture_stagenum+1)*tsize*tsize*4,texture_tmp+texture_stagenum*tsize*tsize*4,tsize*tsize*4);
					_itoa(texture_stagenum,r_string,10);
					SendDlgItemMessage(hDlg,IDC_LIST1,LB_INSERTSTRING,0,(LPARAM) (LPCTSTR)strcat(r_string,tx_gens[tx_log[current_texture][r].fnum].fname));
					texture_stagenum++;
					}
				change_flag=0;
				TUI_hide_param_ctrls(hDlg);
				ShowWindow(GetDlgItem(hDlg,IDC_FVIEW),SW_HIDE);
				EnableWindow(GetDlgItem(hDlg,IDC_BUTTON21),TRUE);
				EnableWindow(GetDlgItem(hDlg,IDC_TCHANGE),TRUE);
				EnableWindow(GetDlgItem(hDlg,IDC_BUTTON17),TRUE);
				EnableWindow(GetDlgItem(hDlg,IDC_BUTTON16),TRUE);
				SendDlgItemMessage(hDlg,IDC_LIST2,LB_SETCURSEL,0,0);
				}

				tst=texture_stagenum;
				draw_tw();

				break;
				}

			case IDC_LIST2:
				{
				int f;
				f=SendDlgItemMessage(hDlg,IDC_LIST2,LB_GETCURSEL,0,0);

				TUI_hide_param_ctrls(hDlg);
				pload(hDlg,f);

				exec_func(hDlg,f);
				tst=texture_stagenum;
				draw_tw();

				if (HIWORD (wParam) == LBN_DBLCLK) if (change_flag==0) SendMessage(Texture_UIDlg,WM_COMMAND,IDC_BUTTON10,0);
				break;
				};


			break;	
			}
		}
	
  }
  return 0L;
}

int tww=32;
int twh=32;
int twox=0;
int twoy=0;

void t_view_rotorzoom (BYTE *dst,int xxx,int yyy,int p1,int p2,int p3)
{
int x,y,r,g,b,a,addr;double alfa,c,d,dx,dy,tx,ty,rtx,rty;
int addr1,addr2;
addr=0;p3*=2;//p1*=2;
alfa=p1*360.0/256.0;
dx=cos(alfa*3.14/180.0)*p2/64.0;
dy=sin(alfa*3.14/180.0)*p2/64.0;

rtx=tsize/2+1.4*tww/2*sin((alfa-45)*3.14/180.0)*p2/64.0+xxx*cos(-alfa*3.14/180)+yyy*sin(-alfa*3.14/180);
rty=tsize/2-1.4*twh/2*cos((alfa-45)*3.14/180.0)*p2/64.0+yyy*cos(alfa*3.14/180)+xxx*sin(alfa*3.14/180);


  for (y=0;y<twh;y++)
  {
	tx=rtx;ty=rty;
	for (x=0;x<tww;x++)
	{
	addr2=(int)x*4+(int)y*4*tww;
	if (tx>tsize||tx<0||ty>tsize||ty<0) 
		{
		if (twf==1)
		{_asm{ mov eax,0
			mov edx,addr2
			mov edi,texture_swp
			mov [edi+edx],eax
		}}
		else
		{	_asm{ mov eax,0x80808080
			mov edx,addr2
			mov edi,texture_swp
			mov [edi+edx],eax
		}}

		goto q;
		}

		{
		addr1=(int)tx*4+(int)ty*4*tsize;
		_asm {
			mov edi,dst
			mov edx,addr1
			add edi,edx
			xor eax,eax
			mov eax,[edi]
			mov edi,texture_swp
			mov edx,addr2
			add edi,edx
			mov [edi],eax
			}
		}
	q:;
	  tx+=dx;ty+=dy;
	}

	rtx-=dy;
	rty+=dx;
  }
}


HWND qqq;
int cx,cy,tx,ty,twx,twy,wx,wy;
int drag_flag=0;


void draw_tw()
{
// HDC mainDC - DC  
int px=0;   //
int py=0;   //
int bs,of; 			
int right,left,top_b;
int icx,icy;
RECT wr;
int y_offset;
GetWindowRect(qqq,&wr);
icx=(wr.right-wr.left); //  
icy=(wr.bottom-wr.top); // 
tww=icx;//     
twh=icy;//     
bs=icx*icy;

BITMAPINFO info; 
ZeroMemory(&info,sizeof(info)); 
info.bmiHeader.biSize=sizeof(info.bmiHeader); 
info.bmiHeader.biWidth=icx; 
 info.bmiHeader.biHeight=icy; 
 info.bmiHeader.biPlanes=1; 
 info.bmiHeader.biBitCount=32; 
 info.bmiHeader.biCompression=BI_RGB; 
 info.bmiHeader.biSizeImage=0; 
 info.bmiHeader.biXPelsPerMeter=3700; 
 info.bmiHeader.biYPelsPerMeter=3700; 
 info.bmiHeader.biClrUsed=16; 
 info.bmiHeader.biClrImportant=0; 

 COLORREF* real_bmp=NULL; 
 HDC hDC = CreateCompatibleDC ( mainDC ); 
 HBITMAP memBMP = CreateDIBSection( hDC, &info, DIB_RGB_COLORS,(void**)&real_bmp,NULL,NULL); 
 HGDIOBJ last_obj=SelectObject ( hDC, memBMP ); 


	int j;
	int _tx,_ty;
	if (drag_flag==0) {_tx=wx;_ty=wy;} else {_tx=twx;_ty=twy;}
	twox=_tx;twoy=_ty;

	t_view_rotorzoom(texture_tmp+tst*tsize*tsize*4,-_tx,_ty,t_viewroll,t_viewzoom,icx/2);

 right=icx;
 
 left=0;
 top_b=0; 
 
 j=icy;

 top_b=top_b+left*4;

 if (icx>0&&icy>0)
 {
 _asm{
	  mov esi,texture_swp
	  mov edi,real_bmp
	  mov edx,top_b
	  add edi,edx

		  mov ebx,icx
		  add ebx,ebx
		  add ebx,ebx

		  mov ecx,j
	lpy:	
			push ecx
			push esi
			push edi
				mov ecx,right
				rep movsd
			pop edi	
			pop esi
			pop ecx

			add edi,ebx
			mov eax,icx
			add eax,eax
			add eax,eax
			add esi,eax

			loop lpy

 	  }
 }
 //----

  BitBlt(mainDC,px,py,icx,icy,hDC,0,0,SRCCOPY); 

  SelectObject ( hDC, last_obj); 
  DeleteObject(memBMP); 
  DeleteDC(hDC); 

 //---

char* aa;aa=new char[100];

_itoa(tst,aa,10);
strcat(aa," texture stage");
SetWindowText(hWndMain2,aa);
delete(aa);

CreateObject();	
}

int spacedown_flag=0;

void change_func(char* st)
{
int a;for (int t=0;t<tfunc_count;t++) 
	{
	if (tx_gens[t].fname==st) 
		{
		a=t;
		SendDlgItemMessage(Texture_UIDlg,IDC_LIST2,LB_SETCURSEL,(WPARAM)a,0);
		TUI_hide_param_ctrls(Texture_UIDlg);
		pload(Texture_UIDlg,a);
		exec_func(Texture_UIDlg,a);
		tst=texture_stagenum;
		draw_tw();
		return;
		}
	}
}

void change_func2(int a)
{
SendDlgItemMessage(Texture_UIDlg,IDC_LIST2,LB_SETCURSEL,(WPARAM)a,0);
TUI_hide_param_ctrls(Texture_UIDlg);
pload(Texture_UIDlg,a);
exec_func(Texture_UIDlg,a);
tst=texture_stagenum;
draw_tw();
}


void roll_param(int i,int zDelta)
{
int a;a=SendDlgItemMessage(Texture_UIDlg,TUI_param_ctrls[i].pslider,TBM_GETPOS,0,0);
a=a+zDelta/50.0;;if (a<0) a=0;if (a>255) a=255;
SendDlgItemMessage(Texture_UIDlg,TUI_param_ctrls[i].pslider,TBM_SETPOS,TRUE,(LPARAM) a);
SetDlgItemInt(Texture_UIDlg,TUI_param_ctrls[i].pnumview,a,FALSE);
tx_gens[SendDlgItemMessage(Texture_UIDlg,IDC_LIST2,LB_GETCURSEL,0,0)].defvalue[i-1]=a;

exec_func(Texture_UIDlg,SendDlgItemMessage(Texture_UIDlg,IDC_LIST2,LB_GETCURSEL,0,0));
draw_tw();
}


LRESULT CALLBACK TextureWProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;int f;

	switch (message) 
	{
	case WM_ACTIVATE:
		if (LOWORD(wParam)==WA_INACTIVE) active_app=0; else active_app=1;
		break;

	case WM_MOVING:
		{
		DrawScene();draw_tw();
		break;
		}

	case WM_CLOSE:
		{
		SendMessage(Parent_hWnd,WM_COMMAND,W_2D,0);
		break;
		}

	case WM_LBUTTONDBLCLK:
		{
		tst=texture_stagenum;
		SendMessage(Texture_UIDlg,WM_COMMAND,IDC_BUTTON10,0);
		break;
		}
	case WM_LBUTTONDOWN:
		{
		int xPos,yPos,fwKeys;
		fwKeys = wParam;        // key flags 
		xPos = LOWORD(lParam);  // horizontal position of cursor 
		yPos = HIWORD(lParam);  // vertical position of cursor 
		tst=texture_stagenum;
		if (drag_flag==0&&spacedown_flag==1) {drag_flag=1;tx=xPos-wx;ty=yPos-wy;SetCursor(hand);cursor=1;}
		break;
		}
	case WM_LBUTTONUP:
		{
		int xPos,yPos,fwKeys;
		fwKeys = wParam;        // key flags 
		xPos = LOWORD(lParam);  // horizontal position of cursor 
		yPos = HIWORD(lParam);  // vertical position of cursor 
		drag_flag=0;SetCursor(pointer);cursor=0;
		wx=twx;wy=twy;
		break;
		}
		
	case WM_CREATE:
		{
		wx=0;wy=0;

		SetCursor(pointer);

		qqq=CreateWindow("STATIC","s123",WS_CHILD|SS_BLACKRECT,0,0,256,256,hWnd,NULL,hInst,NULL);
		ShowWindow(qqq,TRUE);

		mainDC=GetWindowDC(qqq);
		break;
		}

	case WM_MOUSEWHEEL:
		{
		int zDelta;
		zDelta = (short) HIWORD(wParam);    // wheel rotation
		int fwKeys;
		fwKeys = LOWORD(wParam);

			if (HIWORD(GetKeyState('1'))>0)	{roll_param(1,zDelta);break;}
			if (HIWORD(GetKeyState('2'))>0)	{roll_param(2,zDelta);break;}
			if (HIWORD(GetKeyState('3'))>0)	{roll_param(3,zDelta);break;}
			if (HIWORD(GetKeyState('4'))>0)	{roll_param(4,zDelta);break;}
			if (HIWORD(GetKeyState('5'))>0)	{roll_param(5,zDelta);break;}
			if (HIWORD(GetKeyState('6'))>0)	{roll_param(6,zDelta);break;}
			if (HIWORD(GetKeyState('7'))>0)	{roll_param(7,zDelta);break;}

			if (zDelta<0) t_viewzoom-=10; else t_viewzoom+=10;
			if (t_viewzoom<0) t_viewzoom=255;
			if (t_viewzoom>255) t_viewzoom=0;
			draw_tw();
			goto q;
		}

	case WM_MOUSEMOVE:
		{
			if (window!=1) {window=1;winpos();SetFocus(hWndMain2);}

			if (cursor==0) SetCursor (pointer);
			if (cursor==1) SetCursor (hand);
			if (cursor==2) SetCursor (txrot);

		int xPos,yPos,int fwKeys;
		fwKeys = wParam;        // key flags 
		xPos = LOWORD(lParam);  // horizontal position of cursor 
		yPos = HIWORD(lParam);  // vertical position of cursor 


		q:;		
		//--
		  if (fwKeys==MK_LBUTTON) tst=texture_stagenum;

		  if (drag_flag==1) {twx=xPos-tx;twy=yPos-ty;}
		  if (dtx_view==1) draw_tw();

 
		  if (fwKeys==MK_LBUTTON&&drag_flag==0&&spacedown_flag==0)
			{
					xPos=xPos-(tww/2-tsize*64/t_viewzoom/2);
					yPos=yPos-(twh/2-tsize*64/t_viewzoom/2);
					xPos=xPos*t_viewzoom/64;
					yPos=yPos*t_viewzoom/64;
					xPos-=wx;yPos-=wy;	
					xPos=xPos*256/tsize;yPos=255-yPos*256/tsize;//  256

					if (xPos>255) xPos=255;if (xPos<0) xPos=0;
					if (yPos>255) yPos=255;if (yPos<0) yPos=0;


				f=SendDlgItemMessage(Texture_UIDlg,IDC_LIST2,LB_GETCURSEL,0,0);
				if (tx_gens[f].numparams>=2)
				{
				if (*(tx_gens[f].pdesc[0])=='x'||*(tx_gens[f].pdesc[0])=='')//  
					{
					SendDlgItemMessage(Texture_UIDlg,TUI_param_ctrls[1].pslider,TBM_SETPOS,TRUE,(LPARAM) xPos);
					SendDlgItemMessage(Texture_UIDlg,TUI_param_ctrls[2].pslider,TBM_SETPOS,TRUE,(LPARAM) yPos);
					tx_gens[f].defvalue[0]=xPos;
					tx_gens[f].defvalue[1]=yPos;
					if (dtx_view==1) 
					{exec_func(Texture_UIDlg,f);
							draw_tw();}
					}
				}
			}
		 //DrawScene();
		break;
		}


		case WM_CHAR:
			{
			int CharCode = (TCHAR) wParam;
			if (tx_gens[SendDlgItemMessage(Texture_UIDlg,IDC_LIST2,LB_GETCURSEL,0,0)].fname=="DrwTxt")
			{
				int c_carp;
				for (int i=0;i<32;i++) 
					{
					if (*(tx_log[current_texture][texture_stagenum].txt+i)==0) {c_carp=i;goto cok;}
					}
				cok:;

				if (CharCode==0x8&&c_carp>0) {*(tx_log[current_texture][texture_stagenum].txt+c_carp-1)=0;c_carp--;}
				if (CharCode==' '&&c_carp<31)
					{
					*(tx_log[current_texture][texture_stagenum].txt+c_carp)=CharCode;c_carp++;
					*(tx_log[current_texture][texture_stagenum].txt+c_carp)=0;
					}
				if (CharCode>='0'&&CharCode<='9'&&c_carp<31)
					{
					*(tx_log[current_texture][texture_stagenum].txt+c_carp)=CharCode;c_carp++;
					*(tx_log[current_texture][texture_stagenum].txt+c_carp)=0;
					}
				if (CharCode>='A'&&CharCode<='Z'&&c_carp<31)
					{
					*(tx_log[current_texture][texture_stagenum].txt+c_carp)=CharCode;c_carp++;
					*(tx_log[current_texture][texture_stagenum].txt+c_carp)=0;
					}
				if (CharCode>='a'&&CharCode<='z'&&c_carp<31)
					{
					*(tx_log[current_texture][texture_stagenum].txt+c_carp)=CharCode-'a'+'A';c_carp++;
					*(tx_log[current_texture][texture_stagenum].txt+c_carp)=0;
					}

				if ((CharCode==','||CharCode=='.'||CharCode=='!'||CharCode=='?')&&c_carp<31)
					{
					*(tx_log[current_texture][texture_stagenum].txt+c_carp)=CharCode;c_carp++;
					*(tx_log[current_texture][texture_stagenum].txt+c_carp)=0;
					}

				exec_func(Texture_UIDlg,SendDlgItemMessage(Texture_UIDlg,IDC_LIST2,LB_GETCURSEL,0,0));
				draw_tw();
			}
			return(0);
			}
		case WM_KEYDOWN:
			{
			if (tx_gens[SendDlgItemMessage(Texture_UIDlg,IDC_LIST2,LB_GETCURSEL,0,0)].fname!="DrwTxt")
			{
				switch (wParam)
				{
				case VK_F1:{cwps=0;SendMessage(Parent_hWnd,WM_COMMAND,ID_MENUITEM_LP,0);break;}
				case VK_F2:{cwps=1;SendMessage(Parent_hWnd,WM_COMMAND,ID_MENUITEM_LP,0);break;}
				case VK_F3:{cwps=2;SendMessage(Parent_hWnd,WM_COMMAND,ID_MENUITEM_LP,0);break;}
				case VK_F4:{cwps=3;SendMessage(Parent_hWnd,WM_COMMAND,ID_MENUITEM_LP,0);break;}
				case VK_F5:{cwps=4;SendMessage(Parent_hWnd,WM_COMMAND,ID_MENUITEM_LP,0);break;}

				case VK_SPACE :
					{
						cursor=1;
						SetCursor(hand);
						spacedown_flag=1;
						break;
					}
				case '9':
					{
						//winsize to tsize
						SetWindowPos(hWnd,HWND_TOP,0,0,tsize+20,tsize+60,SWP_NOMOVE);
						draw_tw();
						goto ztw;
						break;
					}
				case '8':
					{
						//zoom to winsize
					ztw:;
						RECT r;int shr;
						GetWindowRect(hWnd,&r);
						if ((r.bottom-r.top)<(r.right-r.left)) shr=r.bottom-r.top; else shr=r.right-r.left;
						t_viewzoom=64*(tsize*1.5)/(shr+1);
						draw_tw();
						break;
					}

				case '0':
					{
						t_viewzoom=64;
						goto q;
					}

				case 'L':{change_func("Lenz");break;}
				case 'M':{change_func("Mixer");break;}
				case 'T':{change_func("Twirl");break;}
				case 'Z':{change_func("RotorZoom");break;}
				case 'B':{change_func("Blur");break;}
				case 'S':{change_func("PShift");break;}
				case 'C':{change_func("CrossFade");break;}
				case 'A':{change_func("AddParticle");break;}
				case 'N':{change_func("AddNoise");break;}
				case 'D':{change_func("Map2dPShift");break;}
				case 'J':{change_func("AdjustColor");break;}

				case VK_TAB:
						{
						int i;char c[100];
						i=SendDlgItemMessage(Texture_UIDlg,IDC_LIST2,LB_GETCURSEL,0,0);
						 if (HIWORD(GetKeyState(VK_CONTROL))>0)
							{
							i--;
							if (i<1) i=tfunc_count-1;
							}
						 else
							{
							i++;
							if (i>=tfunc_count) i=1;
							}

						change_func2(i);
						break;
						}

				case 'W':
					{
						twf=1-twf;
						goto q;
					}

				}
			}

			break;
			}
		case WM_KEYUP:
			{
			switch (wParam)
				{
				case VK_SPACE:
					{
						cursor=0;
						SetCursor(pointer);
						spacedown_flag=0;
						break;
					}

				}
			break;
			}

	case WM_SIZE:
		{
		//SetCursor(txrot);
		int cx,cy,sx,sy,sx2,sy2;
		RECT wp;
		GetWindowRect(hWnd,&wp);
		 sx2=wp.right-wp.left;
		 sy2=wp.bottom-wp.top;
		SetWindowPos(qqq,HWND_TOP,0,0,sx2-6,sy2-48,SWP_DRAWFRAME);
		break;
		}

		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   }
   return 0;
}
