#include <mmsystem.h>

//-
int tl_play_pos=0;
int tl_play_pos2=0;
double start_time=0;
const int pt_len=1000;
float bf,brf,p;
char CamIntType=0;
char CamFlyType=0;
char MatIntType=0;
int CamPosObj,CamViewObj;
unsigned char camcap_scn_cam,camcap_scn_tgt;
char CamCapFlag=0;
int cr_stack[4];
int tp=0;

double tmptimer;

typedef struct {double time,segmlen,x,y,z,tgt_x,tgt_y,tgt_z,xy_a,dist;} t_spline_point;
typedef struct {unsigned char count; double splinelen, start_time, curr_segment; t_spline_point points[64];} t_spline;
t_spline Splines[256]; //    256 

//QWORD pos;
bool flag_normalize_tgt=FALSE;
bool flag_normalize_eye=FALSE;
//   
//( ,        )

	//     
bool splCamFlag=FALSE;
unsigned char splCam_spline, splCam_currsegm, splCam_segmcount;
double splCam_timer, splCam_spline_len, splCam_segm_timestart, splCam_segm_timer;

bool pCamFlag=FALSE;
bool pCamEye_flag=FALSE;
unsigned char pCamEye_spline, pCamEye_currsegm, pCamEye_segmcount;
double pCamEye_timer, pCamEye_spline_len, pCamEye_segm_timestart, pCamEye_segm_timer;
unsigned char pCamEye_type; //   
	//0 - eye spline [time,splinenumber,flag_normalize_eye]
	//1 - eye camcap [scn, obj]
bool pCamTgt_flag=FALSE;
unsigned char pCamTgt_spline, pCamTgt_currsegm, pCamTgt_segmcount;
double pCamTgt_timer, pCamTgt_spline_len, pCamTgt_segm_timestart, pCamTgt_segm_timer;
unsigned char pCamTgt_type; //   
	//0 - tgt spline [time,splinenumber,flag_normalize_tgt]
	//1 - tgt camcap [scn, obj]
//  


//      
BOOL CALLBACK _export tracker_UIProc(HWND, UINT, WPARAM, LPARAM);

// 
void trackerUI_init()
{
//   
static DLGPROC lpfnDlgProc;
lpfnDlgProc = (DLGPROC)MakeProcInstance((FARPROC)tracker_UIProc, hInst);
tracker_UIDlg = CreateDialog(hInst, MAKEINTRESOURCE(IDD_TRACKER),Parent_hWnd, lpfnDlgProc);
}

//  
typedef struct {unsigned char min; unsigned char sec; unsigned short msec;} t_trktime;
typedef struct {unsigned char trkcmd; t_trktime time; unsigned char param[6];} t_trkcmd;
typedef struct {t_trktime time; unsigned char cmdcount; t_trkcmd trkcmdlist[16]; char comment[64];} t_trk_timeline;
t_trk_timeline trk_timeline[256];
unsigned char trk_timeline_count;
bool trk_timeline_flags[256];
double trktime_start; //  
double trktime_curr; //    
double trktime_list; //   

unsigned char cam_1;
unsigned char cam_2;
unsigned char cam_pathtype;
unsigned char cam_targettype;
double cam_timer;
double cam_timestart;

	//--   
typedef struct {double timer; double timestart; unsigned char dest; bool flag;} t_sldmat;
t_sldmat sldmat[256];
	//--   
typedef struct {double timer; double timestart; bool flag; unsigned char scn_obj; unsigned char obj; unsigned char scn_tgtobj; unsigned char tgtobj;} t_sldobj;
t_sldobj sldobj[256];
unsigned char sldobj_count;
	//--   
const splineobj_maxcount=256;
typedef struct {bool flag; double timer; unsigned char currsegm, scn_obj, obj, spline; double segmtime_begin[64], segmtimer[64];} t_splineobj;
t_splineobj splineobj[splineobj_maxcount];
unsigned char splineobj_count;

//   
const trk_cmd_count=11;
typedef struct {char* pnames[trk_cmd_count];} t_trkcmd_desc; //  
t_trkcmd_desc trkcmd_desc [trk_cmd_count];

char* trk_cmd[]={	"SetScn",	//0
					"SetCam",	//1
					"SldCam",	//2
					"SldMat",	//3
					"SldObj",	//4
					"CamCap",	//5
					"SetNorm",	//6
					"GetSplObj",//7
					"SplineObj",//8
					"GetSplCam",//9 [cam1,cam2,spleye,spltgt]
					"SplineCam",	//10 [<time>spline,segm_begin,segm_count]
					"pCamEye",	//10
					"pCamTgt",	//11 [type]
				};
unsigned long timemsec;
bool mod_trk_timeline = FALSE;
unsigned char trackertype = 1; //0-old 1-new

typedef struct {unsigned char num,p[4];} tcommand;
tcommand strack[1][pt_len];
int chnl=0;

char* cmd_list[]={	".......",
					"SetScn",
					"SetCam",
					"SldCam",
					"SldMat",
					"SldScn",
					"SldObj",
					"SetSpd",
					"StopObj",
					"StopMat",
					"CamITp",//cam interpolation type
					"MatITp",//material interpolation type
					"CamCap",
					"PAnim"};

int pattern_cur_pos=0;

int ccam=0;int ccampos=0;double starttime=0;
int ncam=0;int ncampos=0;
int spd=4;int cam_slideflag=0;

int cmat[256];int cmatpos[256];
int nmat[256];int nmatpos[256]; int mat_slideflag[256];

int cscn=0;int cscnpos=0; int scn_slideflag=0;
int nscn=0;int nscnpos=0;

int cobj[128];int cobjpos[128];int obj_slideflag[128];
int nobj[128];int nobjpos[128];int nobj_sc[128];

//---    
void Update_trklistUI()
{
SendDlgItemMessage(tracker_UIDlg,IDC_TRKLIST,LB_RESETCONTENT,0,0);
for (int i02=0;i02<trk_timeline_count;i02++)
	{
	//timemsec=trk_timeline[i02].time.msec+60*(trk_timeline[i02].time.sec+60*(trk_timeline[i02].time.min));
	sprintf(tempstr,"%02d:%02d.%04d  [%s]",trk_timeline[i02].time.min,trk_timeline[i02].time.sec,trk_timeline[i02].time.msec,trk_timeline[i02].comment);
	SendDlgItemMessage(tracker_UIDlg,IDC_TRKLIST,LB_ADDSTRING,0,(LPARAM)(LPCTSTR)tempstr);
	}
}
//---    

Update_trkcmdcselparamUI()
{
int i03=SendDlgItemMessage(tracker_UIDlg,IDC_TRKCMDCSEL,CB_GETCURSEL,0,0);
SetDlgItemText(tracker_UIDlg,IDC_TRKPTXT0,trkcmd_desc[i03].pnames[0]);
SetDlgItemText(tracker_UIDlg,IDC_TRKPTXT1,trkcmd_desc[i03].pnames[1]);
SetDlgItemText(tracker_UIDlg,IDC_TRKPTXT2,trkcmd_desc[i03].pnames[2]);
SetDlgItemText(tracker_UIDlg,IDC_TRKPTXT3,trkcmd_desc[i03].pnames[3]);
SetDlgItemText(tracker_UIDlg,IDC_TRKPTXT4,trkcmd_desc[i03].pnames[4]);
SetDlgItemText(tracker_UIDlg,IDC_TRKPTXT5,trkcmd_desc[i03].pnames[5]);
}

Update_trkcmdparamUI()
{
int i01=SendDlgItemMessage(tracker_UIDlg,IDC_TRKLIST,LB_GETCURSEL,0,0);
if (trk_timeline[i01].cmdcount>0)
	{
	int j01=SendDlgItemMessage(tracker_UIDlg,IDC_TRKCMDLIST,LB_GETCURSEL,0,0);
	SendDlgItemMessage(tracker_UIDlg,IDC_TRKCMDCSEL,CB_SETCURSEL,trk_timeline[i01].trkcmdlist[j01].trkcmd,0);
	SetDlgItemText(tracker_UIDlg,IDC_TRKPTXT0,trkcmd_desc[trk_timeline[i01].trkcmdlist[j01].trkcmd].pnames[0]);
	SetDlgItemText(tracker_UIDlg,IDC_TRKPTXT1,trkcmd_desc[trk_timeline[i01].trkcmdlist[j01].trkcmd].pnames[1]);
	SetDlgItemText(tracker_UIDlg,IDC_TRKPTXT2,trkcmd_desc[trk_timeline[i01].trkcmdlist[j01].trkcmd].pnames[2]);
	SetDlgItemText(tracker_UIDlg,IDC_TRKPTXT3,trkcmd_desc[trk_timeline[i01].trkcmdlist[j01].trkcmd].pnames[3]);
	SetDlgItemText(tracker_UIDlg,IDC_TRKPTXT4,trkcmd_desc[trk_timeline[i01].trkcmdlist[j01].trkcmd].pnames[4]);
	SetDlgItemText(tracker_UIDlg,IDC_TRKPTXT5,trkcmd_desc[trk_timeline[i01].trkcmdlist[j01].trkcmd].pnames[5]);
	SetDlgItemInt(tracker_UIDlg,IDC_TRKPMIN,trk_timeline[i01].trkcmdlist[j01].time.min,FALSE);
	SetDlgItemInt(tracker_UIDlg,IDC_TRKPSEC,trk_timeline[i01].trkcmdlist[j01].time.sec,FALSE);
	SetDlgItemInt(tracker_UIDlg,IDC_TRKPMSEC,trk_timeline[i01].trkcmdlist[j01].time.msec,FALSE);
	SetDlgItemInt(tracker_UIDlg,IDC_TRKP1,trk_timeline[i01].trkcmdlist[j01].param[0],FALSE);
	SetDlgItemInt(tracker_UIDlg,IDC_TRKP2,trk_timeline[i01].trkcmdlist[j01].param[1],FALSE);
	SetDlgItemInt(tracker_UIDlg,IDC_TRKP3,trk_timeline[i01].trkcmdlist[j01].param[2],FALSE);
	SetDlgItemInt(tracker_UIDlg,IDC_TRKP4,trk_timeline[i01].trkcmdlist[j01].param[3],FALSE);
	SetDlgItemInt(tracker_UIDlg,IDC_TRKP5,trk_timeline[i01].trkcmdlist[j01].param[4],FALSE);
	}
else
	{
	SetDlgItemInt(tracker_UIDlg,IDC_TRKPMIN,0,FALSE);
	SetDlgItemInt(tracker_UIDlg,IDC_TRKPSEC,0,FALSE);
	SetDlgItemInt(tracker_UIDlg,IDC_TRKPMSEC,0,FALSE);
	SetDlgItemInt(tracker_UIDlg,IDC_TRKP1,0,FALSE);
	SetDlgItemInt(tracker_UIDlg,IDC_TRKP2,0,FALSE);
	SetDlgItemInt(tracker_UIDlg,IDC_TRKP3,0,FALSE);
	SetDlgItemInt(tracker_UIDlg,IDC_TRKP4,0,FALSE);
	SetDlgItemInt(tracker_UIDlg,IDC_TRKP5,0,FALSE);
	Update_trkcmdcselparamUI();
	}
}
//---    
void Update_trkcmdUI()
{
int i00=SendDlgItemMessage(tracker_UIDlg,IDC_TRKLIST,LB_GETCURSEL,0,0);
SendDlgItemMessage(tracker_UIDlg,IDC_TRKCMDLIST,LB_RESETCONTENT,0,0);
for (int j00=0; j00<trk_timeline[i00].cmdcount;j00++)
	{
	SendDlgItemMessage(tracker_UIDlg,IDC_TRKCMDLIST,LB_ADDSTRING,0,(LPARAM)(LPCTSTR)trk_cmd[trk_timeline[i00].trkcmdlist[j00].trkcmd]);
	}
}

//---        
void UpdateTrackerInterface()
{
// oldstyle interface
EnableWindow(GetDlgItem(tracker_UIDlg, IDC_UITRK_OLD), !trackertype);
//EnableWindow(GetDlgItem(tracker_UIDlg, IDC_TL_PPLAY_SND), !trackertype);
//EnableWindow(GetDlgItem(tracker_UIDlg, IDC_TL_PPLAY), !trackertype);
//EnableWindow(GetDlgItem(tracker_UIDlg, IDC_TL_PSTOP), !trackertype);
EnableWindow(GetDlgItem(tracker_UIDlg, IDC_PTX2), !trackertype);
EnableWindow(GetDlgItem(tracker_UIDlg, IDC_PINS), !trackertype);
EnableWindow(GetDlgItem(tracker_UIDlg, IDC_PDEL), !trackertype);
EnableWindow(GetDlgItem(tracker_UIDlg, IDC_PCLR), !trackertype);
EnableWindow(GetDlgItem(tracker_UIDlg, IDC_STD), !trackertype);
EnableWindow(GetDlgItem(tracker_UIDlg, IDC_C0), !trackertype);
EnableWindow(GetDlgItem(tracker_UIDlg, IDC_TRKCMDSEL), !trackertype);
EnableWindow(GetDlgItem(tracker_UIDlg, IDC_TP1), !trackertype);
EnableWindow(GetDlgItem(tracker_UIDlg, IDC_TP2), !trackertype);
EnableWindow(GetDlgItem(tracker_UIDlg, IDC_TP3), !trackertype);
EnableWindow(GetDlgItem(tracker_UIDlg, IDC_TP4), !trackertype);
// newstyle interface

EnableWindow(GetDlgItem(tracker_UIDlg, IDC_TRKLIST), trackertype);
EnableWindow(GetDlgItem(tracker_UIDlg, IDC_TRKADD), trackertype);
EnableWindow(GetDlgItem(tracker_UIDlg, IDC_TRKDEL), trackertype);
EnableWindow(GetDlgItem(tracker_UIDlg, IDC_TRKINS), trackertype);
EnableWindow(GetDlgItem(tracker_UIDlg, IDC_TRKMOD), trackertype);
EnableWindow(GetDlgItem(tracker_UIDlg, IDC_STATIC), trackertype);
EnableWindow(GetDlgItem(tracker_UIDlg, IDC_TRK_COMMENT), trackertype);
EnableWindow(GetDlgItem(tracker_UIDlg, IDC_TRK_MIN), trackertype);
EnableWindow(GetDlgItem(tracker_UIDlg, IDC_TRK_SEC), trackertype);
EnableWindow(GetDlgItem(tracker_UIDlg, IDC_TRK_MSEC), trackertype);
EnableWindow(GetDlgItem(tracker_UIDlg, IDC_TRKCMDCSEL), trackertype);
EnableWindow(GetDlgItem(tracker_UIDlg, IDC_TRKCMDADD), trackertype);
EnableWindow(GetDlgItem(tracker_UIDlg, IDC_TRKCMDDEL), trackertype);
EnableWindow(GetDlgItem(tracker_UIDlg, IDC_TRKCMDLIST), trackertype);
EnableWindow(GetDlgItem(tracker_UIDlg, IDC_TRKPMIN), trackertype);
EnableWindow(GetDlgItem(tracker_UIDlg, IDC_TRKPSEC), trackertype);
EnableWindow(GetDlgItem(tracker_UIDlg, IDC_TRKPMSEC), trackertype);
EnableWindow(GetDlgItem(tracker_UIDlg, IDC_TRKP1), trackertype);
EnableWindow(GetDlgItem(tracker_UIDlg, IDC_TRKP2), trackertype);
EnableWindow(GetDlgItem(tracker_UIDlg, IDC_TRKP3), trackertype);
EnableWindow(GetDlgItem(tracker_UIDlg, IDC_TRKP4), trackertype);
EnableWindow(GetDlgItem(tracker_UIDlg, IDC_TRKP5), trackertype);
EnableWindow(GetDlgItem(tracker_UIDlg, IDC_TRKPTXT0), trackertype);
EnableWindow(GetDlgItem(tracker_UIDlg, IDC_TRKPTXT1), trackertype);
EnableWindow(GetDlgItem(tracker_UIDlg, IDC_TRKPTXT2), trackertype);
EnableWindow(GetDlgItem(tracker_UIDlg, IDC_TRKPTXT3), trackertype);
EnableWindow(GetDlgItem(tracker_UIDlg, IDC_TRKPTXT4), trackertype);
EnableWindow(GetDlgItem(tracker_UIDlg, IDC_TRKPTXT5), trackertype);
EnableWindow(GetDlgItem(tracker_UIDlg, IDC_STATIC1), trackertype);
EnableWindow(GetDlgItem(tracker_UIDlg, IDC_STATIC2), trackertype);
EnableWindow(GetDlgItem(tracker_UIDlg, IDC_STATIC3), trackertype);
EnableWindow(GetDlgItem(tracker_UIDlg, IDC_STATIC4), trackertype);
EnableWindow(GetDlgItem(tracker_UIDlg, IDC_STATIC5), trackertype);
EnableWindow(GetDlgItem(tracker_UIDlg, IDC_STATIC6), trackertype);
}




//---   
void UpdatePattern()
{
	char* cstr,*cp;
	cstr=new char [100];cp=new char [100];
//chnl0
		SendDlgItemMessage(tracker_UIDlg,IDC_C0,LB_RESETCONTENT,0,0);

		for (int t=0;t<pt_len;t++) 
			{
			strcpy(cstr," ");
			if (t<10) strcat(cstr,"0");
			if (t<100) strcat(cstr,"0");
			if (t<1000) strcat(cstr,"0");
			_itoa(t,cp,10);
			strcat(cstr,cp);strcat(cstr,"	");

			strcat(cstr,cmd_list[strack[chnl][t].num]);
			strcat(cstr,"	");
			_itoa(strack[chnl][t].p[0],cp,10);strcat(cstr,cp);strcat(cstr,",");
			_itoa(strack[chnl][t].p[1],cp,10);strcat(cstr,cp);strcat(cstr,",");
			_itoa(strack[chnl][t].p[2],cp,10);strcat(cstr,cp);strcat(cstr,",");
			_itoa(strack[chnl][t].p[3],cp,10);strcat(cstr,cp);

			SendDlgItemMessage(tracker_UIDlg,IDC_C0,LB_ADDSTRING,0,(LPARAM) cstr);
			}
		SendDlgItemMessage(tracker_UIDlg,IDC_C0,LB_SETCURSEL,(WPARAM)pattern_cur_pos,0);

	delete(cstr);delete(cp);
}

char cs_store;char snd_playflag=0;

BOOL CALLBACK tracker_UIProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	int aa;

   static HWND  hTip_trk = NULL;
    static char* buf_trk[]={
        "click to load sound file"
		};
	switch (message) 
	{
	case WM_ACTIVATE:
		{
		if (LOWORD(wParam)==WA_INACTIVE) active_app=0; else active_app=1;
		break;
		}
    case WM_LBUTTONDOWN:
		{
		PostMessage(hWnd, WM_NCLBUTTONDOWN, HTCAPTION,0);
		break;
		}
	case WM_MOVING:
		{
		DrawScene();draw_tw();
		break;
		}
	case WM_MOUSEMOVE:
		{
		if (window!=7&&AutoFocus==0) 
			{
			SetFocus(tracker_UIDlg);window=7;
			}
		break;
		}
	case WM_CLOSE:
		{
		SendMessage(Parent_hWnd,WM_COMMAND,W_TR,0);
		break;
		}
	case WM_INITDIALOG:
		{
		//  
		for (int i=0;i<6;i++){for(int j=0;j<trk_cmd_count-1;j++){trkcmd_desc[i].pnames[j]="none:";}}
		trkcmd_desc[0].pnames[1]="scn:";
		trkcmd_desc[1].pnames[1]="cam:";
		trkcmd_desc[2].pnames[0]="speed (time):"; trkcmd_desc[2].pnames[1]="cam1:"; trkcmd_desc[2].pnames[2]="cam2:"; trkcmd_desc[2].pnames[3]="pathtype:"; trkcmd_desc[2].pnames[4]="target type:";
		trkcmd_desc[3].pnames[0]="speed (time):"; trkcmd_desc[3].pnames[1]="mat1:"; trkcmd_desc[3].pnames[2]="mat2:"; trkcmd_desc[3].pnames[3]="reset:";
		trkcmd_desc[4].pnames[0]="speed (time):"; trkcmd_desc[4].pnames[1]="scn_obj:"; trkcmd_desc[4].pnames[2]="obj:"; trkcmd_desc[4].pnames[3]="scn_tgtobj:"; trkcmd_desc[4].pnames[4]="targetobj:"; trkcmd_desc[4].pnames[5]="reset:";
		trkcmd_desc[5].pnames[1]="scn_objcam:"; trkcmd_desc[5].pnames[2]="objcam:"; trkcmd_desc[5].pnames[3]="scn_objtgt:"; trkcmd_desc[5].pnames[4]="objtarget:";
		trkcmd_desc[6].pnames[1]="scene:"; trkcmd_desc[6].pnames[2]="obj:"; trkcmd_desc[6].pnames[3]="normale:";
		trkcmd_desc[7].pnames[1]="spline:"; trkcmd_desc[7].pnames[2]="spl_scn:"; trkcmd_desc[7].pnames[3]="spl_obj:";
		trkcmd_desc[8].pnames[0]="speed (time):";trkcmd_desc[8].pnames[1]="scn_obj:";trkcmd_desc[8].pnames[2]="obj:";trkcmd_desc[8].pnames[3]="spline:";
			//getsplcam [cam1,cam2,spleye,spltgt]
		trkcmd_desc[9].pnames[1]="cam1:"; trkcmd_desc[9].pnames[2]="cam2:"; trkcmd_desc[9].pnames[3]="spline:";
		trkcmd_desc[10].pnames[0]="speed (time):"; trkcmd_desc[10].pnames[1]="spline:"; trkcmd_desc[10].pnames[2]="beg_segm:"; trkcmd_desc[10].pnames[3]="segm_num:";

		SetDlgItemInt(hWnd,IDC_TRK_MIN,0,FALSE); SetDlgItemInt(hWnd,IDC_TRK_SEC,0,FALSE); SetDlgItemInt(hWnd,IDC_TRK_MSEC,0,FALSE);
		SendDlgItemMessage(hWnd,IDC_TRKCMDCSEL,CB_RESETCONTENT,0,0);
		for (int i1=0;i1<trk_cmd_count;i1++) SendDlgItemMessage(hWnd,IDC_TRKCMDCSEL,CB_ADDSTRING,0,(LPARAM) trk_cmd[i1]);
		SendDlgItemMessage(hWnd,IDC_TRKCMDCSEL,CB_SETCURSEL,0,0);

		SendDlgItemMessage(hWnd,IDC_TRACKERSEL,CB_RESETCONTENT,0,0);
		SendDlgItemMessage(hWnd,IDC_TRACKERSEL,CB_ADDSTRING,0,(LPARAM) "OldStyle tracker");
		SendDlgItemMessage(hWnd,IDC_TRACKERSEL,CB_ADDSTRING,0,(LPARAM) "NewStyle tracker");
		SendDlgItemMessage(hWnd,IDC_TRACKERSEL,CB_SETCURSEL,1,0);
		trackertype=1;
		UpdateTrackerInterface();
		// 
		//SendDlgItemMessage(hWnd,IDC_PATTERN,LB_RESETCONTENT,0,0);
		//for (int t=0;t<64;t++) SendDlgItemMessage(hWnd,IDC_PATTERN,LB_ADDSTRING,0,(LPARAM) cmd_list[strack.chnl[0].cmd[t].num]);
		//SendDlgItemMessage(hWnd,IDC_PATTERN,LB_SETCURSEL,0,0);
		UpdatePattern();
		hTip_trk = CreateToolTip(hWnd);
		BOOL res = AddTool(hTip_trk,GetDlgItem(hWnd,IDC_LS),NULL,0,buf_trk[0]);
		EnableToolTip(hTip_trk,TRUE);
		SendDlgItemMessage(hWnd,IDC_CMD,CB_RESETCONTENT,0,0);
		for (int t=0;t<14;t++) SendDlgItemMessage(hWnd,IDC_CMD,CB_ADDSTRING,0,(LPARAM) cmd_list[t]);
		SendDlgItemMessage(hWnd,IDC_CMD,CB_SETCURSEL,0,0);
		break;
		}
	case WM_COMMAND:
		{
			switch (LOWORD(wParam))
			{
			//  
			case IDC_TRACKERSEL:
				{
				trackertype=SendDlgItemMessage(tracker_UIDlg,IDC_TRACKERSEL,CB_GETCURSEL,0,0);
				UpdateTrackerInterface();
				break;
				}
			case IDC_TRKMOD:
				{
				if (trk_timeline>0)
				{
				if (!mod_trk_timeline)
					{
					mod_trk_timeline=TRUE;
					SetDlgItemText (tracker_UIDlg,IDC_TRKMOD,"ok");
					EnableWindow(GetDlgItem(tracker_UIDlg, IDC_TRKADD), FALSE);
					EnableWindow(GetDlgItem(tracker_UIDlg, IDC_TRKDEL), FALSE);
					EnableWindow(GetDlgItem(tracker_UIDlg, IDC_TRKINS), FALSE);
					EnableWindow(GetDlgItem(tracker_UIDlg, IDC_TRKLIST), FALSE);
					int i=SendDlgItemMessage(tracker_UIDlg,IDC_TRKLIST,LB_GETCURSEL,0,0);
					SetDlgItemText(tracker_UIDlg,IDC_TRK_COMMENT,trk_timeline[i].comment);
					SetDlgItemInt(tracker_UIDlg,IDC_TRK_MIN,trk_timeline[i].time.min,FALSE);
					SetDlgItemInt(tracker_UIDlg,IDC_TRK_SEC,trk_timeline[i].time.sec,FALSE);
					SetDlgItemInt(tracker_UIDlg,IDC_TRK_MSEC,trk_timeline[i].time.msec,FALSE);
					}
				else //
					{
					int a0,a1,a2,aa;
					a0=GetDlgItemInt(hWnd,IDC_TRK_MIN,&aa,TRUE); a1=GetDlgItemInt(hWnd,IDC_TRK_SEC,&aa,TRUE); a2=GetDlgItemInt(hWnd,IDC_TRK_MSEC,&aa,TRUE);
					if (a0>=0&&a0<=59&&a1>=0&&a1<=59&&a2>=0&&a2<=999)
						{
						mod_trk_timeline=FALSE;
						SetDlgItemText (tracker_UIDlg,IDC_TRKMOD,"mod");
						EnableWindow(GetDlgItem(tracker_UIDlg, IDC_TRKADD), TRUE);
						EnableWindow(GetDlgItem(tracker_UIDlg, IDC_TRKDEL), TRUE);
						EnableWindow(GetDlgItem(tracker_UIDlg, IDC_TRKINS), TRUE);
						EnableWindow(GetDlgItem(tracker_UIDlg, IDC_TRKLIST), TRUE);
						int i=SendDlgItemMessage(tracker_UIDlg,IDC_TRKLIST,LB_GETCURSEL,0,0);
						GetDlgItemText (tracker_UIDlg,IDC_TRK_COMMENT,trk_timeline[i].comment,63);
						trk_timeline[i].time.min=a0;
						trk_timeline[i].time.sec=a1;
						trk_timeline[i].time.msec=a2;
						Update_trklistUI();
						SendDlgItemMessage(tracker_UIDlg,IDC_TRKLIST,LB_SETCURSEL,i,0);
						Update_trkcmdUI();
						SendDlgItemMessage(tracker_UIDlg,IDC_TRKCMDLIST,LB_SETCURSEL,0,0);
						Update_trkcmdparamUI();
						}
					}
				}
				break;
				}
			case IDC_TRKADD:
				{
				if (trk_timeline_count<256)
					{
					if (snd_playflag==0) //   textbox`
						{
						int a0,a1,a2,aa;
						a0=GetDlgItemInt(hWnd,IDC_TRK_MIN,&aa,TRUE); a1=GetDlgItemInt(hWnd,IDC_TRK_SEC,&aa,TRUE); a2=GetDlgItemInt(hWnd,IDC_TRK_MSEC,&aa,TRUE);
						if (a0>=0&&a0<=59&&a1>=0&&a1<=59&&a2>=0&&a2<=999)
							{
							GetDlgItemText (tracker_UIDlg,IDC_TRK_COMMENT,trk_timeline[trk_timeline_count].comment,63);
							trk_timeline[trk_timeline_count].time.min=a0;
							trk_timeline[trk_timeline_count].time.sec=a1;
							trk_timeline[trk_timeline_count].time.msec=a2;
							trk_timeline_count++;
							Update_trklistUI();
							SendDlgItemMessage(tracker_UIDlg,IDC_TRKLIST,LB_SETCURSEL,trk_timeline_count-1,0);
							Update_trkcmdUI();
							SendDlgItemMessage(tracker_UIDlg,IDC_TRKCMDLIST,LB_SETCURSEL,0,0);
							Update_trkcmdparamUI();
							}
						}
					else //   
						{
						trk_timeline[trk_timeline_count].time.min=floor(trktime_curr/60000);
						trk_timeline[trk_timeline_count].time.sec=floor((trktime_curr-60000*trk_timeline[trk_timeline_count].time.min)/1000);
						trk_timeline[trk_timeline_count].time.msec=trktime_curr-60000*trk_timeline[trk_timeline_count].time.min-1000*trk_timeline[trk_timeline_count].time.sec;
						sprintf(tempstr,"%02d:%02d.%04d  [%s]",trk_timeline[trk_timeline_count].time.min,trk_timeline[trk_timeline_count].time.sec,trk_timeline[trk_timeline_count].time.msec," ");
						trk_timeline_count++;
						SendDlgItemMessage(tracker_UIDlg,IDC_TRKLIST,LB_ADDSTRING,0,(LPARAM)(LPCTSTR)tempstr);
						SendDlgItemMessage(tracker_UIDlg,IDC_TRKLIST,LB_SETCURSEL,trk_timeline_count-1,0);
						Update_trkcmdUI();
						SendDlgItemMessage(tracker_UIDlg,IDC_TRKCMDLIST,LB_SETCURSEL,0,0);
						Update_trkcmdparamUI();
						}
					}
				break;
				}
			case IDC_TRKINS:
				{
				if (trk_timeline_count<256)
					{
					if (snd_playflag==0) //   textbox`
						{
						int a0,a1,a2,aa;
						a0=GetDlgItemInt(hWnd,IDC_TRK_MIN,&aa,TRUE); a1=GetDlgItemInt(hWnd,IDC_TRK_SEC,&aa,TRUE); a2=GetDlgItemInt(hWnd,IDC_TRK_MSEC,&aa,TRUE);
						if (a0>=0&&a0<=59&&a1>=0&&a1<=59&&a2>=0&&a2<=999)
							{
							int i=SendDlgItemMessage(tracker_UIDlg,IDC_TRKLIST,LB_GETCURSEL,0,0);
							for (int j=255;j>i;j--){trk_timeline[j]=trk_timeline[j-1];}
							GetDlgItemText (tracker_UIDlg,IDC_TRK_COMMENT,trk_timeline[i].comment,63);
							trk_timeline[i].time.min=a0;
							trk_timeline[i].time.sec=a1;
							trk_timeline[i].time.msec=a2;
							trk_timeline[i].cmdcount=0;
							trk_timeline_count++;
							Update_trklistUI();
							SendDlgItemMessage(tracker_UIDlg,IDC_TRKLIST,LB_SETCURSEL,i,0);
							Update_trkcmdUI();
							SendDlgItemMessage(tracker_UIDlg,IDC_TRKCMDLIST,LB_SETCURSEL,0,0);
							Update_trkcmdparamUI();
							}
						}
					else	//   
						{
						int i=SendDlgItemMessage(tracker_UIDlg,IDC_TRKLIST,LB_GETCURSEL,0,0);
						for (int j=255;j>i;j--){trk_timeline[j]=trk_timeline[j-1];}
						trk_timeline[i].time.min=floor(trktime_curr/60000);
						trk_timeline[i].time.sec=floor((trktime_curr-60000*trk_timeline[trk_timeline_count].time.min)/1000);
						trk_timeline[i].time.msec=trktime_curr-60000*trk_timeline[trk_timeline_count].time.min-1000*trk_timeline[trk_timeline_count].time.sec;
						trk_timeline[i].cmdcount=0;
						trk_timeline_count++;
						sprintf(tempstr,"%02d:%02d.%04d  [%s]",trk_timeline[i].time.min,trk_timeline[i].time.sec,trk_timeline[i].time.msec," ");
						SendDlgItemMessage(tracker_UIDlg,IDC_TRKLIST,LB_INSERTSTRING,i,(LPARAM)(LPCTSTR)tempstr);
						Update_trkcmdUI();
						SendDlgItemMessage(tracker_UIDlg,IDC_TRKCMDLIST,LB_SETCURSEL,0,0);
						Update_trkcmdparamUI();
						}
					}
				break;
				}
			case IDC_TRKDEL:
				{
				if (trk_timeline_count>0)
					{
					int i=SendDlgItemMessage(tracker_UIDlg,IDC_TRKLIST,LB_GETCURSEL,0,0);
					for (int j=i;j<254;j++){trk_timeline[j]=trk_timeline[j+1];}
					trk_timeline[255].cmdcount=0;
					trk_timeline_count--;
					Update_trklistUI();
					SendDlgItemMessage(tracker_UIDlg,IDC_TRKLIST,LB_SETCURSEL,i,0);
					Update_trkcmdUI();
					SendDlgItemMessage(tracker_UIDlg,IDC_TRKCMDLIST,LB_SETCURSEL,0,0);
					Update_trkcmdparamUI();
					}
				break;
				}
			case IDC_TRKCMDDEL:
				{
				int i=SendDlgItemMessage(tracker_UIDlg,IDC_TRKLIST,LB_GETCURSEL,0,0);
				int j=SendDlgItemMessage(tracker_UIDlg,IDC_TRKCMDLIST,LB_GETCURSEL,0,0);
				if (trk_timeline[i].cmdcount>0)
					{
					if (trk_timeline[i].cmdcount==j)
						{trk_timeline[i].cmdcount--;}
					else
						{
						for (int k=j+1;k<16;k++){trk_timeline[i].trkcmdlist[k-1]=trk_timeline[i].trkcmdlist[k];}
						trk_timeline[i].cmdcount--;
						}
					Update_trkcmdUI();
					SendDlgItemMessage(tracker_UIDlg,IDC_TRKCMDLIST,LB_SETCURSEL,0,0);
					Update_trkcmdparamUI();
					}
				break;
				}
			case IDC_TRKCMDADD:
				{
				int i=SendDlgItemMessage(tracker_UIDlg,IDC_TRKLIST,LB_GETCURSEL,0,0);
				int j=SendDlgItemMessage(tracker_UIDlg,IDC_TRKCMDLIST,LB_GETCURSEL,0,0);
				int k=SendDlgItemMessage(tracker_UIDlg,IDC_TRKCMDCSEL,CB_GETCURSEL,0,0);
				if (trk_timeline[i].cmdcount<32)
					{
					int a,aa;
					trk_timeline[i].trkcmdlist[trk_timeline[i].cmdcount].trkcmd=k;
					a=GetDlgItemInt(hWnd,IDC_TRKP1,&aa,TRUE); if (a>=0&&a<=255) {trk_timeline[i].trkcmdlist[trk_timeline[i].cmdcount].param[0]=a;}
					a=GetDlgItemInt(hWnd,IDC_TRKP2,&aa,TRUE); if (a>=0&&a<=255) {trk_timeline[i].trkcmdlist[trk_timeline[i].cmdcount].param[1]=a;}
					a=GetDlgItemInt(hWnd,IDC_TRKP3,&aa,TRUE); if (a>=0&&a<=255) {trk_timeline[i].trkcmdlist[trk_timeline[i].cmdcount].param[2]=a;}
					a=GetDlgItemInt(hWnd,IDC_TRKP4,&aa,TRUE); if (a>=0&&a<=255) {trk_timeline[i].trkcmdlist[trk_timeline[i].cmdcount].param[3]=a;}
					a=GetDlgItemInt(hWnd,IDC_TRKP5,&aa,TRUE); if (a>=0&&a<=255) {trk_timeline[i].trkcmdlist[trk_timeline[i].cmdcount].param[4]=a;}
					a=GetDlgItemInt(hWnd,IDC_TRKPMIN,&aa,TRUE); if (a>=0&&a<=59) {trk_timeline[i].trkcmdlist[trk_timeline[i].cmdcount].time.min=a;}
					a=GetDlgItemInt(hWnd,IDC_TRKPSEC,&aa,TRUE); if (a>=0&&a<=59) {trk_timeline[i].trkcmdlist[trk_timeline[i].cmdcount].time.sec=a;}
					a=GetDlgItemInt(hWnd,IDC_TRKPMSEC,&aa,TRUE); if (a>=0&&a<=999) {trk_timeline[i].trkcmdlist[trk_timeline[i].cmdcount].time.msec=a;}
					trk_timeline[i].cmdcount++;
					Update_trkcmdUI();
					SendDlgItemMessage(tracker_UIDlg,IDC_TRKCMDLIST,LB_SETCURSEL,trk_timeline[i].cmdcount-1,0);
					Update_trkcmdparamUI();
					}
				break;
				}
			case IDC_TRKLIST:
				{
				if (HIWORD(wParam) == LBN_SELCHANGE)
					{
					//int i=SendDlgItemMessage(tracker_UIDlg,IDC_TRKLIST,LB_GETCURSEL,0,0);
					//Update_trklistUI();
					//SendDlgItemMessage(tracker_UIDlg,IDC_TRKLIST,LB_SETCURSEL,i,0);
					Update_trkcmdUI();
					SendDlgItemMessage(tracker_UIDlg,IDC_TRKCMDLIST,LB_SETCURSEL,0,0);
					Update_trkcmdparamUI();
					}
				break;
				}
			case IDC_TRKCMDLIST:
				{
				if (HIWORD(wParam) == LBN_SELCHANGE){Update_trkcmdparamUI();}
				break;
				}
			case IDC_TRKCMDCSEL:
				{
				//if (GetFocus()==GetDlgItem(tracker_UIDlg,IDC_TRKCMDCSEL))
				int i=SendDlgItemMessage(tracker_UIDlg,IDC_TRKLIST,LB_GETCURSEL,0,0);
				int j=SendDlgItemMessage(tracker_UIDlg,IDC_TRKCMDLIST,LB_GETCURSEL,0,0);
				int k=SendDlgItemMessage(tracker_UIDlg,IDC_TRKCMDCSEL,CB_GETCURSEL,0,0);
				if (trk_timeline_count>0&&trk_timeline[i].cmdcount>0)
					{
					trk_timeline[i].trkcmdlist[j].trkcmd=k;
					Update_trkcmdUI();
					SendDlgItemMessage(tracker_UIDlg,IDC_TRKCMDLIST,LB_SETCURSEL,j,0);
					}
				Update_trkcmdcselparamUI();
				break;
				}
			case IDC_TRKPMIN: //   
			case IDC_TRKPSEC:
			case IDC_TRKPMSEC:
			case IDC_TRKP1:
			case IDC_TRKP2:
			case IDC_TRKP3:
			case IDC_TRKP4:
			case IDC_TRKP5:
				{
				if (HIWORD (wParam) == EN_CHANGE)
					{
					if (GetFocus()==GetDlgItem(tracker_UIDlg,IDC_TRKPMIN) ||
						GetFocus()==GetDlgItem(tracker_UIDlg,IDC_TRKPSEC) ||
						GetFocus()==GetDlgItem(tracker_UIDlg,IDC_TRKPMSEC) ||
						GetFocus()==GetDlgItem(tracker_UIDlg,IDC_TRKP1) ||
						GetFocus()==GetDlgItem(tracker_UIDlg,IDC_TRKP2) ||
						GetFocus()==GetDlgItem(tracker_UIDlg,IDC_TRKP3) ||
						GetFocus()==GetDlgItem(tracker_UIDlg,IDC_TRKP4) ||
						GetFocus()==GetDlgItem(tracker_UIDlg,IDC_TRKP5))
						{
						int i=SendDlgItemMessage(tracker_UIDlg,IDC_TRKLIST,LB_GETCURSEL,0,0);
						int j=SendDlgItemMessage(tracker_UIDlg,IDC_TRKCMDLIST,LB_GETCURSEL,0,0);
						if (trk_timeline_count>0&&trk_timeline[i].cmdcount>0)
							{
							int a,aa;
							a=GetDlgItemInt(hWnd,IDC_TRKP1,&aa,TRUE); if (a>=0&&a<=255) {trk_timeline[i].trkcmdlist[j].param[0]=a;}
							a=GetDlgItemInt(hWnd,IDC_TRKP2,&aa,TRUE); if (a>=0&&a<=255) {trk_timeline[i].trkcmdlist[j].param[1]=a;}
							a=GetDlgItemInt(hWnd,IDC_TRKP3,&aa,TRUE); if (a>=0&&a<=255) {trk_timeline[i].trkcmdlist[j].param[2]=a;}
							a=GetDlgItemInt(hWnd,IDC_TRKP4,&aa,TRUE); if (a>=0&&a<=255) {trk_timeline[i].trkcmdlist[j].param[3]=a;}
							a=GetDlgItemInt(hWnd,IDC_TRKP5,&aa,TRUE); if (a>=0&&a<=255) {trk_timeline[i].trkcmdlist[j].param[4]=a;}
							a=GetDlgItemInt(hWnd,IDC_TRKPMIN,&aa,TRUE); if (a>=0&&a<=59) {trk_timeline[i].trkcmdlist[j].time.min=a;}
							a=GetDlgItemInt(hWnd,IDC_TRKPSEC,&aa,TRUE); if (a>=0&&a<=59) {trk_timeline[i].trkcmdlist[j].time.sec=a;}
							a=GetDlgItemInt(hWnd,IDC_TRKPMSEC,&aa,TRUE); if (a>=0&&a<=999) {trk_timeline[i].trkcmdlist[j].time.msec=a;}
							}
						}
					}
				break;
				}
				
			//  
			case IDC_PTX2:
				{
				for (int i=pt_len;i>=0;i-=2)
					{
					strack[0][i]=strack[0][i/2];
					strack[0][i-1].num=0;
					strack[0][i-1].p[0]=0;
					strack[0][i-1].p[1]=0;
					strack[0][i-1].p[2]=0;
					strack[0][i-1].p[3]=0;
					}
				UpdatePattern();
				break;
				}
			case IDC_LS:
				{
			int tt;
				char szFile[100] = "\0"; 
			    OPENFILENAME ofn;
					int afs;
					afs=AutoFocus;AutoFocus=1;
				// Initialize OPENFILENAME
				ZeroMemory(&ofn, sizeof(OPENFILENAME));
				ofn.lStructSize = sizeof(OPENFILENAME);
				ofn.hwndOwner = Material_UIDlg;
				ofn.lpstrFile = szFile;
				ofn.nMaxFile = sizeof(szFile);
				ofn.lpstrFilter = "xm(*.xm)\0*.xm\0ogg(*.ogg)\0*.ogg\0v2m(*.v2m)\0*.v2m\0\0";
				ofn.nFilterIndex = 1;
				ofn.lpstrFileTitle = NULL;
				ofn.nMaxFileTitle = 0;
				ofn.lpstrInitialDir = NULL;
				ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST;
				// Display the Open dialog box. 
				if (GetOpenFileName(&ofn))
				{
				SetDlgItemText(hWnd,IDC_MFN,ofn.lpstrFile);
				SetDlgItemText(hWnd,IDC_MFN2,"unknown type"); MusicType=255;
				if (ofn.nFilterIndex==1){SetDlgItemText(hWnd,IDC_MFN2,"trackered (*.xm)");MusicType=0;}
				if (ofn.nFilterIndex==2){SetDlgItemText(hWnd,IDC_MFN2,"streamed (*.ogg)"); MusicType=1;}
				if (ofn.nFilterIndex==3){SetDlgItemText(hWnd,IDC_MFN2,"v2_synth (*.v2m)"); MusicType=2;}
				}
				AutoFocus=afs;
				break;
				}
			case IDC_TP1:
			case IDC_TP2:
			case IDC_TP3:
			case IDC_TP4:
				{
				if (HIWORD (wParam) == EN_CHANGE)  
					{
					if (GetFocus()==GetDlgItem(tracker_UIDlg,IDC_TP1)||
						GetFocus()==GetDlgItem(tracker_UIDlg,IDC_TP2)||
						GetFocus()==GetDlgItem(tracker_UIDlg,IDC_TP3)||
						GetFocus()==GetDlgItem(tracker_UIDlg,IDC_TP4)
						)
						{
						BOOL res;
						strack[chnl][pattern_cur_pos].p[0]=GetDlgItemInt(hWnd,IDC_TP1,&res,0);
						strack[chnl][pattern_cur_pos].p[1]=GetDlgItemInt(hWnd,IDC_TP2,&res,0);
						strack[chnl][pattern_cur_pos].p[2]=GetDlgItemInt(hWnd,IDC_TP3,&res,0);
						strack[chnl][pattern_cur_pos].p[3]=GetDlgItemInt(hWnd,IDC_TP4,&res,0);
						UpdatePattern();
						}
					}
				break;
				}
			/*case IDC_APPLY_TP:
				{
					BOOL res;
					strack[chnl][pattern_cur_pos].p[0]=GetDlgItemInt(hWnd,IDC_TP1,&res,0);
					strack[chnl][pattern_cur_pos].p[1]=GetDlgItemInt(hWnd,IDC_TP2,&res,0);
					strack[chnl][pattern_cur_pos].p[2]=GetDlgItemInt(hWnd,IDC_TP3,&res,0);
					strack[chnl][pattern_cur_pos].p[3]=GetDlgItemInt(hWnd,IDC_TP4,&res,0);
					UpdatePattern();
					break;
				}*/

			case IDC_C0:
				{
					int c;
					pattern_cur_pos=SendDlgItemMessage(hWnd,IDC_C0,LB_GETCURSEL,0,0);
					SendDlgItemMessage(hWnd,IDC_CMD,CB_SETCURSEL,(WPARAM)strack[chnl][pattern_cur_pos].num,0);
					SetDlgItemInt(hWnd,IDC_TP1,strack[chnl][pattern_cur_pos].p[0],FALSE);
					SetDlgItemInt(hWnd,IDC_TP2,strack[chnl][pattern_cur_pos].p[1],FALSE);
					SetDlgItemInt(hWnd,IDC_TP3,strack[chnl][pattern_cur_pos].p[2],FALSE);
					SetDlgItemInt(hWnd,IDC_TP4,strack[chnl][pattern_cur_pos].p[3],FALSE);
					break;
				}
			case IDC_CMD:
				{
					int c;BOOL res;
					pattern_cur_pos=SendDlgItemMessage(hWnd,IDC_C0,LB_GETCURSEL,0,0);
					c=SendDlgItemMessage(hWnd,IDC_CMD,CB_GETCURSEL,0,0);
					strack[chnl][pattern_cur_pos].num=c;
					strack[chnl][pattern_cur_pos].p[0]=GetDlgItemInt(hWnd,IDC_TP1,&res,0);
					strack[chnl][pattern_cur_pos].p[1]=GetDlgItemInt(hWnd,IDC_TP2,&res,0);
					strack[chnl][pattern_cur_pos].p[2]=GetDlgItemInt(hWnd,IDC_TP3,&res,0);
					strack[chnl][pattern_cur_pos].p[3]=GetDlgItemInt(hWnd,IDC_TP4,&res,0);
					UpdatePattern();
					break;
				}
			case IDC_PINS:
				{
					for (int t=(pt_len-1);t>pattern_cur_pos;t--)
						{
						strack[chnl][t].num=strack[chnl][t-1].num;
						strack[chnl][t].p[0]=strack[chnl][t-1].p[0];
						strack[chnl][t].p[1]=strack[chnl][t-1].p[1];
						strack[chnl][t].p[2]=strack[chnl][t-1].p[2];
						strack[chnl][t].p[3]=strack[chnl][t-1].p[3];
						}
						strack[chnl][pattern_cur_pos].num=0;
						strack[chnl][pattern_cur_pos].p[0]=0;
						strack[chnl][pattern_cur_pos].p[1]=0;
						strack[chnl][pattern_cur_pos].p[2]=0;
						strack[chnl][pattern_cur_pos].p[3]=0;
						UpdatePattern();
					break;
				}
			case IDC_PDEL:
				{
					for (int t=pattern_cur_pos;t<(pt_len-1);t++)
						{
						strack[chnl][t].num=strack[chnl][t+1].num;
						strack[chnl][t].p[0]=strack[chnl][t+1].p[0];
						strack[chnl][t].p[1]=strack[chnl][t+1].p[1];
						strack[chnl][t].p[2]=strack[chnl][t+1].p[2];
						strack[chnl][t].p[3]=strack[chnl][t+1].p[3];
						}
						UpdatePattern();
					break;
				}
			case IDC_PCLR:
				{
					strack[chnl][pattern_cur_pos].num=0;
					strack[chnl][pattern_cur_pos].p[0]=0;
					strack[chnl][pattern_cur_pos].p[1]=0;
					strack[chnl][pattern_cur_pos].p[2]=0;
					strack[chnl][pattern_cur_pos].p[3]=0;
					UpdatePattern();
					break;
				}
			case IDC_TL_PPLAY_SND:
				{
				panim_store=anim_view;
				CamIntType=0;
				CamFlyType=0;
				MatIntType=0;
				cs_store=current_scene;
				memcpy(tmp_Materialbank_vertexbumplink,Materialbank_vertexbumplink,sizeof(Materialbank_vertexbumplink));
				memcpy(tmp_Materialbank,Materialbank,sizeof(Materialbank));
				memcpy(restore_Materialbank,Materialbank,sizeof(Materialbank));
				memcpy(tmp_Materialbank_vertexbumpdepth,Materialbank_vertexbumpdepth,sizeof(Materialbank_vertexbumpdepth));
				memcpy(tmp_mod0array,mod0array,sizeof(mod0array));
				memcpy(restore_mod0array,mod0array,sizeof(mod0array));
				memcpy(tmp_clone,clone,sizeof(clone));
				memcpy(_tmp_objects,objects,sizeof(objects));
				memcpy(restore_objects,objects,sizeof(objects));

				ZeroMemory(obj_slideflag,sizeof(obj_slideflag));
				ZeroMemory(mat_slideflag,sizeof(mat_slideflag));

				sldobj_count=0;
				cam_slideflag=0; CamCapFlag=0;
				ZeroMemory(trk_timeline_flags,sizeof(trk_timeline_flags));
				ZeroMemory(sldobj,sizeof(sldobj));
				ZeroMemory(sldmat,sizeof(sldmat));

				delta_cmtime2=cmtime2;
				start_time=cmtime2;
				tl_play_pos2=0;
				SendDlgItemMessage(hWnd,IDC_C0,LB_SETCURSEL,0,0);
				tl_play_flag=1;

				char* fnm;fnm=new char [100];
				GetDlgItemText(hWnd,IDC_MFN,fnm,100);
				snd_playflag=1;
				switch (MusicType)
					{
					case 0: { mod=BASS_MusicLoad(FALSE,fnm,0,0,BASS_MUSIC_RAMP |BASS_MUSIC_POSRESET |BASS_SAMPLE_FLOAT |BASS_MUSIC_FT2MOD,0); BASS_ChannelPlay(mod,TRUE);
						break;}
					case 1: { MusicStream=BASS_StreamCreateFile (FALSE,fnm,0,0,BASS_STREAM_AUTOFREE); BASS_ChannelPlay (MusicStream,FALSE);
						break;}
					case 2:
						{
						//    
					    FILE *myfile;
					    myfile = fopen( fnm, "rb" );
						fseek( myfile, 0, SEEK_END );
						long size = ftell( myfile );
						theTune = (sU8*)malloc( size );
						fseek( myfile, 0, SEEK_SET );
						fread( theTune, sizeof(sU8), size, myfile );
						fclose( myfile );
						//   sBool
						player.Init();
						player.Open(theTune);
						dsInit(player.RenderProxy,&player,Parent_hWnd); //GetForegroundWindow()
						player.Play();
						//sInt startTicks = GetTickCount(); 
						break;
						}
					}
				sa_start_time=GetTickCount();
				trktime_start=GetTickCount();
				cr_stack[0]=0;cr_stack[1]=0;cr_stack[2]=0;cr_stack[3]=0;
				delete (fnm);
				break;
				}
			case IDC_TL_PPLAY:
				{
				panim_store=anim_view;
				CamIntType=0;
				CamFlyType=0;
				MatIntType=0;
				cs_store=current_scene;
				memcpy(tmp_Materialbank,Materialbank,sizeof(Materialbank));
				memcpy(restore_Materialbank,Materialbank,sizeof(Materialbank));
				memcpy(tmp_Materialbank_vertexbumplink,Materialbank_vertexbumplink,sizeof(Materialbank_vertexbumplink));
				memcpy(tmp_Materialbank_vertexbumpdepth,Materialbank_vertexbumpdepth,sizeof(Materialbank_vertexbumpdepth));
				memcpy(tmp_mod0array,mod0array,sizeof(mod0array));
				memcpy(restore_mod0array,mod0array,sizeof(mod0array));
				memcpy(tmp_clone,clone,sizeof(clone));
				memcpy(_tmp_objects,objects,sizeof(objects));
				memcpy(restore_objects,objects,sizeof(objects));

				ZeroMemory(obj_slideflag,sizeof(obj_slideflag));
				ZeroMemory(mat_slideflag,sizeof(mat_slideflag));

				sldobj_count=0;
				cam_slideflag=0; CamCapFlag=0;
				ZeroMemory(trk_timeline_flags,sizeof(trk_timeline_flags));
				ZeroMemory(sldobj,sizeof(sldobj));
				ZeroMemory(sldmat,sizeof(sldmat));

				delta_cmtime2=cmtime2;
				start_time=cmtime2;
				tl_play_pos2=SendDlgItemMessage(hWnd,IDC_C0,LB_GETCURSEL,0,0);
				tl_play_flag=1;
				sa_start_time=GetTickCount();
				trktime_start=GetTickCount();
				cr_stack[0]=0;cr_stack[1]=0;cr_stack[2]=0;cr_stack[3]=0;
				break;
				}
			case IDC_TL_PSTOP:
				{
				if (snd_playflag==1) 
				{
					switch (MusicType)
					{
					case 0:	{ BASS_ChannelStop(mod); 
						break;}
					case 1: { BASS_ChannelStop(MusicStream); 
						break;}
					case 2: {
						//   v2synth
						player.Stop(); dsClose(); player.Close();
						//   
						free(theTune);
						}
					}
					SetWindowText(tracker_UIDlg,"Tracker (timeline)");
					//PlaySound(NULL,NULL,SND_PURGE );
					snd_playflag=0;
				}
				if (tl_play_flag==1)
				{
				current_scene=cs_store;
				memcpy(Materialbank,restore_Materialbank,sizeof(Materialbank));
				memcpy(Materialbank_vertexbumpdepth,tmp_Materialbank_vertexbumpdepth,sizeof(Materialbank_vertexbumpdepth));
				memcpy(Materialbank_vertexbumplink,tmp_Materialbank_vertexbumplink,sizeof(Materialbank_vertexbumplink));
				memcpy(mod0array,restore_mod0array,sizeof(mod0array));
				memcpy(clone,tmp_clone,sizeof(clone));
				memcpy(objects,restore_objects,sizeof(objects));
				tl_play_flag=0;
				}
				anim_view=panim_store;
				break;
				}
			}
			break;
		}

	}
	 return 0L;
}
//---  / 0..1
void Inter(char itype)
{
switch (itype)
	{
	case 0://step=linear(0)
		{
		bf=p;
		brf=1-p;
		break;
		}
	case 1://step=sin(1)
		{
		bf=.5+.5*sin(p*180*grt-90*grt);
		brf=.5+.5*sin((1-p)*180*grt-90*grt);
		break;
		}
	case 2://step=linear(0) & camflytype=catmul-rom(1)
		{
		bf=p;
		brf=1-p;
		break;
		}
	}
}
//---  Catmull-Rom Spline
double spline_katmulrom(double v0,double v1, double v2, double v3, double p)
{
	float t2, t3,a,k[4];
	t2 =  p * p;
	t3 = t2 * p;
	k[0] = -1 * v0 + 3 * v1 - 3 * v2 + v3;
	k[1] =  2 * v0 - 5 * v1 + 4 * v2 - v3;
	k[2] = -1 * v0+ v2;
	k[3] =  2 * v1;
	return ((t3*k[0] + t2*k[1] + p*k[2] + k[3] ) * 0.5f);
}
//-------------------------   (   )
void do_time()
{
double isz,rz;int i,j,k;
if (trackertype==0) //   
{
	// SetWindowText(tracker_UIDlg,"123"); -     
//timing
if (cmtime2>=(delta_cmtime2+64.0*spd)) 
	{
	delta_cmtime2=delta_cmtime2+64.0*spd;
	tl_play_pos2++;
	SendDlgItemMessage(tracker_UIDlg,IDC_C0,LB_SETCURSEL,(WPARAM)tl_play_pos2,0);
	}
if (tl_play_pos2>(pt_len-1)) tl_play_pos2=0;
// 1: set scene
if (strack[chnl][tl_play_pos2].num==1) 
	{
	current_scene=strack[chnl][tl_play_pos2].p[0];
	scn_slideflag=0;
	}
// 2: set camera
if (strack[chnl][tl_play_pos2].num==2) 
	{
		current_cam=strack[chnl][tl_play_pos2].p[0];
		main_cam=cam_bank[strack[chnl][tl_play_pos2].p[0]];
		cam_slideflag=0;
		CamCapFlag=0; //fuck???
	}
// 3: slide camera
if (strack[chnl][tl_play_pos2].num==3) 
	{
	CamCapFlag=0;
	ccam=strack[chnl][tl_play_pos2].p[0];
	if (strack[chnl][tl_play_pos2].p[3]!=0){CamFlyType=strack[chnl][tl_play_pos2].p[3]-1;}
	ccampos=tl_play_pos2;
	cr_stack[0]=cr_stack[1];
	cr_stack[1]=ccam;
	for (i=tl_play_pos2+1;i<(pt_len-1);i++)
		{
		ncampos=i;ncam=strack[chnl][i].p[0];
		cr_stack[2]=ncam;
		if ((strack[chnl][i].num==3)||(strack[chnl][i].num==2)) goto fcam;
		}
	fcam:;
	for (i=ncampos+1;i<(pt_len-1);i++)
		{
		cr_stack[3]=strack[chnl][i].p[0];
		if ((strack[chnl][i].num==3)||(strack[chnl][i].num==2)) goto fcam2;
		}
	fcam2:;
	cam_slideflag=1;
	}
// 4: slide material
if (strack[chnl][tl_play_pos2].num==4) 
	{
	int pp0,pp1;
	pp0=strack[chnl][tl_play_pos2].p[0];
	pp1=strack[chnl][tl_play_pos2].p[1];
	mat_slideflag[pp0]=1;	
	cmat[pp0]=pp0;
	nmat[pp0]=pp1;
	cmatpos[pp0]=tl_play_pos2;
	for (i=tl_play_pos2+1;i<(pt_len-1);i++)
		{
		nmatpos[pp0]=i;
		if (strack[chnl][i].num==9&&strack[chnl][i].p[0]==pp0) goto fmat;
		}
	fmat:;
	}
// 5: slide scene
if (strack[chnl][tl_play_pos2].num==5) 
	{
	scn_slideflag=1;
	cscn=strack[chnl][tl_play_pos2].p[0];
	cscnpos=tl_play_pos2;
	for (i=tl_play_pos2+1;i<(pt_len-1);i++)
		{
		nscnpos=i;nscn=strack[chnl][i].p[0];
		if (strack[chnl][i].num==5) {current_scene=nscn;goto fscn;}
		}
	fscn:;
	}
// 6: slide obj
if (strack[chnl][tl_play_pos2].num==6) 
	{
	int pp0,pp1,pp2,pp3;
	pp0=strack[chnl][tl_play_pos2].p[0];
	pp1=strack[chnl][tl_play_pos2].p[1];
	pp2=strack[chnl][tl_play_pos2].p[2];
	cobj[pp0]=pp0;
	nobj[pp0]=pp1;
	nobj_sc[pp0]=pp2;
	obj_slideflag[pp0]=1;
	cobjpos[pp0]=tl_play_pos2;
	for (i=tl_play_pos2+1;i<(pt_len-1);i++)
		{
		nobjpos[pp0]=i;
		if (strack[chnl][i].num==8&&strack[chnl][i].p[0]==pp0) goto fobj;
		}
	fobj:;
	}
// 10: set CamIntType
if (strack[chnl][tl_play_pos2].num==10)
	{
	CamIntType=strack[chnl][tl_play_pos2].p[0];
	if (CamIntType==2) {CamFlyType=1;}
	}
// 11: set MatIntType
if (strack[chnl][tl_play_pos2].num==11) MatIntType=strack[chnl][tl_play_pos2].p[0];
// 12: capcam
if (strack[chnl][tl_play_pos2].num==12) 
	{
	CamCapFlag=1;
	CamPosObj=strack[chnl][tl_play_pos2].p[0];
	CamViewObj=strack[chnl][tl_play_pos2].p[1];
	}
// 13: panim
if (strack[chnl][tl_play_pos2].num==13) 
	{
	if (tp!=tl_play_pos2) 
		{
		tp=tl_play_pos2;
		anim_view=strack[chnl][tl_play_pos2].p[0];
		if (anim_view==0) sa_start_time=GetTickCount();
		}
	}
//process object
for (int os=0;os<numofobjects[current_scene];os++)
{
	if (obj_slideflag[os]==1)
	{
	//p=((cmtime2-delta_cmtime2)/((double)spd*64.0)+tl_play_pos2-cobjpos[os])/(double)(nobjpos[os]-cobjpos[os]);
	p=((cmtime2-start_time)/(64*spd)-cobjpos[os])/(double)(nobjpos[os]-cobjpos[os]);

		bf=p;brf=1-p;
		if (tl_play_pos2>=nobjpos[os])
			{obj_slideflag[os]=0;
			_tmp_objects[nobj_sc[os]][cobj[os]]=_tmp_objects[current_scene][nobj[os]];
			}
		mod0array[current_scene][cobj[os]].numofmodifers=tmp_mod0array[nobj_sc[os]][nobj[os]].numofmodifers;
		for (int m=0;m<tmp_mod0array[nobj_sc[os]][nobj[os]].numofmodifers;m++) 
			{
			mod0array[current_scene][cobj[os]].modifer[m].type=tmp_mod0array[nobj_sc[os]][nobj[os]].modifer[m].type;
			if (mod0array[current_scene][cobj[os]].modifer[m].x != tmp_mod0array[nobj_sc[os]][nobj[os]].modifer[m].x)
				{mod0array[current_scene][cobj[os]].modifer[m].x=brf*(double)tmp_mod0array[current_scene][cobj[os]].modifer[m].x+bf*(double)tmp_mod0array[nobj_sc[os]][nobj[os]].modifer[m].x;}
			if (mod0array[current_scene][cobj[os]].modifer[m].y != tmp_mod0array[nobj_sc[os]][nobj[os]].modifer[m].y)
				{mod0array[current_scene][cobj[os]].modifer[m].y=brf*(double)tmp_mod0array[current_scene][cobj[os]].modifer[m].y+bf*(double)tmp_mod0array[nobj_sc[os]][nobj[os]].modifer[m].y;}
			if (mod0array[current_scene][cobj[os]].modifer[m].z != tmp_mod0array[nobj_sc[os]][nobj[os]].modifer[m].z)
				{mod0array[current_scene][cobj[os]].modifer[m].z=brf*(double)tmp_mod0array[current_scene][cobj[os]].modifer[m].z+bf*(double)tmp_mod0array[nobj_sc[os]][nobj[os]].modifer[m].z;}
			if (mod0array[current_scene][cobj[os]].modifer[m].rad != tmp_mod0array[nobj_sc[os]][nobj[os]].modifer[m].rad)
				{mod0array[current_scene][cobj[os]].modifer[m].rad=brf*(double)tmp_mod0array[current_scene][cobj[os]].modifer[m].rad+bf*(double)tmp_mod0array[nobj_sc[os]][nobj[os]].modifer[m].rad;}
			if (mod0array[current_scene][cobj[os]].modifer[m].pow != tmp_mod0array[nobj_sc[os]][nobj[os]].modifer[m].pow)
				{mod0array[current_scene][cobj[os]].modifer[m].pow=brf*(double)tmp_mod0array[current_scene][cobj[os]].modifer[m].pow+bf*(double)tmp_mod0array[nobj_sc[os]][nobj[os]].modifer[m].pow;}
			}
		if (_tmp_objects[current_scene][cobj[os]].x != _tmp_objects[nobj_sc[os]][nobj[os]].x)
			{objects[current_scene][cobj[os]].x=brf*(double)_tmp_objects[current_scene][cobj[os]].x+bf*(double)_tmp_objects[nobj_sc[os]][nobj[os]].x;}
		if (_tmp_objects[current_scene][cobj[os]].y != _tmp_objects[nobj_sc[os]][nobj[os]].y)
			{objects[current_scene][cobj[os]].y=brf*(double)_tmp_objects[current_scene][cobj[os]].y+bf*(double)_tmp_objects[nobj_sc[os]][nobj[os]].y;}
		if (_tmp_objects[current_scene][cobj[os]].z != _tmp_objects[nobj_sc[os]][nobj[os]].z)
			{objects[current_scene][cobj[os]].z=brf*(double)_tmp_objects[current_scene][cobj[os]].z+bf*(double)_tmp_objects[nobj_sc[os]][nobj[os]].z;}
		if (_tmp_objects[current_scene][cobj[os]].sx != _tmp_objects[nobj_sc[os]][nobj[os]].sx)
			{objects[current_scene][cobj[os]].sx=brf*(double)_tmp_objects[current_scene][cobj[os]].sx+bf*(double)_tmp_objects[nobj_sc[os]][nobj[os]].sx;}
		if (_tmp_objects[current_scene][cobj[os]].sy != _tmp_objects[nobj_sc[os]][nobj[os]].sy)
			{objects[current_scene][cobj[os]].sy=brf*(double)_tmp_objects[current_scene][cobj[os]].sy+bf*(double)_tmp_objects[nobj_sc[os]][nobj[os]].sy;}
		if (_tmp_objects[current_scene][cobj[os]].sz != _tmp_objects[nobj_sc[os]][nobj[os]].sz)
			{objects[current_scene][cobj[os]].sz=brf*(double)_tmp_objects[current_scene][cobj[os]].sz+bf*(double)_tmp_objects[nobj_sc[os]][nobj[os]].sz;}
	}
}
//process scene
if (scn_slideflag==1)
{
	//p=((cmtime2-delta_cmtime2)/(double(spd)*64.0)+(double)(tl_play_pos2-cscnpos))/double(nscnpos-cscnpos);
	p=((cmtime2-start_time)/(64*spd)-cscnpos)/double(nscnpos-cscnpos);
//	char* ww="           ";
//	_itoa(p*10000,ww,10);
//	SetWindowText(tracker_UIDlg,ww);
		//bf=.5+.5*sin(p*180*grt-90*grt);
		//brf=.5+.5*sin((1-p)*180*grt-90*grt);
		bf=p;
		brf=1.0-p;

		for (int n=0;n<numofobjects[nscn];n++)
		{
		mod0array[current_scene][n].numofmodifers=tmp_mod0array[nscn][n].numofmodifers;
		for (int m=0;m<tmp_mod0array[nscn][n].numofmodifers;m++) 
			{
			mod0array[current_scene][n].modifer[m].type=tmp_mod0array[nscn][n].modifer[m].type;
			mod0array[current_scene][n].modifer[m].x=brf*(double)tmp_mod0array[cscn][n].modifer[m].x+bf*(double)tmp_mod0array[nscn][n].modifer[m].x;
			mod0array[current_scene][n].modifer[m].y=brf*(double)tmp_mod0array[cscn][n].modifer[m].y+bf*(double)tmp_mod0array[nscn][n].modifer[m].y;
			mod0array[current_scene][n].modifer[m].z=brf*(double)tmp_mod0array[cscn][n].modifer[m].z+bf*(double)tmp_mod0array[nscn][n].modifer[m].z;
			mod0array[current_scene][n].modifer[m].rad=brf*(double)tmp_mod0array[cscn][n].modifer[m].rad+bf*(double)tmp_mod0array[nscn][n].modifer[m].rad;
			mod0array[current_scene][n].modifer[m].pow=brf*(double)tmp_mod0array[cscn][n].modifer[m].pow+bf*(double)tmp_mod0array[nscn][n].modifer[m].pow;
			}

		objects[current_scene][n].x=brf*(double)_tmp_objects[cscn][n].x+bf*(double)_tmp_objects[nscn][n].x;
		objects[current_scene][n].y=brf*(double)_tmp_objects[cscn][n].y+bf*(double)_tmp_objects[nscn][n].y;
		objects[current_scene][n].z=brf*(double)_tmp_objects[cscn][n].z+bf*(double)_tmp_objects[nscn][n].z;
		objects[current_scene][n].sx=brf*(double)_tmp_objects[cscn][n].sx+bf*(double)_tmp_objects[nscn][n].sx;
		objects[current_scene][n].sy=brf*(double)_tmp_objects[cscn][n].sy+bf*(double)_tmp_objects[nscn][n].sy;
		objects[current_scene][n].sz=brf*(double)_tmp_objects[cscn][n].sz+bf*(double)_tmp_objects[nscn][n].sz;
		}

}
//process material
for (os=0;os<256;os++)
{
	if (mat_slideflag[os]==1)
	{
	//p=((cmtime2-delta_cmtime2)/((double)spd*64.0)+tl_play_pos2-cmatpos[os])/(double)(nmatpos[os]-cmatpos[os]);
	p=((cmtime2-start_time)/(64*spd)-cmatpos[os])/(double)(nmatpos[os]-cmatpos[os]);
	Inter(MatIntType);
	if (tl_play_pos2>=nmatpos[os])
		{
		mat_slideflag[os]=0;
		tmp_Materialbank[cmat[os]]=tmp_Materialbank[nmat[os]];
		}
	Materialbank[cmat[os]].Ambient.r=brf*(double)tmp_Materialbank[cmat[os]].Ambient.r+bf*(double)tmp_Materialbank[nmat[os]].Ambient.r;
	Materialbank[cmat[os]].Ambient.g=brf*(double)tmp_Materialbank[cmat[os]].Ambient.g+bf*(double)tmp_Materialbank[nmat[os]].Ambient.g;
	Materialbank[cmat[os]].Ambient.b=brf*(double)tmp_Materialbank[cmat[os]].Ambient.b+bf*(double)tmp_Materialbank[nmat[os]].Ambient.b;
	Materialbank[cmat[os]].Diffuse.r=brf*(double)tmp_Materialbank[cmat[os]].Diffuse.r+bf*(double)tmp_Materialbank[nmat[os]].Diffuse.r;
	Materialbank[cmat[os]].Diffuse.g=brf*(double)tmp_Materialbank[cmat[os]].Diffuse.g+bf*(double)tmp_Materialbank[nmat[os]].Diffuse.g;
	Materialbank[cmat[os]].Diffuse.b=brf*(double)tmp_Materialbank[cmat[os]].Diffuse.b+bf*(double)tmp_Materialbank[nmat[os]].Diffuse.b;
	Materialbank[cmat[os]].Specular.r=brf*(double)tmp_Materialbank[cmat[os]].Specular.r+bf*(double)tmp_Materialbank[nmat[os]].Specular.r;
	Materialbank[cmat[os]].Specular.g=brf*(double)tmp_Materialbank[cmat[os]].Specular.g+bf*(double)tmp_Materialbank[nmat[os]].Specular.g;
	Materialbank[cmat[os]].Specular.b=brf*(double)tmp_Materialbank[cmat[os]].Specular.b+bf*(double)tmp_Materialbank[nmat[os]].Specular.b;
	Materialbank[cmat[os]].Power=brf*(double)tmp_Materialbank[cmat[os]].Power+bf*(double)tmp_Materialbank[nmat[os]].Power;
	Materialbank_vertexbumpdepth[cmat[os]]=brf*(double)tmp_Materialbank_vertexbumpdepth[cmat[os]]+bf*(double)tmp_Materialbank_vertexbumpdepth[nmat[os]];
	}
}
//process camera
if (CamCapFlag==1)
{
	CurrentObject[current_scene]=CamPosObj;
	gx=0;
	gy=0;
	gz=0;
	apply_mods();
	gx*=64;gy*=64;gz*=64;
	main_cam.v_x=gx+objects[current_scene][CamPosObj].x;
	main_cam.v_y=gy+objects[current_scene][CamPosObj].y;
	main_cam.v_z=gz+objects[current_scene][CamPosObj].z;
	CurrentObject[current_scene]=CamViewObj;
	gx=0;
	gy=0;
	gz=0;
	apply_mods();
	gx*=64;gy*=64;gz*=64;
	main_cam.tgt_x=gx+objects[current_scene][CamViewObj].x;
	main_cam.tgt_y=gy+objects[current_scene][CamViewObj].y;
	main_cam.tgt_z=gz+objects[current_scene][CamViewObj].z;
}
else
if (cam_slideflag==1)
{
	p=((cmtime2-start_time)/(64*spd)-ccampos)/(double)(ncampos-ccampos);
	Inter(CamIntType);
	switch (CamFlyType)
	{
	case 0: //  
		{
		main_cam.dist=brf*(double)cam_bank[ccam].dist+bf*(double)cam_bank[ncam].dist;
		main_cam.tgt_x=brf*(double)cam_bank[ccam].tgt_x+bf*(double)cam_bank[ncam].tgt_x;
		main_cam.tgt_y=brf*(double)cam_bank[ccam].tgt_y+bf*(double)cam_bank[ncam].tgt_y;
		main_cam.tgt_z=brf*(double)cam_bank[ccam].tgt_z+bf*(double)cam_bank[ncam].tgt_z;
		main_cam.v_x=brf*(double)cam_bank[ccam].v_x+bf*(double)cam_bank[ncam].v_x;
		main_cam.v_y=brf*(double)cam_bank[ccam].v_y+bf*(double)cam_bank[ncam].v_y;
		main_cam.v_z=brf*(double)cam_bank[ccam].v_z+bf*(double)cam_bank[ncam].v_z;
		main_cam.xy_a=brf*(double)cam_bank[ccam].xy_a+bf*(double)cam_bank[ncam].xy_a;
		break;
		}
	case 1: // katmul-room spline
		{
		main_cam.dist=spline_katmulrom(cam_bank[cr_stack[0]].dist,cam_bank[cr_stack[1]].dist,cam_bank[cr_stack[2]].dist,cam_bank[cr_stack[3]].dist,p);
		main_cam.tgt_x=spline_katmulrom(cam_bank[cr_stack[0]].tgt_x,cam_bank[cr_stack[1]].tgt_x,cam_bank[cr_stack[2]].tgt_x,cam_bank[cr_stack[3]].tgt_x,p);
		main_cam.tgt_y=spline_katmulrom(cam_bank[cr_stack[0]].tgt_y,cam_bank[cr_stack[1]].tgt_y,cam_bank[cr_stack[2]].tgt_y,cam_bank[cr_stack[3]].tgt_y,p);
		main_cam.tgt_z=spline_katmulrom(cam_bank[cr_stack[0]].tgt_z,cam_bank[cr_stack[1]].tgt_z,cam_bank[cr_stack[2]].tgt_z,cam_bank[cr_stack[3]].tgt_z,p);
		main_cam.v_x=spline_katmulrom(cam_bank[cr_stack[0]].v_x,cam_bank[cr_stack[1]].v_x,cam_bank[cr_stack[2]].v_x,cam_bank[cr_stack[3]].v_x,p);
		main_cam.v_y=spline_katmulrom(cam_bank[cr_stack[0]].v_y,cam_bank[cr_stack[1]].v_y,cam_bank[cr_stack[2]].v_y,cam_bank[cr_stack[3]].v_y,p);
		main_cam.v_z=spline_katmulrom(cam_bank[cr_stack[0]].v_z,cam_bank[cr_stack[1]].v_z,cam_bank[cr_stack[2]].v_z,cam_bank[cr_stack[3]].v_z,p);
		main_cam.xy_a=spline_katmulrom(cam_bank[cr_stack[0]].xy_a,cam_bank[cr_stack[1]].xy_a,cam_bank[cr_stack[2]].xy_a,cam_bank[cr_stack[3]].xy_a,p);
		break;
		}
	}
}
// 7: set treker speed
if (strack[chnl][tl_play_pos2].num==7) 
	{
	spd=strack[chnl][tl_play_pos2].p[0];
	}
q:;
}

if (trackertype==1) //   
{
	//timing
	trktime_curr=GetTickCount()-trktime_start;
	int xmin=floor((trktime_curr)/(60*1000));
	int xsec=floor((trktime_curr-xmin*60*1000)/1000);
	int xmsec=trktime_curr-xmin*60*1000-xsec*1000;
	sprintf(tempstr,"%02d:%02d.%04d",xmin,xsec,xmsec);
	SetWindowText(tracker_UIDlg,tempstr); //     

	//---     
	for (i=0;i<trk_timeline_count;i++)
	{
	if (trk_timeline_flags[i]==FALSE) //   , 
		{
		trktime_list=trk_timeline[i].time.msec+1000*trk_timeline[i].time.sec+60000*trk_timeline[i].time.min;
		if (trktime_curr>=trktime_list) //  , 
			{
			for (j=0;j<trk_timeline[i].cmdcount;j++) //  - 
				{
				//--- 0: setscene
				if (trk_timeline[i].trkcmdlist[j].trkcmd==0)
					{
					current_scene=trk_timeline[i].trkcmdlist[j].param[0];
					scn_slideflag=0; //fuck???
					}
				//--- 1: setcam
				if (trk_timeline[i].trkcmdlist[j].trkcmd==1)
					{
					current_cam=trk_timeline[i].trkcmdlist[j].param[0];
					main_cam=cam_bank[current_cam];
					cam_slideflag=0; CamCapFlag=0; splCamFlag=0;
					}
				//--- 2: sldcam
				if (trk_timeline[i].trkcmdlist[j].trkcmd==2)
					{
					cam_slideflag=1; CamCapFlag=0; splCamFlag=0;
					cam_1=trk_timeline[i].trkcmdlist[j].param[0];
					cam_2=trk_timeline[i].trkcmdlist[j].param[1];
					cam_pathtype=trk_timeline[i].trkcmdlist[j].param[2];
					cam_targettype=trk_timeline[i].trkcmdlist[j].param[3];
					cam_timer=trk_timeline[i].trkcmdlist[j].time.msec+1000*trk_timeline[i].trkcmdlist[j].time.sec+60000*trk_timeline[i].trkcmdlist[j].time.min;
					cam_timestart=trktime_list;
					}
				//--- 3: sldmat
				if (trk_timeline[i].trkcmdlist[j].trkcmd==3)
					{
					if (sldmat[trk_timeline[i].trkcmdlist[j].param[0]].flag) //      ,    
						{tmp_Materialbank[trk_timeline[i].trkcmdlist[j].param[0]]=Materialbank[trk_timeline[i].trkcmdlist[j].param[0]];}
					sldmat[trk_timeline[i].trkcmdlist[j].param[0]].flag=TRUE;
					sldmat[trk_timeline[i].trkcmdlist[j].param[0]].dest=trk_timeline[i].trkcmdlist[j].param[1];
					sldmat[trk_timeline[i].trkcmdlist[j].param[0]].timer=trk_timeline[i].trkcmdlist[j].time.msec+1000*trk_timeline[i].trkcmdlist[j].time.sec+60000*trk_timeline[i].trkcmdlist[j].time.min;
					sldmat[trk_timeline[i].trkcmdlist[j].param[0]].timestart=trktime_list;
					if (trk_timeline[i].trkcmdlist[j].param[2]==1) //resetmode
						{tmp_Materialbank[trk_timeline[i].trkcmdlist[j].param[0]]=restore_Materialbank[trk_timeline[i].trkcmdlist[j].param[0]];}
					}
				//--- 4: sldobj
				if (trk_timeline[i].trkcmdlist[j].trkcmd==4)
					{
					if (sldobj_count<256) //  32    
						{
						//--
						for (int n=0; n<sldobj_count; n++)
							{
							 //      ,  
							if (sldobj[n].flag && sldobj[n].obj==trk_timeline[i].trkcmdlist[j].param[1] && sldobj[n].scn_obj==trk_timeline[i].trkcmdlist[j].param[0])
								{
								sldobj[n].flag=FALSE;
								for (int m=0;m<tmp_mod0array[sldobj[n].scn_tgtobj][sldobj[n].tgtobj].numofmodifers;m++)
									{
									mod0array[sldobj[n].scn_obj][sldobj[n].obj].modifer[m]=tmp_mod0array[sldobj[n].scn_tgtobj][sldobj[n].tgtobj].modifer[m];
									tmp_mod0array[sldobj[n].scn_obj][sldobj[n].obj].modifer[m]=tmp_mod0array[sldobj[n].scn_tgtobj][sldobj[n].tgtobj].modifer[m];
									}
								objects[sldobj[n].scn_obj][sldobj[n].obj].x=_tmp_objects[sldobj[n].scn_tgtobj][sldobj[n].tgtobj].x;
								objects[sldobj[n].scn_obj][sldobj[n].obj].y=_tmp_objects[sldobj[n].scn_tgtobj][sldobj[n].tgtobj].y;
								objects[sldobj[n].scn_obj][sldobj[n].obj].z=_tmp_objects[sldobj[n].scn_tgtobj][sldobj[n].tgtobj].z;
								objects[sldobj[n].scn_obj][sldobj[n].obj].sx=_tmp_objects[sldobj[n].scn_tgtobj][sldobj[n].tgtobj].sx;
								objects[sldobj[n].scn_obj][sldobj[n].obj].sy=_tmp_objects[sldobj[n].scn_tgtobj][sldobj[n].tgtobj].sy;
								objects[sldobj[n].scn_obj][sldobj[n].obj].sz=_tmp_objects[sldobj[n].scn_tgtobj][sldobj[n].tgtobj].sz;
								_tmp_objects[sldobj[n].scn_obj][sldobj[n].obj].x=_tmp_objects[sldobj[n].scn_tgtobj][sldobj[n].tgtobj].x;
								_tmp_objects[sldobj[n].scn_obj][sldobj[n].obj].y=_tmp_objects[sldobj[n].scn_tgtobj][sldobj[n].tgtobj].y;
								_tmp_objects[sldobj[n].scn_obj][sldobj[n].obj].z=_tmp_objects[sldobj[n].scn_tgtobj][sldobj[n].tgtobj].z;
								_tmp_objects[sldobj[n].scn_obj][sldobj[n].obj].sx=_tmp_objects[sldobj[n].scn_tgtobj][sldobj[n].tgtobj].sx;
								_tmp_objects[sldobj[n].scn_obj][sldobj[n].obj].sy=_tmp_objects[sldobj[n].scn_tgtobj][sldobj[n].tgtobj].sy;
								_tmp_objects[sldobj[n].scn_obj][sldobj[n].obj].sz=_tmp_objects[sldobj[n].scn_tgtobj][sldobj[n].tgtobj].sz;
								}
							}
						//--
						sldobj[sldobj_count].flag=TRUE;
						sldobj[sldobj_count].timer=trk_timeline[i].trkcmdlist[j].time.msec+1000*trk_timeline[i].trkcmdlist[j].time.sec+60000*trk_timeline[i].trkcmdlist[j].time.min;
						sldobj[sldobj_count].timestart=trktime_list;
						sldobj[sldobj_count].scn_obj=trk_timeline[i].trkcmdlist[j].param[0];
						sldobj[sldobj_count].obj=trk_timeline[i].trkcmdlist[j].param[1];
						sldobj[sldobj_count].scn_tgtobj=trk_timeline[i].trkcmdlist[j].param[2];
						sldobj[sldobj_count].tgtobj=trk_timeline[i].trkcmdlist[j].param[3];
						if (trk_timeline[i].trkcmdlist[j].param[4]==1) //reset mode
							{
							_tmp_objects[sldobj[sldobj_count].scn_obj][sldobj[sldobj_count].obj]=restore_objects[sldobj[sldobj_count].scn_obj][sldobj[sldobj_count].obj];
							for (int m=0;m<tmp_mod0array[sldobj[sldobj_count].scn_obj][sldobj[sldobj_count].obj].numofmodifers;m++)
								{
								tmp_mod0array[sldobj[sldobj_count].scn_obj][sldobj[sldobj_count].obj].modifer[m]=restore_mod0array[sldobj[sldobj_count].scn_obj][sldobj[sldobj_count].obj].modifer[m];
								}
							}
						sldobj_count++;
						}
					}
				//--- 5: camcap
				if (trk_timeline[i].trkcmdlist[j].trkcmd==5)
					{
					CamCapFlag=1; cam_slideflag=0; splCamFlag=0;
					CamPosObj=trk_timeline[i].trkcmdlist[j].param[1];
					CamViewObj=trk_timeline[i].trkcmdlist[j].param[3];
					camcap_scn_cam=trk_timeline[i].trkcmdlist[j].param[0];
					camcap_scn_tgt=trk_timeline[i].trkcmdlist[j].param[2];
					}
				//--- 6: setnorm
				if (trk_timeline[i].trkcmdlist[j].trkcmd==6)
					{
					objects[trk_timeline[i].trkcmdlist[j].param[0]][trk_timeline[i].trkcmdlist[j].param[1]].normal=trk_timeline[i].trkcmdlist[j].param[2];
					}
				//--- 7: get spline
				if (trk_timeline[i].trkcmdlist[j].trkcmd==7)
					{
					//, , 
					if (objects[trk_timeline[i].trkcmdlist[j].param[1]][trk_timeline[i].trkcmdlist[j].param[2]].type==31 && mod0array[trk_timeline[i].trkcmdlist[j].param[1]][trk_timeline[i].trkcmdlist[j].param[2]].numofmodifers>3)
						{
						Splines[trk_timeline[i].trkcmdlist[j].param[0]].curr_segment=0;
						Splines[trk_timeline[i].trkcmdlist[j].param[0]].start_time=0;
						Splines[trk_timeline[i].trkcmdlist[j].param[0]].count=mod0array[trk_timeline[i].trkcmdlist[j].param[1]][trk_timeline[i].trkcmdlist[j].param[2]].numofmodifers;
						for (int m=0;m<Splines[trk_timeline[i].trkcmdlist[j].param[0]].count;m++)
							{
							Splines[trk_timeline[i].trkcmdlist[j].param[0]].points[m].x=mod0array[trk_timeline[i].trkcmdlist[j].param[1]][trk_timeline[i].trkcmdlist[j].param[2]].modifer[m].x;
							Splines[trk_timeline[i].trkcmdlist[j].param[0]].points[m].y=mod0array[trk_timeline[i].trkcmdlist[j].param[1]][trk_timeline[i].trkcmdlist[j].param[2]].modifer[m].y;
							Splines[trk_timeline[i].trkcmdlist[j].param[0]].points[m].z=mod0array[trk_timeline[i].trkcmdlist[j].param[1]][trk_timeline[i].trkcmdlist[j].param[2]].modifer[m].z;
							Splines[trk_timeline[i].trkcmdlist[j].param[0]].points[m].time=1000*mod0array[trk_timeline[i].trkcmdlist[j].param[1]][trk_timeline[i].trkcmdlist[j].param[2]].modifer[m].pow+mod0array[trk_timeline[i].trkcmdlist[j].param[1]][trk_timeline[i].trkcmdlist[j].param[2]].modifer[m].rad;
							}
						//      
						D3DXVECTOR3 lvec; float vx,vy,vz;
						Splines[trk_timeline[i].trkcmdlist[j].param[0]].splinelen=0;
						for (m=1;m<Splines[trk_timeline[i].trkcmdlist[j].param[0]].count-2;m++)
							{
							vx=(Splines[trk_timeline[i].trkcmdlist[j].param[0]].points[m+1].x - Splines[trk_timeline[i].trkcmdlist[j].param[0]].points[m].x);
							vy=(Splines[trk_timeline[i].trkcmdlist[j].param[0]].points[m+1].y - Splines[trk_timeline[i].trkcmdlist[j].param[0]].points[m].y);
							vz=(Splines[trk_timeline[i].trkcmdlist[j].param[0]].points[m+1].z - Splines[trk_timeline[i].trkcmdlist[j].param[0]].points[m].z);
							D3DXVECTOR3 lvec (vx,vy,vz);
							Splines[trk_timeline[i].trkcmdlist[j].param[0]].points[m].segmlen=D3DXVec3Length(&lvec);
							Splines[trk_timeline[i].trkcmdlist[j].param[0]].splinelen += Splines[trk_timeline[i].trkcmdlist[j].param[0]].points[m].segmlen;
							}
						}
					}
				//--- 8: spline obj [<timer>,0:scn,1:obj,2:spline]
				if (trk_timeline[i].trkcmdlist[j].trkcmd==8)
					{
					tmptimer=trk_timeline[i].trkcmdlist[j].time.msec+1000*trk_timeline[i].trkcmdlist[j].time.sec+60000*trk_timeline[i].trkcmdlist[j].time.min;
					if (tmptimer==0) //     
						{}
					else //     
						{
						splineobj[splineobj_count].segmtime_begin[0]=trktime_list;
						for (int m=1;m<Splines[trk_timeline[i].trkcmdlist[j].param[2]].count-2;m++)
							{
							splineobj[splineobj_count].segmtimer[m-1]=tmptimer * Splines[trk_timeline[i].trkcmdlist[j].param[2]].points[m].segmlen / Splines[trk_timeline[i].trkcmdlist[j].param[2]].splinelen;
							splineobj[splineobj_count].segmtime_begin[m]=splineobj[splineobj_count].segmtime_begin[m-1] + splineobj[splineobj_count].segmtimer[m-1];
							}
						splineobj[splineobj_count].timer=tmptimer;
						}
					splineobj[splineobj_count].currsegm=0;
					splineobj[splineobj_count].flag=TRUE;
					splineobj[splineobj_count].scn_obj=trk_timeline[i].trkcmdlist[j].param[0];
					splineobj[splineobj_count].obj=trk_timeline[i].trkcmdlist[j].param[1];
					splineobj[splineobj_count].spline=trk_timeline[i].trkcmdlist[j].param[2];
					splineobj_count++;
					}
				//--- 9: get spline cam [cam1,cam2,spleye,spltgt]
				if (trk_timeline[i].trkcmdlist[j].trkcmd==9)
					{
					Splines[trk_timeline[i].trkcmdlist[j].param[2]].count=3+abs(trk_timeline[i].trkcmdlist[j].param[1]-trk_timeline[i].trkcmdlist[j].param[0]);
					Splines[trk_timeline[i].trkcmdlist[j].param[2]].points[0].x=cam_bank[trk_timeline[i].trkcmdlist[j].param[0]].v_x;
					Splines[trk_timeline[i].trkcmdlist[j].param[2]].points[0].y=cam_bank[trk_timeline[i].trkcmdlist[j].param[0]].v_y;
					Splines[trk_timeline[i].trkcmdlist[j].param[2]].points[0].z=cam_bank[trk_timeline[i].trkcmdlist[j].param[0]].v_z;
					Splines[trk_timeline[i].trkcmdlist[j].param[2]].points[0].tgt_x=cam_bank[trk_timeline[i].trkcmdlist[j].param[0]].tgt_x;
					Splines[trk_timeline[i].trkcmdlist[j].param[2]].points[0].tgt_y=cam_bank[trk_timeline[i].trkcmdlist[j].param[0]].tgt_y;
					Splines[trk_timeline[i].trkcmdlist[j].param[2]].points[0].tgt_z=cam_bank[trk_timeline[i].trkcmdlist[j].param[0]].tgt_z;
					Splines[trk_timeline[i].trkcmdlist[j].param[2]].points[0].tgt_z=cam_bank[trk_timeline[i].trkcmdlist[j].param[0]].dist;
					Splines[trk_timeline[i].trkcmdlist[j].param[2]].points[0].xy_a=cam_bank[trk_timeline[i].trkcmdlist[j].param[0]].xy_a;
					//---
					Splines[trk_timeline[i].trkcmdlist[j].param[2]].points[Splines[trk_timeline[i].trkcmdlist[j].param[2]].count-1].x=cam_bank[trk_timeline[i].trkcmdlist[j].param[1]].v_x;
					Splines[trk_timeline[i].trkcmdlist[j].param[2]].points[Splines[trk_timeline[i].trkcmdlist[j].param[2]].count-1].y=cam_bank[trk_timeline[i].trkcmdlist[j].param[1]].v_y;
					Splines[trk_timeline[i].trkcmdlist[j].param[2]].points[Splines[trk_timeline[i].trkcmdlist[j].param[2]].count-1].z=cam_bank[trk_timeline[i].trkcmdlist[j].param[1]].v_z;
					Splines[trk_timeline[i].trkcmdlist[j].param[2]].points[Splines[trk_timeline[i].trkcmdlist[j].param[2]].count-1].tgt_x=cam_bank[trk_timeline[i].trkcmdlist[j].param[1]].tgt_x;
					Splines[trk_timeline[i].trkcmdlist[j].param[2]].points[Splines[trk_timeline[i].trkcmdlist[j].param[2]].count-1].tgt_y=cam_bank[trk_timeline[i].trkcmdlist[j].param[1]].tgt_y;
					Splines[trk_timeline[i].trkcmdlist[j].param[2]].points[Splines[trk_timeline[i].trkcmdlist[j].param[2]].count-1].tgt_z=cam_bank[trk_timeline[i].trkcmdlist[j].param[1]].tgt_z;
					Splines[trk_timeline[i].trkcmdlist[j].param[2]].points[Splines[trk_timeline[i].trkcmdlist[j].param[2]].count-1].dist=cam_bank[trk_timeline[i].trkcmdlist[j].param[1]].dist;
					Splines[trk_timeline[i].trkcmdlist[j].param[2]].points[Splines[trk_timeline[i].trkcmdlist[j].param[2]].count-1].xy_a=cam_bank[trk_timeline[i].trkcmdlist[j].param[1]].xy_a;
					for (int m=1;m<Splines[trk_timeline[i].trkcmdlist[j].param[2]].count-1;m++)
						{
						Splines[trk_timeline[i].trkcmdlist[j].param[2]].points[m].x=cam_bank[trk_timeline[i].trkcmdlist[j].param[0]+m-1].v_x;
						Splines[trk_timeline[i].trkcmdlist[j].param[2]].points[m].y=cam_bank[trk_timeline[i].trkcmdlist[j].param[0]+m-1].v_y;
						Splines[trk_timeline[i].trkcmdlist[j].param[2]].points[m].z=cam_bank[trk_timeline[i].trkcmdlist[j].param[0]+m-1].v_z;
						Splines[trk_timeline[i].trkcmdlist[j].param[2]].points[m].tgt_x=cam_bank[trk_timeline[i].trkcmdlist[j].param[0]+m-1].tgt_x;
						Splines[trk_timeline[i].trkcmdlist[j].param[2]].points[m].tgt_y=cam_bank[trk_timeline[i].trkcmdlist[j].param[0]+m-1].tgt_y;
						Splines[trk_timeline[i].trkcmdlist[j].param[2]].points[m].tgt_z=cam_bank[trk_timeline[i].trkcmdlist[j].param[0]+m-1].tgt_z;
						Splines[trk_timeline[i].trkcmdlist[j].param[2]].points[m].dist=cam_bank[trk_timeline[i].trkcmdlist[j].param[0]+m-1].dist;
						Splines[trk_timeline[i].trkcmdlist[j].param[2]].points[m].xy_a=cam_bank[trk_timeline[i].trkcmdlist[j].param[0]+m-1].xy_a;
						}
					D3DXVECTOR3 lvec; float vx,vy,vz;
					Splines[trk_timeline[i].trkcmdlist[j].param[2]].splinelen=0;
					for (m=1;m<Splines[trk_timeline[i].trkcmdlist[j].param[2]].count-2;m++)
						{
						vx=(Splines[trk_timeline[i].trkcmdlist[j].param[2]].points[m+1].x - Splines[trk_timeline[i].trkcmdlist[j].param[2]].points[m].x);
						vy=(Splines[trk_timeline[i].trkcmdlist[j].param[2]].points[m+1].y - Splines[trk_timeline[i].trkcmdlist[j].param[2]].points[m].y);
						vz=(Splines[trk_timeline[i].trkcmdlist[j].param[2]].points[m+1].z - Splines[trk_timeline[i].trkcmdlist[j].param[2]].points[m].z);
						D3DXVECTOR3 lvec (vx,vy,vz);
						Splines[trk_timeline[i].trkcmdlist[j].param[2]].points[m].segmlen=D3DXVec3Length(&lvec);
						Splines[trk_timeline[i].trkcmdlist[j].param[2]].splinelen += Splines[trk_timeline[i].trkcmdlist[j].param[2]].points[m].segmlen;
						}
					}
				//--- 10: SplineCam [time,0:spline,1:begin_segm,2:segm_count]
				if (trk_timeline[i].trkcmdlist[j].trkcmd==10)
					{
					splCamFlag=TRUE;
					splCam_timer=trk_timeline[i].trkcmdlist[j].time.msec+1000*trk_timeline[i].trkcmdlist[j].time.sec+60000*trk_timeline[i].trkcmdlist[j].time.min;
					splCam_spline=trk_timeline[i].trkcmdlist[j].param[0];
					splCam_currsegm=trk_timeline[i].trkcmdlist[j].param[1];
					splCam_segmcount=trk_timeline[i].trkcmdlist[j].param[2];
					if (splCam_segmcount==0){splCam_segmcount=Splines[splCam_spline].count-3;}
					splCam_spline_len=0;
					for (int m=splCam_currsegm;m<(splCam_currsegm+splCam_segmcount);m++)
						{splCam_spline_len+=Splines[splCam_spline].points[m].segmlen;}
					splCam_segm_timestart=trktime_list;
					splCam_segm_timer=splCam_timer * Splines[splCam_spline].points[splCam_currsegm+1].segmlen / splCam_spline_len;
					}

				/*//--- 10: pCamEye [time,spleye,spltgt,segm]
				if (trk_timeline[i].trkcmdlist[j].trkcmd==10)
					{
					pCamFlag=TRUE; pCamEye_flag=TRUE;
					pCamEye_type=trk_timeline[i].trkcmdlist[j].param[0];
					//cam_eye spline [time,0:type(spline),1:spline,2:begin_segm,3:segm_count,4:flag_normalize_eye]
					if (pCamEye_type==0)
						{
						pCamEye_type=trk_timeline[i].trkcmdlist[j].param[0];
						pCamEye_timer=trk_timeline[i].trkcmdlist[j].time.msec+1000*trk_timeline[i].trkcmdlist[j].time.sec+60000*trk_timeline[i].trkcmdlist[j].time.min;
						pCamEye_spline=trk_timeline[i].trkcmdlist[j].param[1];
						pCamEye_currsegm=trk_timeline[i].trkcmdlist[j].param[2];
						pCamEye_segmcount=trk_timeline[i].trkcmdlist[j].param[3];
						if (pCamEye_segmcount==0){pCamEye_segmcount=Splines[pCamEye_spline].count-3;}
						flag_normalize_eye=trk_timeline[i].trkcmdlist[j].param[4];
						pCamEye_spline_len=0;
						for (int m=pCamEye_currsegm;m<(pCamEye_currsegm+pCamEye_segmcount);m++)
							{pCamEye_spline_len+=Splines[pCamEye_spline].points[m].segmlen;}
						pCamEye_segm_timestart=trktime_list;
						pCamEye_segm_timer=pCamEye_timer * Splines[pCamEye_spline].points[pCamEye_currsegm].segmlen / pCamEye_spline_len;
						}
					}
				//--- 11: pCamTgt [time,spleye,spltgt,segm]
				if (trk_timeline[i].trkcmdlist[j].trkcmd==11)
					{
					pCamFlag=TRUE; pCamTgt_flag=TRUE;
					pCamTgt_type=trk_timeline[i].trkcmdlist[j].param[0];
					//cam_tgt spline [time,0:type(spline),1:spline,2:begin_segm,3:segm_count,4:flag_normalize_tgt]
					if (pCamTgt_type==0 || pCamTgt_type==1)
						{
						pCamTgt_type=trk_timeline[i].trkcmdlist[j].param[0];
						pCamTgt_timer=trk_timeline[i].trkcmdlist[j].time.msec+1000*trk_timeline[i].trkcmdlist[j].time.sec+60000*trk_timeline[i].trkcmdlist[j].time.min;
						pCamTgt_spline=trk_timeline[i].trkcmdlist[j].param[1];
						pCamTgt_currsegm=trk_timeline[i].trkcmdlist[j].param[2];
						pCamTgt_segmcount=trk_timeline[i].trkcmdlist[j].param[3];
						if (pCamTgt_segmcount==0){pCamTgt_segmcount=Splines[pCamTgt_spline].count-3;}
						flag_normalize_tgt=trk_timeline[i].trkcmdlist[j].param[4];
						pCamTgt_spline_len=0;
						for (int m=pCamTgt_currsegm;m<(pCamTgt_currsegm+pCamTgt_segmcount);m++)
							{pCamTgt_spline_len+=Splines[pCamTgt_spline].points[m].segmlen;}
						pCamTgt_segm_timestart=trktime_list;
						pCamTgt_segm_timer=pCamTgt_timer * Splines[pCamTgt_spline].points[pCamTgt_currsegm].segmlen / pCamTgt_spline_len;
						}
					}*/
				//---
				}
			trk_timeline_flags[i]=TRUE; //   
			}
		}
	}
//----------     

//-------- process camera

if (CamCapFlag==1) //process camera cap
	{
	int restore_current_scene=current_scene;
	current_scene=camcap_scn_cam;
	CurrentObject[camcap_scn_cam]=CamPosObj;
	gx=0;
	gy=0;
	gz=0;
	apply_mods();
	gx*=64;gy*=64;gz*=64;
	main_cam.v_x=gx+objects[camcap_scn_cam][CamPosObj].x;
	main_cam.v_y=gy+objects[camcap_scn_cam][CamPosObj].y;
	main_cam.v_z=gz+objects[camcap_scn_cam][CamPosObj].z;
	current_scene=camcap_scn_tgt;
	CurrentObject[camcap_scn_tgt]=CamViewObj;
	gx=0;
	gy=0;
	gz=0;
	apply_mods();
	gx*=64;gy*=64;gz*=64;
	main_cam.tgt_x=gx+objects[camcap_scn_tgt][CamViewObj].x;
	main_cam.tgt_y=gy+objects[camcap_scn_tgt][CamViewObj].y;
	main_cam.tgt_z=gz+objects[camcap_scn_tgt][CamViewObj].z;
	current_scene=restore_current_scene;
	}
//---
if (cam_slideflag==1) //process camera slide
{
	//if (trktime_curr==cam_timestart) {p=0;} else {p=cam_timer/(trktime_curr-cam_timestart);}
	p=1.0*(trktime_curr-cam_timestart)/cam_timer;
	if (p>1) {cam_slideflag=0;}
	else
	{
	bf=p;
	brf=1-p;
	cam_pathtype=0;

	sprintf(tempstr,"%d:%d:%d",trktime_curr,cam_timestart,cam_timer);
	SetDlgItemText(tracker_UIDlg,IDC_STATIC2,tempstr);
	switch (cam_pathtype)
	{
	case 0: //  
		{
		main_cam.dist=brf*(double)cam_bank[cam_1].dist+bf*(double)cam_bank[cam_2].dist;
		main_cam.tgt_x=brf*(double)cam_bank[cam_1].tgt_x+bf*(double)cam_bank[cam_2].tgt_x;
		main_cam.tgt_y=brf*(double)cam_bank[cam_1].tgt_y+bf*(double)cam_bank[cam_2].tgt_y;
		main_cam.tgt_z=brf*(double)cam_bank[cam_1].tgt_z+bf*(double)cam_bank[cam_2].tgt_z;
		main_cam.v_x=brf*(double)cam_bank[cam_1].v_x+bf*(double)cam_bank[cam_2].v_x;
		main_cam.v_y=brf*(double)cam_bank[cam_1].v_y+bf*(double)cam_bank[cam_2].v_y;
		main_cam.v_z=brf*(double)cam_bank[cam_1].v_z+bf*(double)cam_bank[cam_2].v_z;
		main_cam.xy_a=brf*(double)cam_bank[cam_1].xy_a+bf*(double)cam_bank[cam_2].xy_a;
		break;
		}
	}
	}
}

//-------- splineCam
if (splCamFlag)
	{
	p=1.0*(trktime_curr-splCam_segm_timestart)/splCam_segm_timer;
	if (p>1)
		{
		splCam_currsegm++;
		if (splCam_currsegm < splCam_segmcount)
			{ //next segm
			splCam_segm_timestart+=splCam_segm_timer;
			splCam_segm_timer=splCam_timer * Splines[splCam_spline].points[splCam_currsegm+1].segmlen / splCam_spline_len;
			p=1.0*(trktime_curr-splCam_segm_timestart)/splCam_segm_timer;
			}
		else
			{splCamFlag=FALSE;}
		}
	//---
	if (splCamFlag)
		{
		main_cam.v_x=spline_katmulrom( Splines[splCam_spline].points[splCam_currsegm].x, Splines[splCam_spline].points[splCam_currsegm+1].x, Splines[splCam_spline].points[splCam_currsegm+2].x, Splines[splCam_spline].points[splCam_currsegm+3].x, p);
		main_cam.v_y=spline_katmulrom( Splines[splCam_spline].points[splCam_currsegm].y, Splines[splCam_spline].points[splCam_currsegm+1].y, Splines[splCam_spline].points[splCam_currsegm+2].y, Splines[splCam_spline].points[splCam_currsegm+3].y, p);
		main_cam.v_z=spline_katmulrom( Splines[splCam_spline].points[splCam_currsegm].z, Splines[splCam_spline].points[splCam_currsegm+1].z, Splines[splCam_spline].points[splCam_currsegm+2].z, Splines[splCam_spline].points[splCam_currsegm+3].z, p);
		main_cam.tgt_x=spline_katmulrom( Splines[splCam_spline].points[splCam_currsegm].tgt_x, Splines[splCam_spline].points[splCam_currsegm+1].tgt_x, Splines[splCam_spline].points[splCam_currsegm+2].tgt_x, Splines[splCam_spline].points[splCam_currsegm+3].tgt_x, p);
		main_cam.tgt_y=spline_katmulrom( Splines[splCam_spline].points[splCam_currsegm].tgt_y, Splines[splCam_spline].points[splCam_currsegm+1].tgt_y, Splines[splCam_spline].points[splCam_currsegm+2].tgt_y, Splines[splCam_spline].points[splCam_currsegm+3].tgt_y, p);
		main_cam.tgt_z=spline_katmulrom( Splines[splCam_spline].points[splCam_currsegm].tgt_z, Splines[splCam_spline].points[splCam_currsegm+1].tgt_z, Splines[splCam_spline].points[splCam_currsegm+2].tgt_z, Splines[splCam_spline].points[splCam_currsegm+3].tgt_z, p);
		}
	}

/*
//-------- process pCam...
if (pCamFlag)
{
//---
if (pCamEye_flag) // process cam_eye
	{
	if (pCamEye_type==0) //spline cam_eye
		{
		p=1.0*(trktime_curr-pCamEye_segm_timestart)/pCamEye_segm_timer;
		if (p>1)
			{
			pCamEye_currsegm++;
			if (pCamEye_currsegm < pCamEye_segmcount)
				{ //next segm
				pCamEye_segm_timestart+=pCamEye_segm_timer;
				pCamEye_segm_timer=pCamEye_timer * Splines[pCamEye_spline].points[pCamEye_currsegm].segmlen / pCamEye_spline_len;
				}
			else
				{pCamEye_flag=FALSE;}
			}
		if (pCamEye_flag)
			{
			main_cam.tgt_x=spline_katmulrom( Splines[pCamEye_spline].points[pCamEye_currsegm].x, Splines[pCamEye_spline].points[pCamEye_currsegm+1].x, Splines[pCamEye_spline].points[pCamEye_currsegm+2].x, Splines[pCamEye_spline].points[pCamEye_currsegm+3].x, p);
			main_cam.tgt_y=spline_katmulrom( Splines[pCamEye_spline].points[pCamEye_currsegm].y, Splines[pCamEye_spline].points[pCamEye_currsegm+1].y, Splines[pCamEye_spline].points[pCamEye_currsegm+2].y, Splines[pCamEye_spline].points[pCamEye_currsegm+3].y, p);
			main_cam.tgt_z=spline_katmulrom( Splines[pCamEye_spline].points[pCamEye_currsegm].z, Splines[pCamEye_spline].points[pCamEye_currsegm+1].z, Splines[pCamEye_spline].points[pCamEye_currsegm+2].z, Splines[pCamEye_spline].points[pCamEye_currsegm+3].z, p);
			}
		}

	}
//---
if (pCamTgt_flag) // process cam_tgt
	{
	if (pCamTgt_type==0 || pCamTgt_type==1) //spline cam_tgt
		{
		if (pCamTgt_type==0) {p=1.0*(trktime_curr-pCamTgt_segm_timestart)/pCamTgt_segm_timer;}
		if (pCamTgt_type==1) {p=1.0*(trktime_curr-pCamEye_segm_timestart)/pCamEye_segm_timer;}
		if (p>1)
			{
			if (pCamTgt_type==0)
				{
				pCamTgt_currsegm++;
				if (pCamTgt_currsegm < pCamTgt_segmcount)
					{ //next segm
					pCamTgt_segm_timestart+=pCamTgt_segm_timer;
					pCamTgt_segm_timer=pCamTgt_timer * Splines[pCamTgt_spline].points[pCamTgt_currsegm].segmlen / pCamTgt_spline_len;
					}
				else
					{pCamTgt_flag=FALSE;}
				}
			if (pCamTgt_type==1){pCamTgt_currsegm++;}
			}
		if (pCamTgt_flag)
			{
			main_cam.tgt_x=spline_katmulrom( Splines[pCamTgt_spline].points[pCamTgt_currsegm].x, Splines[pCamTgt_spline].points[pCamTgt_currsegm+1].x, Splines[pCamTgt_spline].points[pCamTgt_currsegm+2].x, Splines[pCamTgt_spline].points[pCamTgt_currsegm+3].x, p);
			main_cam.tgt_y=spline_katmulrom( Splines[pCamTgt_spline].points[pCamTgt_currsegm].y, Splines[pCamTgt_spline].points[pCamTgt_currsegm+1].y, Splines[pCamTgt_spline].points[pCamTgt_currsegm+2].y, Splines[pCamTgt_spline].points[pCamTgt_currsegm+3].y, p);
			main_cam.tgt_z=spline_katmulrom( Splines[pCamTgt_spline].points[pCamTgt_currsegm].z, Splines[pCamTgt_spline].points[pCamTgt_currsegm+1].z, Splines[pCamTgt_spline].points[pCamTgt_currsegm+2].z, Splines[pCamTgt_spline].points[pCamTgt_currsegm+3].z, p);
			}
		}

	}
//---
}
*/


//-------- process material
for (i=0;i<256;i++)
	{
	if (sldmat[i].flag)
		{
		p=(trktime_curr-sldmat[i].timestart)/sldmat[i].timer;
		if (p>1)
			{
			sldmat[i].flag=FALSE;
			tmp_Materialbank[i]=tmp_Materialbank[sldmat[i].dest];
			Materialbank[i]=tmp_Materialbank[sldmat[i].dest];
			}
		else
			{
			bf=p;
			brf=1-p;
			Materialbank[i].Ambient.r=brf*(double)tmp_Materialbank[i].Ambient.r+bf*(double)tmp_Materialbank[sldmat[i].dest].Ambient.r;
			Materialbank[i].Ambient.g=brf*(double)tmp_Materialbank[i].Ambient.g+bf*(double)tmp_Materialbank[sldmat[i].dest].Ambient.g;
			Materialbank[i].Ambient.b=brf*(double)tmp_Materialbank[i].Ambient.b+bf*(double)tmp_Materialbank[sldmat[i].dest].Ambient.b;
			Materialbank[i].Diffuse.r=brf*(double)tmp_Materialbank[i].Diffuse.r+bf*(double)tmp_Materialbank[sldmat[i].dest].Diffuse.r;
			Materialbank[i].Diffuse.g=brf*(double)tmp_Materialbank[i].Diffuse.g+bf*(double)tmp_Materialbank[sldmat[i].dest].Diffuse.g;
			Materialbank[i].Diffuse.b=brf*(double)tmp_Materialbank[i].Diffuse.b+bf*(double)tmp_Materialbank[sldmat[i].dest].Diffuse.b;
			Materialbank[i].Specular.r=brf*(double)tmp_Materialbank[i].Specular.r+bf*(double)tmp_Materialbank[sldmat[i].dest].Specular.r;
			Materialbank[i].Specular.g=brf*(double)tmp_Materialbank[i].Specular.g+bf*(double)tmp_Materialbank[sldmat[i].dest].Specular.g;
			Materialbank[i].Specular.b=brf*(double)tmp_Materialbank[i].Specular.b+bf*(double)tmp_Materialbank[sldmat[i].dest].Specular.b;
			Materialbank[i].Power=brf*(double)tmp_Materialbank[i].Power+bf*(double)tmp_Materialbank[sldmat[i].dest].Power;
			Materialbank_vertexbumpdepth[i]=brf*(double)tmp_Materialbank_vertexbumpdepth[i]+bf*(double)tmp_Materialbank_vertexbumpdepth[sldmat[i].dest];
			}
		}
	}

//-------- process spline objects
k=splineobj_count; j=0; //      
for (i=0;i<k;i++){if (splineobj[i].flag){splineobj[j]=splineobj[i]; j++;} else {splineobj_count--;}}
//--- splobj
for (i=0;i<splineobj_count;i++)
	{
	//p=(trktime_curr-sldobj[i].timestart)/sldobj[i].timer;
	//splineobj[i].currsegm
	p=(trktime_curr-splineobj[i].segmtime_begin[splineobj[i].currsegm])/splineobj[i].segmtimer[splineobj[i].currsegm];
	if (p>1)
		{
		splineobj[i].currsegm++;
		if (splineobj[i].currsegm<(Splines[splineobj[i].spline].count-3))
			{p=(trktime_curr-splineobj[i].segmtime_begin[splineobj[i].currsegm])/splineobj[i].segmtimer[splineobj[i].currsegm];}
		else
			{splineobj[i].flag=FALSE;}
		}
	//--- -  (p<=1) ??? (p<=1.1)???
	if (splineobj[i].flag)
		{
			objects[splineobj[i].scn_obj][splineobj[i].obj].x=spline_katmulrom(
		Splines[splineobj[i].spline].points[splineobj[i].currsegm].x,
		Splines[splineobj[i].spline].points[splineobj[i].currsegm+1].x,
		Splines[splineobj[i].spline].points[splineobj[i].currsegm+2].x,
		Splines[splineobj[i].spline].points[splineobj[i].currsegm+3].x, p);
			objects[splineobj[i].scn_obj][splineobj[i].obj].y=spline_katmulrom(
		Splines[splineobj[i].spline].points[splineobj[i].currsegm].y,
		Splines[splineobj[i].spline].points[splineobj[i].currsegm+1].y,
		Splines[splineobj[i].spline].points[splineobj[i].currsegm+2].y,
		Splines[splineobj[i].spline].points[splineobj[i].currsegm+3].y, p);
			objects[splineobj[i].scn_obj][splineobj[i].obj].z=spline_katmulrom(
		Splines[splineobj[i].spline].points[splineobj[i].currsegm].z,
		Splines[splineobj[i].spline].points[splineobj[i].currsegm+1].z,
		Splines[splineobj[i].spline].points[splineobj[i].currsegm+2].z,
		Splines[splineobj[i].spline].points[splineobj[i].currsegm+3].z, p);
		}
	}


//-------- process sld objects
k=sldobj_count; j=0; //      
for (i=0;i<k;i++){if (sldobj[i].flag){sldobj[j]=sldobj[i]; j++;} else {sldobj_count--;}}
//--- sldobj
for (i=0;i<sldobj_count;i++)
	{
	if (sldobj[i].flag)
		{
		//if (trktime_curr!=sldobj[i].timestart) {p=sldobj[i].timer/(trktime_curr-sldobj[i].timestart);} else {p=0;}
		p=(trktime_curr-sldobj[i].timestart)/sldobj[i].timer;
		if (p>1)
			{
			sldobj[i].flag=FALSE;
			for (int m=0;m<tmp_mod0array[sldobj[i].scn_tgtobj][sldobj[i].tgtobj].numofmodifers;m++)
				{
				mod0array[sldobj[i].scn_obj][sldobj[i].obj].modifer[m]=tmp_mod0array[sldobj[i].scn_tgtobj][sldobj[i].tgtobj].modifer[m];
				tmp_mod0array[sldobj[i].scn_obj][sldobj[i].obj].modifer[m]=tmp_mod0array[sldobj[i].scn_tgtobj][sldobj[i].tgtobj].modifer[m];
				}
			objects[sldobj[i].scn_obj][sldobj[i].obj].x=_tmp_objects[sldobj[i].scn_tgtobj][sldobj[i].tgtobj].x;
			objects[sldobj[i].scn_obj][sldobj[i].obj].y=_tmp_objects[sldobj[i].scn_tgtobj][sldobj[i].tgtobj].y;
			objects[sldobj[i].scn_obj][sldobj[i].obj].z=_tmp_objects[sldobj[i].scn_tgtobj][sldobj[i].tgtobj].z;
			objects[sldobj[i].scn_obj][sldobj[i].obj].sx=_tmp_objects[sldobj[i].scn_tgtobj][sldobj[i].tgtobj].sx;
			objects[sldobj[i].scn_obj][sldobj[i].obj].sy=_tmp_objects[sldobj[i].scn_tgtobj][sldobj[i].tgtobj].sy;
			objects[sldobj[i].scn_obj][sldobj[i].obj].sz=_tmp_objects[sldobj[i].scn_tgtobj][sldobj[i].tgtobj].sz;
			_tmp_objects[sldobj[i].scn_obj][sldobj[i].obj].x=_tmp_objects[sldobj[i].scn_tgtobj][sldobj[i].tgtobj].x;
			_tmp_objects[sldobj[i].scn_obj][sldobj[i].obj].y=_tmp_objects[sldobj[i].scn_tgtobj][sldobj[i].tgtobj].y;
			_tmp_objects[sldobj[i].scn_obj][sldobj[i].obj].z=_tmp_objects[sldobj[i].scn_tgtobj][sldobj[i].tgtobj].z;
			_tmp_objects[sldobj[i].scn_obj][sldobj[i].obj].sx=_tmp_objects[sldobj[i].scn_tgtobj][sldobj[i].tgtobj].sx;
			_tmp_objects[sldobj[i].scn_obj][sldobj[i].obj].sy=_tmp_objects[sldobj[i].scn_tgtobj][sldobj[i].tgtobj].sy;
			_tmp_objects[sldobj[i].scn_obj][sldobj[i].obj].sz=_tmp_objects[sldobj[i].scn_tgtobj][sldobj[i].tgtobj].sz;
			}
		else
			{
			bf=p;
			brf=1-p;
			mod0array[sldobj[i].scn_obj][sldobj[i].obj].numofmodifers=tmp_mod0array[sldobj[i].scn_tgtobj][sldobj[i].tgtobj].numofmodifers;
			for (int m=0;m<tmp_mod0array[sldobj[i].scn_tgtobj][sldobj[i].tgtobj].numofmodifers;m++) 
				{
				mod0array[sldobj[i].scn_obj][sldobj[i].obj].modifer[m].type=tmp_mod0array[sldobj[i].scn_tgtobj][sldobj[i].tgtobj].modifer[m].type;
				if (mod0array[sldobj[i].scn_obj][sldobj[i].obj].modifer[m].x != tmp_mod0array[sldobj[i].scn_tgtobj][sldobj[i].tgtobj].modifer[m].x)
					{mod0array[sldobj[i].scn_obj][sldobj[i].obj].modifer[m].x=brf*(double)tmp_mod0array[sldobj[i].scn_obj][sldobj[i].obj].modifer[m].x+bf*(double)tmp_mod0array[sldobj[i].scn_tgtobj][sldobj[i].tgtobj].modifer[m].x;}
				if (mod0array[sldobj[i].scn_obj][sldobj[i].obj].modifer[m].y != tmp_mod0array[sldobj[i].scn_tgtobj][sldobj[i].tgtobj].modifer[m].y)
					{mod0array[sldobj[i].scn_obj][sldobj[i].obj].modifer[m].y=brf*(double)tmp_mod0array[sldobj[i].scn_obj][sldobj[i].obj].modifer[m].y+bf*(double)tmp_mod0array[sldobj[i].scn_tgtobj][sldobj[i].tgtobj].modifer[m].y;}
				if (mod0array[sldobj[i].scn_obj][sldobj[i].obj].modifer[m].z != tmp_mod0array[sldobj[i].scn_tgtobj][sldobj[i].tgtobj].modifer[m].z)
					{mod0array[sldobj[i].scn_obj][sldobj[i].obj].modifer[m].z=brf*(double)tmp_mod0array[sldobj[i].scn_obj][sldobj[i].obj].modifer[m].z+bf*(double)tmp_mod0array[sldobj[i].scn_tgtobj][sldobj[i].tgtobj].modifer[m].z;}
				if (mod0array[sldobj[i].scn_obj][sldobj[i].obj].modifer[m].rad != tmp_mod0array[sldobj[i].scn_tgtobj][sldobj[i].tgtobj].modifer[m].rad)
					{mod0array[sldobj[i].scn_obj][sldobj[i].obj].modifer[m].rad=brf*(double)tmp_mod0array[sldobj[i].scn_obj][sldobj[i].obj].modifer[m].rad+bf*(double)tmp_mod0array[sldobj[i].scn_tgtobj][sldobj[i].tgtobj].modifer[m].rad;}
				if (mod0array[sldobj[i].scn_obj][sldobj[i].obj].modifer[m].pow != tmp_mod0array[sldobj[i].scn_tgtobj][sldobj[i].tgtobj].modifer[m].pow)
					{mod0array[sldobj[i].scn_obj][sldobj[i].obj].modifer[m].pow=brf*(double)tmp_mod0array[sldobj[i].scn_obj][sldobj[i].obj].modifer[m].pow+bf*(double)tmp_mod0array[sldobj[i].scn_tgtobj][sldobj[i].tgtobj].modifer[m].pow;}
				}
			if (_tmp_objects[sldobj[i].scn_obj][sldobj[i].obj].x != _tmp_objects[sldobj[i].scn_tgtobj][sldobj[i].tgtobj].x)
				{objects[sldobj[i].scn_obj][sldobj[i].obj].x=brf*(double)_tmp_objects[sldobj[i].scn_obj][sldobj[i].obj].x+bf*(double)_tmp_objects[sldobj[i].scn_tgtobj][sldobj[i].tgtobj].x;}
			if (_tmp_objects[sldobj[i].scn_obj][sldobj[i].obj].y != _tmp_objects[sldobj[i].scn_tgtobj][sldobj[i].tgtobj].y)
				{objects[sldobj[i].scn_obj][sldobj[i].obj].y=brf*(double)_tmp_objects[sldobj[i].scn_obj][sldobj[i].obj].y+bf*(double)_tmp_objects[sldobj[i].scn_tgtobj][sldobj[i].tgtobj].y;}
			if (_tmp_objects[sldobj[i].scn_obj][sldobj[i].obj].z != _tmp_objects[sldobj[i].scn_tgtobj][sldobj[i].tgtobj].z)
				{objects[sldobj[i].scn_obj][sldobj[i].obj].z=brf*(double)_tmp_objects[sldobj[i].scn_obj][sldobj[i].obj].z+bf*(double)_tmp_objects[sldobj[i].scn_tgtobj][sldobj[i].tgtobj].z;}
			if (_tmp_objects[sldobj[i].scn_obj][sldobj[i].obj].sx != _tmp_objects[sldobj[i].scn_tgtobj][sldobj[i].tgtobj].sx)
				{objects[sldobj[i].scn_obj][sldobj[i].obj].sx=brf*(double)_tmp_objects[sldobj[i].scn_obj][sldobj[i].obj].sx+bf*(double)_tmp_objects[sldobj[i].scn_tgtobj][sldobj[i].tgtobj].sx;}
			if (_tmp_objects[sldobj[i].scn_obj][sldobj[i].obj].sy != _tmp_objects[sldobj[i].scn_tgtobj][sldobj[i].tgtobj].sy)
				{objects[sldobj[i].scn_obj][sldobj[i].obj].sy=brf*(double)_tmp_objects[sldobj[i].scn_obj][sldobj[i].obj].sy+bf*(double)_tmp_objects[sldobj[i].scn_tgtobj][sldobj[i].tgtobj].sy;}
			if (_tmp_objects[sldobj[i].scn_obj][sldobj[i].obj].sz != _tmp_objects[sldobj[i].scn_tgtobj][sldobj[i].tgtobj].sz)
				{objects[sldobj[i].scn_obj][sldobj[i].obj].sz=brf*(double)_tmp_objects[sldobj[i].scn_obj][sldobj[i].obj].sz+bf*(double)_tmp_objects[sldobj[i].scn_tgtobj][sldobj[i].tgtobj].sz;}
			}
		}
	}
}

};



void PlayTrack()
{
	panim_store=anim_view;
	CamIntType=0;
	CamFlyType=0;
	MatIntType=0;
	cs_store=current_scene;
	memcpy(tmp_Materialbank,Materialbank,sizeof(Materialbank));
	memcpy(restore_Materialbank,Materialbank,sizeof(Materialbank));
	memcpy(tmp_Materialbank_vertexbumplink,Materialbank_vertexbumplink,sizeof(Materialbank_vertexbumplink));
	memcpy(tmp_Materialbank_vertexbumpdepth,Materialbank_vertexbumpdepth,sizeof(Materialbank_vertexbumpdepth));
	memcpy(tmp_mod0array,mod0array,sizeof(mod0array));
	memcpy(restore_mod0array,mod0array,sizeof(mod0array));
	memcpy(tmp_clone,clone,sizeof(clone));
	memcpy(_tmp_objects,objects,sizeof(objects));
	memcpy(restore_objects,objects,sizeof(objects));

	ZeroMemory(obj_slideflag,sizeof(obj_slideflag));
	ZeroMemory(mat_slideflag,sizeof(mat_slideflag));

	sldobj_count=0;
	cam_slideflag=0; CamCapFlag=0;
	ZeroMemory(trk_timeline_flags,sizeof(trk_timeline_flags));
	ZeroMemory(sldobj,sizeof(sldobj));
	ZeroMemory(sldmat,sizeof(sldmat));

	delta_cmtime2=cmtime2;
	start_time=cmtime2;
	//tl_play_pos2=SendDlgItemMessage(hWnd,IDC_C0,LB_GETCURSEL,0,0);
	tl_play_flag=1;
	sa_start_time=GetTickCount();
	trktime_start=GetTickCount();
	cr_stack[0]=0;cr_stack[1]=0;cr_stack[2]=0;cr_stack[3]=0;

}


