//DirectX9 init code

bool windowed=TRUE;
//int screen_width=1024;
//int screen_height=768;

int screen_width=800;
int screen_height=600;

  D3DLIGHT9 light,light2;

  D3DMATERIAL9 mtrl;

//
void DrawModifer();
void DrawGrid();
#include "D3D9_camera.h"
#include "D3D9_run.h"
#include "misc.h"

bool InitD3D(HWND hWnd)
{
  //   Direct3D
  pD3D = Direct3DCreate9(D3D_SDK_VERSION);
  if( !pD3D)
    return false;

  //screen_width=GetSystemMetrics(SM_CXSCREEN);
  //screen_height=GetSystemMetrics(SM_CXSCREEN);

  //   .
  D3DPRESENT_PARAMETERS d3dpp = {0};
  d3dpp.BackBufferWidth=screen_width;
  d3dpp.BackBufferHeight=screen_height;
  d3dpp.BackBufferFormat=D3DFMT_A8R8G8B8;
  d3dpp.EnableAutoDepthStencil=TRUE ;
  d3dpp.AutoDepthStencilFormat=D3DFMT_D16;
  d3dpp.BackBufferCount=1;

  //d3dpp.MultiSampleType=D3DMULTISAMPLE_TYPE(D3DMULTISAMPLE_4_SAMPLES);
  //d3dpp.Flags=0;

  //d3dpp.MultiSampleType=D3DMULTISAMPLE_TYPE(D3DMULTISAMPLE_4_SAMPLES);
  d3dpp.Flags=D3DPRESENTFLAG_LOCKABLE_BACKBUFFER; //=0

  d3dpp.hDeviceWindow=hWnd;
  d3dpp.Windowed = windowed;
  d3dpp.SwapEffect = D3DSWAPEFFECT_DISCARD;
  d3dpp.PresentationInterval=D3DPRESENT_INTERVAL_IMMEDIATE;
  HRESULT hr;

  hr = pD3D->CreateDevice( D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd,
                           D3DCREATE_HARDWARE_VERTEXPROCESSING,
                           &d3dpp, &pDevice );

  if( FAILED(hr) || !pDevice)
    return false;

D3DXCreateFontA (pDevice, 34, 0, 0, 1, FALSE,  DEFAULT_CHARSET, OUT_DEFAULT_PRECIS,	DEFAULT_QUALITY, DEFAULT_PITCH | FF_DONTCARE, "Arial", &truetypefont);

const D3DVERTEXELEMENT9 decl[] = 
{
    {0, 0, D3DDECLTYPE_FLOAT3, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_POSITION, 0}, //        
    {0, 0, D3DDECLTYPE_FLOAT3, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_NORMAL, 0}, //    
	{0, 0, D3DDECLTYPE_D3DCOLOR, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_COLOR, 0}, // dword  
    {0, 0, D3DDECLTYPE_FLOAT2, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_TEXCOORD, 0}, //     
    D3DDECL_END()
};
pDevice->CreateVertexDeclaration(decl, &g_pVertexDecl);

//  3D 
objects[current_scene][0].px=32;
objects[current_scene][0].py=32;
objects[current_scene][0].sx=64;
objects[current_scene][0].sy=64;
objects[current_scene][0].sz=64;
objects[current_scene][0].type=0;
objects[current_scene][0].x=0;
objects[current_scene][0].y=0;
objects[current_scene][0].z=0;
objects[current_scene][0].cv=1;
objects[current_scene][0].cu=1;
objects[current_scene][0].texture=0;
objects[current_scene][0].rendertype=0;
objects[current_scene][0].ctrl_style=0;

numofobjects[0]=1;
CurrentObject[0]=0;

for (int i=0;i<255;i++)	
{
cam_bank[i]=main_cam;
}

//  

  ZeroMemory( &mtrl, sizeof(mtrl) );

  ZeroMemory( &light, sizeof(light) );
  ZeroMemory( &light, sizeof(light2) );

//-TEXTURE
  //D3DLOCKED_RECT tl;
  //pDevice->CreateTexture(tsize,tsize,0,0,D3DFMT_A8R8G8B8,D3DPOOL_DEFAULT,&pTexture[current_texture],NULL);
  
  //create all textures
  int t;
  t=0;
//  pDevice->CreateTexture(32,32,0,D3DUSAGE_RENDERTARGET,D3DFMT_A8R8G8B8,D3DPOOL_DEFAULT,&pTexture[t],NULL);
  for (t=0;t<256;t++)
  {
  pDevice->CreateTexture(tsize,tsize,0,0,D3DFMT_A8R8G8B8,D3DPOOL_MANAGED,&pTexture[t],NULL);
  Materialbank[t].Power=255;
  }
  




  bool rr;
  D3DLOCKED_RECT tl;
  rr=pTexture[253]->LockRect(0,&tl,NULL,D3DLOCK_DISCARD);
  for (int y=0;y<tsize;y++)
  {
	//memcpy ((BYTE*)tl.pBits+y*tl.Pitch,texture_tmp+y*4*tsize+texture_stagenum*tsize*tsize*4,tsize*4);
	  for (int x=0;x<tsize*4;x++) *((BYTE*)tl.pBits+y*tl.Pitch+x)=255;
  }
  pTexture[253]->UnlockRect(0);

//---

  pDevice->SetRenderState(D3DRS_CULLMODE, D3DPMISCCAPS_CULLNONE);
  //D3DCULL_CW
  //   
  SetView();
  SetProjecton();


  return true;
}


void ReleaseD3D()
{

  if(pDevice)
    pDevice->Release();
  if(pD3D)
    pD3D->Release();
}


