//    FPS
	static DWORD fps_previous_time;
	static int count_fps;
	static int print_count_fps;
	static DWORD fps_current_time;
	static char FPS_[256] = {0};
	static RECT rc;
	static float fps_start_time = GetTickCount ();

//     render scene
	int sc_list[256]; int sc_list_size;	int sc_list_cam[256];

struct GRID {float x,y,z;}; // 
GRID g[256];

struct MyVertex {float x, y, z, n1, n2, n3;DWORD color; float tu, tv;};
#define D3DFVF_MYVERTEX (D3DFVF_XYZ | D3DFVF_NORMAL | D3DFVF_DIFFUSE | D3DFVF_TEX1 )//     .

int NumVerts;//  
int NumTriangles;//  

MyVertex pMyVerts[256*256*5];

void apply_mods();
void DrawSpline();

//---   FPS
void CalcFPS()
{
if (clean_view==0)
	{
	fps_current_time = GetTickCount () - fps_start_time;
	count_fps++;
	if (fps_current_time >= (fps_previous_time + 1000))
		{
		print_count_fps = count_fps;
		fps_previous_time = fps_current_time;
		count_fps = 0;
		}
	sprintf	(FPS_, "FPS:%4d", print_count_fps);
	SetRect( &rc, 3, 3, 400, 50 ); truetypefont->DrawTextA (NULL, FPS_, -1, &rc, DT_TOP, 0xff000000);
	SetRect( &rc, 7, 7, 400, 50 ); truetypefont->DrawTextA (NULL, FPS_, -1, &rc, DT_TOP, 0xff000000);
	SetRect( &rc, 3, 7, 400, 50 ); truetypefont->DrawTextA (NULL, FPS_, -1, &rc, DT_TOP, 0xff000000);
	SetRect( &rc, 7, 3, 400, 50 ); truetypefont->DrawTextA (NULL, FPS_, -1, &rc, DT_TOP, 0xff000000);
	SetRect( &rc, 5, 5, 400-2, 50-2 ); truetypefont->DrawTextA (NULL, FPS_, -1, &rc, DT_TOP, 0xffffffff);
	}
}

//---   
void lighting()
{
//float b = float(GetTickCount()%0xffff)/0xffff * 3.141593f * 182;
int f,t;

//cam_p();

pDevice->SetRenderState(D3DRS_LIGHTING, TRUE);
pDevice->SetRenderState(D3DRS_SPECULARENABLE, TRUE );

pDevice->SetRenderState(D3DRS_AMBIENT,0x00ffffff);

pDevice->SetRenderState(D3DRS_SPECULARMATERIALSOURCE, D3DMCS_MATERIAL);
pDevice->SetRenderState(D3DRS_DIFFUSEMATERIALSOURCE, D3DMCS_MATERIAL);
pDevice->SetRenderState(D3DRS_NORMALIZENORMALS, TRUE);

for (int z=0;z<8;z++) pDevice->LightEnable(z,FALSE); 

int clight;int mlink;
clight=0;

double gx1,gy1,gz1,gx2,gy2,gz2;

t=CurrentObject[current_scene];

for (int y=0;y<256;y++)for (int x=0;x<256;x++) meshsel[y][x]=1;//   -   

for (int c=0;c<numofobjects[current_scene];c++)
{
CurrentObject[current_scene]=c;

  mlink=objects[current_scene][c].material;

  lightbank[clight].Attenuation0=0;
  lightbank[clight].Attenuation1=objects[current_scene][c].sy/64.0;;
  lightbank[clight].Attenuation2=objects[current_scene][c].sz/64.0;;
  lightbank[clight].Falloff=1;

if (objects[current_scene][c].type==15)
	{
	lightbank[clight].Type=D3DLIGHT_DIRECTIONAL;
	lightbank[clight].Diffuse.r=Materialbank[mlink].Diffuse.r;
	lightbank[clight].Diffuse.g=Materialbank[mlink].Diffuse.g;
	lightbank[clight].Diffuse.b=Materialbank[mlink].Diffuse.b;
	lightbank[clight].Ambient.r=Materialbank[mlink].Ambient.r;
	lightbank[clight].Ambient.g=Materialbank[mlink].Ambient.g;
	lightbank[clight].Ambient.b=Materialbank[mlink].Ambient.b;
	lightbank[clight].Specular.r=Materialbank[mlink].Specular.r;
	lightbank[clight].Specular.g=Materialbank[mlink].Specular.g;
	lightbank[clight].Specular.b=Materialbank[mlink].Specular.b;

	gx=0;gy=0;gz=0;

	apply_mods();

	gx=gx-(objects[current_scene][c].x)/64.0;
	gy=gy-(objects[current_scene][c].y)/64.0;
	gz=gz-(objects[current_scene][c].z)/64.0;


		gx1=gx*cosalfa-gy*sinalfa;
		gy1=gx*sinalfa+gy*cosalfa;
		gy2=gy1*cosbeta-gz*sinbeta;		
		
		gx=gx1*coscalfa-gy2*sincalfa;
		gy=gx1*sincalfa+gy2*coscalfa;
		gz=gy1*sinbeta+gz*cosbeta;
	
		gx=gx*main_cam.dist;gy=gy*main_cam.dist;gz=gz*main_cam.dist;
	
	lightbank[clight].Direction.x=gx;
	lightbank[clight].Direction.y=gz;
	lightbank[clight].Direction.z=gy;

	pDevice->LightEnable(clight,TRUE); 
	pDevice->SetLight(clight,&lightbank[clight]);
	clight++;
	}

if (objects[current_scene][c].type==16)
	{

	lightbank[clight].Type=D3DLIGHT_POINT;
	lightbank[clight].Diffuse.r=Materialbank[mlink].Diffuse.r;
	lightbank[clight].Diffuse.g=Materialbank[mlink].Diffuse.g;
	lightbank[clight].Diffuse.b=Materialbank[mlink].Diffuse.b;
	lightbank[clight].Ambient.r=Materialbank[mlink].Ambient.r;
	lightbank[clight].Ambient.g=Materialbank[mlink].Ambient.g;
	lightbank[clight].Ambient.b=Materialbank[mlink].Ambient.b;
	lightbank[clight].Specular.r=Materialbank[mlink].Specular.r;
	lightbank[clight].Specular.g=Materialbank[mlink].Specular.g;
	lightbank[clight].Specular.b=Materialbank[mlink].Specular.b;

	gx=0;gy=0;gz=0;

	apply_mods();

	gx=gx+(objects[current_scene][c].x-main_cam.tgt_x)/64.0;
	gy=gy+(objects[current_scene][c].y-main_cam.tgt_y)/64.0;
	gz=gz+(objects[current_scene][c].z-main_cam.tgt_z)/64.0;
	
		gx1=gx*cosalfa-gy*sinalfa;
		gy1=gx*sinalfa+gy*cosalfa;
		gy2=gy1*cosbeta-gz*sinbeta;		
		
		gx=gx1*coscalfa-gy2*sincalfa;
		gy=gx1*sincalfa+gy2*coscalfa;
		gz=gy1*sinbeta+gz*cosbeta;
	
		gx=gx*main_cam.dist;gy=gy*main_cam.dist;gz=gz*main_cam.dist;

	lightbank[clight].Position.x=gx;
	lightbank[clight].Position.y=gz;
	lightbank[clight].Position.z=gy;
	lightbank[clight].Range=objects[current_scene][c].sx/64.0*(main_cam.dist/1.5625);

	pDevice->LightEnable(clight,TRUE); 
	pDevice->SetLight(clight,&lightbank[clight]);
	clight++;
	}

if (clight>7) goto ex;
}


ex:;
CurrentObject[current_scene]=t;
}

//--- 
bool CreateObject()
{
  bool rr;

if (texture_type[current_texture]==0)
{
  D3DLOCKED_RECT tl;
  rr=pTexture[current_texture]->LockRect(0,&tl,NULL,D3DLOCK_DISCARD);
  if (rr==D3D_OK)
  {
	  for (int y=0;y<tsize;y++)
		{
		memcpy ((BYTE*)tl.pBits+y*tl.Pitch,texture_tmp+y*4*tsize+tst*tsize*tsize*4,tsize*4);
		}
	  pTexture[current_texture]->UnlockRect(0);
  }
}

//bump
if (texture_type[current_texture]==2)
{
  D3DLOCKED_RECT tl;
  rr=pTexture[current_texture]->LockRect(0,&tl,NULL,D3DLOCK_DISCARD);
  BYTE* addr;
  for (int y=0;y<tsize;y++)
  {
	//memcpy ((BYTE*)tl.pBits+y*tl.Pitch,texture_tmp+y*4*tsize+tst*tsize*tsize*4,tsize*4);
	for (int x=0;x<tsize;x++)
	  {addr=texture_tmp+tst*tsize*tsize*4+y*4*tsize+x*4;
	  pokeb((BYTE*)tl.pBits+y*tl.Pitch+x*4,128+peekb(addr+4)-peekb(addr));
	  pokeb((BYTE*)tl.pBits+y*tl.Pitch+x*4+1,128+peekb(addr+tsize*4)-peekb(addr));
	  pokeb((BYTE*)tl.pBits+y*tl.Pitch+x*4+2,peekb(addr));
	}
  }
  pTexture[current_texture]->UnlockRect(0);
}


  return true;
}
//
void DrawGeoForSelect(int x,int y)
{
int _st;

cam_p();
pDevice->SetRenderState(D3DRS_FOGENABLE, FALSE);

  if (windowed==FALSE) SetCursor(NULL);

for(int f=0;f<8;f++)
{
pDevice->LightEnable(f,FALSE);
}

  pDevice->SetRenderState(D3DRS_ZENABLE,D3DZB_TRUE);
  pDevice->SetRenderState(D3DRS_ZWRITEENABLE,TRUE);

  pDevice->Clear(0,NULL, D3DCLEAR_ZBUFFER,0,1.0f,0); 
  pDevice->Clear(0,NULL, D3DCLEAR_TARGET,D3DCOLOR_ARGB(0,255,255,255),1.0f,0); 
  pDevice->SetRenderState(D3DRS_SHADEMODE,D3DSHADE_FLAT);

  pDevice->SetRenderState(D3DRS_AMBIENT,0x00ffffff);

  pDevice->BeginScene();
  
  pDevice->SetSamplerState(0,D3DSAMP_MAGFILTER,D3DTEXF_LINEAR);

SetWorld();//       
pDevice->SetFVF(D3DFVF_MYVERTEX);//   
//pDevice->SetVertexDeclaration(g_pVertexDecl); //setfvf
pDevice->SetRenderState(D3DRS_FILLMODE,D3DFILL_SOLID);
pDevice->SetTextureStageState( 1, D3DTSS_COLOROP, D3DTOP_DISABLE );
pDevice->SetRenderState(D3DRS_ALPHABLENDENABLE,FALSE);
pDevice->SetRenderState(D3DRS_SPECULARENABLE, FALSE );


_st=CurrentObject[current_scene];
//render
for (CurrentObject[current_scene]=0;CurrentObject[current_scene]<numofobjects[current_scene];CurrentObject[current_scene]++)
{double nr;
if (group_h_flag==1)
	{
	if (objects[current_scene][CurrentObject[current_scene]].ctrl_obj!=objects[current_scene][_st].ctrl_obj||objects[current_scene][_st].ctrl_style==0)
		{
		goto nxo1;
		}
	}
  createVbuf_for_accel();
nr=objects[current_scene][CurrentObject[current_scene]].normal-1;
  if (nr==1) pDevice->SetRenderState(D3DRS_CULLMODE, D3DCULL_CW);
  if (nr==-1) pDevice->SetRenderState(D3DRS_CULLMODE, D3DCULL_CCW);
  if (nr==0) pDevice->SetRenderState(D3DRS_CULLMODE, D3DPMISCCAPS_CULLNONE);
  if (nr==2) pDevice->SetRenderState(D3DRS_CULLMODE, D3DPMISCCAPS_CULLNONE);
  if (nr==3) pDevice->SetRenderState(D3DRS_CULLMODE, D3DPMISCCAPS_CULLNONE);

  pDevice->SetTexture(0,pTexture[253]);
	Materialbank[254].Ambient.r=CurrentObject[current_scene]/256.0;
	Materialbank[254].Ambient.g=CurrentObject[current_scene]/256.0;
	Materialbank[254].Ambient.b=CurrentObject[current_scene]/256.0;
	Materialbank[254].Specular.r=0;
	Materialbank[254].Specular.g=0;
	Materialbank[254].Specular.b=0;
	Materialbank[254].Diffuse.r=0;
	Materialbank[254].Diffuse.g=0;
	Materialbank[254].Diffuse.b=0;
  pDevice->SetMaterial( &Materialbank[254]);
	if (objects[current_scene][CurrentObject[current_scene]].type!=11&&objects[current_scene][CurrentObject[current_scene]].type!=22) pDevice->DrawPrimitiveUP(D3DPT_TRIANGLELIST,NumTriangles,pMyVerts,sizeof(MyVertex));  //  
nxo1:;
}
CurrentObject[current_scene]=_st;

int a;
	CalcFPS();
  pDevice->EndScene();
  pDevice->Present( NULL, NULL, NULL, NULL );

//-----

  LPDIRECT3DSURFACE9 RT;
  D3DLOCKED_RECT tl;
  D3DLOCKED_RECT rl;
 
  pDevice->GetRenderTarget(0,&RT);
  RT->LockRect(&rl,NULL,D3DLOCK_DISCARD);

  a=peekb((BYTE*)rl.pBits+y*rl.Pitch+x*4);
  if (a<254) 
	{
	  if (setcontroller_flag==1) 
		{
		  objects[current_scene][CurrentObject[current_scene]].ctrl_obj=a;
		  objects[current_scene][CurrentObject[current_scene]].ctrl_style=1;
		  setcontroller_flag=0;
		  cursor=0;
		}
	  else CurrentObject[current_scene]=a;
	}
  
  RT->UnlockRect();
//  _itoa(CurrentObject[current_scene],r_string,10);
//  MessageBox(Parent_hWnd,r_string," ",MB_OK);

//---

}
int st1_laststate,lasttexture,lastmaterial;

//------------------------------------------------------------------
//-draw objects-----------------------------------------------------
//------------------------------------------------------------------

int crmtype[8],crmtex[8];

inline DWORD F2DW( FLOAT f ) { return *((DWORD*)&f); }

void mtx() //  
{
pDevice->SetTexture(0,pTexture[objects[current_scene][CurrentObject[current_scene]].texture]);

	crmtype[1]=Materialbank_st1[objects[current_scene][CurrentObject[current_scene]].material].type;
	crmtex[1]=Materialbank_st1[objects[current_scene][CurrentObject[current_scene]].material].texture;

	crmtype[2]=Materialbank_st2[objects[current_scene][CurrentObject[current_scene]].material].type;
	crmtex[2]=Materialbank_st2[objects[current_scene][CurrentObject[current_scene]].material].texture;

if (crmtype[1]==10)
	{
		pDevice->SetTexture( 1, pTexture[crmtex[1]] );
		pDevice->SetTexture( 2, pTexture[crmtex[2]] );

		// Stage 0: The base texture
		pDevice->SetTextureStageState( 0, D3DTSS_COLOROP, D3DTOP_MODULATE );
		pDevice->SetTextureStageState( 0, D3DTSS_COLORARG1, D3DTA_TEXTURE );
		pDevice->SetTextureStageState( 0, D3DTSS_COLORARG2, D3DTA_DIFFUSE );
		pDevice->SetTextureStageState( 0, D3DTSS_ALPHAOP, D3DTOP_SELECTARG1 );
		pDevice->SetTextureStageState( 0, D3DTSS_ALPHAARG1, D3DTA_TEXTURE ); 

		// Stage 1: T.
		pDevice->SetTextureStageState( 1, D3DTSS_TEXCOORDINDEX,D3DTSS_TCI_PASSTHRU );

		pDevice->SetTextureStageState( 1, D3DTSS_COLOROP, D3DTOP_BUMPENVMAP);
		pDevice->SetTextureStageState( 1, D3DTSS_COLORARG1, D3DTA_TEXTURE );
		pDevice->SetTextureStageState( 1, D3DTSS_COLORARG2, D3DTA_CURRENT );

		// Stage 2: 
		pDevice->SetTextureStageState( 2, D3DTSS_TEXCOORDINDEX,D3DTSS_TCI_PASSTHRU );

		pDevice->SetTextureStageState( 2, D3DTSS_COLOROP, D3DTOP_MODULATE  );
		pDevice->SetTextureStageState( 2, D3DTSS_COLORARG1, D3DTA_TEXTURE );
		pDevice->SetTextureStageState( 2, D3DTSS_COLORARG2, D3DTA_DIFFUSE  );

		pDevice->SetTextureStageState( 1, D3DTSS_BUMPENVMAT00, F2DW(1.0f) );
		pDevice->SetTextureStageState( 1, D3DTSS_BUMPENVMAT01, F2DW(0.0f) );
		pDevice->SetTextureStageState( 1, D3DTSS_BUMPENVMAT10, F2DW(0.0f) );
		pDevice->SetTextureStageState( 1, D3DTSS_BUMPENVMAT11, F2DW(1.0f) );

	}
if (crmtype[1]==11)
	{
	pDevice->SetSamplerState(256,D3DSAMP_DMAPOFFSET,111);
	}

if (crmtype[1]<10)
{

for (int s=1;s<=2;s++)
	{
  	 if (crmtype[s]==0)
		{
		pDevice->SetTextureStageState( s, D3DTSS_COLOROP, D3DTOP_DISABLE );
		}
  	 
	 if (crmtype[s]==1)
		{
		pDevice->SetTexture(s,pTexture[crmtex[s]]);
		pDevice->SetTextureStageState( s, D3DTSS_COLOROP, D3DTOP_ADD );
		pDevice->SetTextureStageState( s, D3DTSS_TEXTURETRANSFORMFLAGS,D3DTTFF_COUNT2 );			 
		pDevice->SetTextureStageState( s, D3DTSS_TEXCOORDINDEX,D3DTSS_TCI_CAMERASPACEREFLECTIONVECTOR );
		}
  	 if (crmtype[s]==2)
		{
		pDevice->SetTexture(s,pTexture[crmtex[s]]);
		pDevice->SetTextureStageState( s, D3DTSS_COLOROP, D3DTOP_SUBTRACT );
		pDevice->SetTextureStageState( s, D3DTSS_TEXTURETRANSFORMFLAGS,D3DTTFF_COUNT2 );			 
		pDevice->SetTextureStageState( s, D3DTSS_TEXCOORDINDEX,D3DTSS_TCI_CAMERASPACEREFLECTIONVECTOR );
		}
  	 if (crmtype[s]==3)
		{
		pDevice->SetTexture(s,pTexture[crmtex[s]]);
		pDevice->SetTextureStageState( s, D3DTSS_COLOROP, D3DTOP_MODULATE );
		pDevice->SetTextureStageState( s, D3DTSS_TEXTURETRANSFORMFLAGS,D3DTTFF_COUNT2 );			 
		pDevice->SetTextureStageState( s, D3DTSS_TEXCOORDINDEX,D3DTSS_TCI_CAMERASPACEREFLECTIONVECTOR );
		}
	 //sfere mapping
	 if (crmtype[s]==4)
		{
		pDevice->SetTexture(s,pTexture[crmtex[s]]);
		pDevice->SetTextureStageState( s, D3DTSS_COLOROP, D3DTOP_ADD );
		pDevice->SetTextureStageState( s, D3DTSS_TEXTURETRANSFORMFLAGS,D3DTTFF_COUNT2 );			 
		pDevice->SetTextureStageState( s, D3DTSS_TEXCOORDINDEX,D3DTSS_TCI_SPHEREMAP );
		}
	 if (crmtype[s]==5)
		{
		pDevice->SetTexture(s,pTexture[crmtex[s]]);
		pDevice->SetTextureStageState( s, D3DTSS_COLOROP, D3DTOP_SUBTRACT );
		pDevice->SetTextureStageState( s, D3DTSS_TEXTURETRANSFORMFLAGS,D3DTTFF_COUNT2 );			 
		pDevice->SetTextureStageState( s, D3DTSS_TEXCOORDINDEX,D3DTSS_TCI_SPHEREMAP );
		}
	 if (crmtype[s]==6)
		{
		pDevice->SetTexture(s,pTexture[crmtex[s]]);
		pDevice->SetTextureStageState( s, D3DTSS_COLOROP, D3DTOP_MODULATE );
		pDevice->SetTextureStageState( s, D3DTSS_TEXTURETRANSFORMFLAGS,D3DTTFF_COUNT2 );			 
		pDevice->SetTextureStageState( s, D3DTSS_TEXCOORDINDEX,D3DTSS_TCI_SPHEREMAP );
		}
	 //simple
	 if (crmtype[s]==7)
		{
		pDevice->SetTexture(s,pTexture[crmtex[s]]);
		pDevice->SetTextureStageState( s, D3DTSS_COLOROP, D3DTOP_ADD );
		pDevice->SetTextureStageState( s, D3DTSS_TEXTURETRANSFORMFLAGS,D3DTTFF_COUNT2 );			 
		pDevice->SetTextureStageState( s, D3DTSS_TEXCOORDINDEX,D3DTSS_TCI_PASSTHRU );
		}
	 if (crmtype[s]==8)
		{
		pDevice->SetTexture(s,pTexture[crmtex[s]]);
		pDevice->SetTextureStageState( s, D3DTSS_COLOROP, D3DTOP_SUBTRACT );
		pDevice->SetTextureStageState( s, D3DTSS_TEXTURETRANSFORMFLAGS,D3DTTFF_COUNT2 );			 
		pDevice->SetTextureStageState( s, D3DTSS_TEXCOORDINDEX,D3DTSS_TCI_PASSTHRU );
		}
	 if (crmtype[s]==9)
		{
		pDevice->SetTexture(s,pTexture[crmtex[s]]);
		pDevice->SetTextureStageState( s, D3DTSS_COLOROP, D3DTOP_MODULATE );
		pDevice->SetTextureStageState( s, D3DTSS_TEXTURETRANSFORMFLAGS,D3DTTFF_COUNT2);			 
		pDevice->SetTextureStageState( s, D3DTSS_TEXCOORDINDEX,D3DTSS_TCI_PASSTHRU );
		}
	}
}

}

float Start,End;
void fogging() //    
{
Start=objects[current_scene][CurrentObject[current_scene]].sx*main_cam.dist/3.0;
End=objects[current_scene][CurrentObject[current_scene]].sy*main_cam.dist/3.0;
pDevice->SetRenderState(D3DRS_FOGENABLE, TRUE);

int fr,fg,fb;
fr=(int)256*Materialbank[objects[current_scene][CurrentObject[current_scene]].material].Ambient.r;
fg=(int)256*Materialbank[objects[current_scene][CurrentObject[current_scene]].material].Ambient.g;
fb=(int)256*Materialbank[objects[current_scene][CurrentObject[current_scene]].material].Ambient.b;

pDevice->SetRenderState(D3DRS_FOGCOLOR, (fr<<16)|(fg<<8)|(fb));
pDevice->SetRenderState(D3DRS_FOGVERTEXMODE, D3DFOG_LINEAR);
pDevice->SetRenderState(D3DRS_FOGSTART, *(DWORD *)(&Start));
pDevice->SetRenderState(D3DRS_FOGEND,   *(DWORD *)(&End));
}

//inline DWORD F2DW( FLOAT f ) { return *((DWORD*)&f); }


//---------------------   
void DrawObject()
{
  double nr;
//cam_p();
  SetWorld();//       
  //pDevice->SetVertexDeclaration(g_pVertexDecl); //setfvf
  pDevice->SetFVF(D3DFVF_MYVERTEX);//   

int _st;

//clone code
cloner();
//-----------

_st=CurrentObject[current_scene];
//render
for (CurrentObject[current_scene]=0;CurrentObject[current_scene]<numofobjects[current_scene];CurrentObject[current_scene]++)
{
//editing feature only
if (group_h_flag==1)
	{
	if (objects[current_scene][CurrentObject[current_scene]].ctrl_obj!=objects[current_scene][_st].ctrl_obj||objects[current_scene][_st].ctrl_style==0)
		{
		goto nxo1;
		}
	}
//--------------------
if (objects[current_scene][CurrentObject[current_scene]].rendertype==0)
{
  if (objects[current_scene][CurrentObject[current_scene]].type==15||objects[current_scene][CurrentObject[current_scene]].type==16) if (clean_view==1) goto nxo1;		

	//--spline katmul rom
  if (objects[current_scene][CurrentObject[current_scene]].type==31)
	{
	DrawSpline();
	goto nxo1;
	}

	//--set groupshader
  if (objects[current_scene][CurrentObject[current_scene]].type==29)
	{
	if (groupfx_flag==FALSE)
		{
		groupfx_index=objshader[current_scene][CurrentObject[current_scene]];
		if (groupfx_index>0&&shader_loadflag[groupfx_index-1]==1)
			{
			numPasses=0;
			groupfx_flag=TRUE;
			groupfx_begin=CurrentObject[current_scene];
			MatWorldView = MatWorld * MatView;
			pEffect[groupfx_index-1]->SetValue("MatProj", &MatProj, D3DX_DEFAULT);
			pEffect[groupfx_index-1]->SetValue("MatWorldView", &MatWorldView, D3DX_DEFAULT);
			hEffTech=pEffect[groupfx_index-1]->GetTechniqueByName("t0");
			pEffect[groupfx_index-1]->SetTechnique(hEffTech);
			pEffect[groupfx_index-1]->Begin(&numPasses, 0);
			ipass=0;
			pEffect[groupfx_index-1]->BeginPass(ipass);
			}
		}
	goto nxo1;
	}
	//-- end or process groupshader
  if (objects[current_scene][CurrentObject[current_scene]].type==30)
	{
	if (groupfx_flag==TRUE)
		{
		pEffect[groupfx_index-1]->EndPass();
		ipass++;
		if (ipass>=numPasses)
			{
			pEffect[groupfx_index-1]->End();
			groupfx_flag=FALSE;
			}
		else
			{
			pEffect[groupfx_index-1]->BeginPass(ipass);
			CurrentObject[current_scene]=groupfx_begin;
			}
		}
	goto nxo1;
	}

	//--set texfilter [xyz]
  if (objects[current_scene][CurrentObject[current_scene]].type==25)
  {
	 pDevice->SetSamplerState(0,D3DSAMP_MAGFILTER,objects[current_scene][CurrentObject[current_scene]].x);
	 pDevice->SetSamplerState(0,D3DSAMP_MINFILTER,objects[current_scene][CurrentObject[current_scene]].x);
	 pDevice->SetSamplerState(1,D3DSAMP_MAGFILTER,objects[current_scene][CurrentObject[current_scene]].y);
	 pDevice->SetSamplerState(1,D3DSAMP_MINFILTER,objects[current_scene][CurrentObject[current_scene]].y);
	 pDevice->SetSamplerState(2,D3DSAMP_MAGFILTER,objects[current_scene][CurrentObject[current_scene]].z);
	 pDevice->SetSamplerState(2,D3DSAMP_MINFILTER,objects[current_scene][CurrentObject[current_scene]].z);
	 goto nxo1;
  }

	//--set shademode [x]
  if (objects[current_scene][CurrentObject[current_scene]].type==26)
  {
	 pDevice->SetRenderState(D3DRS_SHADEMODE,objects[current_scene][CurrentObject[current_scene]].x);
	 goto nxo1;
  }
	//--cam_flip_y
  if (objects[current_scene][CurrentObject[current_scene]].type==28) {main_cam.v_x=-main_cam.v_x;cam_p;goto nxo1;}


  //--fog 
  if (objects[current_scene][CurrentObject[current_scene]].type==21) {fogging();goto nxo1;}
  //dynamic textures
  if (dtx_view==0&&objects[current_scene][CurrentObject[current_scene]].type==24) 
	{
	 int a;a=current_texture;
	 texture_size[current_texture]=tsize;
	 texture_stagenums[current_texture]=texture_stagenum;
	 current_texture=objects[current_scene][CurrentObject[current_scene]].texture;
	 tsize=texture_size[current_texture];
	 texture_stagenum=texture_stagenums[current_texture];
		calc_texture_silent();
		current_texture=a;
	 tsize=texture_size[current_texture];
	 texture_stagenum=texture_stagenums[current_texture];
	 goto nxo1;
	}

  createVbuf_for_accel();
nr=objects[current_scene][CurrentObject[current_scene]].normal-1;
  if (nr==1) pDevice->SetRenderState(D3DRS_CULLMODE, D3DCULL_CW);
  if (nr==-1) pDevice->SetRenderState(D3DRS_CULLMODE, D3DCULL_CCW);
  if (nr==0) pDevice->SetRenderState(D3DRS_CULLMODE, D3DPMISCCAPS_CULLNONE);
  if (nr==2) pDevice->SetRenderState(D3DRS_CULLMODE, D3DPMISCCAPS_CULLNONE);
  if (nr==3) pDevice->SetRenderState(D3DRS_CULLMODE, D3DPMISCCAPS_CULLNONE);
  if (nr==4&&clean_view!=0) goto nxo1;

mtx();//multitexturing

  pDevice->SetMaterial( &Materialbank[objects[current_scene][CurrentObject[current_scene]].material]);
	//--zbuf cleaner
  if (objects[current_scene][CurrentObject[current_scene]].type==12) {pDevice->Clear(0,NULL, D3DCLEAR_ZBUFFER,0,1.0f,0); goto nxo1;}
	//--render scene sc[x] cam[y]
  if (objects[current_scene][CurrentObject[current_scene]].type==20) goto nxo1;
	//--copy to texture tex[t]
  if (objects[current_scene][CurrentObject[current_scene]].type==19) 
	{
		LPDIRECT3DSURFACE9 RT,RT2;
		pDevice->GetRenderTarget(0,&RT);
		pTexture[objects[current_scene][CurrentObject[current_scene]].texture]->GetSurfaceLevel(0,&RT2);
		pDevice->StretchRect(RT,NULL,RT2,NULL,D3DTEXF_NONE);
		goto nxo1;
	  }
	//--postprocessor
  if (objects[current_scene][CurrentObject[current_scene]].type==11)
	{
	pDevice->SetRenderState(D3DRS_ZWRITEENABLE,FALSE);
	pDevice->SetRenderState(D3DRS_ZENABLE,D3DZB_FALSE );
	//shader fx
	effindex=objshader[current_scene][CurrentObject[current_scene]];
	if (groupfx_flag==FALSE&&effindex>0&&shader_loadflag[effindex-1]==1)
		{
		numPasses=0;
		MatWorldView = MatWorld * MatView;
		pEffect[effindex-1]->SetValue("MatProj", &MatProj, D3DX_DEFAULT);
		pEffect[effindex-1]->SetValue("MatWorldView", &MatWorldView, D3DX_DEFAULT);
		hEffTech = pEffect[effindex-1]->GetTechniqueByName("t0");
		pEffect[effindex-1]->SetTechnique(hEffTech);
		pEffect[effindex-1]->Begin(&numPasses, 0);
		for(ipass=0; ipass < numPasses; ipass++)
			{
			pEffect[effindex-1]->BeginPass(ipass);
			pDevice->DrawPrimitiveUP(D3DPT_TRIANGLELIST,NumTriangles,pMyVerts,sizeof(MyVertex));  //  
			pEffect[effindex-1]->EndPass();
			}
		pEffect[effindex-1]->End();
		}
		else {pDevice->DrawPrimitiveUP(D3DPT_TRIANGLELIST,NumTriangles,pMyVerts,sizeof(MyVertex));}
	pDevice->SetRenderState(D3DRS_ZENABLE,D3DZB_TRUE );
	pDevice->SetRenderState(D3DRS_ZWRITEENABLE,TRUE);
	goto nxo1;
	}

	//shader fx
	effindex=objshader[current_scene][CurrentObject[current_scene]];
	if (groupfx_flag==FALSE&&effindex>0&&shader_loadflag[effindex-1]==1)
		{
		numPasses=0;
		MatWorldView = MatWorld * MatView;
		pEffect[effindex-1]->SetValue("MatProj", &MatProj, D3DX_DEFAULT);
		pEffect[effindex-1]->SetValue("MatWorldView", &MatWorldView, D3DX_DEFAULT);
		hEffTech = pEffect[effindex-1]->GetTechniqueByName("t0");
		pEffect[effindex-1]->SetTechnique(hEffTech);
		pEffect[effindex-1]->Begin(&numPasses, 0);
		for(ipass=0; ipass < numPasses; ipass++)
			{
			pEffect[effindex-1]->BeginPass(ipass);
			pDevice->DrawPrimitiveUP(D3DPT_TRIANGLELIST,NumTriangles,pMyVerts,sizeof(MyVertex));  //  
			pEffect[effindex-1]->EndPass();
			}
		pEffect[effindex-1]->End();
		}
		else {pDevice->DrawPrimitiveUP(D3DPT_TRIANGLELIST,NumTriangles,pMyVerts,sizeof(MyVertex));}
nxo1:;
}
}

//render alfa
	pDevice->SetRenderState(D3DRS_ZWRITEENABLE,FALSE);
	pDevice->SetRenderState(D3DRS_ALPHABLENDENABLE,TRUE);
	pDevice->SetRenderState(D3DRS_BLENDOP,D3DBLENDOP_ADD);
	pDevice->SetRenderState(D3DRS_SRCBLEND,D3DBLEND_ONE);
	pDevice->SetRenderState(D3DRS_DESTBLEND,D3DBLEND_ONE);

for (CurrentObject[current_scene]=0;CurrentObject[current_scene]<numofobjects[current_scene];CurrentObject[current_scene]++)
{
//editing feature only
if (group_h_flag==1)
	{
	if (objects[current_scene][CurrentObject[current_scene]].ctrl_obj!=objects[current_scene][_st].ctrl_obj||objects[current_scene][_st].ctrl_style==0)
		{
		goto nxo2;
		}
	}
//--------------------
if (objects[current_scene][CurrentObject[current_scene]].rendertype>0)
{
	//--sun
if (objects[current_scene][CurrentObject[current_scene]].type==15||objects[current_scene][CurrentObject[current_scene]].type==16) if (clean_view==1) goto nxo2;
	//--spline katmul rom
  if (objects[current_scene][CurrentObject[current_scene]].type==31)
	{
	DrawSpline();
	goto nxo2;
	}
	//--set texfilter [xyz]
  if (objects[current_scene][CurrentObject[current_scene]].type==25)
	{
	 pDevice->SetSamplerState(0,D3DSAMP_MAGFILTER,objects[current_scene][CurrentObject[current_scene]].x);
	 pDevice->SetSamplerState(0,D3DSAMP_MINFILTER,objects[current_scene][CurrentObject[current_scene]].x);
	 pDevice->SetSamplerState(1,D3DSAMP_MAGFILTER,objects[current_scene][CurrentObject[current_scene]].y);
	 pDevice->SetSamplerState(1,D3DSAMP_MINFILTER,objects[current_scene][CurrentObject[current_scene]].y);
	 pDevice->SetSamplerState(2,D3DSAMP_MAGFILTER,objects[current_scene][CurrentObject[current_scene]].z);
	 pDevice->SetSamplerState(2,D3DSAMP_MINFILTER,objects[current_scene][CurrentObject[current_scene]].z);
	 goto nxo2;
	}
	//--set shademode [x]
  if (objects[current_scene][CurrentObject[current_scene]].type==26)
	{
	 pDevice->SetRenderState(D3DRS_SHADEMODE,objects[current_scene][CurrentObject[current_scene]].x);
	 goto nxo2;
	 }
	//--cam_flip_y
  if (objects[current_scene][CurrentObject[current_scene]].type==28) {main_cam.v_x=-main_cam.v_x;cam_p;goto nxo2;}
  //--fog 
	if (objects[current_scene][CurrentObject[current_scene]].type==21) {fogging();goto nxo2;}
	//dynamic textures
	if (dtx_view==0&&objects[current_scene][CurrentObject[current_scene]].type==24) 
	{
	 int a;a=current_texture;
	 texture_size[current_texture]=tsize;
	 texture_stagenums[current_texture]=texture_stagenum;
	 current_texture=objects[current_scene][CurrentObject[current_scene]].texture;
	 tsize=texture_size[current_texture];
	 texture_stagenum=texture_stagenums[current_texture];
		calc_texture_silent();
		current_texture=a;
	 tsize=texture_size[current_texture];
	 texture_stagenum=texture_stagenums[current_texture];
	 goto nxo2;
	}

	double nr;
  createVbuf_for_accel();

  if (objects[current_scene][CurrentObject[current_scene]].rendertype==1) pDevice->SetRenderState(D3DRS_BLENDOP,D3DBLENDOP_ADD);
  if (objects[current_scene][CurrentObject[current_scene]].rendertype==2) pDevice->SetRenderState(D3DRS_BLENDOP,D3DBLENDOP_REVSUBTRACT);
  if (objects[current_scene][CurrentObject[current_scene]].rendertype==3) pDevice->SetRenderState(D3DRS_BLENDOP,D3DBLENDOP_SUBTRACT);
  if (objects[current_scene][CurrentObject[current_scene]].rendertype==4) pDevice->SetRenderState(D3DRS_BLENDOP,D3DBLENDOP_MIN);
  if (objects[current_scene][CurrentObject[current_scene]].rendertype==5) pDevice->SetRenderState(D3DRS_BLENDOP,D3DBLENDOP_MAX);
  if (objects[current_scene][CurrentObject[current_scene]].rendertype==6) 
					{
					 pDevice->SetRenderState(D3DRS_ZENABLE,D3DZB_TRUE);
					 pDevice->SetRenderState(D3DRS_ZWRITEENABLE,TRUE);
					 pDevice->SetRenderState(D3DRS_ALPHAREF, (DWORD)0x00000001);
					 pDevice->SetRenderState(D3DRS_ALPHATESTENABLE, TRUE); 
					 pDevice->SetRenderState(D3DRS_ALPHAFUNC, D3DCMP_GREATEREQUAL);
					 pDevice->SetRenderState(D3DRS_BLENDOP,D3DBLENDOP_ADD);
					 pDevice->SetRenderState(D3DRS_SRCBLEND,D3DBLEND_SRCALPHA);
					 pDevice->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA);
					}
  nr=objects[current_scene][CurrentObject[current_scene]].normal-1;
  if (nr==1) pDevice->SetRenderState(D3DRS_CULLMODE, D3DCULL_CW);
  if (nr==-1) pDevice->SetRenderState(D3DRS_CULLMODE, D3DCULL_CCW);
  if (nr==0) pDevice->SetRenderState(D3DRS_CULLMODE, D3DPMISCCAPS_CULLNONE);
  if (nr==2) pDevice->SetRenderState(D3DRS_CULLMODE, D3DPMISCCAPS_CULLNONE);
  if (nr==3) pDevice->SetRenderState(D3DRS_CULLMODE, D3DPMISCCAPS_CULLNONE);
  if (nr==4&&clean_view!=0) goto nxo2;

  mtx(); //multitexturing

  pDevice->SetMaterial( &Materialbank[objects[current_scene][CurrentObject[current_scene]].material]);
	//--zbuf cleaner
  if (objects[current_scene][CurrentObject[current_scene]].type==12) {pDevice->Clear(0,NULL, D3DCLEAR_ZBUFFER,0,1.0f,0); goto nxo2;}
	//--render scene sc[x] cam[y]
  if (objects[current_scene][CurrentObject[current_scene]].type==20) goto nxo2;
	//--copy to texture tex[t]
  if (objects[current_scene][CurrentObject[current_scene]].type==19) //copy
		{
		LPDIRECT3DSURFACE9 RT,RT2;
		pDevice->GetRenderTarget(0,&RT);
		pTexture[objects[current_scene][CurrentObject[current_scene]].texture]->GetSurfaceLevel(0,&RT2);
		pDevice->StretchRect(RT,NULL,RT2,NULL,D3DTEXF_NONE);
		goto nxo2;
		}
	//--postprocessor
	if (objects[current_scene][CurrentObject[current_scene]].type==11)
	{
	pDevice->SetRenderState(D3DRS_ZWRITEENABLE,FALSE);
	pDevice->SetRenderState(D3DRS_ZENABLE,D3DZB_FALSE );
	//shader fx
	effindex=objshader[current_scene][CurrentObject[current_scene]];
	if (groupfx_flag==FALSE&&effindex>0&&shader_loadflag[effindex-1]==1)
		{
		numPasses=0;
		MatWorldView = MatWorld * MatView;
		pEffect[effindex-1]->SetValue("MatProj", &MatProj, D3DX_DEFAULT);
		pEffect[effindex-1]->SetValue("MatWorldView", &MatWorldView, D3DX_DEFAULT);
		hEffTech = pEffect[effindex-1]->GetTechniqueByName("t0");
		pEffect[effindex-1]->SetTechnique(hEffTech);
		pEffect[effindex-1]->Begin(&numPasses, 0);
		for(ipass=0; ipass < numPasses; ipass++)
			{
			pEffect[effindex-1]->BeginPass(ipass);
			pDevice->DrawPrimitiveUP(D3DPT_TRIANGLELIST,NumTriangles,pMyVerts,sizeof(MyVertex));  //  
			pEffect[effindex-1]->EndPass();
			}
		pEffect[effindex-1]->End();
		}
	else {pDevice->DrawPrimitiveUP(D3DPT_TRIANGLELIST,NumTriangles,pMyVerts,sizeof(MyVertex));}
	pDevice->SetRenderState(D3DRS_ZENABLE,D3DZB_TRUE );
	pDevice->SetRenderState(D3DRS_ZWRITEENABLE,TRUE);
	}
	else
	{
	//shader fx
	effindex=objshader[current_scene][CurrentObject[current_scene]];
	if (groupfx_flag==FALSE&&effindex>0&&shader_loadflag[effindex-1]==1)
		{
		numPasses=0;
		MatWorldView = MatWorld * MatView;
		pEffect[effindex-1]->SetValue("MatProj", &MatProj, D3DX_DEFAULT);
		pEffect[effindex-1]->SetValue("MatWorldView", &MatWorldView, D3DX_DEFAULT);
		hEffTech = pEffect[effindex-1]->GetTechniqueByName("t0");
		pEffect[effindex-1]->SetTechnique(hEffTech);
		pEffect[effindex-1]->Begin(&numPasses, 0);
		for(ipass=0; ipass < numPasses; ipass++)
			{
			pEffect[effindex-1]->BeginPass(ipass);
			pDevice->DrawPrimitiveUP(D3DPT_TRIANGLELIST,NumTriangles,pMyVerts,sizeof(MyVertex));  //  
			pEffect[effindex-1]->EndPass();
			}
		pEffect[effindex-1]->End();
		}
	else {pDevice->DrawPrimitiveUP(D3DPT_TRIANGLELIST,NumTriangles,pMyVerts,sizeof(MyVertex));}
	}

  if (objects[current_scene][CurrentObject[current_scene]].rendertype==6) //   
					{
					 pDevice->SetRenderState(D3DRS_ALPHATESTENABLE, FALSE); 
					 pDevice->SetRenderState(D3DRS_BLENDOP,D3DBLENDOP_ADD);
					 pDevice->SetRenderState(D3DRS_SRCBLEND,D3DBLEND_ONE);
					 pDevice->SetRenderState(D3DRS_DESTBLEND,D3DBLEND_ONE);
					 pDevice->SetRenderState(D3DRS_ZWRITEENABLE,FALSE);
					}
nxo2:;
}
}
	pDevice->SetRenderState(D3DRS_ZWRITEENABLE,TRUE);
	pDevice->SetRenderState(D3DRS_ALPHABLENDENABLE,FALSE);
	pDevice->SetRenderState( D3DRS_ALPHATESTENABLE, FALSE );

//
CurrentObject[current_scene]=_st;

if (clean_view==0) 
	{
	DrawModifer();DrawGrid();DrawLinks();
	DrawXYZ();

	pDevice->SetRenderState(D3DRS_ZWRITEENABLE,TRUE);
	pDevice->SetRenderState(D3DRS_ZENABLE,D3DZB_TRUE );
	pDevice->SetRenderState(D3DRS_ALPHABLENDENABLE,FALSE);
	pDevice->SetRenderState( D3DRS_ALPHATESTENABLE, FALSE );
	}
}

//==============================================================================
//   
//==============================================================================
void DrawSceneGeo()
{
int i,j;int iii;int csc;
pDevice->SetRenderState(D3DRS_FOGENABLE, FALSE);

// ,     
if (tl_play_flag==1) do_time();

//1:   20:(RenderScene)       
sc_list_size=0;
for (j=0;j<255;j++)
{
if (objects[current_scene][j].type==20)
	{
	if (objects[current_scene][j].x>=0&&objects[current_scene][j].x<64)
		{
		sc_list[sc_list_size]=objects[current_scene][j].x;
		if (objects[current_scene][j].y>=0&&objects[current_scene][j].y<256)
			{sc_list_cam[sc_list_size]=objects[current_scene][j].y;}
		sc_list_size++;
		}
	}
}

//2:   ,      
if (anim_view==0) cmtime=((float)GetTickCount()*timescaller/256.0-sa_start_time)/1024.0 * 3.141593f;
cmtime2=float(GetTickCount()); // 

// 
if (ProjectionType==0) SetProjecton(); else SetIzoProjecton();

  //if (windowed==FALSE) SetCursor(NULL);
  //CreateObject();

  if (viewstyle==0) pDevice->SetRenderState(D3DRS_FILLMODE,D3DFILL_SOLID);
  if (viewstyle==1) 
	  pDevice->SetRenderState(D3DRS_FILLMODE,D3DFILL_WIREFRAME);

  pDevice->SetRenderState(D3DRS_ZENABLE,D3DZB_TRUE);
  pDevice->SetRenderState(D3DRS_ZWRITEENABLE,TRUE);

  pDevice->Clear(0,NULL, D3DCLEAR_ZBUFFER,0,8.0f,0); 
  pDevice->Clear(0,NULL, D3DCLEAR_TARGET,D3DCOLOR_ARGB(0,120,120,120),8.0f,0); 
  pDevice->SetRenderState(D3DRS_SHADEMODE,D3DSHADE_GOURAUD);

  pDevice->BeginScene();

  pDevice->SetSamplerState(0,D3DSAMP_MAGFILTER,D3DTEXF_LINEAR);
	pDevice->SetSamplerState(0,D3DSAMP_MINFILTER,D3DTEXF_LINEAR);
  pDevice->SetSamplerState(1,D3DSAMP_MAGFILTER,D3DTEXF_LINEAR);
  	pDevice->SetSamplerState(1,D3DSAMP_MINFILTER,D3DTEXF_LINEAR);
  pDevice->SetSamplerState(2,D3DSAMP_MAGFILTER,D3DTEXF_LINEAR);
  	pDevice->SetSamplerState(2,D3DSAMP_MINFILTER,D3DTEXF_LINEAR);

	//---   RenderScene   ,   
	iii=0;
	csc=current_scene;
nextsc:;
	current_scene=sc_list[iii];
	if (sc_list_size==0) current_scene=csc;
	cam_bank[255]=main_cam;
	if (sc_list_size!=0) main_cam=cam_bank[sc_list_cam[iii]];
	cam_p();
	lighting();
	DrawObject(); //   
	main_cam=cam_bank[255];
	if (iii<(sc_list_size-1)) {iii++;goto nextsc;}
	current_scene=csc;

  CalcFPS(); //  FPS

  pDevice->EndScene();
  pDevice->Present( NULL, NULL, NULL, NULL );

//get_RTdata------------------   ???
  LPDIRECT3DSURFACE9 RT;
  LPDIRECT3DSURFACE9 RT2;

//---

  if (rt_captureflag==1)
  {
	int trt;
	trt=rt_capture_desttexture;
  D3DLOCKED_RECT tl;
  D3DLOCKED_RECT rl;
  pDevice->GetRenderTarget(0,&RT);
  RT->LockRect(&rl,NULL,D3DLOCK_DISCARD);
  int xstp,ystp,a,sd,td,tt;
  xstp=(256*screen_width)/texture_size[trt];
  ystp=(256*screen_height)/texture_size[trt];
  sd=0;td=0;
  for (int y=0;y<texture_size[trt];y++)
  {
	  sd=(ystp*y/256)*rl.Pitch;tt=0;
	  td=(texture_size[trt]-y-1)*texture_size[trt]*4;//-4;
	  for (int x=0;x<texture_size[trt];x++)
	  {
		a=peekd((BYTE*)rl.pBits+sd+4*(tt/256));tt=tt+xstp;
		poked(FC+td,a);td+=4;
	  }

  }
  RT->UnlockRect();
  rt_captureflag==0;
  }  

//---------------------------- 
//  return 0;
}

