BOOL CALLBACK _export SSynth_UIProc(HWND, UINT, WPARAM, LPARAM);

short int* sbuf;
unsigned char* svbuf;
int swmid,szoom,spos,swd;

typedef struct {int fnum;unsigned int _p[10];} s_log;

int sample_len[255];
int current_sample=0;
int current_s_stage=-1;
int s_numofstages[255];

s_log sm_log[256][256];

typedef struct {LPCTSTR fname;
				int numparams;
				LPCTSTR pdesc[7];
				int defvalue[7];
				int range[7];} s_fdesc;

s_fdesc sm_gens[100];
int stfunc_count=0;

param_ctrls SUI_param_ctrls[8];

#include "soundsynth/generators.h"
#include "soundsynth/mam_dsp.h"

HDC SDC;
BITMAPINFO info; 
COLORREF* real_bmp; 
HDC hDC;
HBITMAP memBMP;
HGDIOBJ last_obj;

void CopySampleToScreen()
{

ZeroMemory(&info,sizeof(info)); 
info.bmiHeader.biSize=sizeof(info.bmiHeader); 
info.bmiHeader.biWidth=swd; 
 info.bmiHeader.biHeight=swmid*2; 
 info.bmiHeader.biPlanes=1; 
 info.bmiHeader.biBitCount=32; 
 info.bmiHeader.biCompression=BI_RGB; 
 info.bmiHeader.biSizeImage=0; 
 info.bmiHeader.biXPelsPerMeter=3700; 
 info.bmiHeader.biYPelsPerMeter=3700; 
 info.bmiHeader.biClrUsed=16; 
 info.bmiHeader.biClrImportant=0; 

 real_bmp=NULL; 
 memBMP = CreateDIBSection( hDC, &info, DIB_RGB_COLORS,(void**)&real_bmp,NULL,NULL); 

last_obj=SelectObject ( hDC, memBMP );

 memcpy(real_bmp,svbuf,swd*4*swmid*2);
 //----

 BitBlt(SDC,0,0,swd,swmid*2,hDC,0,0,SRCCOPY); 

// SelectObject ( hDC, last_obj); 
 DeleteObject(memBMP); 


}

void DrawSample()
{
short int s;
ZeroMemory(svbuf,256*256*4);

for (int x=0;x<swd;x++)
	{
	s=*(sbuf+current_s_stage*sample_len[current_sample]*2+spos*2+2*(int)(x*szoom/256.0));
	s=s*swmid/32768.0;
	
	if ((spos+(int)(x*szoom/256.0))>sample_len[current_sample]) s=0;

	if (s>0) 
	  for (int y=0;y<(s-1);y++)
		{	
		*(svbuf+x*4+(y+swmid)*4*swd)=0xffffffff;
		}	
	else
	  for (int y=0;y<(abs(s)-1);y++)
		{	
		*(svbuf+x*4+(swmid-y)*4*swd)=0xffffffff;
		}	

	}

CopySampleToScreen();
}

void SUI_hide_param_ctrls()
{
	// 
	for (int i=0;i<7;i++)
	{
	ShowWindow(GetDlgItem(SSynth_UIDlg,SUI_param_ctrls[i].pdesc),FALSE);
	ShowWindow(GetDlgItem(SSynth_UIDlg,SUI_param_ctrls[i].pminus),FALSE);
	ShowWindow(GetDlgItem(SSynth_UIDlg,SUI_param_ctrls[i].pplus),FALSE);
	ShowWindow(GetDlgItem(SSynth_UIDlg,SUI_param_ctrls[i].pnumview),FALSE);
	ShowWindow(GetDlgItem(SSynth_UIDlg,SUI_param_ctrls[i].pslider),FALSE);
	}
	SetDlgItemText(SSynth_UIDlg,IDC_SFN,"");
}

void DrawLog()
{
	SendDlgItemMessage(SSynth_UIDlg,IDC_SLOG,LB_RESETCONTENT,0,0);
	for (int i=0;i<s_numofstages[current_sample];i++)
		{
		if (i>9) _itoa(i,r_string,10); else {strcpy(r_string,"0");_itoa(i,r_serv,10);strcat(r_string,r_serv);}
		strcat(r_string,":");
		strcat(r_string,sm_gens[sm_log[current_sample][i].fnum].fname);
		strcat(r_string,"(");
		for (int r=0;r<sm_gens[sm_log[current_sample][i].fnum].numparams;r++)
			{
			_itoa(sm_log[current_sample][i]._p[r],r_serv,10);strcat(r_string,r_serv);
			if (r==sm_gens[sm_log[current_sample][i].fnum].numparams-1) strcat(r_string,")"); else strcat(r_string,",");
			}
		SendDlgItemMessage(SSynth_UIDlg,IDC_SLOG,LB_INSERTSTRING,0,(LPARAM) (LPCTSTR) r_string);					
		}
}

void s_pload()
{
	SUI_hide_param_ctrls();
	int i;
	i=SendDlgItemMessage(SSynth_UIDlg,IDC_SCOM,LB_GETCURSEL,0,0);
	
	sm_log[current_sample][current_s_stage].fnum=i;
	
	if (i>=0&&i<stfunc_count)
	{
	SetDlgItemText(SSynth_UIDlg,IDC_SFN,sm_gens[i].fname);
	for (int j=0;j<sm_gens[i].numparams;j++)
		{

		sm_log[current_sample][current_s_stage]._p[j]=sm_gens[i].defvalue[j];

		SendDlgItemMessage(SSynth_UIDlg,SUI_param_ctrls[j].pslider,TBM_SETRANGE,TRUE,(LPARAM) MAKELONG(0,sm_gens[i].range[j]));
		SendDlgItemMessage(SSynth_UIDlg,SUI_param_ctrls[j].pslider,TBM_SETPOS,TRUE,(LPARAM) sm_gens[i].defvalue[j]);
		SetDlgItemInt(SSynth_UIDlg,SUI_param_ctrls[j].pnumview,sm_gens[i].defvalue[j],FALSE);
		SetDlgItemText(SSynth_UIDlg,SUI_param_ctrls[j].pdesc,sm_gens[i].pdesc[j]);
		
		ShowWindow(GetDlgItem(SSynth_UIDlg,SUI_param_ctrls[j].pslider),TRUE);
		ShowWindow(GetDlgItem(SSynth_UIDlg,SUI_param_ctrls[j].pdesc),TRUE);
		ShowWindow(GetDlgItem(SSynth_UIDlg,SUI_param_ctrls[j].pnumview),TRUE);
		ShowWindow(GetDlgItem(SSynth_UIDlg,SUI_param_ctrls[j].pminus),TRUE);
		ShowWindow(GetDlgItem(SSynth_UIDlg,SUI_param_ctrls[j].pplus),TRUE);
		}
	}
}

void s_pload_fromlog()
{
	SUI_hide_param_ctrls();
	int i;
	i=SendDlgItemMessage(SSynth_UIDlg,IDC_SCOM,LB_GETCURSEL,0,0);
	
	if (i>=0&&i<stfunc_count)
	{
	SetDlgItemText(SSynth_UIDlg,IDC_SFN,sm_gens[i].fname);
	for (int j=0;j<sm_gens[i].numparams;j++)
		{
		SendDlgItemMessage(SSynth_UIDlg,SUI_param_ctrls[j].pslider,TBM_SETRANGE,TRUE,(LPARAM) MAKELONG(0,sm_gens[i].range[j]));
		SendDlgItemMessage(SSynth_UIDlg,SUI_param_ctrls[j].pslider,TBM_SETPOS,TRUE,(LPARAM) sm_log[current_sample][current_s_stage]._p[j]);
		SetDlgItemInt(SSynth_UIDlg,SUI_param_ctrls[j].pnumview,sm_log[current_sample][current_s_stage]._p[j],FALSE);
		SetDlgItemText(SSynth_UIDlg,SUI_param_ctrls[j].pdesc,sm_gens[i].pdesc[j]);
		
		ShowWindow(GetDlgItem(SSynth_UIDlg,SUI_param_ctrls[j].pslider),TRUE);
		ShowWindow(GetDlgItem(SSynth_UIDlg,SUI_param_ctrls[j].pdesc),TRUE);
		ShowWindow(GetDlgItem(SSynth_UIDlg,SUI_param_ctrls[j].pnumview),TRUE);
		ShowWindow(GetDlgItem(SSynth_UIDlg,SUI_param_ctrls[j].pminus),TRUE);
		ShowWindow(GetDlgItem(SSynth_UIDlg,SUI_param_ctrls[j].pplus),TRUE);
		}
	}
}


int _p[8];

void CalcSampleStage()
{
signed short *_in,*_out; int _len;
_in=sbuf+(current_s_stage-1)*sample_len[current_sample]*2;
_out=sbuf+current_s_stage*sample_len[current_sample]*2;
_len=sample_len[current_sample];

if (current_s_stage>=0)
{
for (int m=0;m<7;m++) _p[m]=sm_log[current_sample][current_s_stage]._p[m];
switch (sm_log[current_sample][current_s_stage].fnum)
	{
	case 0:	Sinus(_p[0],_p[1],_p[2]); break;
	case 1:	AbsSinus(_p[0],_p[1],_p[2]); break;
	case 2:	Square(_p[0],_p[1],_p[2]); break;
	case 3:	Triangle(_p[0],_p[1],_p[2]); break;
	case 4:	Saw(_p[0],_p[1],_p[2]); break;
	case 5:	SoftSaw(_p[0],_p[1],_p[2]); break;
	case 6:	Noise(_p[0],_p[1]); break;
	case 7:	Mixer(_p[0],_p[1],_p[2],_p[3],_p[4],_p[5],_p[6]); break;
	case 8:	Morf(_p[0],_p[1]); break;
	case 9:	Env(_p[0],_p[1],_p[2],_p[3]); break;
	case 10:Flanger(_p[0],_p[1]); break;
	case 11:Eq(_p[0],_p[1],_p[2],_p[3],_p[4],_p[5]); break;
	case 12:Reverse(); break;
	case 13:SinPack(); break;
	case 14:Pluck(_p[0],_p[1],_p[2]); break;
	case 15:VRoll(_p[0]); break;
	case 16:Reverb(_p[0],_p[1],_p[2]); break;
	case 17:SinPackSlide(_p[0],_p[1]); break;
	case 18:BaseDrum(); break;
	case 19:Resample(_p[0]); break;
	case 20:Invert(); break;
	case 21:Compress(_p[0]); break;
	case 22:Compress2(_p[0]); break;
	case 23:SinPack2(_p[0],_p[1],_p[2],_p[3],_p[4],_p[5],_p[6]); break;
	case 24:SSawPack(_p[0],_p[1],_p[2],_p[3],_p[4],_p[5],_p[6]); break;
	case 25:Vibrato(_p[0],_p[1]); break;
	case 26:Shift(_p[0]); break;
	case 27:Roll(_p[0]); break;
	case 28:sample_len[current_sample]=_p[0]*4410; break;
	case 29:LS_Filter(_in, _out, _len, ((double)_p[0])/255.0);break;
	case 30:HS_Filter(_in, _out, _len, ((double)_p[0])/255.0);break;
	case 31:Resonator(_in, _out, _len, _p[0]*100+_p[1], ((double)_p[2])/255.0, ((double)_p[3]/255.0));break;
	case 32:Slew_Compressor(_in, _out, _len, ((double)_p[0])/255.0, ((double)_p[1])/255.0);break;
	case 33:Distorter(_in, _out, _len, ((double)_p[0])/255.0,((double)_p[1])/255.0,((double)_p[2])/255.0);break;
	case 34:FM_Operator(_in, _out, _len, _p[0]*100+_p[1], ((double)_p[2])/255.0, _p[3]*100+_p[4]);break;
	case 35:HP_Filter(_in,_out,_len,_p[0]*100+_p[1]); break;
	case 36:LP_Filter(_in,_out,_len,_p[0]/2,_p[1]/2); break;
	case 37:Normalize(_in,_out,_len); break;
	case 38:EasyLoop(_in,_out,_len,((double)_p[0])/255.0); break;
	case 39:LP_Filter2(_in,_out,_len,_p[0]/2,_p[1]/2,_p[2],_p[3],_p[4],_p[5],_p[6]); break;
	}
}
}

void CalcSample()
{
	int t;
	t=current_s_stage;

	for (current_s_stage=0;current_s_stage<s_numofstages[current_sample];current_s_stage++) 
		{
		CalcSampleStage();
		}
	current_s_stage=t;
if (current_s_stage>0) memmove(sbuf+(current_s_stage+1)*sample_len[current_sample]*2,sbuf+(current_s_stage)*sample_len[current_sample]*2,sample_len[current_sample]*2);
	
}

BOOL CALLBACK SSynth_UIProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	if (message==WM_COMMAND)
	for (int i=0;i<7;i++)
	{
		if (LOWORD(wParam)==SUI_param_ctrls[i].pminus)
		{
		if (sm_log[current_sample][current_s_stage]._p[i]>0)
			{
			sm_log[current_sample][current_s_stage]._p[i]--;
			SetDlgItemInt(hWnd,SUI_param_ctrls[i].pnumview,sm_log[current_sample][current_s_stage]._p[i],FALSE);
			SendDlgItemMessage(SSynth_UIDlg,SUI_param_ctrls[i].pslider,TBM_SETPOS,TRUE,(LPARAM) sm_log[current_sample][current_s_stage]._p[i]);
			}
		CalcSampleStage();
		DrawSample();
		}
		if (LOWORD(wParam)==SUI_param_ctrls[i].pplus)
		{
		if (sm_log[current_sample][current_s_stage]._p[i]<
			sm_gens[sm_log[current_sample][current_s_stage].fnum].range[i])
			{
			sm_log[current_sample][current_s_stage]._p[i]++;
			SetDlgItemInt(hWnd,SUI_param_ctrls[i].pnumview,sm_log[current_sample][current_s_stage]._p[i],FALSE);
			SendDlgItemMessage(SSynth_UIDlg,SUI_param_ctrls[i].pslider,TBM_SETPOS,TRUE,(LPARAM) sm_log[current_sample][current_s_stage]._p[i]);
			}
		CalcSampleStage();
		DrawSample();
		}
		if (LOWORD(wParam)==SUI_param_ctrls[i].pnumview)
		{
			if (HIWORD (wParam) == EN_CHANGE)  
			{
			if (GetFocus()==GetDlgItem(SSynth_UIDlg,SUI_param_ctrls[i].pnumview))
				{
				int a,b;
				a=GetDlgItemInt(SSynth_UIDlg,SUI_param_ctrls[i].pnumview,&b,TRUE);
				if (b!=TRUE) {a=0;SetDlgItemInt(SSynth_UIDlg,SUI_param_ctrls[i].pnumview,a,FALSE);}
				if (a>sm_gens[sm_log[current_sample][current_s_stage].fnum].range[i]) {a=sm_gens[sm_log[current_sample][current_s_stage].fnum].range[i];SetDlgItemInt(SSynth_UIDlg,SUI_param_ctrls[i].pnumview,a,FALSE);}
				if (a<0) {a=0;SetDlgItemInt(SSynth_UIDlg,SUI_param_ctrls[i].pnumview,a,FALSE);}
				sm_log[current_sample][current_s_stage]._p[i]=a;
			
				SendDlgItemMessage(SSynth_UIDlg,SUI_param_ctrls[i].pslider,TBM_SETPOS,TRUE,(LPARAM) a);
				CalcSampleStage();
				DrawSample();
				}

			}
		}
	}

	switch (message) 
	{
	case WM_ACTIVATE:
		if (LOWORD(wParam)==WA_INACTIVE) active_app=0; else active_app=1;
		break;

	case WM_CLOSE:
		{
		ShowWindow(SSynth_UIDlg,SW_HIDE);
		CheckMenuItem(GetMenu(Parent_hWnd), W_SYNTH, MF_BYCOMMAND | MF_UNCHECKED);
		w_state[9]=1;

		break;
		}

	case WM_MOUSEMOVE:
		{
		DrawSample();
		break;
		}

	case WM_INITDIALOG:
		{


		break;
		}

	case WM_HSCROLL:
		{
		double t;int a;
		t=SendDlgItemMessage (hWnd,IDC_SZOOM,TBM_GETPOS,0,0);
		szoom=256+128*t;
		t=SendDlgItemMessage (hWnd,IDC_SPOS,TBM_GETPOS,0,0);
		spos=t*44100/swd;

		a=0;
		for (int j=0;j<7;j++)
		{
		if (GetFocus()==GetDlgItem(SSynth_UIDlg,SUI_param_ctrls[j].pslider)) a=1;
		}

		if (a==1)
		{
			sm_log[current_sample][current_s_stage].fnum=SendDlgItemMessage(SSynth_UIDlg,IDC_SCOM,LB_GETCURSEL,0,0);
			for (int i=0;i<7;i++)
			{
			sm_log[current_sample][current_s_stage]._p[i]=SendDlgItemMessage (hWnd,SUI_param_ctrls[i].pslider,TBM_GETPOS,0,0);
			SetDlgItemInt(hWnd,SUI_param_ctrls[i].pnumview,sm_log[current_sample][current_s_stage]._p[i],FALSE);
			}
			CalcSampleStage();
		}
		
		DrawSample();

		break;
		}
		
	case WM_COMMAND:
		{
		switch (LOWORD(wParam))
			{
			case IDC_SPREV:
				int i;
				if (current_sample>0) current_sample--;
				current_s_stage=s_numofstages[current_sample]-1;
				DrawLog();
				CalcSample();
				DrawSample();
				SetDlgItemInt(SSynth_UIDlg,IDC_SNUM,current_sample,FALSE);
				SendDlgItemMessage(SSynth_UIDlg,IDC_SLOG,LB_SETCURSEL,0,0);
					current_s_stage=s_numofstages[current_sample]-SendDlgItemMessage(SSynth_UIDlg,IDC_SLOG,LB_GETCURSEL,0,0)-1;
					i=SendDlgItemMessage(SSynth_UIDlg,IDC_SLOG,LB_GETCURSEL,0,0);
					SendDlgItemMessage(SSynth_UIDlg,IDC_SCOM,LB_SETCURSEL,sm_log[current_sample][current_s_stage].fnum,0);
					DrawLog();
					s_pload_fromlog();
					CalcSampleStage();
					DrawSample();
					SendDlgItemMessage(SSynth_UIDlg,IDC_SLOG,LB_SETCURSEL,i,0);

				break;
			case IDC_SNEXT:
			
				if (current_sample<255) current_sample++;
				current_s_stage=s_numofstages[current_sample]-1;
				DrawLog();
				CalcSample();
				DrawSample();
				SetDlgItemInt(SSynth_UIDlg,IDC_SNUM,current_sample,FALSE);
				SendDlgItemMessage(SSynth_UIDlg,IDC_SLOG,LB_SETCURSEL,0,0);
					current_s_stage=s_numofstages[current_sample]-SendDlgItemMessage(SSynth_UIDlg,IDC_SLOG,LB_GETCURSEL,0,0)-1;
					i=SendDlgItemMessage(SSynth_UIDlg,IDC_SLOG,LB_GETCURSEL,0,0);
					SendDlgItemMessage(SSynth_UIDlg,IDC_SCOM,LB_SETCURSEL,sm_log[current_sample][current_s_stage].fnum,0);
					DrawLog();
					s_pload_fromlog();
					CalcSampleStage();
					DrawSample();
					SendDlgItemMessage(SSynth_UIDlg,IDC_SLOG,LB_SETCURSEL,i,0);

				break;

			case IDC_SCOM:
				{
						if (HIWORD (wParam)==LBN_DBLCLK) 
							{
							s_numofstages[current_sample]++;
							current_s_stage++;
							sm_log[current_sample][current_s_stage].fnum=0;
							sm_log[current_sample][current_s_stage]._p[0]=0;
							sm_log[current_sample][current_s_stage]._p[1]=0;
							sm_log[current_sample][current_s_stage]._p[2]=0;
							sm_log[current_sample][current_s_stage]._p[3]=0;
							sm_log[current_sample][current_s_stage]._p[4]=0;
							sm_log[current_sample][current_s_stage]._p[5]=0;
							sm_log[current_sample][current_s_stage]._p[6]=0;
							CalcSampleStage();
							DrawSample();
							DrawLog();
							SendDlgItemMessage(SSynth_UIDlg,IDC_SLOG,LB_SETCURSEL,0,0);
							}

					s_pload();
					CalcSampleStage();
					DrawLog();
					DrawSample();
					SendDlgItemMessage(SSynth_UIDlg,IDC_SLOG,LB_SETCURSEL,s_numofstages[current_sample]-current_s_stage-1,0);
				break;
				}
			case IDC_SLOG:
				{
				//if (HIWORD (wParam) == LBN_SELCHANGE) 
					int i;
					
					current_s_stage=s_numofstages[current_sample]-SendDlgItemMessage(SSynth_UIDlg,IDC_SLOG,LB_GETCURSEL,0,0)-1;
					i=SendDlgItemMessage(SSynth_UIDlg,IDC_SLOG,LB_GETCURSEL,0,0);
					SendDlgItemMessage(SSynth_UIDlg,IDC_SCOM,LB_SETCURSEL,sm_log[current_sample][current_s_stage].fnum,0);
					DrawLog();
					s_pload_fromlog();
					CalcSampleStage();
					DrawSample();
					SendDlgItemMessage(SSynth_UIDlg,IDC_SLOG,LB_SETCURSEL,i,0);
				break;
				}


			case IDC_BUTTONUP:
				{int i;
				i=SendDlgItemMessage(SSynth_UIDlg,IDC_SLOG,LB_GETCURSEL,0,0);
				if (i>0&&i<s_numofstages[current_sample])
					{
					i=s_numofstages[current_sample]-i;
					sm_log[current_sample][255]=sm_log[current_sample][i];
					sm_log[current_sample][i]=sm_log[current_sample][i-1];
					sm_log[current_sample][i-1]=sm_log[current_sample][255];
					
					DrawLog();
					s_pload_fromlog();
					CalcSampleStage();
					DrawSample();
					SendDlgItemMessage(SSynth_UIDlg,IDC_SLOG,LB_SETCURSEL,s_numofstages[current_sample]-i-1,0);
					}
				break;
				}
			case IDC_BUTTONDOWN:
				{int i;
				i=SendDlgItemMessage(SSynth_UIDlg,IDC_SLOG,LB_GETCURSEL,0,0);
				if (i>=0&&i<s_numofstages[current_sample])
					{
					i=s_numofstages[current_sample]-i-1;
					sm_log[current_sample][255]=sm_log[current_sample][i];
					sm_log[current_sample][i]=sm_log[current_sample][i-1];
					sm_log[current_sample][i-1]=sm_log[current_sample][255];
					DrawLog();
					s_pload_fromlog();
					CalcSampleStage();
					DrawSample();
					SendDlgItemMessage(SSynth_UIDlg,IDC_SLOG,LB_SETCURSEL,s_numofstages[current_sample]-i,0);
					}
				break;
				}

			case IDC_SOK:
				{
				if (LB_ERR==SendDlgItemMessage(SSynth_UIDlg,IDC_SLOG,LB_GETCURSEL,0,0)) 
				{
					SendDlgItemMessage(SSynth_UIDlg,IDC_SLOG,LB_SETCURSEL,0,0);
				}

				if (LB_ERR==SendDlgItemMessage(SSynth_UIDlg,IDC_SCOM,LB_GETCURSEL,0,0)) 
				{
					SendDlgItemMessage(SSynth_UIDlg,IDC_SCOM,LB_SETCURSEL,0,0);
				}


				/*for (int i=s_numofstages[current_sample];i>current_s_stage;i++)
					{
						sm_log[current_sample][i]=sm_log[current_sample][i-1];
					}*/
				//sm_log[current_sample][current_s_stage]=sm_log[current_sample][i-1];
				//current_s_stage++;//=s_numofstages[current_sample];
				//current_s_stage=s_numofstages[current_sample]-1;
				
					//if (s_numofstages[current_sample]!=0) 
				

					s_numofstages[current_sample]++;
				current_s_stage++;

				s_pload();

				/*sm_log[current_sample][current_s_stage].fnum=0;
				sm_log[current_sample][current_s_stage]._p[0]=0;
				sm_log[current_sample][current_s_stage]._p[1]=0;
				sm_log[current_sample][current_s_stage]._p[2]=0;
				sm_log[current_sample][current_s_stage]._p[3]=0;
				sm_log[current_sample][current_s_stage]._p[4]=0;
				sm_log[current_sample][current_s_stage]._p[5]=0;
				sm_log[current_sample][current_s_stage]._p[6]=0;*/

				CalcSampleStage();
				DrawSample();
				DrawLog();
				SendDlgItemMessage(SSynth_UIDlg,IDC_SLOG,LB_SETCURSEL,0,0);

				//if (LB_ERR!=SendDlgItemMessage(SSynth_UIDlg,IDC_SLOG,LB_GETCURSEL,0,0)) 
				//{
					//s_pload();
				//}
				//					CalcSampleStage();
				//					DrawLog();
				//					DrawSample();
				//	SendDlgItemMessage(SSynth_UIDlg,IDC_SLOG,LB_SETCURSEL,s_numofstages[current_sample]-current_s_stage-1,0);
				//SendDlgItemMessage(SSynth_UIDlg,IDC_SLOG,LB_SETCURSEL,0,0);
				break;
				}

			case IDC_SDEL:
				{
				current_s_stage=s_numofstages[current_sample]-SendDlgItemMessage(SSynth_UIDlg,IDC_SLOG,LB_GETCURSEL,0,0)-1;

					if (current_s_stage>=0) 
					{
					for (int i=current_s_stage;i<s_numofstages[current_sample];i++)
						{
						sm_log[current_sample][i]=sm_log[current_sample][i+1];
						}
					s_numofstages[current_sample]--;
					if (s_numofstages[current_sample]<current_s_stage) current_s_stage=s_numofstages[current_sample]-1;
					DrawLog();
					SendDlgItemMessage(SSynth_UIDlg,IDC_SLOG,LB_SETCURSEL,s_numofstages[current_sample]-current_s_stage,0);
					}
				break;
				}

			case IDC_SPLAY:
				{
				CalcSample();
				SetCurrentDirectory(cdir);
					char* fbuf;
				fbuf=new char [88316];
				CalcSample();
				SetCurrentDirectory(cdir);
	

					int fmt[]={1,1,44100,44100,1,16,0};
					short int k;

					FILE *fp;

					fp = fopen("template.wav", "wb");
					fprintf(fp,"RIFF");
					int aln;
					aln=46+2*sample_len[current_sample]-8;
					fwrite(&aln,4,1,fp);
					fprintf(fp,"WAVE");
					fprintf(fp,"fmt ");
					aln=18;fwrite(&aln,4,1,fp);//  
						//fmt
						k=fmt[0];fwrite(&k,2,1,fp);
						k=fmt[1];fwrite(&k,2,1,fp);
						fwrite(&fmt[2],4,2,fp);
						k=fmt[4];fwrite(&k,2,1,fp);
						k=fmt[5];fwrite(&k,2,1,fp);
						k=fmt[6];fwrite(&k,2,1,fp);
						//
					fprintf(fp,"data");
					aln=2*sample_len[current_sample];fwrite(&aln,4,1,fp);

					fwrite(sbuf+(s_numofstages[current_sample]-1)*sample_len[current_sample]*2,sample_len[current_sample]*2,1,fp);

					fclose(fp);
				

				delete (fbuf);
			
		
				PlaySound("template.wav",NULL,SND_ASYNC|SND_FILENAME);
				break;
				}

			case IDC_LOADSAMPLE:
			{
				int tt;
				char* i,*m;int sl,r,r2,t,j,mj;
				char* aa;aa=new char[100];
				char szFile[100] = "\0"; 
				FILE *fp;
				//char* log_buff;log_buff=new char [1000000];

			    OPENFILENAME ofn;
					int afs;
					afs=AutoFocus;AutoFocus=1;
				// Initialize OPENFILENAME
				ZeroMemory(&ofn, sizeof(OPENFILENAME));
				ofn.lStructSize = sizeof(OPENFILENAME);
				ofn.hwndOwner = Parent_hWnd;
				ofn.lpstrFile = szFile;
				ofn.nMaxFile = sizeof(szFile);
				ofn.lpstrFilter = "Plasticator sample\0*.psm\0";
				ofn.nFilterIndex = 1;
				ofn.lpstrFileTitle = NULL;
				ofn.nMaxFileTitle = 0;
				ofn.lpstrInitialDir = NULL;
				ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST;
		
				// Display the Open dialog box. 
				if (GetOpenFileName(&ofn)==TRUE)
				{
				fp = fopen(ofn.lpstrFile, "rb");
				fread(&sm_log[current_sample],1,sizeof(s_log)*256,fp);
				fread(&current_s_stage,4,1,fp);
				fread(&s_numofstages[current_sample],4,1,fp);
				fclose (fp);
				}
				AutoFocus=afs;

				CalcSample();
				DrawSample();
				DrawLog();
				SendDlgItemMessage(SSynth_UIDlg,IDC_SLOG,LB_SETCURSEL,0,0);

				break;
	
				}


			case IDC_LOADSAMPLEPACK:
			{
				int tt;
				char* i,*m;int sl,r,r2,t,j,mj;
				char* aa;aa=new char[100];
				char szFile[100] = "\0"; 
				FILE *fp;
				//char* log_buff;log_buff=new char [1000000];

			    OPENFILENAME ofn;
					int afs;
					afs=AutoFocus;AutoFocus=1;
				// Initialize OPENFILENAME
				ZeroMemory(&ofn, sizeof(OPENFILENAME));
				ofn.lStructSize = sizeof(OPENFILENAME);
				ofn.hwndOwner = Parent_hWnd;
				ofn.lpstrFile = szFile;
				ofn.nMaxFile = sizeof(szFile);
				ofn.lpstrFilter = "Plasticator samples pack\0*.psp\0";
				ofn.nFilterIndex = 1;
				ofn.lpstrFileTitle = NULL;
				ofn.nMaxFileTitle = 0;
				ofn.lpstrInitialDir = NULL;
				ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST;
		
				// Display the Open dialog box. 
				if (GetOpenFileName(&ofn)==TRUE)
				{
				fp = fopen(ofn.lpstrFile, "rb");
				fread(sm_log,1,sizeof(s_log)*256*256,fp);
				fread(&current_s_stage,4,1,fp);
				fread(&s_numofstages,4,255,fp);
				fclose (fp);
				}
				AutoFocus=afs;

				CalcSample();
				DrawSample();
				DrawLog();
				SendDlgItemMessage(SSynth_UIDlg,IDC_SLOG,LB_SETCURSEL,0,0);

				break;
	
				}

			case IDC_SSAVE:
				{

				OPENFILENAME ofn;
				char ttt[100]="\0";
				char szFile[100] = "\0"; 
				int i,j;
				FILE *fp;char* aa;aa=new char [100];
				char* name;name=new char[100];
					int afs;
					afs=AutoFocus;AutoFocus=1;
				// Initialize OPENFILENAME
				ZeroMemory(&ofn, sizeof(OPENFILENAME));
				ofn.lStructSize = sizeof(OPENFILENAME);
				ofn.hwndOwner = Parent_hWnd;
				ofn.lpstrFile = szFile;
				ofn.nMaxFile = sizeof(szFile);
				ofn.lpstrFilter = "Plasticator samples pack\0*.psp\0";
				ofn.nFilterIndex = 1;
				ofn.lpstrFileTitle = NULL;
				ofn.nMaxFileTitle = 0;
				ofn.lpstrInitialDir = NULL;
				ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST |OFN_OVERWRITEPROMPT;
				// Display the Open dialog box. 
				if (GetSaveFileName(&ofn)==TRUE)
				{
				strcpy(name,ofn.lpstrFile);
				if (NULL==strstr(ofn.lpstrFile,".psp")) strcat(name,".psp");

				fp = fopen(name, "wb");

				fwrite(sm_log,1,sizeof(s_log)*256*256,fp);
				fwrite(&current_s_stage,4,1,fp);
				fwrite(&s_numofstages,4,255,fp);

				fclose(fp);
				}
			
				delete (aa);
				delete (name);

				break;
				}
			case IDC_SAVESAMPLE:
				{

				OPENFILENAME ofn;
				char ttt[100]="\0";
				char szFile[100] = "\0"; 
				int i,j;
				FILE *fp;char* aa;aa=new char [100];
				char* name;name=new char[100];
					int afs;
					afs=AutoFocus;AutoFocus=1;
				// Initialize OPENFILENAME
				ZeroMemory(&ofn, sizeof(OPENFILENAME));
				ofn.lStructSize = sizeof(OPENFILENAME);
				ofn.hwndOwner = Parent_hWnd;
				ofn.lpstrFile = szFile;
				ofn.nMaxFile = sizeof(szFile);
				ofn.lpstrFilter = "Plasticator sample\0*.psm\0";
				ofn.nFilterIndex = 1;
				ofn.lpstrFileTitle = NULL;
				ofn.nMaxFileTitle = 0;
				ofn.lpstrInitialDir = NULL;
				ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST |OFN_OVERWRITEPROMPT;
				// Display the Open dialog box. 
				if (GetSaveFileName(&ofn)==TRUE)
				{
				strcpy(name,ofn.lpstrFile);
				if (NULL==strstr(ofn.lpstrFile,".psm")) strcat(name,".psm");

				fp = fopen(name, "wb");

				fwrite(&(sm_log[current_sample][0]),1,sizeof(s_log)*256,fp);
				fwrite(&current_s_stage,4,1,fp);
				fwrite(&s_numofstages[current_sample],4,1,fp);

				fclose(fp);
				}
			
				delete (aa);
				delete (name);

				break;
				}

			case IDC_SSAVELOG:
				{
				_itoa(current_sample,r_string,10);
				strcat(r_string,".slog");

				OPENFILENAME ofn;
				char ttt[100]="\0";
				char szFile[100] = "\0"; 
				int i,j;
				char* aa;aa=new char [100];
				char* name;name=new char[100];
				//	int afs;
				//	afs=AutoFocus;AutoFocus=1;
				// Initialize OPENFILENAME
				ZeroMemory(&ofn, sizeof(OPENFILENAME));
				ofn.lStructSize = sizeof(OPENFILENAME);
				ofn.hwndOwner = Parent_hWnd;
				ofn.lpstrFile = szFile;
				strcpy(ofn.lpstrFile,r_string);
				ofn.nMaxFile = sizeof(szFile);
				ofn.lpstrFilter = "sample file\0*.slog\0";
				ofn.nFilterIndex = 1;
				ofn.lpstrFileTitle = NULL;
				ofn.nMaxFileTitle = 0;
				ofn.lpstrInitialDir = NULL;
				ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST |OFN_OVERWRITEPROMPT;
				// Display the Open dialog box. 
				if (GetSaveFileName(&ofn)==TRUE)
					{
					strcpy(name,ofn.lpstrFile);
					if (NULL==strstr(ofn.lpstrFile,".slog")) strcat(name,".slog");
					FILE *fp;
					fp = fopen(name, "wb");
						for (int ix=s_numofstages[current_sample]-1;ix>=0;ix--)
						{
						SendDlgItemMessage(SSynth_UIDlg,IDC_SLOG,LB_GETTEXT,ix,(LPARAM) (LPCTSTR)r_string);
						strcat(r_string,";");
						strcpy(r_serv,r_string+3);
						
						fprintf(fp,r_serv);
						fprintf(fp,"\n");
						}
					fclose( fp );
					}

				delete (aa);
				delete (name);

				break;
				}


			case IDC_SSAVEWAVE:
				{
				CalcSample();
				SetCurrentDirectory(cdir);
					char* fbuf;
				fbuf=new char [88316];

				_itoa(current_sample,r_string,10);
				strcat(r_string,".wav");

				OPENFILENAME ofn;
				char ttt[100]="\0";
				char szFile[100] = "\0"; 
				int i,j;
				FILE *fp;char* aa;aa=new char [100];
				char* name;name=new char[100];
				//	int afs;
				//	afs=AutoFocus;AutoFocus=1;
				// Initialize OPENFILENAME
				ZeroMemory(&ofn, sizeof(OPENFILENAME));
				ofn.lStructSize = sizeof(OPENFILENAME);
				ofn.hwndOwner = Parent_hWnd;
				ofn.lpstrFile = szFile;
				strcpy(ofn.lpstrFile,r_string);
				ofn.nMaxFile = sizeof(szFile);
				ofn.lpstrFilter = "Wav file\0*.wav\0";
				ofn.nFilterIndex = 1;
				ofn.lpstrFileTitle = NULL;
				ofn.nMaxFileTitle = 0;
				ofn.lpstrInitialDir = NULL;
				ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST |OFN_OVERWRITEPROMPT;
				// Display the Open dialog box. 
				if (GetSaveFileName(&ofn)==TRUE)
				{
					int fmt[]={1,1,44100,44100,1,16,0};
					short int k;
					strcpy(name,ofn.lpstrFile);
					if (NULL==strstr(ofn.lpstrFile,".wav")) strcat(name,".wav");

					FILE *fp;
					fp = fopen(name, "wb");
					fprintf(fp,"RIFF");
					int aln;
					aln=46+2*sample_len[current_sample]-8;
					fwrite(&aln,4,1,fp);
					fprintf(fp,"WAVE");
					fprintf(fp,"fmt ");
					aln=18;fwrite(&aln,4,1,fp);//  
						//fmt
						k=fmt[0];fwrite(&k,2,1,fp);
						k=fmt[1];fwrite(&k,2,1,fp);
						fwrite(&fmt[2],4,2,fp);
						k=fmt[4];fwrite(&k,2,1,fp);
						k=fmt[5];fwrite(&k,2,1,fp);
						k=fmt[6];fwrite(&k,2,1,fp);
						//
					fprintf(fp,"data");
					aln=2*sample_len[current_sample];fwrite(&aln,4,1,fp);

					fwrite(sbuf+(s_numofstages[current_sample]-1)*sample_len[current_sample]*2,sample_len[current_sample]*2,1,fp);

					fclose(fp);
				}

				delete (fbuf);
			
				delete (aa);
				delete (name);
				break;
				}

			}
		}
		
	}
 return 0L;
}

// 
void SSynthUI_init()
{
	//   

static DLGPROC lpfnDlgProc;
lpfnDlgProc = (DLGPROC)MakeProcInstance((FARPROC)SSynth_UIProc, hInst);
SSynth_UIDlg = CreateDialog(hInst, MAKEINTRESOURCE(IDD_SSYNTH),Parent_hWnd, lpfnDlgProc);
//

 

ZeroMemory(&info,sizeof(info)); 
info.bmiHeader.biSize=sizeof(info.bmiHeader); 
info.bmiHeader.biWidth=swd; 
 info.bmiHeader.biHeight=swmid*2; 
 info.bmiHeader.biPlanes=1; 
 info.bmiHeader.biBitCount=32; 
 info.bmiHeader.biCompression=BI_RGB; 
 info.bmiHeader.biSizeImage=0; 
 info.bmiHeader.biXPelsPerMeter=3700; 
 info.bmiHeader.biYPelsPerMeter=3700; 
 info.bmiHeader.biClrUsed=16; 
 info.bmiHeader.biClrImportant=0; 

SDC=GetDC(GetDlgItem(SSynth_UIDlg,IDC_SW));
 real_bmp=NULL; 
	hDC = CreateCompatibleDC ( SDC ); 
 memBMP = CreateDIBSection( hDC, &info, DIB_RGB_COLORS,(void**)&real_bmp,NULL,NULL); 

last_obj=SelectObject ( hDC, memBMP );

//
for (int m=0;m<255;m++) {sample_len[m]=44100;s_numofstages[m]=0;}

SetDlgItemInt(SSynth_UIDlg,IDC_SNUM,current_sample,FALSE);

//
int csg=0;

sm_gens[csg].fname="Sinus";sm_gens[csg].numparams=3;
	sm_gens[csg].pdesc[0]="";sm_gens[csg].defvalue[0]=440;sm_gens[csg].range[0]=440*4;
	sm_gens[csg].pdesc[1]="";sm_gens[csg].defvalue[1]=255;sm_gens[csg].range[1]=255;
	sm_gens[csg].pdesc[2]="";sm_gens[csg].defvalue[2]=0;sm_gens[csg].range[2]=255;
csg++;

sm_gens[csg].fname="AbsSinus";sm_gens[csg].numparams=3;
	sm_gens[csg].pdesc[0]="";sm_gens[csg].defvalue[0]=440;sm_gens[csg].range[0]=440*4;
	sm_gens[csg].pdesc[1]="";sm_gens[csg].defvalue[1]=255;sm_gens[csg].range[1]=255;
	sm_gens[csg].pdesc[2]="";sm_gens[csg].defvalue[2]=0;sm_gens[csg].range[2]=255;
csg++;

sm_gens[csg].fname="Square";sm_gens[csg].numparams=3;
	sm_gens[csg].pdesc[0]="";sm_gens[csg].defvalue[0]=440;sm_gens[csg].range[0]=440*4;
	sm_gens[csg].pdesc[1]="";sm_gens[csg].defvalue[1]=255;sm_gens[csg].range[1]=255;
	sm_gens[csg].pdesc[2]="";sm_gens[csg].defvalue[2]=0;sm_gens[csg].range[2]=255;
csg++;

sm_gens[csg].fname="Triangle";sm_gens[csg].numparams=3;
	sm_gens[csg].pdesc[0]="";sm_gens[csg].defvalue[0]=440;sm_gens[csg].range[0]=440*4;
	sm_gens[csg].pdesc[1]="";sm_gens[csg].defvalue[1]=255;sm_gens[csg].range[1]=255;
	sm_gens[csg].pdesc[2]="";sm_gens[csg].defvalue[2]=0;sm_gens[csg].range[2]=255;
csg++;

sm_gens[csg].fname="Saw";sm_gens[csg].numparams=3;
	sm_gens[csg].pdesc[0]="";sm_gens[csg].defvalue[0]=440;sm_gens[csg].range[0]=440*4;
	sm_gens[csg].pdesc[1]="";sm_gens[csg].defvalue[1]=255;sm_gens[csg].range[1]=255;
	sm_gens[csg].pdesc[2]="";sm_gens[csg].defvalue[2]=0;sm_gens[csg].range[2]=255;
csg++;

sm_gens[csg].fname="SoftSaw";sm_gens[csg].numparams=3;
	sm_gens[csg].pdesc[0]="";sm_gens[csg].defvalue[0]=440;sm_gens[csg].range[0]=440*4;
	sm_gens[csg].pdesc[1]="";sm_gens[csg].defvalue[1]=255;sm_gens[csg].range[1]=255;
	sm_gens[csg].pdesc[2]="";sm_gens[csg].defvalue[2]=0;sm_gens[csg].range[2]=255;
csg++;

sm_gens[csg].fname="Noise";sm_gens[csg].numparams=2;
	sm_gens[csg].pdesc[0]="";sm_gens[csg].defvalue[0]=440;sm_gens[csg].range[0]=440*4;
	sm_gens[csg].pdesc[1]="";sm_gens[csg].defvalue[1]=255;sm_gens[csg].range[1]=255;
csg++;

sm_gens[csg].fname="Mixer";sm_gens[csg].numparams=7;
	sm_gens[csg].pdesc[0]=" 1";sm_gens[csg].defvalue[0]=1;sm_gens[csg].range[0]=255;
	sm_gens[csg].pdesc[1]=" 2";sm_gens[csg].defvalue[1]=1;sm_gens[csg].range[1]=255;
	sm_gens[csg].pdesc[2]=" 1";sm_gens[csg].defvalue[2]=128;sm_gens[csg].range[2]=255;
	sm_gens[csg].pdesc[3]=" 2";sm_gens[csg].defvalue[3]=128;sm_gens[csg].range[3]=255;
	sm_gens[csg].pdesc[4]=" 1";sm_gens[csg].defvalue[4]=0;sm_gens[csg].range[4]=8192;
	sm_gens[csg].pdesc[5]=" 2";sm_gens[csg].defvalue[5]=0;sm_gens[csg].range[5]=8192;
	sm_gens[csg].pdesc[6]=" ";sm_gens[csg].defvalue[6]=0;sm_gens[csg].range[6]=255;
csg++;

sm_gens[csg].fname="Morf";sm_gens[csg].numparams=2;
	sm_gens[csg].pdesc[0]=" 1";sm_gens[csg].defvalue[0]=1;sm_gens[csg].range[0]=255;
	sm_gens[csg].pdesc[1]=" 2";sm_gens[csg].defvalue[1]=1;sm_gens[csg].range[1]=255;
csg++;

sm_gens[csg].fname="Env";sm_gens[csg].numparams=4;
	sm_gens[csg].pdesc[0]="1-";sm_gens[csg].defvalue[0]=0;sm_gens[csg].range[0]=100;
	sm_gens[csg].pdesc[1]="1";sm_gens[csg].defvalue[1]=255;sm_gens[csg].range[1]=255;
	sm_gens[csg].pdesc[2]="2-";sm_gens[csg].defvalue[2]=100;sm_gens[csg].range[2]=100;
	sm_gens[csg].pdesc[3]="2";sm_gens[csg].defvalue[3]=0;sm_gens[csg].range[3]=255;
csg++;

sm_gens[csg].fname="Flanger";sm_gens[csg].numparams=2;
	sm_gens[csg].pdesc[0]="";sm_gens[csg].defvalue[0]=1;sm_gens[csg].range[0]=255;
	sm_gens[csg].pdesc[1]="";sm_gens[csg].defvalue[1]=1;sm_gens[csg].range[1]=255;
csg++;

sm_gens[csg].fname="Eq";sm_gens[csg].numparams=6;
	sm_gens[csg].pdesc[0]="f1";sm_gens[csg].defvalue[0]=128;sm_gens[csg].range[0]=255;
	sm_gens[csg].pdesc[1]="f2";sm_gens[csg].defvalue[1]=128;sm_gens[csg].range[1]=255;
	sm_gens[csg].pdesc[2]="f3";sm_gens[csg].defvalue[2]=128;sm_gens[csg].range[2]=255;
	sm_gens[csg].pdesc[3]="f4";sm_gens[csg].defvalue[3]=128;sm_gens[csg].range[3]=255;
	sm_gens[csg].pdesc[4]="f5";sm_gens[csg].defvalue[4]=128;sm_gens[csg].range[4]=255;
	sm_gens[csg].pdesc[5]="f6";sm_gens[csg].defvalue[5]=128;sm_gens[csg].range[5]=255;
csg++;

sm_gens[csg].fname="Reverse";sm_gens[csg].numparams=0;
csg++;


sm_gens[csg].fname="SinPack";sm_gens[csg].numparams=0;
csg++;


sm_gens[csg].fname="Pluck";sm_gens[csg].numparams=3;
	sm_gens[csg].pdesc[0]="f1";sm_gens[csg].defvalue[0]=23;sm_gens[csg].range[0]=100;
	sm_gens[csg].pdesc[1]="f2";sm_gens[csg].defvalue[1]=32;sm_gens[csg].range[1]=100;
	sm_gens[csg].pdesc[2]=" ";sm_gens[csg].defvalue[2]=10;sm_gens[csg].range[2]=50;
csg++;


sm_gens[csg].fname="VRoll";sm_gens[csg].numparams=1;
	sm_gens[csg].pdesc[0]="";sm_gens[csg].defvalue[0]=0;sm_gens[csg].range[0]=255;
csg++;

sm_gens[csg].fname="Reverb";sm_gens[csg].numparams=3;
	sm_gens[csg].pdesc[0]="";sm_gens[csg].defvalue[0]=1;sm_gens[csg].range[0]=10000;
	sm_gens[csg].pdesc[1]=".";sm_gens[csg].defvalue[1]=22;sm_gens[csg].range[1]=255;
	sm_gens[csg].pdesc[2]=" ";sm_gens[csg].defvalue[2]=22;sm_gens[csg].range[2]=255;
csg++;

sm_gens[csg].fname="SinPackSlide";sm_gens[csg].numparams=2;
	sm_gens[csg].pdesc[0]="";sm_gens[csg].defvalue[0]=1;sm_gens[csg].range[0]=255;
	sm_gens[csg].pdesc[1]=" -";sm_gens[csg].defvalue[1]=440;sm_gens[csg].range[1]=440*4;
csg++;

sm_gens[csg].fname="BaseDrum";sm_gens[csg].numparams=0;
csg++;

sm_gens[csg].fname="Resample";sm_gens[csg].numparams=1;
	sm_gens[csg].pdesc[0]=",*100";sm_gens[csg].defvalue[0]=1;sm_gens[csg].range[0]=2550;
csg++;

sm_gens[csg].fname="Invert";sm_gens[csg].numparams=0;
csg++;

sm_gens[csg].fname="Compress";sm_gens[csg].numparams=1;
	sm_gens[csg].pdesc[0]="";sm_gens[csg].defvalue[0]=128;sm_gens[csg].range[0]=255;
csg++;

sm_gens[csg].fname="Compress2";sm_gens[csg].numparams=1;
	sm_gens[csg].pdesc[0]="";sm_gens[csg].defvalue[0]=128;sm_gens[csg].range[0]=255;
csg++;

sm_gens[csg].fname="SinPack2";sm_gens[csg].numparams=7;
	sm_gens[csg].pdesc[0]="";sm_gens[csg].defvalue[0]=220;sm_gens[csg].range[0]=1760;
	sm_gens[csg].pdesc[1]="a1";sm_gens[csg].defvalue[1]=128;sm_gens[csg].range[1]=255;
	sm_gens[csg].pdesc[2]="a2";sm_gens[csg].defvalue[2]=128;sm_gens[csg].range[2]=255;
	sm_gens[csg].pdesc[3]="a3";sm_gens[csg].defvalue[3]=128;sm_gens[csg].range[3]=255;
	sm_gens[csg].pdesc[4]="a4";sm_gens[csg].defvalue[4]=128;sm_gens[csg].range[4]=255;
	sm_gens[csg].pdesc[5]="a5";sm_gens[csg].defvalue[5]=128;sm_gens[csg].range[5]=255;
	sm_gens[csg].pdesc[6]="a6";sm_gens[csg].defvalue[6]=128;sm_gens[csg].range[6]=255;
csg++;

sm_gens[csg].fname="SSawPack";sm_gens[csg].numparams=7;
	sm_gens[csg].pdesc[0]="";sm_gens[csg].defvalue[0]=220;sm_gens[csg].range[0]=1760;
	sm_gens[csg].pdesc[1]="a1";sm_gens[csg].defvalue[1]=128;sm_gens[csg].range[1]=255;
	sm_gens[csg].pdesc[2]="a2";sm_gens[csg].defvalue[2]=128;sm_gens[csg].range[2]=255;
	sm_gens[csg].pdesc[3]="a3";sm_gens[csg].defvalue[3]=128;sm_gens[csg].range[3]=255;
	sm_gens[csg].pdesc[4]="a4";sm_gens[csg].defvalue[4]=128;sm_gens[csg].range[4]=255;
	sm_gens[csg].pdesc[5]="a5";sm_gens[csg].defvalue[5]=128;sm_gens[csg].range[5]=255;
	sm_gens[csg].pdesc[6]="a6";sm_gens[csg].defvalue[6]=128;sm_gens[csg].range[6]=255;
csg++;

sm_gens[csg].fname="Vibrato";sm_gens[csg].numparams=2;
	sm_gens[csg].pdesc[0]="";sm_gens[csg].defvalue[0]=1;sm_gens[csg].range[0]=255;
	sm_gens[csg].pdesc[1]="";sm_gens[csg].defvalue[1]=1;sm_gens[csg].range[1]=255;
csg++;

sm_gens[csg].fname="Shift";sm_gens[csg].numparams=1;
	sm_gens[csg].pdesc[0]=", %";sm_gens[csg].defvalue[0]=1;sm_gens[csg].range[0]=100;
csg++;

sm_gens[csg].fname="Roll";sm_gens[csg].numparams=1;
	sm_gens[csg].pdesc[0]=", %";sm_gens[csg].defvalue[0]=1;sm_gens[csg].range[0]=100;
csg++;

sm_gens[csg].fname="SetSize";sm_gens[csg].numparams=1;
	sm_gens[csg].pdesc[0]="  .";sm_gens[csg].defvalue[0]=1;sm_gens[csg].range[0]=100;
csg++;

sm_gens[csg].fname="mam_LS_Filter";sm_gens[csg].numparams=1;
	sm_gens[csg].pdesc[0]="filter factor";sm_gens[csg].defvalue[0]=1;sm_gens[csg].range[0]=255;
csg++;

sm_gens[csg].fname="mam_HS_Filter";sm_gens[csg].numparams=1;
	sm_gens[csg].pdesc[0]="filter factor";sm_gens[csg].defvalue[0]=1;sm_gens[csg].range[0]=255;
csg++;

sm_gens[csg].fname="mam_Resonator";sm_gens[csg].numparams=4;
	sm_gens[csg].pdesc[0]=" ";sm_gens[csg].defvalue[0]=1;sm_gens[csg].range[0]=221;
	sm_gens[csg].pdesc[1]="";sm_gens[csg].defvalue[1]=1;sm_gens[csg].range[1]=100;
	sm_gens[csg].pdesc[2]="resonance";sm_gens[csg].defvalue[2]=1;sm_gens[csg].range[2]=255;
	sm_gens[csg].pdesc[3]="decay";sm_gens[csg].defvalue[3]=1;sm_gens[csg].range[3]=255;
csg++;

sm_gens[csg].fname="mam_Slew_Compressor";sm_gens[csg].numparams=2;
	sm_gens[csg].pdesc[0]="factor";sm_gens[csg].defvalue[0]=1;sm_gens[csg].range[0]=255;
	sm_gens[csg].pdesc[1]="limitation";sm_gens[csg].defvalue[1]=1;sm_gens[csg].range[1]=255;
csg++;

sm_gens[csg].fname="mam_Distorter";sm_gens[csg].numparams=3;
	sm_gens[csg].pdesc[0]="d.f. center";sm_gens[csg].defvalue[0]=1;sm_gens[csg].range[0]=255;
	sm_gens[csg].pdesc[1]="d.f.high";sm_gens[csg].defvalue[1]=1;sm_gens[csg].range[1]=255;
	sm_gens[csg].pdesc[2]="center pt pos";sm_gens[csg].defvalue[2]=1;sm_gens[csg].range[2]=255;
csg++;

sm_gens[csg].fname="mam_FM_Operator";sm_gens[csg].numparams=5;
	sm_gens[csg].pdesc[0]="op.freq  ";sm_gens[csg].defvalue[0]=1;sm_gens[csg].range[0]=221;
	sm_gens[csg].pdesc[1]="op.freq ";sm_gens[csg].defvalue[1]=1;sm_gens[csg].range[1]=100;
	sm_gens[csg].pdesc[2]="amp";sm_gens[csg].defvalue[2]=1;sm_gens[csg].range[2]=255;
	sm_gens[csg].pdesc[3]="mod.freq  ";sm_gens[csg].defvalue[3]=1;sm_gens[csg].range[3]=221;
	sm_gens[csg].pdesc[4]="mod.freq ";sm_gens[csg].defvalue[4]=1;sm_gens[csg].range[4]=100;
csg++;

sm_gens[csg].fname="mam_HP_Filter";sm_gens[csg].numparams=2;
	sm_gens[csg].pdesc[0]=" ";sm_gens[csg].defvalue[0]=1;sm_gens[csg].range[0]=221;
	sm_gens[csg].pdesc[1]="";sm_gens[csg].defvalue[1]=1;sm_gens[csg].range[1]=100;
csg++;

sm_gens[csg].fname="mam_LP_Filter";sm_gens[csg].numparams=2;
	sm_gens[csg].pdesc[0]="utoff";sm_gens[csg].defvalue[0]=127;sm_gens[csg].range[0]=256;
	sm_gens[csg].pdesc[1]="resonance";sm_gens[csg].defvalue[1]=127;sm_gens[csg].range[1]=256;
csg++;

sm_gens[csg].fname="mam_Normalise";sm_gens[csg].numparams=0;
csg++;

sm_gens[csg].fname="mam_EasyLoop";sm_gens[csg].numparams=1;
	sm_gens[csg].pdesc[0]="smooth";sm_gens[csg].defvalue[0]=127;sm_gens[csg].range[0]=255;
csg++;

sm_gens[csg].fname="mam_LP_Filter2";sm_gens[csg].numparams=7;
	sm_gens[csg].pdesc[0]="utoff";sm_gens[csg].defvalue[0]=127;sm_gens[csg].range[0]=256;
	sm_gens[csg].pdesc[1]="resonance";sm_gens[csg].defvalue[1]=127;sm_gens[csg].range[1]=256;
	sm_gens[csg].pdesc[2]="cutoffSpd";sm_gens[csg].defvalue[2]=127;sm_gens[csg].range[2]=256;
	sm_gens[csg].pdesc[3]="cutoffAmp";sm_gens[csg].defvalue[3]=127;sm_gens[csg].range[3]=256;
	sm_gens[csg].pdesc[4]="resoSpd";sm_gens[csg].defvalue[4]=127;sm_gens[csg].range[4]=256;
	sm_gens[csg].pdesc[5]="resoAmp";sm_gens[csg].defvalue[5]=127;sm_gens[csg].range[5]=256;
	sm_gens[csg].pdesc[6]="Phaze";sm_gens[csg].defvalue[6]=127;sm_gens[csg].range[6]=256;
csg++;

stfunc_count=csg;

char st[100];
SendDlgItemMessage(SSynth_UIDlg,IDC_SCOM,LB_RESETCONTENT,0,0);
for (int n=0;n<stfunc_count;n++) 
{
	strcpy(st,sm_gens[n].fname);
	SendDlgItemMessage(SSynth_UIDlg,IDC_SCOM,LB_ADDSTRING,0,(LPARAM) st);
}

//
sbuf=new short int [44100*2*300];
sbuf=sbuf+44100*2*10;
svbuf=new unsigned char [256*256*4];

double a;
for (int x=0;x<44100;x++)
	{
	a=0;//(32767-2*x*32767.0/44100.0)*sin((double(x))/30.0);
	*(sbuf+x*2)=(short int)a;
	}

SST_init();

spos=0;
szoom=256;
RECT r;
GetWindowRect(GetDlgItem(SSynth_UIDlg,IDC_SW),&r);
swmid=(r.bottom-r.top)/2;
swd=r.right-r.left;

SendDlgItemMessage (SSynth_UIDlg,IDC_SZOOM,TBM_SETRANGE,TRUE,MAKELONG(0,160));
SendDlgItemMessage (SSynth_UIDlg,IDC_SPOS,TBM_SETRANGE,TRUE,MAKELONG(0,255));

SUI_param_ctrls[0].pdesc=IDC_SPNAME1;
SUI_param_ctrls[0].pslider=IDC_SPSLIDER1;
SUI_param_ctrls[0].pplus=IDC_SPPLUS1;
SUI_param_ctrls[0].pminus=IDC_SPMINUS1;
SUI_param_ctrls[0].pnumview=IDC_SPEDIT1;

SUI_param_ctrls[1].pdesc=IDC_SPNAME2;
SUI_param_ctrls[1].pslider=IDC_SPSLIDER2;
SUI_param_ctrls[1].pplus=IDC_SPPLUS2;
SUI_param_ctrls[1].pminus=IDC_SPMINUS2;
SUI_param_ctrls[1].pnumview=IDC_SPEDIT2;

SUI_param_ctrls[2].pdesc=IDC_SPNAME3;
SUI_param_ctrls[2].pslider=IDC_SPSLIDER3;
SUI_param_ctrls[2].pplus=IDC_SPPLUS3;
SUI_param_ctrls[2].pminus=IDC_SPMINUS3;
SUI_param_ctrls[2].pnumview=IDC_SPEDIT3;

SUI_param_ctrls[3].pdesc=IDC_SPNAME4;
SUI_param_ctrls[3].pslider=IDC_SPSLIDER4;
SUI_param_ctrls[3].pplus=IDC_SPPLUS4;
SUI_param_ctrls[3].pminus=IDC_SPMINUS4;
SUI_param_ctrls[3].pnumview=IDC_SPEDIT4;

SUI_param_ctrls[4].pdesc=IDC_SPNAME5;
SUI_param_ctrls[4].pslider=IDC_SPSLIDER5;
SUI_param_ctrls[4].pplus=IDC_SPPLUS5;
SUI_param_ctrls[4].pminus=IDC_SPMINUS5;
SUI_param_ctrls[4].pnumview=IDC_SPEDIT5;

SUI_param_ctrls[5].pdesc=IDC_SPNAME6;
SUI_param_ctrls[5].pslider=IDC_SPSLIDER6;
SUI_param_ctrls[5].pplus=IDC_SPPLUS6;
SUI_param_ctrls[5].pminus=IDC_SPMINUS6;
SUI_param_ctrls[5].pnumview=IDC_SPEDIT6;

SUI_param_ctrls[6].pdesc=IDC_SPNAME7;
SUI_param_ctrls[6].pslider=IDC_SPSLIDER7;
SUI_param_ctrls[6].pplus=IDC_SPPLUS7;
SUI_param_ctrls[6].pminus=IDC_SPMINUS7;
SUI_param_ctrls[6].pnumview=IDC_SPEDIT7;

}

