#include "vd\viewport.h"

BYTE* Mptr;

unsigned char msec_l, msec_h;

LoadTextureToGPU(BYTE* mptr,int index)
{
bool rr;
  D3DLOCKED_RECT tl;
  rr=pTexture[index]->LockRect(0,&tl,NULL,D3DLOCK_DISCARD);
  for (int y=0;y<tsize;y++)
  {
	memcpy ((BYTE*)tl.pBits+y*tl.Pitch,mptr+tsize*4*y,tsize*4);
  }
  pTexture[index]->UnlockRect(0);
  //SetWindowPos(Parent_hWnd,HWND_TOP,GetSystemMetrics(SM_CXSCREEN)/2-(42+index*3)/2,GetSystemMetrics(SM_CYSCREEN)/2-42/2,42+index*3,22,SWP_DRAWFRAME);
  //SetWindowText(Parent_hWnd,"Painting textures...");
}

void CrtTexture(unsigned char index,short int size,unsigned char type)
{
if (type==0) pDevice->CreateTexture(size,size,0,0,D3DFMT_A8R8G8B8,D3DPOOL_MANAGED,&pTexture[index],NULL);
if (type==1) pDevice->CreateTexture(size,size,0,D3DUSAGE_RENDERTARGET,D3DFMT_A8R8G8B8,D3DPOOL_DEFAULT,&pTexture[index],NULL);
//tsize=size;
//texture_stagenum=1;Mptr=texture_tmp+texture_stagenum*tsize*tsize*4;
current_texture=index;
}

int fnum,arg[10];char txs[32];



void ExecTexCommand()
{
//process functions

switch (fnum)
{
case 1:Cells			(Mptr,arg[1],arg[2],arg[3],arg[4]);break;
case 2:Plasm			(Mptr,arg[1],arg[2],arg[3],arg[4]);break;
case 3:ChessField		(Mptr,arg[1],arg[2]);break;
case 4:Mandelbrot		(Mptr,arg[1],arg[2],arg[3],arg[4]);break;
case 5:Julia			(Mptr,arg[1],arg[2]);break;
case 6:List				(Mptr,arg[1],arg[2],arg[3],arg[4],arg[5],arg[6],arg[7]);break;
case 7:Clouds			(Mptr,arg[1],arg[2],arg[3]);break;
case 8:LGradient		(Mptr,arg[1],arg[2],arg[3],arg[4],arg[5],arg[6]);break;
case 9:RenderScene		(Mptr,arg[1],arg[2]);break;

case 11:Box				(Mptr,arg[1],arg[2],arg[3],arg[4],arg[5],arg[6],arg[7]);break;
case 12:Circle			(Mptr,arg[1],arg[2],arg[3],arg[4],arg[5],arg[6]);break;
case 13:AddParticle		(Mptr,arg[1],arg[2],arg[3],arg[4],arg[5],arg[6],arg[7]);break;
case 14:AddSprite		(Mptr,arg[1],arg[2],arg[3],arg[4],arg[5]);break;
case 15:DrwTxt			(Mptr,arg[1],arg[2],arg[3],&txs[0]);break;

case 17:SolidFill		(Mptr,arg[1],arg[2],arg[3],arg[4],arg[5],arg[6]);break;
case 18:AddNoise		(Mptr,arg[1]);break;
case 19:AddStars		(Mptr,arg[1],arg[2]);break;
case 20:SinDistort		(Mptr,arg[1],arg[2],arg[3],arg[4]);break;
case 21:Twirl			(Mptr,arg[1],arg[2],arg[3],arg[4],arg[5]);break;
case 22:Lenz			(Mptr,arg[1],arg[2],arg[3],arg[4]);break;
case 23:Blur			(Mptr,arg[1],arg[2]);break;
case 24:MotionBlur		(Mptr,arg[1],arg[2]);break;
case 25:RadialBlur		(Mptr,arg[1],arg[2]);break;
case 26:Sharpen			(Mptr);break;
case 27:PShift			(Mptr,arg[1],arg[2],arg[3],arg[4]);break;
case 28:RadialPShift	(Mptr,arg[1],arg[2],arg[3],arg[4]);break;
case 29:Map2dPShift		(Mptr,arg[1],arg[2],arg[3]);break;
case 30:Map2dPShift2	(Mptr,arg[1],arg[2],arg[3],arg[4],arg[5]);break;
case 31:Median			(Mptr);break;
case 32:Dilate			(Mptr);break;
case 33:Erode			(Mptr);break;
case 34:Edge			(Mptr);break;
case 35:Emboss			(Mptr);break;
case 36:RotorZoom		(Mptr,arg[1],arg[2],arg[3],arg[4],arg[5],arg[6]);break;
case 37:Roll			(Mptr,arg[1],arg[2],arg[3]);break;
case 38:Tiling			(Mptr,arg[1],arg[2],arg[3],arg[4]);break;
case 39:Mozaic			(Mptr,arg[1]);break;
case 40:Mixer			(Mptr,arg[1],arg[2],arg[3],arg[4],arg[5]);break;
case 41:CrossFade		(Mptr,arg[1],arg[2]);break;
case 42:Clear			(Mptr);break;
case 43:ClearRGB		(Mptr);break;
case 44:CopyBlueToAlfa		(Mptr);break;
case 45:InvertAlfa		(Mptr);break;
case 46:ClearAlfa		(Mptr);break;

case 48:Invert			(Mptr);break;
case 49:ScaleColor		(Mptr,arg[1],arg[2],arg[3]);break;
case 50:AdjustColor		(Mptr,arg[1],arg[2],arg[3]);break;
case 51:SinColor		(Mptr,arg[1],arg[2],arg[3],arg[4]);break;
//case 52:SetTxBase		(arg[1],arg[2],arg[3],arg[4],arg[5],arg[7],arg[7]);break;
//case 53:SetTxAmp		(arg[1],arg[2],arg[3],arg[4],arg[5],arg[7],arg[7]);break;
//case 54:SetTxSpd		(arg[1],arg[2],arg[3],arg[4],arg[5],arg[7],arg[7]);break;
//case 55:SetTxFz		(arg[1],arg[2],arg[3],arg[4],arg[5],arg[7],arg[7]);break;
//case 56:SinAnimP		(arg[1]);break;
//case 57:AbsSinAnimP		(arg[1]);break;
//case 58:CycleSinAnimP	(arg[1]);break;
//case 59:memcpy			(Mptr,Mptr-tsize*tsize*4,tsize*tsize*4);break;
}
}

void Precalc()
{


//geometry
int f;
int numofscenes;
int p;p=0;
numofscenes=geo[p];p++;

for (current_scene=0;current_scene<numofscenes;current_scene++)
{
numofobjects[current_scene]=geo[p];p++;
for (f=0;f<numofobjects[current_scene];f++) {objects[current_scene][f].cu=geo[p];p++;}
	for (f=0;f<numofobjects[current_scene];f++) {objects[current_scene][f].cv=geo[p];p++;}
	for (f=0;f<numofobjects[current_scene];f++) {objects[current_scene][f].material=geo[p];p++;} 
		for (f=0;f<numofobjects[current_scene];f++) {objects[current_scene][f].normal=geo[p];p++;}
		for (f=0;f<numofobjects[current_scene];f++) {objects[current_scene][f].px=geo[p];p++;}
		for (f=0;f<numofobjects[current_scene];f++) {objects[current_scene][f].py=geo[p];p++;}
		
		for (f=0;f<numofobjects[current_scene];f++) {objects[current_scene][f].sx=geo[p]*256;p++;}
			for (f=0;f<numofobjects[current_scene];f++) {objects[current_scene][f].sx+=geo[p];p++;}
		for (f=0;f<numofobjects[current_scene];f++) {objects[current_scene][f].sy=geo[p]*256;p++;} 
			for (f=0;f<numofobjects[current_scene];f++) {objects[current_scene][f].sy+=geo[p];p++;}
		for (f=0;f<numofobjects[current_scene];f++) {objects[current_scene][f].sz=geo[p]*256;p++;} 
			for (f=0;f<numofobjects[current_scene];f++) {objects[current_scene][f].sz+=geo[p];p++;}
		
		for (f=0;f<numofobjects[current_scene];f++) {objects[current_scene][f].texture=geo[p];p++;}
		for (f=0;f<numofobjects[current_scene];f++) {objects[current_scene][f].type=geo[p];p++;} 
		
		for (f=0;f<numofobjects[current_scene];f++) {objects[current_scene][f].x=geo[p]*256-32768;p++;} 
			for (f=0;f<numofobjects[current_scene];f++) {objects[current_scene][f].x+=geo[p];p++;}
		for (f=0;f<numofobjects[current_scene];f++) {objects[current_scene][f].y=geo[p]*256-32768;p++;}
			for (f=0;f<numofobjects[current_scene];f++) {objects[current_scene][f].y+=geo[p];p++;} 
		for (f=0;f<numofobjects[current_scene];f++) {objects[current_scene][f].z=geo[p]*256-32768;p++;}
			for (f=0;f<numofobjects[current_scene];f++) {objects[current_scene][f].z+=geo[p];p++;} 
		
		for (f=0;f<numofobjects[current_scene];f++) {objects[current_scene][f].rendertype=geo[p];p++;}
		for (f=0;f<numofobjects[current_scene];f++) {objects[current_scene][f].ctrl_obj=geo[p];p++;} 
		for (f=0;f<numofobjects[current_scene];f++) {objects[current_scene][f].ctrl_style=geo[p];p++;}
}

for (current_scene=0;current_scene<numofscenes;current_scene++)
{
	for (int f=0;f<numofobjects[current_scene];f++)
	{
	mod0array[current_scene][f].numofmodifers=geo[p];p++;
	for (int n=0;n<mod0array[current_scene][f].numofmodifers;n++)
		{
		mod0array[current_scene][f].modifer[n].x=geo[p];p++;
		mod0array[current_scene][f].modifer[n].y=geo[p];p++;
		mod0array[current_scene][f].modifer[n].z=geo[p];p++;
		mod0array[current_scene][f].modifer[n].rad=geo[p];p++;
		mod0array[current_scene][f].modifer[n].pow=geo[p];p++;
		mod0array[current_scene][f].modifer[n].type=geo[p];p++;
		}
	}
}

p=0;
for (current_scene=0;current_scene<numofscenes;current_scene++)
{
	for (int f=0;f<numofobjects[current_scene];f++)
	{
	clone[current_scene][f].clone_count=clones_data[p];p++;
	clone[current_scene][f].clone_type=clones_data[p];p++;
	clone[current_scene][f].offset=clones_data[p];p++;
	clone[current_scene][f].offset2=clones_data[p];p++;
	}
}

current_scene=0;

	
//materials
for (int i=0;i<255;i++)
{
	Materialbank[i].Diffuse.r=materials[i*16+0]/64.0;
	Materialbank[i].Diffuse.g=materials[i*16+1]/64.0;
	Materialbank[i].Diffuse.b=materials[i*16+2]/64.0;
	Materialbank[i].Specular.r=materials[i*16+3]/64.0;
	Materialbank[i].Specular.g=materials[i*16+4]/64.0;
	Materialbank[i].Specular.b=materials[i*16+5]/64.0;
	Materialbank[i].Ambient.r=materials[i*16+6]/64.0;
	Materialbank[i].Ambient.g=materials[i*16+7]/64.0;
	Materialbank[i].Ambient.b=materials[i*16+8]/64.0;
	Materialbank[i].Power=materials[i*16+9];
	Materialbank_vertexbumplink[i]=materials[i*16+10];
	Materialbank_vertexbumpdepth[i]=materials[i*16+11];
	Materialbank_st1[i].type=materials[i*16+12];
	Materialbank_st1[i].texture=materials[i*16+13];
	Materialbank_st2[i].type=materials[i*16+14];
	Materialbank_st2[i].texture=materials[i*16+15];
}

//camera
for (i=0;i<254;i++)
{
	cam_bank[i].dist=camera_data[i*8+0]*4/256.0;
	cam_bank[i].tgt_x=camera_data[i*8+1];
	cam_bank[i].tgt_y=camera_data[i*8+2];
	cam_bank[i].tgt_z=camera_data[i*8+3];
	cam_bank[i].v_x=camera_data[i*8+4];
	cam_bank[i].v_y=camera_data[i*8+5];
	cam_bank[i].v_z=camera_data[i*8+6];
	cam_bank[i].xy_a=camera_data[i*8+7]/100.0;
}
main_cam=cam_bank[0];

/*cam_bank[85].dist=2;
cam_bank[85].tgt_x=-1855;
cam_bank[85].tgt_y=-2153;
cam_bank[85].tgt_z=-1183;
cam_bank[85].v_x=-1764;
cam_bank[85].v_y=-2156;
cam_bank[85].v_z=-1142;
cam_bank[85].xy_a=0;*/

//tracker
p=0;
for (i=0;i<900;i++)
{
	if (i==140) p=p+5*8;
	if (i==430) p=p+5*3;
	strack[0][i].num=track_data[p];p++;
	strack[0][i].p[0]=track_data[p];p++;
	strack[0][i].p[1]=track_data[p];p++;
	strack[0][i].p[2]=track_data[p];p++;
	strack[0][i].p[3]=track_data[p];p++;
}

trk_timeline_count=newtrack_data_count;
// new track loader
int ittindex=0;
for (int itt=0;itt<newtrack_data_count;itt++)
{
	trk_timeline[itt].time.min=newtrack_data[ittindex]; ittindex++;
	trk_timeline[itt].time.sec=newtrack_data[ittindex]; ittindex++;
		msec_l=newtrack_data[ittindex]; ittindex++;
		msec_h=newtrack_data[ittindex]; ittindex++;
	trk_timeline[itt].time.msec=msec_h*256+msec_l;
	trk_timeline[itt].cmdcount=newtrack_data[ittindex]; ittindex++;
	for (int jtt=0;jtt<16;jtt++)
	{
		trk_timeline[itt].trkcmdlist[jtt].trkcmd=newtrack_data[ittindex]; ittindex++;
		trk_timeline[itt].trkcmdlist[jtt].time.min=newtrack_data[ittindex]; ittindex++;
		trk_timeline[itt].trkcmdlist[jtt].time.sec=newtrack_data[ittindex]; ittindex++;
			msec_l=newtrack_data[ittindex]; ittindex++;
			msec_h=newtrack_data[ittindex]; ittindex++;
		trk_timeline[itt].trkcmdlist[jtt].time.msec=msec_h*256+msec_l;
		trk_timeline[itt].trkcmdlist[jtt].param[0]=newtrack_data[ittindex]; ittindex++;
		trk_timeline[itt].trkcmdlist[jtt].param[1]=newtrack_data[ittindex]; ittindex++;
		trk_timeline[itt].trkcmdlist[jtt].param[2]=newtrack_data[ittindex]; ittindex++;
		trk_timeline[itt].trkcmdlist[jtt].param[3]=newtrack_data[ittindex]; ittindex++;
		trk_timeline[itt].trkcmdlist[jtt].param[4]=newtrack_data[ittindex]; ittindex++;
		trk_timeline[itt].trkcmdlist[jtt].param[5]=newtrack_data[ittindex]; ittindex++;

	}
}

//Texture Loader
p=0;
int tst,ttp,np,tn;

tn=0;

for (int ttc=1;ttc<textures_count-1;ttc++)
{


Mptr=texture_tmp;

tst=tdt[p++];//  
ttp=tdt[p++];// 
tsize=32*tdt[p++];

CrtTexture(tn,tsize,ttp);
Clear(Mptr);

for (int y=1;y<tst;y++)
{

fnum=tdt[p++];//  -
np=tnp[fnum];//   -

	// 
	for (int x=0;x<np;x++)
	{
		arg[x+1]=tdt[p++];
	}
	
	//   drwtxt
	if (fnum==15)
	{
		int j=0;
		while (tdt[p]!=0) txs[j++]=tdt[p++];
		if (tdt[p]==0) {txs[j]=0;p++;}
	}
	
	Mptr=Mptr+tsize*tsize*4;
	current_texture=tn;
	ExecTexCommand();//exec tfunc
	memcpy (Mptr+tsize*tsize*4,Mptr,tsize*tsize*4);
}

if (ttp==0) LoadTextureToGPU(Mptr,tn);

tn++;

}

/*Mptr=texture_tmp;
tsize=256;
ttp=0;
CrtTexture(19,tsize,ttp);
current_texture=19;
Clear(Mptr);
Mptr=Mptr+tsize*tsize*4;RenderScene(Mptr,2,85);
RenderScene(Mptr,2,85);
memcpy (Mptr+tsize*tsize*4,Mptr,tsize*tsize*4);
Mptr=Mptr+tsize*tsize*4;AdjustColor(Mptr,128,122,255);memcpy (Mptr+tsize*tsize*4,Mptr,tsize*tsize*4);
Mptr=Mptr+tsize*tsize*4;AdjustColor(Mptr,128,125,255);memcpy (Mptr+tsize*tsize*4,Mptr,tsize*tsize*4);
Mptr=Mptr+tsize*tsize*4;AdjustColor(Mptr,128,125,255);memcpy (Mptr+tsize*tsize*4,Mptr,tsize*tsize*4);
Mptr=Mptr+tsize*tsize*4;AdjustColor(Mptr,128,125,255);memcpy (Mptr+tsize*tsize*4,Mptr,tsize*tsize*4);
Mptr=Mptr+tsize*tsize*4;AdjustColor(Mptr,128,125,255);memcpy (Mptr+tsize*tsize*4,Mptr,tsize*tsize*4);
Mptr=Mptr+tsize*tsize*4;AdjustColor(Mptr,128,125,255);memcpy (Mptr+tsize*tsize*4,Mptr,tsize*tsize*4);
Mptr=Mptr+tsize*tsize*4;AdjustColor(Mptr,128,125,255);memcpy (Mptr+tsize*tsize*4,Mptr,tsize*tsize*4);
Mptr=Mptr+tsize*tsize*4;AdjustColor(Mptr,128,125,255);memcpy (Mptr+tsize*tsize*4,Mptr,tsize*tsize*4);
Mptr=Mptr+tsize*tsize*4;AdjustColor(Mptr,128,125,255);memcpy (Mptr+tsize*tsize*4,Mptr,tsize*tsize*4);
Mptr=Mptr+tsize*tsize*4;CopyBlueToAlfa(Mptr);memcpy (Mptr+tsize*tsize*4,Mptr,tsize*tsize*4);
Mptr=Mptr+tsize*tsize*4;Mixer(Mptr,1,11,255,0,1); memcpy (Mptr+tsize*tsize*4,Mptr,tsize*tsize*4);
LoadTextureToGPU(Mptr,19);

Mptr=texture_tmp;
tsize=512;
ttp=0;
current_texture=19;
CrtTexture(140,tsize,ttp);
Clear(Mptr);
Mptr=Mptr+tsize*tsize*4;RenderScene(Mptr,15,9);RenderScene(Mptr,15,9);memcpy (Mptr+tsize*tsize*4,Mptr,tsize*tsize*4);
Mptr=Mptr+tsize*tsize*4;Box(Mptr,127,127,255,161,255,255,255);memcpy (Mptr+tsize*tsize*4,Mptr,tsize*tsize*4);
Mptr=Mptr+tsize*tsize*4;CopyBlueToAlfa(Mptr);memcpy (Mptr+tsize*tsize*4,Mptr,tsize*tsize*4);
Mptr=Mptr+tsize*tsize*4;Mixer(Mptr,1,1,62,196,0);memcpy (Mptr+tsize*tsize*4,Mptr,tsize*tsize*4);
Mptr=Mptr+tsize*tsize*4;AdjustColor(Mptr,128,104,202);memcpy (Mptr+tsize*tsize*4,Mptr,tsize*tsize*4);
LoadTextureToGPU(Mptr,140);*/

tsize=512;
ttp=1;
current_texture=140;
CrtTexture(140,tsize,ttp);

}
