void RenderScene(BYTE* mp,int scn,int camn)
{	
	int tc,ts,cv;
	if (scn<128)//  -  (   !)
	{
		rt_captureflag=1;rt_capture_desttexture=current_texture;
		ts=current_scene;tc=current_cam;
		current_scene=scn;current_cam=camn;
		tmp_main_cam=main_cam;main_cam=cam_bank[current_cam];
		
		cv=clean_view;clean_view=1;

			DrawScene();
			clean_view=cv;

		BYTE* dstaddr;int t;
		//dstaddr=mp;//texture_tmp+texture_stagenum*tsize*tsize*4;
		dstaddr=texture_tmp+texture_stagenum*tsize*tsize*4; //for runtime
		t=tsize*tsize;

		_asm{
		mov ecx,t
			mov edi,dstaddr
			mov esi,FC
		lp:
			mov eax,[esi]
				mov [edi],ax
				shr eax,16
				mov [edi+2],al
				add edi,4
				add esi,4
			loop lp
			}

		rt_captureflag=0;current_scene=ts;current_cam=tc;
		main_cam=tmp_main_cam;
	}

}

void SinDistort(BYTE *dst,int xamp,int xfreq,int yamp,int yfreq)
{
int x,y,x1,y1,tyc;
xamp=xamp*tsize/256;yamp=yamp*tsize/256;
xfreq=xfreq*256/tsize;yfreq=yfreq*256/tsize;

BYTE* src;
src=dst-tsize*tsize*4;

for (y=0;y<tsize;y++)
{
	tyc=yamp*sin(y*yfreq/32.0*3.14/180.0);
for (x=0;x<tsize;x++)
	{
		y1=y+xamp*sin(x*xfreq/32.0*3.14/180.0);
		x1=x+tyc;
		
		while (x1<0) x1+=tsize;while (y1<0) y1+=tsize;
		while (x1>=tsize) x1-=tsize;while (y1>=tsize) y1-=tsize;

		get_rgb(src,x1,y1);
		place_rgb(dst,x,y);
	}
}
}



void RotorZoom (BYTE *dst,int xxx,int yyy,int p1,int p2,int p3,int p4)
{
int x,y,r,g,b,a,addr;double alfa,c,d,dx,dy,tx,ty,rtx,rty,mtx,mty;
int addr1,addr2;
_asm{finit};

BYTE* src;
src=dst-tsize*tsize*4;

addr=0;
xxx=(255.0-xxx)*tsize/256.0;yyy=(255.0-yyy)*tsize/256.0;
xxx-=tsize/2;yyy-=tsize/2;
xxx=xxx*p2/64.0;yyy=yyy*p2/64.0;
alfa=p1*360.0/256.0;
dx=cos(alfa*3.14/180.0)*p2/64.0;
dy=sin(alfa*3.14/180.0)*p2/64.0;

rtx=tsize/2+1.4*tsize/2*sin((alfa-45)*3.14/180.0)*p2/64.0+xxx*cos(-alfa*3.14/180)+yyy*sin(-alfa*3.14/180);
rty=tsize/2-1.4*tsize/2*cos((alfa-45)*3.14/180.0)*p2/64.0+yyy*cos(alfa*3.14/180)+xxx*sin(alfa*3.14/180);

  for (y=0;y<tsize;y++)
  {
	tx=rtx;ty=rty;
	for (x=0;x<tsize;x++)
	{
	mtx=tx*(double)p3/64.0;
	mty=ty*(double)p4/64.0;

	if (mtx<tsize&&mtx>=0&&mty<tsize&&mty>=0) 
		{
		addr1=(int)mtx*4+(int)mty*4*tsize;
		addr2=(int)x*4+(int)y*4*tsize;
		_asm {
			mov edi,src
			mov edx,addr1
			add edi,edx
			xor eax,eax
			mov eax,[edi]
			mov edi,dst
			mov edx,addr2
			add edi,edx
			mov [edi],ax
			shr eax,16
			mov [edi+2],al
			}
		}
	else
		{
		//_rgb=0;
		addr2=(int)x*4+(int)y*4*tsize;
		_asm{ mov eax,0
			mov edx,addr2
			mov edi,dst
			mov [edi+edx],ax
			add edi,2
			mov [edi+edx],al
			}
		
	//	goto qwer;
		}

	qwer:;
	  tx+=dx;ty+=dy;
	}
	rtx-=dy;
	rty+=dx;
  }
}

void Twirl (BYTE *dst,int xxx,int yyy,int p1,int skrut,int rad)
{
int x,y,r,g,b,a,addr;double c,d,dx,dy;
addr=0;
xxx=xxx*tsize/256;yyy=yyy*tsize/256;
rad=rad*tsize/256;

memcpy(dst,dst-tsize*tsize*4,tsize*tsize*4);
	for (y=0;y<tsize;y++)
	for (x=0;x<tsize;x++)
	{
		dx=x-xxx;
		dy=y-yyy;
		d=sqrt(dx*dx+dy*dy);
		if (d>rad) goto q;
		c=atan2(dy,dx);
		c=c+(p1-128)*360.0/256.0*3.14/180.0+(((double)(rad-d))/((double)rad))*(skrut-128)*360/256*3.14/180;
		dx=xxx+d*cos(c);
		dy=yyy+d*sin(c);
		if (dx>=tsize) goto q;if (dx<0) goto q;
		if (dy>=tsize) goto q;if (dy<0) goto q;

		get_rgb(dst-tsize*tsize*4,dx,dy);
		place_rgb(dst,x,y);
q:;
	}
}


void Lenz (BYTE *dst,int xxx,int yyy,int p1,int p2)
{
int x,y,r,g,b,a,addr;double c,d,dx,dy;double xp;
addr=0;
xxx=xxx*tsize/256;yyy=yyy*tsize/256;
p2=p2*tsize/256;
xp=4*(p1-128)/128.0;
if (p2==0) p2=1;
memcpy(dst,dst-tsize*tsize*4,tsize*tsize*4);
	for (y=0;y<tsize;y++)
	for (x=0;x<tsize;x++)
	{
		dx=x-xxx;
		dy=y-yyy;
		d=sqrt(dx*dx+dy*dy);
		if (d>p2) goto q;
		d=p2-d;
		d=1+xp*d/p2;
		dx=xxx+dx*d;
		dy=yyy+dy*d;
		if (dx>=tsize) goto q;if (dx<0) goto q;
		if (dy>=tsize) goto q;if (dy<0) goto q;
	//-		
		get_rgb(dst-tsize*tsize*4,dx,dy);
		place_rgb(dst,x,y);
q:;
	}
}


void Blur(BYTE *buf,int count,int comp)
{
__int64 maska1=0x007f7f7f007f7f7f;
__int64 maska2=0x001f1f1f001f1f1f;
__int64 maska3=0xff000000ff000000;
BYTE* tpt;
	__int64 ms;double jh;

	ms=(__int64)comp;
	ms=ms|(ms*256);
	ms=ms|(ms*65536);
	ms=ms|(ms*65536*256);
	ms=ms|(ms*65536*65536);

	ZeroMemory(texture_swp,tsize*tsize*4);
	memcpy(texture_swp+tsize*tsize*4,buf-tsize*tsize*4,tsize*tsize*4);
	ZeroMemory(texture_swp+2*tsize*tsize*4,tsize*tsize*4);
	tpt=texture_swp+tsize*tsize*4-tsize*4;

for (int i=0;i<count;i++)
{
	int buf_len=(tsize+2)*tsize*4/8;
	int scan_len=tsize*4;
	int lastlineofs=(tsize-1)*tsize*4;

	_asm{
				movq mm0,maska1
				movq mm1,maska2
				movq mm6,maska3
				movq mm7,ms
				
				mov edi,tpt
				mov esi,edi
				mov edx,scan_len

				mov eax,edi
				mov ebx,edi
				mov ecx,i
				add ecx,ecx
				add ecx,ecx
				add eax,ecx
				sub ebx,ecx
				shr ecx,2
				inc ecx

				push ecx
			lp2:
				sub esi,edx
				loop lp2

				pop ecx
				shr ecx,3
				inc ecx

			lp3:
				add edi,edx
				loop lp3

				

				mov edx,tpt


				mov ecx,buf_len
			lp: 
				movq mm2,[edi]
				movq mm3,[eax]
				movq mm4,[ebx]
				movq mm5,[esi]

				psrlq mm2,1
				psrlq mm3,3
				psrlq mm4,3
				psrlq mm5,3
				pand mm2,mm0
				pand mm3,mm1
				pand mm4,mm1
				pand mm5,mm1

				paddusb mm2,mm3
				paddusb mm2,mm4
				paddusb mm2,mm5

				paddusb mm2,mm7


				movq mm3,[edx]
				psrlq mm3,3
				pand mm3,mm1
				paddusb mm2,mm3


//mask alfa
				movq mm3,[edx]
				pand mm3,mm6
				por mm2,mm3
				
//
				movq [edx],mm2

				add edi,8
				add esi,8

				add eax,8
				add ebx,8
				add edx,8

				dec ecx
				jnz lp
		emms			
		}
}
memcpy(buf,texture_swp+tsize*tsize*4,tsize*tsize*4);
}

void MotionBlur(BYTE *buf,int count,int comp)
{
__int64 maska1=0x007f7f7f007f7f7f;
__int64 maska2=0x001f1f1f001f1f1f;
__int64 maska3=0xff000000ff000000;
BYTE* tpt;
	__int64 ms;double jh;

	ms=(__int64)comp;
	ms=ms|(ms*256);
	ms=ms|(ms*65536);
	ms=ms|(ms*65536*256);
	ms=ms|(ms*65536*65536);

	ZeroMemory(texture_swp,tsize*tsize*4);
	memcpy(texture_swp+tsize*tsize*4,buf-tsize*tsize*4,tsize*tsize*4);
	tpt=texture_swp+tsize*tsize*4-tsize*4;
	ZeroMemory(texture_swp+2*tsize*tsize*4,tsize*tsize*4);

for (int i=0;i<count;i++)
{
	int buf_len=(tsize+2)*tsize*4/8;
	int scan_len=tsize*4;
	int lastlineofs=(tsize-1)*tsize*4;

	_asm{
				movq mm0,maska1
				movq mm1,maska2
				movq mm6,maska3
				movq mm7,ms
				
				mov edi,tpt
				mov esi,edi
				mov edx,scan_len

				mov eax,edi
				mov ebx,edi
				mov ecx,i
				add ecx,ecx
				add ecx,ecx
				add eax,ecx
				sub ebx,ecx

				mov edx,tpt


				mov ecx,buf_len
			lp: 
				movq mm2,[edi]
				movq mm3,[eax]
				movq mm4,[ebx]
				movq mm5,[esi]

				psrlq mm2,1
				psrlq mm3,3
				psrlq mm4,3
				psrlq mm5,3
				pand mm2,mm0
				pand mm3,mm1
				pand mm4,mm1
				pand mm5,mm1

				paddusb mm2,mm3
				paddusb mm2,mm4
				paddusb mm2,mm5

				paddusb mm2,mm7


				movq mm3,[edx]
				psrlq mm3,3
				pand mm3,mm1
				paddusb mm2,mm3


//mask alfa
				movq mm3,[edx]
				pand mm3,mm6
				por mm2,mm3
				
//
				movq [edx],mm2

				add edi,8
				add esi,8

				add eax,8
				add ebx,8
				add edx,8

				dec ecx
				jnz lp
		emms			
		}
}
memcpy(buf,texture_swp+tsize*tsize*4,tsize*tsize*4);
}


void PShift(BYTE *dst,int p1,int p2,int p3,int p4)
{
int x,y,u,m,mr,mg,mb,ur,ug,ub,ur1,ug1,ub1;
BYTE* src;
src=dst-tsize*tsize*4;

p1=p1*tsize/256;
p2=p2*tsize/256;
p3=p3*tsize/256;

for (y=0;y<tsize;y++)
for (x=0;x<tsize;x++)
	{
		mr=peekb(x*4+y*4*tsize+src)*p1/64;
		mg=peekb(x*4+y*4*tsize+src+1)*p2/64;
		mb=peekb(x*4+y*4*tsize+src+2)*p3/64;

		ur=peekb(x*4+4*(int)(mr)+y*4*tsize+src);
		ug=peekb(x*4+4*(int)(mg)+y*4*tsize+src+1);
		ub=peekb(x*4+4*(int)(mb)+y*4*tsize+src+2);

		ur1=ur*p4/255+(ur+ug+ub)*(255-p4)/255/3;
		ug1=ug*p4/255+(ur+ug+ub)*(255-p4)/255/3;
		ub1=ub*p4/255+(ur+ug+ub)*(255-p4)/255/3;

		pokeb(x*4+y*4*tsize+0+dst,ur1);
		pokeb(x*4+y*4*tsize+1+dst,ug1);
		pokeb(x*4+y*4*tsize+2+dst,ub1);
	}
}

void RadialPShift(BYTE *dst,int p1,int p2,int p3,int p4)
{
int x,y,u,m,mr,mg,mb,dx,dy,d,ur,ug,ub,ur1,ug1,ub1;
BYTE* src;
src=dst-tsize*tsize*4;

p1=p1*tsize/256;
p2=p2*tsize/256;
p3=p3*tsize/256;

for (y=0;y<tsize;y++)
for (x=0;x<tsize;x++)
	{
		mr=peekb(x*4+y*4*tsize+src)*p1;
		mg=peekb(x*4+y*4*tsize+src+1)*p2;
		mb=peekb(x*4+y*4*tsize+src+2)*p3;
		
		dx=x-tsize/2;dy=y-tsize/2;dx=tsize/2+dx*65536/(65536+mr);dy=tsize/2+dy*65536/(65536+mr);
		if (dx>=tsize) dx=tsize-1;if (dx<0) dx=0;if (dy>=tsize) dy=tsize-1;if (dy<0) dy=0;
		ur=peekb(dx*4+dy*4*tsize+src);

		dx=x-tsize/2;dy=y-tsize/2;dx=tsize/2+dx*65536/(65536+mg);dy=tsize/2+dy*65536/(65536+mg);
		if (dx>=tsize) dx=tsize-1;if (dx<0) dx=0;if (dy>=tsize) dy=tsize-1;if (dy<0) dy=0;
		ug=peekb(dx*4+dy*4*tsize+src+1);

		dx=x-tsize/2;dy=y-tsize/2;dx=tsize/2+dx*65536/(65536+mb);dy=tsize/2+dy*65536/(65536+mb);
		if (dx>=tsize) dx=tsize-1;if (dx<0) dx=0;if (dy>=tsize) dy=tsize-1;if (dy<0) dy=0;
		ub=peekb(dx*4+dy*4*tsize+src+2);

		ur1=ur*p4/255+(ur+ug+ub)*(255-p4)/255/3;
		ug1=ug*p4/255+(ur+ug+ub)*(255-p4)/255/3;
		ub1=ub*p4/255+(ur+ug+ub)*(255-p4)/255/3;

		pokeb(x*4+y*4*tsize+0+dst,ur1);
		pokeb(x*4+y*4*tsize+1+dst,ug1);
		pokeb(x*4+y*4*tsize+2+dst,ub1);
q:;
	}
}

void RadialBlur(BYTE *dst,int p1,int p2)
{
int x,y,u,m,mr,mg,mb,dx,dy,d,ur,ug,ub;
p2=255-p2;

BYTE* src;
src=dst-tsize*tsize*4;
memcpy(dst,src,tsize*tsize*4);

for (int i=0;i<p1;i++)
{
memcpy(texture_swp,dst,tsize*tsize*4);

for (y=0;y<tsize;y++)
for (x=0;x<tsize;x++)
	{
		m=p2;
		dx=tsize/2+(x-tsize/2)*m/255.0;
		dy=tsize/2+(y-tsize/2)*m/255.0;
		if (dx>=tsize||dx<1||dy>=tsize||dy<1) goto q;

		for (u=0;u<3;u++)
			{
			ur=(peekb(x*4+y*4*tsize+dst+u)*4+
				peekb((dx+1)*4+dy*4*tsize+texture_swp+u)+
				peekb((dx-1)*4+dy*4*tsize+texture_swp+u)+
				peekb(dx*4+(dy+1)*4*tsize+texture_swp+u)+
				peekb(dx*4+(dy-1)*4*tsize+texture_swp+u))/8;
			pokeb(x*4+y*4*tsize+u+dst,ur);
			}
		q:;
	}
}

}


void Roll(BYTE *dst,int tlofx,int tlofy,int flip)
{
int x,y,u,r1,c1,c2,dx,dy,d,tx,ty,rtx,rty,fl;
BYTE* src;
src=dst-tsize*tsize*4;
memcpy(dst,src,tsize*tsize*4);

tlofx++;tlofy++;
tlofx=tlofx*tsize/256;tlofy=tlofy*tsize/256;
tlofy=((tsize-tlofy)-tsize/2)*2;

for (y=0;y<tsize;y++) 
	{
	for (x=0;x<tsize;x++) 
		{
		dx=x+tlofx;if (dx>=tsize) dx-=tsize;if (dx<0) dx+=tsize;
		dy=y+tlofy;if (dy>=tsize) dy-=tsize;if (dy<0) dy+=tsize;
		if (flip==0) for (fl=0;fl<3;fl++) pokeb (x*4+y*4*tsize+dst+fl,peekb(src+dx*4+dy*4*tsize+fl));
		if (flip==1) for (fl=0;fl<3;fl++) pokeb ((tsize-x-1)*4+y*4*tsize+dst+fl,peekb(src+dx*4+dy*4*tsize+fl));
		if (flip==2) for (fl=0;fl<3;fl++) pokeb (x*4+(tsize-y-1)*4*tsize+dst+fl,peekb(src+dx*4+dy*4*tsize+fl));
		if (flip==3) for (fl=0;fl<3;fl++) pokeb ((tsize-x-1)*4+(tsize-y-1)*4*tsize+dst+fl,peekb(src+dx*4+dy*4*tsize+fl));
		}
	}
}


void Tiling(BYTE *dst,int tlofx,int tlofy,int anglestep, int mixtype)
{
int x,y,u,r1,c1,c2,dx,dy,d,tx,ty;int ts;
double rtx,rty;
double angle;

Roll(dst,tlofx,tlofy,0);


ts=tsize*tsize;
_asm{
mov ecx,ts
mov eax,0
mov edi,texture_swp
mov esi,dst

lppp:
		mov [edi],ax
		mov [edi+2],al
		mov bl,[esi+3]
		mov [edi+3],bl
		add edi,4
		add esi,4
		loop lppp
}

anglestep=anglestep*360/256;
if (anglestep<15) anglestep=15;
for (angle=0;angle<360;angle+=anglestep)
{
for (y=0;y<tsize;y++)
for (x=0;x<tsize;x++)
	{
	    rtx=(x-tsize/2)*cos(angle*grt)-(y-tsize/2)*sin(angle*grt)+tsize/2;
		rty=(x-tsize/2)*sin(angle*grt)+(y-tsize/2)*cos(angle*grt)+tsize/2;
		if (rtx>0&&rtx<tsize&&rty>0&&rty<tsize)	get_rgb(dst,(int)rtx,(int)rty); else _rgb=0;
		if (mixtype==0) add_rgb(texture_swp,x,y);
		if (mixtype==1) placeif1_rgb(texture_swp,x,y);
	}

}
memcpy(dst,texture_swp,tsize*tsize*4);
}

//--------------------------------
int dp[5];

void insert_sort(int a)
{
	if (a<=dp[4]) return;
  if (a<=dp[3]) { dp[4]=a; return;}

  for (int t=0;t<2;t++)
	
		if (a>dp[t]) {
    for (int i=3;i<t;i--) dp[i+1]=dp[i];
    dp[t]=a;
    return;
		}

  dp[4]=dp[3];
  dp[3]=a;
return;
}

void Median(BYTE *dst)
{
int x,y,ym,yp,xm,xp,u;
BYTE* src;
src=dst-tsize*tsize*4;
		 
  for (y=0;y<tsize;y++)
	{
		ym=y-1;	if (ym<0) ym=0;//tsize-1;
		yp=y+1; if (yp>=tsize) yp=tsize-1;//0;
		for (x=0;x<tsize;x++)
		{
	    xm=x-1; if (xm<0) xm=0;//tsize-1;
		  xp=x+1; if (xp>=tsize) xp=tsize-1;//0;

		  for (u=0;u<3;u++)
		  {
			dp[0]=peekb(src + xm*3 +ym*3*256 + u);
			insert_sort(peekb(src + x*4 +ym*4*tsize+ u));
			insert_sort(peekb(src + xp*4+ym*4*tsize+ u));
			insert_sort(peekb(src + xm*4+y*4*tsize + u));
			insert_sort(peekb(src + x*4 +y*4*tsize + u));
			insert_sort(peekb(src + xp*4+y*4*tsize + u));
			insert_sort(peekb(src + xm*4 +yp*4*tsize + u));
			insert_sort(peekb(src + x*4 +yp*4*tsize + u));
			insert_sort(peekb(src + xp*4 +yp*4*tsize+ u));
			pokeb(dst+x*4+y*4*tsize+u,dp[4]);
			dp[0]=0; dp[1]=0; dp[2]=0; dp[3]=0; dp[4]=0;
		  }
		  pokeb(dst+x*4+y*tsize*4+3,peekb(src+x*4+y*tsize*4+3));
		}
  }

}
//-----------

void Dilate(BYTE *dst)
{
	int x,y,ym,yp,xm,xp;
	int r1,g1,b1,r,g,b,u;
BYTE* src;
src=dst-tsize*tsize*4;

  for (y=0;y<tsize;y++)
	{
		ym=y-1;	if (ym<0) ym=0;//256-1;
		yp=y+1; if (yp>=tsize) yp=tsize-1;//0;
		for (x=0;x<tsize;x++)
		{

		  for (u=0;u<3;u++)
		  {
			xm=x-1; if (xm<0) xm=0;//256-1;
			xp=x+1; if (xp>=tsize) xp=tsize-1;//0;
			r=peekb(src+xm*4+ym*4*tsize+u);
			r1=peekb(src+x*4+ym*4*tsize+u);			if (r1>r) r=r1;
			r1=peekb(src+xp*4+ym*4*tsize+u);		if (r1>r) r=r1;
			r1=peekb(src+xm*4+y*4*tsize+u);			if (r1>r) r=r1;
    		r1=peekb(src+x*4+y*4*tsize+u);			if (r1>r) r=r1;
    		r1=peekb(src+xp*4+y*4*tsize+u);			if (r1>r) r=r1;
    		r1=peekb(src+xm*4+yp*4*tsize+u);		if (r1>r) r=r1;
			r1=peekb(src+x*4+yp*4*tsize+u);			if (r1>r) r=r1;
			r1=peekb(src+xp*4+yp*4*tsize+u);	 	if (r1>r) r=r1;

			pokeb(dst+x*4+y*4*tsize+u,r);
		  }
		  pokeb(dst+x*4+y*tsize*4+3,peekb(src+x*4+y*tsize*4+3));
		}
	}
}


void Erode(BYTE *dst)
{
	int x,y,ym,yp,xm,xp;
  int r1,g1,b1,r,g,b,u;
BYTE* src;
src=dst-tsize*tsize*4;

  for (y=0;y<tsize;y++)
	{
		ym=y-1;	if (ym<0) ym=0;//256-1;
		yp=y+1; if (yp>=tsize) yp=tsize-1;//0;
		for (x=0;x<tsize;x++)
		{
	    xm=x-1; if (xm<0) xm=0;//256-1;
		  xp=x+1; if (xp>=tsize) xp=tsize-1;//0;

		  for (u=0;u<3;u++)
		  {
			r =peekb(src+xm*4+ym*4*tsize+u);
			r1=peekb(src+x*4+ym*4*tsize+u);		if (r1<r) r=r1;
			r1=peekb(src+xp*4+ym*4*tsize+u);	if (r1<r) r=r1;
			r1=peekb(src+xm*4+y*4*tsize+u);		if (r1<r) r=r1;
			r1=peekb(src+x*4+y*4*tsize+u);		if (r1<r) r=r1;
			r1=peekb(src+xp*4+y*4*tsize+u);		if (r1<r) r=r1;
			r1=peekb(src+xm*4+yp*4*tsize+u);	if (r1<r) r=r1;
			r1=peekb(src+x*4+yp*4*tsize+u);		if (r1<r) r=r1;
			r1=peekb(src+xp*4+yp*4*tsize+u);	if (r1<r) r=r1;
			
			pokeb(dst+x*4+y*4*tsize+u,r);
		  }    
		  pokeb(dst+x*4+y*tsize*4+3,peekb(src+x*4+y*tsize*4+3));
		}
	}
}

//---------

void Edge(BYTE *dst)
{
BYTE* src;
src=dst-tsize*tsize*4;
  int r,g,b,x,y;
  int xp,xm,yp,ym,u;

  for (y=0;y<tsize;y++)
  {
    for (x=0;x<tsize;x++)
    {
			xm=1;	if (x==0) xm=0;//-tsize;
			xp=1;	if (x==tsize) xp=0;//-tsize;
			ym=1;	if (y==0) ym=0;//-tsize;
			yp=1;	if (y==tsize) yp=0;//-tsize;
		for (u=0;u<3;u++)
		{
		r=abs(peekb(src+(x-xm)*4+(y-ym)*4*tsize+u)
         +2*peekb(src+(x+0)*4+(y-ym)*4*tsize+u)
         +peekb(src+(x+xp)*4+(y-ym)*4*tsize+u)
         -peekb(src+(x-xm)*4+(y+yp)*4*tsize+u)
         -2*peekb(src+(x+0)*4+(y+yp)*4*tsize+u)
         -peekb(src+(x+xp)*4+(y+yp)*4*tsize+u))*2;
		if (r>255) r=255; if (r<0) r=0;
		pokeb(dst+x*4+y*4*tsize+u,r);
		}
	pokeb(dst+x*4+y*tsize*4+3,peekb(src+x*4+y*tsize*4+3));
    }
  }

}
//-----

void Emboss(BYTE *dst)
{
BYTE* src;
src=dst-tsize*tsize*4;
  int r1,g1,b1,r2,g2,b2,x,y,mx,my;
  mx=my=tsize;
  int xm,xp,ym,yp,u;  
//ClrTexture(texture_swp,0);
  for (y=0;y<my;y++)
  {
    for (x=0;x<mx;x++)
    {
			xm=1;	if (x==0) xm=0;//-(256-1);
			xp=1;	if (x==tsize-1) xp=0;//-(256-1);
			ym=1;	if (y==0) ym=0;//-(256-1);
			yp=1;	if (y==tsize-1) yp=0;//-(256-1);

	for (u=0;u<3;u++)
	{
		r1=128
		-peekb(src+(x-xm)*4+(y-ym)*tsize*4+u)+
		-peekb(src+(x-xm)*4+y*tsize*4+u)+
		-peekb(src+(x-xm)*4+(y+yp)*tsize*4+u)+
		peekb(src+(x+xp)*4+(y-ym)*tsize*4+u)+
		peekb(src+(x+xp)*4+y*tsize*4+u)+
		peekb(src+(x+xp)*4+(y+yp)*tsize*4+u);
		r2=128
		-peekb(src+(x-xm)*4+(y-ym)*tsize*4+u)+
		-peekb(src+x*4+(y-ym)*tsize*4+u)+
		-peekb(src+(x+xp)*4+(y-ym)*tsize*4+u)+
		peekb(src+(x-xm)*4+(y+yp)*tsize*4+u)+
		peekb(src+x*4+(y+yp)*tsize*4+u)+
		peekb(src+(x+xp)*4+(y+yp)*tsize*4+u);
		r1=(int)(sqrt(r1*r1+r2*r2));
		if (r1>255) r1=255; if (r1<0) r1=0;
		pokeb(dst+x*4+y*4*tsize+u,r1);
	}
    pokeb(dst+x*4+y*tsize*4+3,peekb(src+x*4+y*tsize*4+3));
    }
  }
}


//---
void Sharpen(BYTE *dst)
{
  int r,g,b,x,y,u;
  BYTE* src;
  src=dst-tsize*tsize*4;

  int xm,xp,ym,yp;
  for (y=0;y<tsize;y++)
  {
    for (x=0;x<tsize;x++)
    {
			xm=1;	if (x==0) xm=0;//-256;
			xp=1;	if (x==tsize-1) xp=0;//-256;
			ym=1;	if (y==0) ym=0;//-256;
			yp=1;	if (y==tsize-1) yp=0;//-256;
		for (u=0;u<3;u++)
		{
			r = (5*peekb(src+(x+0)*4+(y+0)*tsize*4+u) >> 1)
         -((peekb(src+(x-xm)*4+(y-ym)*tsize*4+u)
           +peekb(src+(x-xm)*4+(y+yp)*tsize*4+u)
           +peekb(src+(x+xp)*4+(y-ym)*tsize*4+u)
           +peekb(src+(x+xp)*4+(y+yp)*tsize*4+u)) >> 3)
         -((peekb(src+(x-xm)*4+(y+0)*tsize*4+u)
           +peekb(src+(x+xp)*4+(y+0)*tsize*4+u)
           +peekb(src+(x+0)*4+(y-ym)*tsize*4+u)
           +peekb(src+(x+0)*4+(y+yp)*tsize*4+u)) >> 2);
			if (r>255) r=255; if (r<0) r=0;
			pokeb(dst+x*4+y*tsize*4+u,r);
		}
		pokeb(dst+x*4+y*tsize*4+3,peekb(src+x*4+y*tsize*4+3));
    }
  }
}

void AddParticle(BYTE *dst,double tx, double ty,double b,double g,double r,double rad, double zt)
{
double intens=255;

BYTE* src;
src=dst-tsize*tsize*4;

tx=tx*tsize/256;ty=ty*tsize/256;
rad=rad*tsize/256;

	r=(r-128)*2*((intens-128)/128.0);
	g=(g-128)*2*((intens-128)/128.0);
	b=(b-128)*2*((intens-128)/128.0);
	double rx,ry,tr,sr,sg,sb,a;
	int x,y;

  for (y=0;y<tsize;y++)
  {
    for (x=0;x<tsize;x++)
    {

	rx=x-tx;ry=y-ty;
	tr=sqrt(rx*rx+ry*ry);
	if (tr>rad) tr=rad;
	tr=rad-tr;


	a=(4*zt*rad/128.0*tr/32.0)/(rad+1);if (a>1) a=1;

	sr=(r*a);
	sr=peekb(src+x*4+y*4*tsize)+sr;
	if (sr>255) sr=255;if (sr<0) sr=0;

	sg=(g*a);
	sg=peekb(src+x*4+y*4*tsize+1)+sg;
	if (sg>255) sg=255;if (sg<0) sg=0;

	sb=(b*a);
	sb=peekb(src+x*4+y*4*tsize+2)+sb;
	if (sb>255) sb=255;if (sb<0) sb=0;
	
	pokeb(dst+x*4+y*tsize*4+0,sr);
	pokeb(dst+x*4+y*tsize*4+1,sg);
	pokeb(dst+x*4+y*tsize*4+2,sb);
	}
  }
}

void AddSprite(BYTE *dst,int tx, int ty,int st,int rad,int roll)
{
double intens=255;
BYTE* stn;
if (st<1) st=1;
memcpy(dst,dst-tsize*tsize*4,tsize*tsize*4);
memcpy(texture_swp,texture_tmp+st*tsize*tsize*4,tsize*tsize*4);
RotorZoom(texture_swp+tsize*tsize*4,tx,ty,roll,rad,64,64);

int t;t=tsize*tsize*4/8;
stn=texture_swp+tsize*tsize*4;
__int64 m1=0x00ffffff00ffffff;
_asm{
	mov ecx,t
		mov esi,stn
		mov edi,dst
		movq mm2,m1
lp:
		movq mm0,[esi]
			pand mm0,mm2
		movq mm1,[edi]

		paddusb mm0,mm1
		movq [edi],mm0

		add esi,8
		add edi,8

		loop lp
	emms

	}
}


void Mozaic(BYTE* dst,int p)
{
p++;
memcpy(dst,dst-tsize*tsize*4,tsize*tsize*4);

int x,y,a,tx,ty;
  for (y=0;y<tsize;y++)
    for (x=0;x<tsize;x++)
	{
	tx=x*p; while (tx>=tsize) tx=tx-tsize;
	ty=y*p; while (ty>=tsize) ty=ty-tsize;
	get_rgb(dst-tsize*tsize*4,tx,ty);
	place_rgb(dst,x,y);
	}
}

void Clear(BYTE* dst)
{
	int ts;
memcpy(dst,dst-tsize*tsize*4,tsize*tsize*4);
	ts=tsize*tsize;
	_asm{
		mov ecx,ts
			mov edi,dst
			mov eax,0
			rep stosd
		}
}

void ClearRGB(BYTE* dst)
{
	int ts;
memcpy(dst,dst-tsize*tsize*4,tsize*tsize*4);
	ts=tsize*tsize;
	_asm{
		mov ecx,ts
			mov edi,dst
			mov eax,0

		lp:	
			mov [edi],ax
				mov [edi+2],al
				add edi,4
			loop lp
		}
}


void ClearAlfa(BYTE* dst)
{
	int ts;
memcpy(dst,dst-tsize*tsize*4,tsize*tsize*4);
	ts=tsize*tsize;
	_asm{
		mov ecx,ts
			mov edi,dst
			mov eax,255
		lp:	
			mov [edi+3],al
			add edi,4
			loop lp

		}
}

void CopyBlueToAlfa(BYTE* dst)
{
	int ts;
	ts=tsize*tsize;
memcpy(dst,dst-tsize*tsize*4,tsize*tsize*4);
	_asm{
		mov ecx,ts
			mov edi,dst
		lp:	
			mov al,[edi]
			mov [edi+3],al
			add edi,4
			loop lp

		}
}



void Mixer(BYTE* dst,int p1,int p2,int p3,int p4,int p5)
{
int i,addr1,addr2,a,b,c;
addr1=p1*tsize*tsize*4;addr2=p2*tsize*tsize*4;
i=0;
while (i<tsize*tsize*4)
	{
	a=peekb(texture_tmp+addr1+i);
	b=peekb(texture_tmp+addr2+i);
		if (p5==0) c=a*p3/256+b*p4/256;
		if (p5==1) c=a*p3/256-b*p4/256;
		if (p5==2) c=b*p4/256-a*p3/256;
		if (p5==3) c=4*a*p3/256*b*p4/256/256;
		if (p5==4) {if (a*p3>b*p4) c=2*a*p3/256; else c=2*b*p4/256;}
		if (p5==5) {if (a*p3<b*p4) c=2*a*p3/256; else c=2*b*p4/256;}
	if (c>255) c=255;
	if (c<0) c=0;
	pokeb (dst+i,c);i++;

	a=peekb(texture_tmp+addr1+i);
	b=peekb(texture_tmp+addr2+i);
		if (p5==0) c=a*p3/256+b*p4/256;
		if (p5==1) c=a*p3/256-b*p4/256;
		if (p5==2) c=b*p4/256-a*p3/256;
		if (p5==3) c=4*a*p3/256*b*p4/256/256;
		if (p5==4) {if (a*p3>b*p4) c=2*a*p3/256; else c=2*b*p4/256;}
		if (p5==5) {if (a*p3<b*p4) c=2*a*p3/256; else c=2*b*p4/256;}
	if (c>255) c=255;
	if (c<0) c=0;
	pokeb (dst+i,c);i++;

	a=peekb(texture_tmp+addr1+i);
	b=peekb(texture_tmp+addr2+i);
		if (p5==0) c=a*p3/256+b*p4/256;
		if (p5==1) c=a*p3/256-b*p4/256;
		if (p5==2) c=b*p4/256-a*p3/256;
		if (p5==3) c=4*a*p3/256*b*p4/256/256;
		if (p5==4) {if (a*p3>b*p4) c=2*a*p3/256; else c=2*b*p4/256;}
		if (p5==5) {if (a*p3<b*p4) c=2*a*p3/256; else c=2*b*p4/256;}
	if (c>255) c=255;
	if (c<0) c=0;
	pokeb (dst+i,c);i++;i++;


	}
}


void CrossFade(BYTE* dst,int p1,int p2)
{
int x,y,a,b,c,d,e;

memcpy(dst,dst-tsize*tsize*4,tsize*tsize*4);

p1=p1*tsize/256;
p1/=2;
if (p2==0)
for (y=0;y<tsize;y++)
for (x=0;x<p1;x++)
	{
	
	for (e=0;e<3;e++)
		{
		a=peekb(dst+x*4+y*tsize*4+e);
		b=peekb(dst+(tsize-1)*4-x*4+y*tsize*4+e);
		c=(p1-x)*((a+b)/2)/p1+a*x/p1;
		d=(p1-x)*((a+b)/2)/p1+b*x/p1;
		pokeb (dst+x*4+y*tsize*4+e,c);
		pokeb (dst+(tsize-1)*4-x*4+y*tsize*4+e,d);
		}
	}

if (p2==1)
for (y=0;y<p1;y++)
for (x=0;x<tsize;x++)
	{
	for (e=0;e<3;e++)
		{
		a=peekb(dst+x*4+y*tsize*4+e);
		b=peekb(dst+x*4+(tsize-1-y)*tsize*4+e);
		c=(p1-y)*((a+b)/2)/p1+a*y/p1;
		d=(p1-y)*((a+b)/2)/p1+b*y/p1;
		pokeb (dst+x*4+y*tsize*4+e,c);
		pokeb (dst+x*4+(tsize-1-y)*tsize*4+e,d);
		}
	}
}


//solidfill - 1stpass opt by Shimara
long int v=0,ii;
int *x3,*y3, fillcolor, sample, range1;
BYTE* dst1;

//
void draw(int x1,int y1){
	if ((x1<0)||(x1>tsize)||(y1<0)||(y1>tsize)) return;
	if ((peekb(texture_swp+x1+y1*tsize))==1) return;
	get_r_g_b(dst1,x1,y1);
	if (((_r+_g+_b)/3)>=(sample+range1)) return;
	if (((_r+_g+_b)/3)<=(sample-range1)) return;
	v++;
	//    ,
	//   tsize>=128  stack overflow
	if (v>=100){
		x3[ii]=x1;
		y3[ii]=y1;
		ii++;
		return;
	};
	_rgb=fillcolor;
	if (x1+1<=tsize){
		if ((peekb(texture_swp+x1+1+y1*tsize))==1){
			place_rgb(dst1,x1,y1);
			pokeb (texture_swp+x1+y1*tsize,1);
			draw(x1-1,y1);
			draw(x1,y1-1);
			draw(x1,y1+1);
			draw(x1+1,y1);
			return;
		}
	}
	if (y1+1<=tsize){
		if ((peekb(texture_swp+x1+(y1+1)*tsize))==1){
			place_rgb(dst1,x1,y1);
			pokeb (texture_swp+x1+y1*tsize,1);
			draw(x1-1,y1);
			draw(x1,y1-1);
			draw(x1,y1+1);
			draw(x1+1,y1);
			return;
		}
	}	
	if (y1-1>=0){
		if ((peekb(texture_swp+x1+(y1-1)*tsize))==1){
			place_rgb(dst1,x1,y1);
			pokeb (texture_swp+x1+y1*tsize,1);
			draw(x1-1,y1);
			draw(x1,y1-1);
			draw(x1,y1+1);
			draw(x1+1,y1);
			return;
		}
	}
	if (x1-1>=0){
		if ((peekb(texture_swp+x1-1+y1*tsize))==1){
			place_rgb(dst1,x1,y1);
			pokeb (texture_swp+x1+y1*tsize,1);
			draw(x1-1,y1);
			draw(x1,y1-1);
			draw(x1,y1+1);
			draw(x1+1,y1);
			return;
		}
	}
	return;
}

//~x15 by Shimara
void SolidFill(BYTE* dst,int x,int y,int r,int g,int b,int range){
memcpy(dst,dst-tsize*tsize*4,tsize*tsize*4);

x3=new int[tsize*tsize];
y3=new int[tsize*tsize];
	v=0;
int df,rf,mixcolor,ts,i,k;
x=x*tsize/256;y=y*tsize/256;
ts=tsize*tsize;
dst1=dst;
range1=range;
_asm{
	mov ecx,ts
	mov edi,texture_swp
	mov eax,0 //unknown
	rep stosd
	}
fillcolor=(r<<16)+(g<<8)+b;
get_r_g_b(dst,x,y);
sample=(_r+_g+_b)/3;
pokeb(texture_swp+x+y*tsize,1);//possible
place_rgb(dst,x,y);
range++;

//     
for(i=0;i<tsize*tsize;i++){x3[i]=-1;y3[i]=-1;}
k=(tsize*tsize)/50;
for (i=0;i<((tsize*tsize)/50);i++){
	x3[i]=-1;x3[i+1]=-1;x3[i+2]=-1;x3[i+3]=-1;x3[i+4]=-1;x3[i+5]=-1;x3[i+6]=-1;x3[i+7]=-1;x3[i+8]=-1;x3[i+9]=-1;
	x3[i+10]=-1;x3[i+11]=-1;x3[i+12]=-1;x3[i+13]=-1;x3[i+14]=-1;x3[i+15]=-1;x3[i+16]=-1;x3[i+17]=-1;x3[i+18]=-1;x3[i+19]=-1;
	x3[i+20]=-1;x3[i+21]=-1;x3[i+22]=-1;x3[i+23]=-1;x3[i+24]=-1;x3[i+25]=-1;x3[i+26]=-1;x3[i+27]=-1;x3[i+28]=-1;x3[i+29]=-1;
	x3[i+30]=-1;x3[i+31]=-1;x3[i+32]=-1;x3[i+33]=-1;x3[i+34]=-1;x3[i+35]=-1;x3[i+36]=-1;x3[i+37]=-1;x3[i+38]=-1;x3[i+39]=-1;
	x3[i+40]=-1;x3[i+41]=-1;x3[i+42]=-1;x3[i+43]=-1;x3[i+44]=-1;x3[i+45]=-1;x3[i+46]=-1;x3[i+47]=-1;x3[i+48]=-1;x3[i+49]=-1;
	y3[i]=-1;y3[i+1]=-1;y3[i+2]=-1;y3[i+3]=-1;y3[i+4]=-1;y3[i+5]=-1;y3[i+6]=-1;y3[i+7]=-1;y3[i+8]=-1;y3[i+9]=-1;
	y3[i+10]=-1;y3[i+11]=-1;y3[i+12]=-1;y3[i+13]=-1;y3[i+14]=-1;y3[i+15]=-1;y3[i+16]=-1;y3[i+17]=-1;y3[i+18]=-1;y3[i+19]=-1;
	y3[i+20]=-1;y3[i+21]=-1;y3[i+22]=-1;y3[i+23]=-1;y3[i+24]=-1;y3[i+25]=-1;y3[i+26]=-1;y3[i+27]=-1;y3[i+28]=-1;y3[i+29]=-1;
	y3[i+30]=-1;y3[i+31]=-1;y3[i+32]=-1;y3[i+33]=-1;y3[i+34]=-1;y3[i+35]=-1;y3[i+36]=-1;y3[i+37]=-1;y3[i+38]=-1;y3[i+39]=-1;
	y3[i+40]=-1;y3[i+41]=-1;y3[i+42]=-1;y3[i+43]=-1;y3[i+44]=-1;y3[i+45]=-1;y3[i+46]=-1;y3[i+47]=-1;y3[i+48]=-1;y3[i+49]=-1;
}
for (i=k*50;i<tsize*tsize;i++){
	x3[i]=-1;
	y3[i]=-1;
}

ii=0;
v=0;
draw(modul(x-1),y);
draw(x,modul(y-1));
draw(x,modul(y+1));
draw(modul(x+1),y);
// ! ii - 
for (i=0;i<ii;i++){
	v=0;
	if ((x3[i]>=0)&&(y3[i]>=0))  draw(x3[i],y3[i]);
}
delete[]x3;
delete[]y3;
}


void Map2dPShift(BYTE* dst,int p1,int p2,int p3)
{
int addr,a,dx,dy,x,y,cx,cy,i;
addr=p1*tsize*tsize*4;
i=0;cx=0;cy=0;
BYTE* src;
src=dst-tsize*tsize*4;


while (i<tsize*tsize*4)
	{
		dx=peekb(texture_tmp+addr+i)-tsize/2;
		dy=peekb(texture_tmp+addr+i+1)-tsize/2;

		cx++;if (cx>=tsize) {cx=0;cy++;}

		x=cx+dx*p2/128;y=cy+dy*p3/128;
		while (x>=tsize) x-=tsize;while (y>=tsize) y-=tsize;
		while (x<0) x+=tsize;while (y<0) y+=tsize;
	
		get_rgb(src,x,y);
		place_rgb(dst,cx,cy);
		i+=4;
	}
}

void Map2dPShift2(BYTE* dst,int p1,int p2,int p3,int p4,int p5)
{
int addr,a,dx,dy,x,y,cx,cy,i;
addr=p1*tsize*tsize*4;
i=0;cx=0;cy=0;
BYTE* src;
src=dst-tsize*tsize*4;


while (i<tsize*tsize*4)
	{
		dx=peekb(texture_tmp+addr+i)-tsize/2;
		dy=peekb(texture_tmp+addr+i+1)-tsize/2;

		cx++;if (cx>=tsize) {cx=0;cy++;}

		x=cx+dx*p2/128+p3;y=cy+dy*p4/128+p5;
		while (x>=tsize) x-=tsize;while (y>=tsize) y-=tsize;
		while (x<0) x+=tsize;while (y<0) y+=tsize;
	
		get_rgb(src,x,y);
		place_rgb(dst,cx,cy);
		i+=4;
	}
}