//geometry generator

int c_side=0;//   

typedef struct {double x,y,z,u,v,r,g,b,n1,n2,n3;} genvertex;
genvertex temp_vbuffer[256*256];

void sun_n()
{
	gx=32*sin(ay/2*grt)*cos(ax*grt);
	gy=32*sin(ay/2*grt)*sin(ax*grt);
	gz=32*cos(ay/2*grt);
}

//--
void sphere()
{
	gx=objects[current_scene][CurrentObject[current_scene]].sx*sin(ay/2*grt)*cos(ax*grt);
	gy=objects[current_scene][CurrentObject[current_scene]].sy*sin(ay/2*grt)*sin(ax*grt);
	gz=objects[current_scene][CurrentObject[current_scene]].sz*cos(ay/2*grt);
}

void dome()
{
	gx=objects[current_scene][CurrentObject[current_scene]].sx*sin(ay/4*grt)*cos(ax*grt);
	gy=objects[current_scene][CurrentObject[current_scene]].sy*sin(ay/4*grt)*sin(ax*grt);
	gz=objects[current_scene][CurrentObject[current_scene]].sz*cos(ay/4*grt);
}


void truba()
{
	gx=objects[current_scene][CurrentObject[current_scene]].sx*sin(ax*grt);
	gy=objects[current_scene][CurrentObject[current_scene]].sy*cos(ax*grt);
	gz=objects[current_scene][CurrentObject[current_scene]].sz*ay/180.0-objects[current_scene][CurrentObject[current_scene]].sz;
}

void cylinder()
{
	gx=objects[current_scene][CurrentObject[current_scene]].sx*sin(ax*grt);
	gy=objects[current_scene][CurrentObject[current_scene]].sy*cos(ax*grt);
	gz=objects[current_scene][CurrentObject[current_scene]].sz*ay/180.0-objects[current_scene][CurrentObject[current_scene]].sz;
	if (gty==0) {gx=0;gy=0;}
	if (gty==gpy) {gx=0;gy=0;}
}

void bochka()
{
	gx=objects[current_scene][CurrentObject[current_scene]].sx*sin(ax*grt);
	gy=objects[current_scene][CurrentObject[current_scene]].sy*cos(ax*grt);
	gz=objects[current_scene][CurrentObject[current_scene]].sz*ay/180.0-objects[current_scene][CurrentObject[current_scene]].sz;
	if (gty==gpy) {gx=0;gy=0;}
}

void flat_postprocessor()
{
	gx=objects[current_scene][CurrentObject[current_scene]].sx*ax/360.0-objects[current_scene][CurrentObject[current_scene]].sx/2.0;
	gy=objects[current_scene][CurrentObject[current_scene]].sy*ay/360.0-objects[current_scene][CurrentObject[current_scene]].sy/2.0;
	gx/=32;gy/=32;
	gz=0;
}

void flat()
{
	gx=-(2*objects[current_scene][CurrentObject[current_scene]].sx*ax/360.0-objects[current_scene][CurrentObject[current_scene]].sx);
	gy=(2*objects[current_scene][CurrentObject[current_scene]].sy*ay/360.0-objects[current_scene][CurrentObject[current_scene]].sy);
	gz=0;
}


void terrain()
{
bool rr;
  D3DLOCKED_RECT tl;

	gx=-(2*objects[current_scene][CurrentObject[current_scene]].sx*ax/360.0-objects[current_scene][CurrentObject[current_scene]].sx);
	gz=(2*objects[current_scene][CurrentObject[current_scene]].sy*ay/360.0-objects[current_scene][CurrentObject[current_scene]].sy);
	gy=0;

  if (texture_type[Materialbank_vertexbumplink[objects[current_scene][CurrentObject[current_scene]].material]]==0)
  {
	rr=pTexture[Materialbank_vertexbumplink[objects[current_scene][CurrentObject[current_scene]].material]]->LockRect(0,&tl,NULL,D3DLOCK_DISCARD);

  if (gtx<gpx&&gty<gpy) gy=-peekb((BYTE*)tl.pBits+(int)gty*tl.Pitch+(int)gtx*4)*objects[current_scene][CurrentObject[current_scene]].sx*Materialbank_vertexbumpdepth[objects[current_scene][CurrentObject[current_scene]].material]/1024.0/16.0;
  if (gtx==gpx&&gty<gpy) gy=-peekb((BYTE*)tl.pBits+(int)gty*tl.Pitch+0)*objects[current_scene][CurrentObject[current_scene]].sx*Materialbank_vertexbumpdepth[objects[current_scene][CurrentObject[current_scene]].material]/1024.0/16.0;
  if (gtx<gpx&&gty==gpy) gy=-peekb((BYTE*)tl.pBits+0*tl.Pitch+(int)gtx*4)*objects[current_scene][CurrentObject[current_scene]].sx*Materialbank_vertexbumpdepth[objects[current_scene][CurrentObject[current_scene]].material]/1024.0/16.0;
  if (gtx==gpx&&gty==gpy) gy=-peekb((BYTE*)tl.pBits+0+0)*objects[current_scene][CurrentObject[current_scene]].sx*Materialbank_vertexbumpdepth[objects[current_scene][CurrentObject[current_scene]].material]/1024.0/16.0;

  pTexture[Materialbank_vertexbumplink[objects[current_scene][CurrentObject[current_scene]].material]]->UnlockRect(0);
  }
}

void terrainsphere()
{
  double rd;rd=0;bool rr;
  D3DLOCKED_RECT tl;
  if (texture_type[Materialbank_vertexbumplink[objects[current_scene][CurrentObject[current_scene]].material]]==0)
  {
  rr=pTexture[Materialbank_vertexbumplink[objects[current_scene][CurrentObject[current_scene]].material]]->LockRect(0,&tl,NULL,D3DLOCK_DISCARD);

  if (gtx<gpx&&gty<gpy) rd=(double)(peekb((BYTE*)tl.pBits+(int)gty*tl.Pitch+(int)gtx*4))*Materialbank_vertexbumpdepth[objects[current_scene][CurrentObject[current_scene]].material]*objects[current_scene][CurrentObject[current_scene]].sx/256.0;
  if (gtx==gpx&&gty<gpy) rd=(double)(peekb((BYTE*)tl.pBits+(int)gty*tl.Pitch))*Materialbank_vertexbumpdepth[objects[current_scene][CurrentObject[current_scene]].material]*objects[current_scene][CurrentObject[current_scene]].sx/256.0;
  if (gtx<gpx&&gty==gpy) rd=(double)(peekb((BYTE*)tl.pBits+(int)gtx*4))*Materialbank_vertexbumpdepth[objects[current_scene][CurrentObject[current_scene]].material]*objects[current_scene][CurrentObject[current_scene]].sx/256.0;
  if (gtx==gpx&&gty==gpy) rd=(double)(peekb((BYTE*)tl.pBits))*Materialbank_vertexbumpdepth[objects[current_scene][CurrentObject[current_scene]].material]*objects[current_scene][CurrentObject[current_scene]].sx/256.0;
  
  pTexture[Materialbank_vertexbumplink[objects[current_scene][CurrentObject[current_scene]].material]]->UnlockRect(0);
  }

	gx=(objects[current_scene][CurrentObject[current_scene]].sx+rd)*sin(ay/2*grt)*cos(ax*grt);
	gy=(objects[current_scene][CurrentObject[current_scene]].sy+rd)*sin(ay/2*grt)*sin(ax*grt);
	gz=(objects[current_scene][CurrentObject[current_scene]].sz+rd)*cos(ay/2*grt);

}


void terraintruba()
{
  double rd;rd=0;
  bool rr;
  D3DLOCKED_RECT tl;
  if (texture_type[Materialbank_vertexbumplink[objects[current_scene][CurrentObject[current_scene]].material]]==0)
  {
  rr=pTexture[Materialbank_vertexbumplink[objects[current_scene][CurrentObject[current_scene]].material]]->LockRect(0,&tl,NULL,D3DLOCK_DISCARD);

  if (gtx<gpx&&gty<gpy) rd=(double)(peekb((BYTE*)tl.pBits+(int)gty*tl.Pitch+(int)gtx*4))*Materialbank_vertexbumpdepth[objects[current_scene][CurrentObject[current_scene]].material]*objects[current_scene][CurrentObject[current_scene]].sx/256.0;
  if (gtx==gpx&&gty<gpy) rd=(double)(peekb((BYTE*)tl.pBits+(int)gty*tl.Pitch))*Materialbank_vertexbumpdepth[objects[current_scene][CurrentObject[current_scene]].material]*objects[current_scene][CurrentObject[current_scene]].sx/256.0;
  if (gtx<gpx&&gty==gpy) rd=(double)(peekb((BYTE*)tl.pBits+(int)gtx*4))*Materialbank_vertexbumpdepth[objects[current_scene][CurrentObject[current_scene]].material]*objects[current_scene][CurrentObject[current_scene]].sx/256.0;
  if (gtx==gpx&&gty==gpy) rd=(double)(peekb((BYTE*)tl.pBits))*Materialbank_vertexbumpdepth[objects[current_scene][CurrentObject[current_scene]].material]*objects[current_scene][CurrentObject[current_scene]].sx/256.0;
  
  pTexture[Materialbank_vertexbumplink[objects[current_scene][CurrentObject[current_scene]].material]]->UnlockRect(0);
  }

	gx=(objects[current_scene][CurrentObject[current_scene]].sx+rd)*sin(ax*grt);
	gy=(objects[current_scene][CurrentObject[current_scene]].sy+rd)*cos(ax*grt);
	gz=(objects[current_scene][CurrentObject[current_scene]].sz)*ay/180.0-objects[current_scene][CurrentObject[current_scene]].sz;

}


void cube1()
{
	double cgx,cgy,cgz;
		cgx=ax-180;
		cgy=ay-180;
		cgz=180;

	if (c_side<4)
		{
			gx=cgx*cos(c_side*90*grt)-cgz*sin(c_side*90*grt);
			gz=cgx*sin(c_side*90*grt)+cgz*cos(c_side*90*grt);
			gy=cgy;
		}
		else
		{
			gz=cgz*cos((c_side-4)*180*grt+90*grt)-cgy*sin((c_side-4)*180*grt+90*grt);
			gy=cgz*sin((c_side-4)*180*grt+90*grt)+cgy*cos((c_side-4)*180*grt+90*grt);
			gx=cgx;
		}
		

		gx=-2*gx*objects[current_scene][CurrentObject[current_scene]].sx/360.0;
		gy=-2*gy*objects[current_scene][CurrentObject[current_scene]].sy/360.0;
		gz=-2*gz*objects[current_scene][CurrentObject[current_scene]].sz/360.0;


}

void cube1_terrain()
{
double cgx,cgy,cgz;

  bool rr;
  D3DLOCKED_RECT tl;

	cgx=ax-180;
	cgy=ay-180;
	cgz=180;//+peekb((BYTE*)tl.pBits+(int)gty*tl.Pitch+(int)gtx*4)*Materialbank_vertexbumpdepth[objects[current_scene][CurrentObject[current_scene]].material]/4.0;

  if (texture_type[Materialbank_vertexbumplink[objects[current_scene][CurrentObject[current_scene]].material]]==0)
  {
  rr=pTexture[Materialbank_vertexbumplink[objects[current_scene][CurrentObject[current_scene]].material]]->LockRect(0,&tl,NULL,D3DLOCK_DISCARD);

	cgx=ax-180;
	cgy=ay-180;
	cgz=180+peekb((BYTE*)tl.pBits+(int)gty*tl.Pitch+(int)gtx*4)*Materialbank_vertexbumpdepth[objects[current_scene][CurrentObject[current_scene]].material]/4.0;
		
	if (gtx==gpx) cgz=180+peekb((BYTE*)tl.pBits+(int)gty*tl.Pitch)*Materialbank_vertexbumpdepth[objects[current_scene][CurrentObject[current_scene]].material]/4.0;
	if (gty==gpy) cgz=180+peekb((BYTE*)tl.pBits+(int)gtx*4)*Materialbank_vertexbumpdepth[objects[current_scene][CurrentObject[current_scene]].material]/4.0;
	if (gtx==gpx&&gty==gpy) cgz=180+peekb((BYTE*)tl.pBits)*Materialbank_vertexbumpdepth[objects[current_scene][CurrentObject[current_scene]].material]/4.0;	
  pTexture[Materialbank_vertexbumplink[objects[current_scene][CurrentObject[current_scene]].material]]->UnlockRect(0);
  }

	if (c_side<4)
		{
			gx=cgx*cos(c_side*90*grt)-cgz*sin(c_side*90*grt);
			gz=cgx*sin(c_side*90*grt)+cgz*cos(c_side*90*grt);
			gy=cgy;
		}
		else
		{
			gz=cgz*cos((c_side-4)*180*grt+90*grt)-cgy*sin((c_side-4)*180*grt+90*grt);
			gy=cgz*sin((c_side-4)*180*grt+90*grt)+cgy*cos((c_side-4)*180*grt+90*grt);
			gx=cgx;
		}

		gx=-2*gx*objects[current_scene][CurrentObject[current_scene]].sx/360.0;
		gy=-2*gy*objects[current_scene][CurrentObject[current_scene]].sy/360.0;
		gz=-2*gz*objects[current_scene][CurrentObject[current_scene]].sz/360.0;



}

void cube1_terrain_minus()
{
double cgx,cgy,cgz;

  bool rr;
  D3DLOCKED_RECT tl;

	cgx=ax-180;
	cgy=ay-180;
	cgz=180;//+peekb((BYTE*)tl.pBits+(int)gty*tl.Pitch+(int)gtx*4)*Materialbank_vertexbumpdepth[objects[current_scene][CurrentObject[current_scene]].material]/4.0;

  if (texture_type[Materialbank_vertexbumplink[objects[current_scene][CurrentObject[current_scene]].material]]==0)
  {
  rr=pTexture[Materialbank_vertexbumplink[objects[current_scene][CurrentObject[current_scene]].material]]->LockRect(0,&tl,NULL,D3DLOCK_DISCARD);

	cgx=ax-180;
	cgy=ay-180;
	cgz=180-peekb((BYTE*)tl.pBits+(int)gty*tl.Pitch+(int)gtx*4)*Materialbank_vertexbumpdepth[objects[current_scene][CurrentObject[current_scene]].material]/4.0;
		
	if (gtx==gpx) cgz=180-peekb((BYTE*)tl.pBits+(int)gty*tl.Pitch)*Materialbank_vertexbumpdepth[objects[current_scene][CurrentObject[current_scene]].material]/4.0;
	if (gty==gpy) cgz=180-peekb((BYTE*)tl.pBits+(int)gtx*4)*Materialbank_vertexbumpdepth[objects[current_scene][CurrentObject[current_scene]].material]/4.0;
	if (gtx==gpx&&gty==gpy) cgz=180-peekb((BYTE*)tl.pBits)*Materialbank_vertexbumpdepth[objects[current_scene][CurrentObject[current_scene]].material]/4.0;	
  pTexture[Materialbank_vertexbumplink[objects[current_scene][CurrentObject[current_scene]].material]]->UnlockRect(0);
  }

	if (c_side<4)
		{
			gx=cgx*cos(c_side*90*grt)-cgz*sin(c_side*90*grt);
			gz=cgx*sin(c_side*90*grt)+cgz*cos(c_side*90*grt);
			gy=cgy;
		}
		else
		{
			gz=cgz*cos((c_side-4)*180*grt+90*grt)-cgy*sin((c_side-4)*180*grt+90*grt);
			gy=cgz*sin((c_side-4)*180*grt+90*grt)+cgy*cos((c_side-4)*180*grt+90*grt);
			gx=cgx;
		}
		

		gx=-2*gx*objects[current_scene][CurrentObject[current_scene]].sx/360.0;
		gy=-2*gy*objects[current_scene][CurrentObject[current_scene]].sy/360.0;
		gz=-2*gz*objects[current_scene][CurrentObject[current_scene]].sz/360.0;
}

void torus()
{
	double b2,tmx,tmy,tmz;

	gx=objects[current_scene][CurrentObject[current_scene]].sx*sin(ax*grt)/64.0;
	gy=objects[current_scene][CurrentObject[current_scene]].sy*cos(ax*grt)/64.0+1;
	gz=0;

			b2=(180*gty/(((int)gpy/2)*2))*grt*2;
			tmz=gz*cos(b2)-gy*sin(b2);
			tmy=gz*sin(b2)+gy*cos(b2);
			gz=tmz;gy=tmy-1;

	gx=-gx*objects[current_scene][CurrentObject[current_scene]].sz;
	gy=-gy*objects[current_scene][CurrentObject[current_scene]].sz;
	gz=-gz*objects[current_scene][CurrentObject[current_scene]].sz;
	
	gy-=(objects[current_scene][CurrentObject[current_scene]].sz);
}

void terrain_torus()
{
  double b2,tmx,tmy,tmz;
  double rd;
  bool rr;
	rd=0;
  if (texture_type[Materialbank_vertexbumplink[objects[current_scene][CurrentObject[current_scene]].material]]==0)
  {
  D3DLOCKED_RECT tl;
  rr=pTexture[Materialbank_vertexbumplink[objects[current_scene][CurrentObject[current_scene]].material]]->LockRect(0,&tl,NULL,D3DLOCK_DISCARD);

  
  if (gtx<gpx&&gty<gpy) rd=(double)(peekb((BYTE*)tl.pBits+(int)gty*tl.Pitch+(int)gtx*4))*Materialbank_vertexbumpdepth[objects[current_scene][CurrentObject[current_scene]].material]*objects[current_scene][CurrentObject[current_scene]].sx/256.0/64.0;
  if (gtx==gpx&&gty<gpy) rd=(double)(peekb((BYTE*)tl.pBits+(int)gty*tl.Pitch))*Materialbank_vertexbumpdepth[objects[current_scene][CurrentObject[current_scene]].material]*objects[current_scene][CurrentObject[current_scene]].sx/256.0/64.0;
  if (gtx<gpx&&gty==gpy) rd=(double)(peekb((BYTE*)tl.pBits+(int)gtx*4))*Materialbank_vertexbumpdepth[objects[current_scene][CurrentObject[current_scene]].material]*objects[current_scene][CurrentObject[current_scene]].sx/256.0/64.0;
  if (gtx==gpx&&gty==gpy) rd=(double)(peekb((BYTE*)tl.pBits))*Materialbank_vertexbumpdepth[objects[current_scene][CurrentObject[current_scene]].material]*objects[current_scene][CurrentObject[current_scene]].sx/256.0/64.0;

  pTexture[Materialbank_vertexbumplink[objects[current_scene][CurrentObject[current_scene]].material]]->UnlockRect(0);
  }

	gx=(objects[current_scene][CurrentObject[current_scene]].sx+rd)*sin(ax*grt)/64.0;
	gy=(objects[current_scene][CurrentObject[current_scene]].sy+rd)*cos(ax*grt)/64.0+1;
	gz=0;
	
			b2=(180*gty/(((int)gpy/2)*2))*grt*2;
			tmz=gz*cos(b2)-gy*sin(b2);
			tmy=gz*sin(b2)+gy*cos(b2);
			gz=tmz;gy=tmy-1;

	gx=-gx*objects[current_scene][CurrentObject[current_scene]].sz;
	gy=-gy*objects[current_scene][CurrentObject[current_scene]].sz;
	gz=-gz*objects[current_scene][CurrentObject[current_scene]].sz;

	gy-=(objects[current_scene][CurrentObject[current_scene]].sz);
}

void truba_loft()
{
	gx=objects[current_scene][CurrentObject[current_scene]].sx*sin(ax*grt);
	gy=objects[current_scene][CurrentObject[current_scene]].sy*cos(ax*grt);
	gz=objects[current_scene][CurrentObject[current_scene]].sz*ay/180.0-objects[current_scene][CurrentObject[current_scene]].sz;
if (gty<mod0array[current_scene][CurrentObject[current_scene]].numofmodifers)
	{
	gx=gx*mod0array[current_scene][CurrentObject[current_scene]].modifer[(int)gty].rad/256.0;
	gy=gy*mod0array[current_scene][CurrentObject[current_scene]].modifer[(int)gty].rad/256.0;

	gx=gx+mod0array[current_scene][CurrentObject[current_scene]].modifer[(int)gty].x;
	gy=gy+mod0array[current_scene][CurrentObject[current_scene]].modifer[(int)gty].y;
	gz=gz+mod0array[current_scene][CurrentObject[current_scene]].modifer[(int)gty].z;
	}

}

double prx[3],pry[3],prz[3],b21,b22,tmx,tmy,tmz;

void truba_loft2()
{
	gx=objects[current_scene][CurrentObject[current_scene]].sx*sin(ax*grt);
	gy=objects[current_scene][CurrentObject[current_scene]].sy*cos(ax*grt);
	gz=0;

	if (gty<mod0array[current_scene][CurrentObject[current_scene]].numofmodifers)
	{
		gx=gx*mod0array[current_scene][CurrentObject[current_scene]].modifer[(int)gty].rad/256.0;
		gy=gy*mod0array[current_scene][CurrentObject[current_scene]].modifer[(int)gty].rad/256.0;

		prx[0]=mod0array[current_scene][CurrentObject[current_scene]].modifer[(int)gty].x;
		pry[0]=mod0array[current_scene][CurrentObject[current_scene]].modifer[(int)gty].y;
		prz[0]=mod0array[current_scene][CurrentObject[current_scene]].modifer[(int)gty].z;

		if (gty==gpy) goto rp;

		if (gty>0&&gty<gpy)
		{
		prx[1]=mod0array[current_scene][CurrentObject[current_scene]].modifer[(int)gty-1].x;
		pry[1]=mod0array[current_scene][CurrentObject[current_scene]].modifer[(int)gty-1].y;
		prz[1]=mod0array[current_scene][CurrentObject[current_scene]].modifer[(int)gty-1].z;
		prx[2]=mod0array[current_scene][CurrentObject[current_scene]].modifer[(int)gty+1].x;
		pry[2]=mod0array[current_scene][CurrentObject[current_scene]].modifer[(int)gty+1].y;
		prz[2]=mod0array[current_scene][CurrentObject[current_scene]].modifer[(int)gty+1].z;
		b21=(atan2(pry[2]-pry[0],prz[2]-prz[0])+atan2(pry[0]-pry[1],prz[0]-prz[1]))/2.0;

	rp:;	
		tmz=gz*cos(b21)-gy*sin(b21);
		tmy=gz*sin(b21)+gy*cos(b21);
		gy=tmy;
		gz=tmz;
		}
	gz=gz+objects[current_scene][CurrentObject[current_scene]].sz*ay/180.0-objects[current_scene][CurrentObject[current_scene]].sz;
	
	gx=gx+prx[0];
	gy=gy+pry[0];
	gz=gz+prz[0];
	}

}

double fp2_x,fp2_y,fp2_z;

void vertexdataloader()
{
double nax,nay,naz,nbx,nby,nbz,nx,ny,nz,px1,px2,py1,py2,pz1,pz2,sq,f,gx1,gy1,gz1,gx2,gy2,gz2;
double ang_x,ang_y,ang_z;
double q;

double camc;
camc=main_cam.dist/1,5625;

timescaller=256;

q=global_quality/128.0;
if (objects[current_scene][CurrentObject[current_scene]].type==8||objects[current_scene][CurrentObject[current_scene]].type==9||objects[current_scene][CurrentObject[current_scene]].type==10||objects[current_scene][CurrentObject[current_scene]].type==12||objects[current_scene][CurrentObject[current_scene]].type==13||objects[current_scene][CurrentObject[current_scene]].type==17) q=1;

gpx=(int)(objects[current_scene][CurrentObject[current_scene]].px*q);
gpy=(int)(objects[current_scene][CurrentObject[current_scene]].py*q);

for (int y=0;y<256;y++)for (int x=0;x<256;x++) meshsel[y][x]=1;//   -   

/*	gx=objects[current_scene][CurrentObject[current_scene]].sx*ax/360.0-objects[current_scene][CurrentObject[current_scene]].sx/2.0;
	gy=objects[current_scene][CurrentObject[current_scene]].sy*ay/360.0-objects[current_scene][CurrentObject[current_scene]].sy/2.0;
	gx/=32;gy/=32;
	gz=0;*/

for (gty=0;gty<(gpy+1);gty++)
	{
	for (gtx=0;gtx<(gpx+1);gtx++)
		{
		for (int s=0;s<255;s++) ufl[s]=0;

		ay=gty*360.0/gpy;ax=gtx*360.0/gpx;
		gu=ax/360.0;gv=ay/360.0;

		switch (objects[current_scene][CurrentObject[current_scene]].type)
		{
		case 0:{sphere();break;}
		case 1:{truba();break;}
		case 2:{cylinder();break;}
		case 3:{bochka();break;}
		case 4:{flat();break;}
		case 5:{terrain();break;}
		case 6:{terrainsphere();break;}
		case 7:{terraintruba();break;}
		case 8:{cube1();break;}
		case 9:{cube1_terrain();break;}
		case 10:{cube1_terrain_minus();break;}
		case 11:{
				flat_postprocessor(); 
				apply_mods();
				gx=gx+objects[current_scene][CurrentObject[current_scene]].x/64.0;
				gy=gy+objects[current_scene][CurrentObject[current_scene]].y/64.0;
				goto skip_transformations;
				}
		//12 - zbuf cleaner
		case 13:{torus();break;}
		case 14:{terrain_torus();break;}
		case 15:{sun_n();break;}
		case 16:{sun_n();break;}
		case 17:{truba_loft();break;}
		case 18:{truba_loft2();break;}
		//19 - copy to texture
		//20 - render scene
		//21 - fog
		case 22:{
				flat();
				gx/=64.0;gy/=64.0;gz/=64.0;
				fp2_x=gx*camc;fp2_y=gy*camc;fp2_z=gz*camc;
				gx=0;gy=0;gz=0;
				break;
				}
		case 23:{dome();break;}
		//24 - calc texture
		//25 - set texfilter
		//26 - set shademode
		case 27:{sun_n();break;}//27 - marker
		}
		gx/=64.0;gy/=64.0;gz/=64.0;
//-- 
		
		curobj_store=CurrentObject[current_scene];
		pass2flag=0;
		mspeed=0;mfaze=0;mampx=0;mampy=0;mampz=0;
		mxcrd_amp=0;mycrd_amp=0;mzcrd_amp=0;

re_pass:;
		apply_mods();
		if (objects[current_scene][CurrentObject[current_scene]].ctrl_style==1)
		if (objects[current_scene][CurrentObject[current_scene]].ctrl_obj!=curobj_store)
		{
		if (ufl[objects[current_scene][CurrentObject[current_scene]].ctrl_obj]==0)
			{
			ufl[objects[current_scene][CurrentObject[current_scene]].ctrl_obj]=1;
			CurrentObject[current_scene]=objects[current_scene][CurrentObject[current_scene]].ctrl_obj;
			goto re_pass;
			}
		}

		if (objects[current_scene][CurrentObject[current_scene]].ctrl_style==2)
		if (objects[current_scene][CurrentObject[current_scene]].ctrl_obj!=curobj_store)
		{
		if (ufl[objects[current_scene][CurrentObject[current_scene]].ctrl_obj]==0)
			{
			ufl[objects[current_scene][CurrentObject[current_scene]].ctrl_obj]=1;
			CurrentObject[current_scene]=objects[current_scene][CurrentObject[current_scene]].ctrl_obj;
			pass2flag=1;
			goto re_pass;
			}
		}
		pass2flag=0;
		CurrentObject[current_scene]=curobj_store;

//--   
		gx=gx+objects[current_scene][CurrentObject[current_scene]].x/64.0;
		gy=gy+objects[current_scene][CurrentObject[current_scene]].y/64.0;
		gz=gz+objects[current_scene][CurrentObject[current_scene]].z/64.0;
//--   -   
		gx=gx-main_cam.tgt_x/64.0;
		gy=gy-main_cam.tgt_y/64.0;
		gz=gz-main_cam.tgt_z/64.0;
//--
if (objects[current_scene][CurrentObject[current_scene]].type!=11) {gx=gx*main_cam.dist;gy=gy*main_cam.dist;gz=gz*main_cam.dist;}
//--   -   
		gx1=gx*cosalfa-gy*sinalfa;
		gy1=gx*sinalfa+gy*cosalfa;
		gy2=gy1*cosbeta-gz*sinbeta;		
		
		gx=gx1*coscalfa-gy2*sincalfa;
		gy=gx1*sincalfa+gy2*coscalfa;
		gz=gy1*sinbeta+gz*cosbeta;

//post2
if (objects[current_scene][CurrentObject[current_scene]].type==22)
	{
	gx+=fp2_x;gy+=fp2_y;gz+=fp2_z;

	}
//-----
if (upview==1)
{
gy1=gy;gz1=gz;
gy=-gz1;gz=gy1;
}

if (upview==2)
{
gx1=gx;gy1=gy;gz1=gz;
gx=gx1;gy=gz1;gz=-gy1;
}

//--
skip_transformations:;
//--
		//--   
//
		temp_vbuffer[(int)(gpx+1)*(int)gty+(int)gtx].x=gx;
		temp_vbuffer[(int)(gpx+1)*(int)gty+(int)gtx].y=gz;
		temp_vbuffer[(int)(gpx+1)*(int)gty+(int)gtx].z=gy;

		temp_vbuffer[(int)(gpx+1)*(int)gty+(int)gtx].u=gu*objects[current_scene][CurrentObject[current_scene]].cu;
		temp_vbuffer[(int)(gpx+1)*(int)gty+(int)gtx].v=gv*objects[current_scene][CurrentObject[current_scene]].cv;

		}
	}

//-----------------

// 
for (gty=0;gty<(gpy+1);gty++)
	{
	for (gtx=0;gtx<(gpx+1);gtx++)
		{
		if (gty==0) 
		{
		px1=temp_vbuffer[(int)(gpx+1)*(int)gty+(int)gtx].x;
		py1=temp_vbuffer[(int)(gpx+1)*(int)gty+(int)gtx].y;
		pz1=temp_vbuffer[(int)(gpx+1)*(int)gty+(int)gtx].z;
		px2=temp_vbuffer[(int)(gpx+1)*(int)(gty+1)+(int)gtx+1].x;
		py2=temp_vbuffer[(int)(gpx+1)*(int)(gty+1)+(int)gtx+1].y;
		pz2=temp_vbuffer[(int)(gpx+1)*(int)(gty+1)+(int)gtx+1].z;
		}
		else
		{
			px1=temp_vbuffer[(int)(gpx+1)*(int)gty+(int)gtx].x;
			py1=temp_vbuffer[(int)(gpx+1)*(int)gty+(int)gtx].y;
			pz1=temp_vbuffer[(int)(gpx+1)*(int)gty+(int)gtx].z;
			px2=temp_vbuffer[(int)(gpx+1)*(int)gty+(int)gtx+1].x;
			py2=temp_vbuffer[(int)(gpx+1)*(int)gty+(int)gtx+1].y;
			pz2=temp_vbuffer[(int)(gpx+1)*(int)gty+(int)gtx+1].z;
		}
		nax=px2-px1;nay=py2-py1;naz=pz2-pz1;

		if (gty==gpy) 
		{
			px1=temp_vbuffer[(int)(gpx+1)*(int)gty+(int)gtx].x;
			py1=temp_vbuffer[(int)(gpx+1)*(int)gty+(int)gtx].y;
			pz1=temp_vbuffer[(int)(gpx+1)*(int)gty+(int)gtx].z;
			px2=temp_vbuffer[(int)(gpx+1)*(int)(gty-1)+(int)gtx].x;
			py2=temp_vbuffer[(int)(gpx+1)*(int)(gty-1)+(int)gtx].y;
			pz2=temp_vbuffer[(int)(gpx+1)*(int)(gty-1)+(int)gtx].z;
			nbx=px2-px1;nby=py2-py1;nbz=pz2-pz1;
	
			px1=temp_vbuffer[(int)(gpx+1)*(int)gty+(int)gtx].x;
			py1=temp_vbuffer[(int)(gpx+1)*(int)gty+(int)gtx].y;
			pz1=temp_vbuffer[(int)(gpx+1)*(int)gty+(int)gtx].z;
			px2=temp_vbuffer[(int)(gpx+1)*(int)(gty-1)+(int)gtx+1].x;
			py2=temp_vbuffer[(int)(gpx+1)*(int)(gty-1)+(int)gtx+1].y;
			pz2=temp_vbuffer[(int)(gpx+1)*(int)(gty-1)+(int)gtx+1].z;
			nax=px2-px1;nay=py2-py1;naz=pz2-pz1;
			nax=-nax;nay=-nay;naz=-naz;
		}
		else
		{
		px1=temp_vbuffer[(int)(gpx+1)*(int)(gty)+(int)gtx].x;
		py1=temp_vbuffer[(int)(gpx+1)*(int)(gty)+(int)gtx].y;
		pz1=temp_vbuffer[(int)(gpx+1)*(int)(gty)+(int)gtx].z;
		px2=temp_vbuffer[(int)(gpx+1)*(int)(gty+1)+(int)gtx].x;
		py2=temp_vbuffer[(int)(gpx+1)*(int)(gty+1)+(int)gtx].y;
		pz2=temp_vbuffer[(int)(gpx+1)*(int)(gty+1)+(int)gtx].z;
		nbx=px2-px1;nby=py2-py1;nbz=pz2-pz1;
		}

		nx=nay*nbz-naz*nby;
		ny=naz*nbx-nax*nbz;
		nz=nax*nby-nay*nbx;

		sq=sqrt( nx *nx + ny * ny + nz * nz );
		if (sq!=0)
		{
			double nr;
		f = 1.0f/sq;
		nr=objects[current_scene][CurrentObject[current_scene]].normal-1;
		if (nr<2) f*=(-nr);
		if (nr==2) f*=1;
		if (nr==3) f*=-1;
		nx *= f;ny *= f;nz *= f;
		}

	/*	if (gty==gpy) 
		{
		nx=temp_vbuffer[(int)(gpx)].n1;
		ny=temp_vbuffer[(int)(gpx)].n2;
		nz=temp_vbuffer[(int)(gpx)].n3;
		}*/

		if (gtx==gpx) 
		{
		nx=temp_vbuffer[(int)(gpx+1)*(int)gty].n1;
		ny=temp_vbuffer[(int)(gpx+1)*(int)gty].n2;
		nz=temp_vbuffer[(int)(gpx+1)*(int)gty].n3;
		}

		temp_vbuffer[(int)(gpx+1)*(int)gty+(int)gtx].n1=nx;
		temp_vbuffer[(int)(gpx+1)*(int)gty+(int)gtx].n2=ny;
		temp_vbuffer[(int)(gpx+1)*(int)gty+(int)gtx].n3=nz;
		}
	}

}

//
int buffilloffset;

void CreateBufFromSpline()
{
}



void CreateBufFromVertexData()
{
	double q;
int t;t=buffilloffset;
	vertexdataloader();

	q=global_quality/128.0;
	if (objects[current_scene][CurrentObject[current_scene]].type==8||objects[current_scene][CurrentObject[current_scene]].type==9||objects[current_scene][CurrentObject[current_scene]].type==10||objects[current_scene][CurrentObject[current_scene]].type==12||objects[current_scene][CurrentObject[current_scene]].type==13||objects[current_scene][CurrentObject[current_scene]].type==17) q=1;

	gpx=(int)(objects[current_scene][CurrentObject[current_scene]].px*q);
	gpy=(int)(objects[current_scene][CurrentObject[current_scene]].py*q);

	for (gty=0;gty<gpy;gty++)
		{
		for (gtx=0;gtx<gpx;gtx++)
			{
			pMyVerts[t+0].x=temp_vbuffer[(int)(gpx+1)*(int)(gty+0)+(int)gtx+0].x;
			pMyVerts[t+1].x=temp_vbuffer[(int)(gpx+1)*(int)(gty+0)+(int)gtx+1].x;
			pMyVerts[t+2].x=temp_vbuffer[(int)(gpx+1)*(int)(gty+1)+(int)gtx+0].x;
			
			pMyVerts[t+0].y=temp_vbuffer[(int)(gpx+1)*(int)(gty+0)+(int)gtx+0].y;
			pMyVerts[t+1].y=temp_vbuffer[(int)(gpx+1)*(int)(gty+0)+(int)gtx+1].y;
			pMyVerts[t+2].y=temp_vbuffer[(int)(gpx+1)*(int)(gty+1)+(int)gtx+0].y;

			pMyVerts[t+0].z=temp_vbuffer[(int)(gpx+1)*(int)(gty+0)+(int)gtx+0].z;
			pMyVerts[t+1].z=temp_vbuffer[(int)(gpx+1)*(int)(gty+0)+(int)gtx+1].z;
			pMyVerts[t+2].z=temp_vbuffer[(int)(gpx+1)*(int)(gty+1)+(int)gtx+0].z;

			pMyVerts[t+0].tu=temp_vbuffer[(int)(gpx+1)*(int)(gty+0)+(int)gtx+0].u;
			pMyVerts[t+1].tu=temp_vbuffer[(int)(gpx+1)*(int)(gty+0)+(int)gtx+1].u;
			pMyVerts[t+2].tu=temp_vbuffer[(int)(gpx+1)*(int)(gty+1)+(int)gtx+0].u;

			pMyVerts[t+0].tv=temp_vbuffer[(int)(gpx+1)*(int)(gty+0)+(int)gtx+0].v;
			pMyVerts[t+1].tv=temp_vbuffer[(int)(gpx+1)*(int)(gty+0)+(int)gtx+1].v;
			pMyVerts[t+2].tv=temp_vbuffer[(int)(gpx+1)*(int)(gty+1)+(int)gtx+0].v;

			pMyVerts[t+0].color=0xffffffff;
			pMyVerts[t+1].color=0xffffffff;
			pMyVerts[t+2].color=0xffffffff;

			pMyVerts[t+0].n1=temp_vbuffer[(int)(gpx+1)*(int)(gty+0)+(int)gtx+0].n1;
			pMyVerts[t+0].n2=temp_vbuffer[(int)(gpx+1)*(int)(gty+0)+(int)gtx+0].n2;
			pMyVerts[t+0].n3=temp_vbuffer[(int)(gpx+1)*(int)(gty+0)+(int)gtx+0].n3;
			
			pMyVerts[t+1].n1=temp_vbuffer[(int)(gpx+1)*(int)(gty+0)+(int)gtx+1].n1;
			pMyVerts[t+1].n2=temp_vbuffer[(int)(gpx+1)*(int)(gty+0)+(int)gtx+1].n2;
			pMyVerts[t+1].n3=temp_vbuffer[(int)(gpx+1)*(int)(gty+0)+(int)gtx+1].n3;
			
			pMyVerts[t+2].n1=temp_vbuffer[(int)(gpx+1)*(int)(gty+1)+(int)gtx+0].n1;
			pMyVerts[t+2].n2=temp_vbuffer[(int)(gpx+1)*(int)(gty+1)+(int)gtx+0].n2;
			pMyVerts[t+2].n3=temp_vbuffer[(int)(gpx+1)*(int)(gty+1)+(int)gtx+0].n3;

			t=t+3;
			//---
			pMyVerts[t+0].x=temp_vbuffer[(int)(gpx+1)*(int)(gty+0)+(int)gtx+1].x;
			pMyVerts[t+1].x=temp_vbuffer[(int)(gpx+1)*(int)(gty+1)+(int)gtx+1].x;
			pMyVerts[t+2].x=temp_vbuffer[(int)(gpx+1)*(int)(gty+1)+(int)gtx+0].x;
			
			pMyVerts[t+0].y=temp_vbuffer[(int)(gpx+1)*(int)(gty+0)+(int)gtx+1].y;
			pMyVerts[t+1].y=temp_vbuffer[(int)(gpx+1)*(int)(gty+1)+(int)gtx+1].y;
			pMyVerts[t+2].y=temp_vbuffer[(int)(gpx+1)*(int)(gty+1)+(int)gtx+0].y;

			pMyVerts[t+0].z=temp_vbuffer[(int)(gpx+1)*(int)(gty+0)+(int)gtx+1].z;
			pMyVerts[t+1].z=temp_vbuffer[(int)(gpx+1)*(int)(gty+1)+(int)gtx+1].z;
			pMyVerts[t+2].z=temp_vbuffer[(int)(gpx+1)*(int)(gty+1)+(int)gtx+0].z;

			pMyVerts[t+0].tu=temp_vbuffer[(int)(gpx+1)*(int)(gty+0)+(int)gtx+1].u;
			pMyVerts[t+1].tu=temp_vbuffer[(int)(gpx+1)*(int)(gty+1)+(int)gtx+1].u;
			pMyVerts[t+2].tu=temp_vbuffer[(int)(gpx+1)*(int)(gty+1)+(int)gtx+0].u;

			pMyVerts[t+0].tv=temp_vbuffer[(int)(gpx+1)*(int)(gty+0)+(int)gtx+1].v;
			pMyVerts[t+1].tv=temp_vbuffer[(int)(gpx+1)*(int)(gty+1)+(int)gtx+1].v;
			pMyVerts[t+2].tv=temp_vbuffer[(int)(gpx+1)*(int)(gty+1)+(int)gtx+0].v;

			pMyVerts[t+0].color=0xffffffff;
			pMyVerts[t+1].color=0xffffffff;
			pMyVerts[t+2].color=0xffffffff;

			pMyVerts[t+0].n1=temp_vbuffer[(int)(gpx+1)*(int)(gty+0)+(int)gtx+1].n1;
			pMyVerts[t+0].n2=temp_vbuffer[(int)(gpx+1)*(int)(gty+0)+(int)gtx+1].n2;
			pMyVerts[t+0].n3=temp_vbuffer[(int)(gpx+1)*(int)(gty+0)+(int)gtx+1].n3;
			
			pMyVerts[t+1].n1=temp_vbuffer[(int)(gpx+1)*(int)(gty+1)+(int)gtx+1].n1;
			pMyVerts[t+1].n2=temp_vbuffer[(int)(gpx+1)*(int)(gty+1)+(int)gtx+1].n2;
			pMyVerts[t+1].n3=temp_vbuffer[(int)(gpx+1)*(int)(gty+1)+(int)gtx+1].n3;
			
			pMyVerts[t+2].n1=temp_vbuffer[(int)(gpx+1)*(int)(gty+1)+(int)gtx+0].n1;
			pMyVerts[t+2].n2=temp_vbuffer[(int)(gpx+1)*(int)(gty+1)+(int)gtx+0].n2;
			pMyVerts[t+2].n3=temp_vbuffer[(int)(gpx+1)*(int)(gty+1)+(int)gtx+0].n3;

			t=t+3;
			}
		}
	NumVerts = 2*gpx*gpy*3;//  
	NumTriangles = gpx*gpy*2;//  

}

void createVbuf_for_accel()
{
	buffilloffset=0;
	
	if ((objects[current_scene][CurrentObject[current_scene]].type)==8||(objects[current_scene][CurrentObject[current_scene]].type)==9||(objects[current_scene][CurrentObject[current_scene]].type)==10) 
		{
		for (c_side=0;c_side<6;c_side++)
			{
			buffilloffset=2*c_side*gpx*gpy*3;
			CreateBufFromVertexData();
			}
		NumVerts = 2*6*objects[current_scene][CurrentObject[current_scene]].px*objects[current_scene][CurrentObject[current_scene]].py*3;//  
		NumTriangles = 2*6*objects[current_scene][CurrentObject[current_scene]].px*objects[current_scene][CurrentObject[current_scene]].py;//  
		}
	else CreateBufFromVertexData();
}